C
C     rwbrook.f: Fortran interface to MMDB for handling coordinates
C
C     This library is free software: you can redistribute it and/or
C     modify it under the terms of the GNU Lesser General Public License
C     version 3, modified in accordance with the provisions of the 
C     license to address the requirements of UK law.
C 
C     You should have received a copy of the modified GNU Lesser General 
C     Public License along with this library.  If not, copies may be 
C     downloaded from http://www.ccp4.ac.uk/ccp4license.php
C 
C     This program is distributed in the hope that it will be useful,
C     but WITHOUT ANY WARRANTY; without even the implied warranty of
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C     GNU Lesser General Public License for more details.
C
C**************************************************************************
C
C
C**************************************************************************
C
C
C Modifications
C
C     CCB 23/4/01
C     test to determine if H or R spacegroup, XYZOPEN2
C
      SUBROUTINE XYZINIT()
C     ====================
C
C_BEGIN_XYZINIT
C
C	This subroutine initialises the common block RBRKAA ready for reading
C and writing coordinate files. Also, the common blocks associated with 
C storing the header information are initialised. It should be called only 
C once from the top of the program.
C
C Parameters:
C
C       NONE
C
C COMMONS:
C
C         /RBRKAA/ FILESOPEN,LOGUNIT(MAXFILESOPEN),UNIT(MAXFILESOPEN),
C                  TYPE(MAXFILESOPEN)
C
C           FILESOPEN       no. of current coordinate files open.
C           LOGUNIT          logical name of file
C           UNIT            if the file is PDB then the unit is the physical
C                           channel opened. If CIF then is related to blocks.
C           TYPE            indicates whether PDB (1,-1) or CIF (2,-2). If
C                           negative then file is output file.
C
C_END_XYZINIT
C
C     .. Parameters ..
      INTEGER MAXFILESOPEN
      PARAMETER (MAXFILESOPEN=90)
C     ..
C     .. Variables in Common ..
      REAL CELL,CELLAS,RF,RO,RR,VOL
      INTEGER FILESOPEN,ITYP,NCODE,TYPE,UNIT
      CHARACTER LOGUNIT*80,BRKSPGRP*15
      LOGICAL IFCRYS,IFHDOUT,IFNEWCRYS,IFSCAL,MATRIX
C     ..
C     .. Local Scalars ..
      INTEGER I
C     ..
      EXTERNAL MMDB_F_INIT,SIMRWBROOK
C     ..
C     .. Common Blocks ..
      COMMON /RBRKAA/ FILESOPEN,LOGUNIT(MAXFILESOPEN),
     +                UNIT(MAXFILESOPEN),TYPE(MAXFILESOPEN)
      COMMON /RBRKXX/ IFCRYS,IFSCAL,ITYP,MATRIX,IFHDOUT,IFNEWCRYS
      COMMON /RBRKZZ/ CELL(6),RR(3,3,6),VOL,CELLAS(6)
      COMMON /ORTHOG/ RO(4,4),RF(4,4),NCODE
      COMMON /ORTHOGU/ ROU(4,4),RFU(4,4)
      COMMON /RBRKSPGRP/BRKSPGRP
C     ..
C     .. Save ..
      SAVE /RBRKAA/,/RBRKXX/,/RBRKZZ/,/ORTHOG/,/ORTHOGU/
C     ..

      FILESOPEN = 0

      DO 10 I=1,MAXFILESOPEN
        LOGUNIT(I) = ' '
        UNIT(I) = 0
        TYPE(I) = 0
   10 CONTINUE

      DO 20 I=1,6
        CELL(I) = 0.0
        CELLAS(I) = 0.0
   20 CONTINUE

      IFCRYS=.FALSE.
      IFSCAL=.FALSE.
      MATRIX=.FALSE.
      IFHDOUT=.FALSE.
      IFNEWCRYS=.FALSE.
      NCODE=0
      ITYP=0
C
C
      DO 30 I=1,3
        DO 40 J=I+1,4
          RO(I,J)=0.0
          RO(J,I)=0.0
          RF(I,J)=0.0
          RF(J,I)=0.0
          ROU(I,J)=0.0
          ROU(J,I)=0.0
          RFU(I,J)=0.0
          RFU(J,I)=0.0
40      CONTINUE
        RO(I,I)=1.0
        RF(I,I)=1.0
        ROU(I,I)=1.0
        RFU(I,I)=1.0
30    CONTINUE
C
C
      RO(4,4)=1.0
      RF(4,4)=1.0
      ROU(4,4)=1.0
      RFU(4,4)=1.0

      BRKSPGRP = ' '

C... mmdb fortran call to initialise
      CALL MMDB_F_INIT
C... mmdb mimic rwbrook
      CALL SIMRWBROOK(1)

      RETURN
      END
C
C
C
      SUBROUTINE RBINIT(IUNIT)
C     ========================
C
C_BEGIN_RBINIT
C
C      This routine is obsolete and should be removed.
C
C_END_RBINIT
C
C     .. Parameters ..
      INTEGER MAXFILESOPEN
      PARAMETER (MAXFILESOPEN=90)
C     ..
C     .. Scalar Arguments ..
      INTEGER IUNIT
C     ..
C     .. Local Scalars ..
      INTEGER I,J,IRET
C     ..
C     .. Scalars in Common ..
      INTEGER FILESOPEN,NCODE,ITYP
      LOGICAL IFHDOUT,IFNEWCRYS,IFCRYS,IFSCAL,MATRIX
C     ..
C     .. Arrays in Common ..
      REAL RF,RO
      INTEGER UNIT,TYPE
      CHARACTER LOGUNIT*80
C     ..
C     .. External Routines ..
      EXTERNAL MMDB_F_INIT,MMDB_F_REWD,SIMRWBROOK
C     ..
C     .. Common Blocks ..
      COMMON /RBRKAA/ FILESOPEN,LOGUNIT(MAXFILESOPEN),
     +                UNIT(MAXFILESOPEN),TYPE(MAXFILESOPEN)
      COMMON /RBRKXX/IFCRYS,IFSCAL,ITYP,MATRIX,IFHDOUT,IFNEWCRYS
      COMMON /ORTHOG/RO(4,4),RF(4,4),NCODE
      COMMON /ORTHOGU/ ROU(4,4),RFU(4,4)
C     ..
C     .. Save Statement ..
      SAVE /RBRKAA/,/RBRKXX/,/ORTHOG/
C     ..
C
C---- Make sure that MMDB_F_INIT is only called once. However,
C     this is not fool proof
C
      DO 10 I=1,10
        IF (IUNIT .EQ. UNIT(I)) GOTO 20
   10 CONTINUE

C...  mmdb, initialise and simulate rwbrook
      CALL MMDB_F_INIT 
      CALL SIMRWBROOK(1)

C...  mmdb, rewind channel
   20 CALL MMDB_F_REWD(IUNIT,IRET)
      IFCRYS=.FALSE.
      IFSCAL=.FALSE.
      MATRIX=.FALSE.
      NCODE=0
      ITYP=0
      IBRKFL=0
C
C
      DO 30 I=1,3
        DO 40 J=I+1,4
          RO(I,J)=0.0
          RO(J,I)=0.0
          RF(I,J)=0.0
          RF(J,I)=0.0
          ROU(I,J)=0.0
          ROU(J,I)=0.0
          RFU(I,J)=0.0
          RFU(J,I)=0.0
   40   CONTINUE
        RO(I,I)=1.0
        RF(I,I)=1.0
        ROU(I,I)=1.0
        RFU(I,I)=1.0
   30 CONTINUE
      RO(4,4)=1.0
      RF(4,4)=1.0
      ROU(4,4)=1.0
      RFU(4,4)=1.0


      RETURN
      END
C
C
C
      SUBROUTINE XYZOPEN(LOGNAM,RWSTAT,FILTYP,IUNIT,IFAIL)
C     =====================================================
C
C_BEGIN_XYZOPEN
C
C      Calls XYZOPEN2 which has an extra paramater for ignoring
C      Symmetry and Cryst cards
C
C Parameters:
C
C         LOGNAM (I)   CHARACTER*(*) but maximum of eight? The logical unit 
C                                    to which the file is assigned
C         RWSTAT (I)   CHARACTER*(*) if 'INPUT' then file is readonly
C                                    if 'OUTPUT' then file is an output file.
C         FILTYP (I)   CHARACTER*(*) if 'CIF' then the file type is treated as
C                                    CIF. If 'PDB' then the file type is 
C                                    treated as PDB. If blank then file type is
C                                    automatically determined for input files 
C                                    and for output file the file type will be
C                                    the same as the first file opened or 
C                                    defaulted to PDB.
C         IUNIT  (I/O) INTEGER       If zero then unit is decided else
C		  	             file opened on that unit
C                                    checked against previous data if 
C                                    applicable. NOT used with output files.
C         IFAIL  (I/O) INTEGER       On input    = 0 stop on failure 
C                                                = 1 continue on failure
C
C                                    On output   unchanged if OK
C                                                = -1  if error
C
C
C_END_XYZOPEN
C
C   
      implicit none
C     ..
C     .. Arguments ..
      INTEGER IUNIT, IFAIL,ICRYST
      CHARACTER*(*) FILTYP,LOGNAM,RWSTAT
      ICRYST = 0

      CALL XYZOPEN2(LOGNAM,RWSTAT,FILTYP,IUNIT,IFAIL,ICRYST)

      RETURN
      END
C
C
C
      SUBROUTINE XYZOPEN2(LOGNAM,RWSTAT,FILTYP,IUNIT,IFAIL,ICRYST)
C     =====================================================
C
C_BEGIN_XYZOPEN2
C
C      Opens a coordinate file for input or output. The channel number can
C be determined automatically or set on input. The header info.
C is also read: cell, orthog. matrix and symmetry.
C This is a version of XYZOPEN with an extra argument to flag whether or
C not the CRYST and SCALE cards are required.
C
C Parameters:
C
C         LOGNAM (I)   CHARACTER*(*) but maximum of eight? The logical unit 
C                                    to which the file is assigned
C         RWSTAT (I)   CHARACTER*(*) if 'INPUT' then file is readonly
C                                    if 'OUTPUT' then file is an output file.
C         FILTYP (I)   CHARACTER*(*) if 'CIF' then the file type is treated as
C                                    CIF. If 'PDB' then the file type is 
C                                    treated as PDB. If blank then file type is
C                                    automatically determined for input files 
C                                    and for output file the file type will be
C                                    the same as the first file opened or 
C                                    defaulted to PDB.
C         IUNIT  (I/O) INTEGER       If zero then unit is decided else
C		  	             file opened on that unit
C                                    checked against previous data if 
C                                    applicable. NOT used with output files.
C         IFAIL  (I/O) INTEGER       On input    = 0 stop on failure 
C                                                = 1 continue on failure
C
C                                    On output   unchanged if OK
C                                                = -1  if error
C
C         ICRYST (I/O) INTEGER       If zero, then check for and use CRYST
C                                    and SCALE cards in input PDB.
C                                    If one, ignore these cards even if
C                                    present.
C
C
C_END_XYZOPEN2
C
C   
      implicit none
C     .. Parameters ..
      INTEGER MAXFILESOPEN,MAXSYM
      PARAMETER (MAXFILESOPEN=90,MAXSYM=96)
      INTEGER RWBERR_Ok,RWBERR_NoMatrices
      PARAMETER (RWBERR_Ok=0,RWBERR_NoMatrices=-16)
C     ..
C     .. Arguments ..
      INTEGER IFAIL,IUNIT,ICRYST,II,III,JJ,K,ISYM
      REAL AM,BM,RCHK1,RCHK2,FAC
      CHARACTER*(*) FILTYP,LOGNAM,RWSTAT
C     ..
C     .. Variables in Common ..
      REAL CELL,CELLAS,RF,RO,RR,VOL,ROU,RFU
      INTEGER FILESOPEN,ITYP,NCODE,TYPE,UNIT
      CHARACTER*80 LOGUNIT,BRKSPGRP*15
      LOGICAL IFCRYS,IFHDOUT,IFNEWCRYS,IFSCAL,MATRIX
c  Check symmetry stuff
C
      integer  nsymchk,lspgrp,nsymppdbs,nsympdbs,ist
      real rsymchk(4,4,maxsym), rsympdbs(4,4,maxsym)
      character NAMSPG_CIFS*20,nampg*10
C     ..
C     .. Local Scalars ..
      REAL ERROR,VOLCHK
      INTEGER IRET
      INTEGER I,IORTH,IFILTYP,J,LL,ILEN,KLEN
      CHARACTER ERRLIN*600,FILNAM*255
      CHARACTER LFILTYP*3,LRWSTAT*5, SPGCHK*30
      CHARACTER*40 ORTH(6)
C     ..
C     .. Local Arrays ..
      REAL P(4,4)
      CHARACTER IEC(3)*2
C     ..
C     .. External Functions ..
      INTEGER LENSTR,CCPNUN
      LOGICAL CCPEXS
      EXTERNAL CCPEXS,LENSTR,CCPNUN
C     ..
C     .. External Routines ..
      EXTERNAL CCPDPN,CCPERR,CCPUPC,RBFROR,RBRINV,UGTENV,
     *          MMDB_F_OPENL,MMDB_F_RBSPGRP,RBERRSTOP,
     *          MMDB_F_RBCELL,MMDB_F_WBSPGRP,MMDB_F_RBORF

C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS
C     ..
C     .. Common Blocks ..
      COMMON /RBRKAA/ FILESOPEN,LOGUNIT(MAXFILESOPEN),
     +                UNIT(MAXFILESOPEN),TYPE(MAXFILESOPEN)
      COMMON /RBRKXX/IFCRYS,IFSCAL,ITYP,MATRIX,IFHDOUT,IFNEWCRYS
      COMMON /RBRKZZ/CELL(6),RR(3,3,6),VOL,CELLAS(6)
      COMMON /ORTHOG/RO(4,4),RF(4,4),NCODE
      COMMON /ORTHOGU/ ROU(4,4),RFU(4,4)
      COMMON /RBRKSPGRP/BRKSPGRP
C     ..
C     .. Save ..
      SAVE /RBRKAA/,/RBRKXX/,/RBRKZZ/,/ORTHOG/
C     ..
C     .. Data Statement ..
      DATA IEC /'E1','E2','E3'/
      DATA ORTH/'A // XO, C* // ZO (STANDARD PDB)',
     *          'B // XO, A* // ZO',
     *          'C // XO, B* // ZO',
     *          'HEX A+B // XO, C* // ZO',
     *          'A* // XO, C // ZO (ROLLETT)',
     *          'A // XO, B* // YO'/
C     ..
      I = 0
      II = 0
      IFILTYP = 1
      LL = 0
      LRWSTAT = RWSTAT
      LFILTYP = FILTYP
      CALL CCPUPC(LFILTYP)
      CALL CCPUPC(LRWSTAT)
C
C---- If too many files opened
C
      IF (FILESOPEN .EQ. MAXFILESOPEN) THEN
        CALL CCPERR(1,' *** ERROR: too many coordinate files open. ***')
      ENDIF
C...
C...  MMDB open channel (need to test for failures)
      FILNAM = ' '
      CALL UGTENV(LOGNAM,FILNAM)
      IF (LRWSTAT(1:5) .EQ. 'INPUT' .AND. FILNAM.EQ.' ') THEN
        CALL MMDB_F_OPEN(LOGNAM,LRWSTAT,LFILTYP,IUNIT,IRET)
      ELSEIF (LRWSTAT(1:5) .EQ. 'INPUT') THEN
        CALL MMDB_F_OPENL(LOGNAM,LRWSTAT,LFILTYP,IUNIT,IRET)
      ELSE
        IF (LFILTYP(1:1).EQ.' ' .AND. FILESOPEN.GE.1) THEN
          IF (ABS(TYPE(1)).EQ.1) THEN
            IFILTYP = 1
            LFILTYP = 'PDB'
          ELSEIF (ABS(TYPE(1)).EQ.2) THEN
            IFILTYP = 2
            LFILTYP = 'CIF'
          ENDIF
        ENDIF
        CALL MMDB_F_OPENL(LOGNAM,LRWSTAT,LFILTYP,IUNIT,IRET)
      ENDIF
      IF (IRET.NE.RWBERR_Ok) THEN
        IF (IRET.NE.RWBERR_NoMatrices) THEN
C...  MMDB error information
          CALL RBERRSTOP(1,IRET,IUNIT,1)
          ERRLIN = ' XYZOPEN: Error opening logical name '//LOGNAM
          IF (IFAIL .EQ. 0) THEN
            CALL CCPERR(1,ERRLIN(1:LENSTR(ERRLIN)))
          ELSE
            CALL CCPERR(2,ERRLIN(1:LENSTR(ERRLIN)))
            IFAIL = -1
            RETURN
          ENDIF
        ENDIF
      ENDIF
C
C==== If the file is an INPUT file
C
      IF (LRWSTAT(1:5) .EQ. 'INPUT') THEN
C
C---- Determine whether CIF or PDB
C
        IF (LFILTYP(1:1) .EQ. ' ') THEN
          FILESOPEN = FILESOPEN + 1
          LOGUNIT(FILESOPEN) = LOGNAM
          UNIT(FILESOPEN) = IUNIT
          TYPE(FILESOPEN) = 1
        ENDIF  
C
C---- If known as CIF
C
       IF (LFILTYP(1:3).EQ.'CIF' .OR. IFILTYP.EQ.2) THEN
          FILESOPEN = FILESOPEN + 1
          LOGUNIT(FILESOPEN) = LOGNAM
          UNIT(FILESOPEN) = IUNIT
          TYPE(FILESOPEN) = 2
        ENDIF
C
C---- If known as a PDB file
C
        IF (LFILTYP(1:3).EQ.'PDB') THEN
          FILESOPEN = FILESOPEN + 1
          LOGUNIT(FILESOPEN) = LOGNAM
          UNIT(FILESOPEN) = IUNIT
          TYPE(FILESOPEN) = 1
        ENDIF
C
C---- Cell card found - calculate standard orthogonalising matrix
C     Check if you already have a cell which is inconsistent with 
C     this one
C
        IF (ICRYST.EQ.0) THEN
            ITYP=1
            BRKSPGRP = ' '
C...  MMDB get spacegroup and cell (cache)
            CALL MMDB_F_RBSPGRP(IUNIT,SPGCHK,IRET)
            ILEN = LENSTR(SPGCHK)
            IF (ILEN.LE.1) THEN 
               CALL CCPERR(2,' No Space group given on PDB CRYST1 line')
            ELSE
               BRKSPGRP = SPGCHK
            ENDIF
C...
C...  MMDB get CELL and VOL for cache
            CALL MMDB_F_RBCELL(IUNIT,CELL,VOL,IRET)
            IF (IRET.EQ.0) THEN
              IFCRYS=.TRUE.
            ELSE
              IFCRYS=.FALSE.
            ENDIF
C...  MMDB get the orthogonalisation and fractional matrices
            RO(1,1) = 0.0
            CALL MMDB_F_RBORF(IUNIT,RO,RF,NCODE,IRET)
            IF (NCODE.LT.0) THEN
               ERRLIN = 
     +        'XYZOPEN2: Orthogonalisation code not determined.  '//
     +        'Possible disagreement between CRYST1 and SCALEx cards.'
               CALL CCPERR(2,ERRLIN(1:LENSTR(ERRLIN)))
            ENDIF
C IFSCAL indicates SCALEx cards found, MATRIX indicates RO,RF in /ORTHOG/ set up
            IF (IRET.EQ.0) THEN
              IFSCAL=.TRUE.
              MATRIX=.TRUE.
            ELSE
              IFSCAL=.FALSE.
              MATRIX=.FALSE.
            ENDIF
C
C If BRKSPGRP contains "/" it is probably a Patterson group and may
C occupy the full 15 characters. Else it may be from the PDB and
C may contain Z value which must be removed.

             IF (INDEX(BRKSPGRP,'/').EQ.0) BRKSPGRP(12:15) = ' '

C  Read symmetry operators.
             IF (BRKSPGRP.NE.' ') THEN
C  Consistency check for R and H space groups.
C      (using angles only)
C---- H name associated with a=b; Gamma = 120
                IF( BRKSPGRP(1:1) .EQ. 'R' ) THEN
                   IF(abs(cell(4)-90.0).LT.0.001 .AND.
     +                  abs(cell(5)-90.0).LT.0.001 .AND.
     +                  abs(cell(6)-120.0).LT.0.001) THEN
                      BRKSPGRP(1:1)='H'
                      CALL CCPERR(2,
     +                     ' Changing "rhombohedral" to "hexagonal"')
                      CALL MMDB_F_WBSPGRP(IUNIT,BRKSPGRP,IRET)
                   END IF
C---- R name associated with a=b=c; Alpha=Beta=Gamma 
                ELSE IF( BRKSPGRP(1:1) .EQ. 'H' ) THEN
                   IF(abs(cell(4)-cell(5)).LT.0.001.AND.
     +                  abs(cell(5)-cell(6)).LT.0.001.AND.
     +                  abs(cell(6)-cell(4)).LT.0.001) THEN
                      BRKSPGRP(1:1)='R'
                      CALL CCPERR(2,
     +                     ' Changing "hexagonal" to "rhombohedral"')
                      CALL MMDB_F_WBSPGRP(IUNIT,BRKSPGRP,IRET)
                   END IF
                END IF
C
             END IF
C...   set up standard orth matrices (cache)
            IF (IFCRYS) CALL RBFROR
          ENDIF
C
C==== If the file is an OUTPUT file
C
      ELSE

        IF (LFILTYP(1:3) .EQ. 'CIF') IFILTYP = 2 
        IF (LFILTYP(1:3) .EQ. 'PDB') IFILTYP = 1
C
C---- Open output PDB file
C
        IF (IFILTYP .EQ. 1) THEN
          FILESOPEN = FILESOPEN + 1
          LOGUNIT(FILESOPEN) = LOGNAM
          UNIT(FILESOPEN) = IUNIT
          TYPE(FILESOPEN) = -1
        ENDIF

        IF (IFILTYP .EQ. 2) THEN
          FILESOPEN = FILESOPEN + 1
          LOGUNIT(FILESOPEN) = LOGNAM
          UNIT(FILESOPEN) = IUNIT
          TYPE(FILESOPEN) = -2
        ENDIF
      ENDIF

C     Generate ROU and RFU for AnisoU stuff
       IF (MATRIX) THEN
         RFU(4,4) = 1.0
         DO I = 1,3
         FAC= SQRT(RF(I,1)*RF(I,1) + RF(I,2)*RF(I,2) +
     +              RF(I,3)*RF(I,3))
         RFU(I,1) = RF(I,1)/FAC
         RFU(I,2) = RF(I,2)/FAC
         RFU(I,3) = RF(I,3)/FAC
         RFU(I,4) = 0.0
         RFU(4,I) = 0.0
         END DO 
         CALL RBRINV(RFU,ROU)
       END IF 
C     If reading in: check SCAL and CRYST1 cards
      IF (IFILTYP.EQ.1 .AND. LRWSTAT(1:5).EQ.'INPUT' .AND. ICRYST.EQ.0)
     +              THEN
        IF (.NOT.IFCRYS) THEN
          WRITE(ERRLIN,FMT='(A,A)') ' NO CRYST CARDS READ FROM ',LOGNAM
          CALL CCPERR (2,ERRLIN(1:LENSTR(ERRLIN)))
        END IF
        IF (.NOT.IFSCAL) THEN
          WRITE(ERRLIN,FMT='(A,A)') ' NO SCALE CARDS READ FROM ',LOGNAM
          CALL CCPERR (2,ERRLIN(1:LENSTR(ERRLIN)))
        END IF
      END IF
      RETURN
      END
C
C
C
      SUBROUTINE XYZCLOSE(IUNIT)
C     ==========================
C
C_BEGIN_XYZCLOSE
C
C	This subroutine closes a coordinate file. 
C
C Parameters:
C
C         IUNIT  (I)   INTEGER    Unit number for file
C
C_END_XYZCLOSE
C
C     .. Parameters ..
      INTEGER MAXFILESOPEN
      PARAMETER (MAXFILESOPEN=90)
C     ..
C     .. Arguments ..
      INTEGER IUNIT
C     ..
C     .. Variables in Common ..
      INTEGER FILESOPEN, UNIT, TYPE
      CHARACTER*80 LOGUNIT
C     ..
C     .. Local Scalars ..
      INTEGER I,II,IRET
C     ..
      EXTERNAL MMDB_F_CLOSE
C     ..
C     .. Common Blocks ..
      COMMON /RBRKAA/ FILESOPEN,LOGUNIT(MAXFILESOPEN),
     +                UNIT(MAXFILESOPEN),TYPE(MAXFILESOPEN)
C     ..
C     .. Save ..
      SAVE /RBRKAA/
C     ..
C
      II = 0

      DO 10 I=1,FILESOPEN
        IF (UNIT(I) .EQ. IUNIT) THEN
          II = I
          GOTO  20
        ENDIF
   10 CONTINUE

   20 IF (II .NE. 0) THEN
        IF (FILESOPEN.NE.1 .AND. II.NE.FILESOPEN) THEN
          LOGUNIT(II) = LOGUNIT(FILESOPEN)
          UNIT(II) = UNIT(FILESOPEN)
          TYPE(II) = TYPE(FILESOPEN)
        ENDIF
        FILESOPEN = FILESOPEN - 1
      ENDIF

C... MMDB, close the channel (some info in cache)
      CALL MMDB_F_CLOSE(IUNIT,IRET)

      RETURN
      END
C
C
C
      SUBROUTINE XYZADVANCE(IUNIT,IOUT,ITER,*,*)
C     ==========================================
C
C_BEGIN_XYZADVANCE
C
C When IUNIT represents an input coordinate file, this subroutine reads 
C recognised data lines into a buffer BROOK, from which XYZATOM and 
C XYZCOORD can extract useful information. Optionally, if the card is 
C unrecognised (eg REMARK) then the line can be echoed to an output file.
C
C When IUNIT represents an output coordinate file, this subroutine writes 
C out the contents of the buffer WBROOK or WBROOK1. This buffer is filled
C from an input file, or by calls to XYZATOM and XYZCOORD.
C
C Parameters:
C
C      IUNIT  (I) Channel number of the coordinate file
C
C      These arguments are not relevant for output files.
C        IOUT (I) Logical unit number to which non-atom/hetatm/anisou records 
C                 are to be written (may be blank if reading only)
C        ITER (I) FLAG =1, return if 'ter' card found (via return 1)
C                      =0, do not return when 'ter' card found
C      RETURN 1   Return on TER card if ITER=1
C      RETURN 2   Return on end of file.
C
C_END_XYZADVANCE
C
C     .. Paramters ..
      INTEGER MAXFILESOPEN
      PARAMETER (MAXFILESOPEN=90)
      INTEGER RWBERR_Ok     
      PARAMETER (RWBERR_Ok=0)
C     ..
C     .. Arguments ..
      INTEGER IOUT,ITER,IUNIT
C     ..
C     .. Variables in Common ..
      REAL CELL,CELLAS,RF,RO,RR,VOL
      INTEGER FILESOPEN,NCODE,TYPE,UNIT
      CHARACTER LOGUNIT*80,BRKSPGRP*15
      LOGICAL IFCRYS,IFHDOUT,IFNEWCRYS,IFSCAL,MATRIX
C     ..
C     .. Local Variables ..
      INTEGER I,II,IRET,IRE,ITE
      CHARACTER*80 ERRLIN
      CHARACTER*6 ITYPE(7)
C     ..
C     .. External Routines ..
      EXTERNAL CCPERR,MMDB_F_COPY,MMDB_F_ADVANCE
C     ..
C     .. Common Blocks ..
      COMMON /RBRKAA/ FILESOPEN,LOGUNIT(MAXFILESOPEN),
     +                UNIT(MAXFILESOPEN),TYPE(MAXFILESOPEN)
      COMMON /RBRKXX/ IFCRYS,IFSCAL,ITYP,MATRIX,IFHDOUT,IFNEWCRYS
      COMMON /RBRKZZ/ CELL(6),RR(3,3,6),VOL,CELLAS(6)
      COMMON /ORTHOG/ RO(4,4),RF(4,4),NCODE
      COMMON /ORTHOGU/ ROU(4,4),RFU(4,4)
      COMMON /RBRKSPGRP/BRKSPGRP
C     ..
C     .. Save Statement ..
      SAVE /RBRKAA/,/RBRKXX/,/RBRKZZ/,/ORTHOG/

      II = 0
      DO 10 I=1,FILESOPEN
        IF (IUNIT .EQ. UNIT(I)) THEN
          II = I
          GOTO 15
        ENDIF
   10 CONTINUE

      ERRLIN = ' ERROR: in XYZADVANCE file has not been opened'
      CALL CCPERR(1,ERRLIN)
C
C...  opened read
 15   IF (TYPE(II).GT.0) THEN
C...    copying across
        IF (IOUT.NE.0) THEN
          IF(.NOT.IFHDOUT)THEN
            IF(IFCRYS .AND. .NOT.IFNEWCRYS) THEN
C..   MMDB, copy header information
              CALL MMDB_F_COPY(IOUT,IUNIT,2,IRE)
              IFHDOUT=.TRUE.
            ELSE 
C...  MMDB, copy header less CRYST1 cards
              CALL MMDB_F_COPY(IOUT,IUNIT,3,IRE)
            ENDIF
          ENDIF 
C...  MMDB, advance pointer allowing for TER cards
          CALL MMDB_F_ADVANCE(IUNIT,IOUT,ITER,IRET)
        ELSE
C...   MMDB, standard advance pointer
          CALL MMDB_F_ADVANCE(IUNIT,IOUT,ITER,IRET)
        ENDIF
      ELSE
        IF(.NOT.IFHDOUT .AND. IFCRYS) THEN
          CALL MMDB_F_WBSPGRP(IOUT,BRKSPGRP,IRE)
          CALL MMDB_F_WBCELL(IOUT,CELL,NCODE,IRE)
          IFHDOUT=.TRUE.
        ENDIF
        CALL MMDB_F_ADVANCE(IUNIT,IOUT,ITER,IRET)
      ENDIF

      IF (IRET.EQ.1) RETURN 1
      IF (IRET.EQ.2) RETURN 2
C
      END
C
C
C
      SUBROUTINE XYZATOM(IUNIT,ISER,ATNAM,RESNAM,CHNNAM,IRESN,
     *RESNO,INSCOD,ALTCOD,SEGID,IZ,ID)
C     ========================================================
C
C_BEGIN_XYZATOM
C
C	This subroutine reads or writes the atom name, residue name, 
C chain name etc. into the buffer. XYZADVANCE actually advances a line 
C or atom. The character strings have undefined length in order to make 
C change easier. However, these data items will be strictly defined in 
C the working format.
C
C Parameters:
C
C       IUNIT  (I)  Logical unit of the input coordinate file
C        ISER (I/O) Atom serial number
C       ATNAM (I/O) Atom name        (left justified)
C      RESNAM (I/O) Residue name     
C      CHNNAM (I/O) Chain name       
C       IRESN (I/O) Residue number as an integer
C       RESNO  (O)  Residue number as character, NOT used for output file
C      INSCOD (I/O) The insertion code
C      ALTCOD (I/O) The alternate conformation code.
C       SEGID (I/O) Segid is here to complete PDB standard.
C          IZ  (O)  Atomic number (returned as 7 from ambiguous atoms),
C                   NOT used for output file
C          ID (I/O) Atomic ID related to atomic number (element symbol
C                   right justified), plus the ionic state +2, +3 etc..
C
C_END_XYZATOM
C     
C     .. Paramters ..
      INTEGER MAXFILESOPEN
      PARAMETER (MAXFILESOPEN=90)
      INTEGER RWBERR_Ok,RWBWAR_MASK 
      PARAMETER (RWBERR_Ok=0,RWBWAR_MASK=16384)
      INTEGER RWBWAR_WrongSerial
      PARAMETER (RWBWAR_WrongSerial=16448)
C     ..
C     .. Arguments ..
      INTEGER IRESN,ISER,IUNIT,IZ
      CHARACTER*(*) RESNO,ATNAM,RESNAM,CHNNAM
      CHARACTER*(*) ID,INSCOD,ALTCOD,SEGID
      CHARACTER*6 ITYPE(7)
C     ..
C     .. Variables in Common ..
      INTEGER FILESOPEN,ITYP,UNIT,TYPE
      CHARACTER LOGUNIT*80
      LOGICAL IFCRYS,IFHDOUT,IFNEWCRYS,IFSCAL,MATRIX
C     ..
C     .. Local Scalars ..
      REAL U(6),OCC,X,Y,Z
      INTEGER I,II,IRET
      CHARACTER*100 ERRLIN
C     ..
C     .. External Routines/Functions ..
      EXTERNAL CCPERR,MMDB_F_ATOM,RBERRSTOP
C     ..
C     .. Common Blocks ..
      COMMON /RBRKAA/ FILESOPEN,LOGUNIT(MAXFILESOPEN),
     +                UNIT(MAXFILESOPEN),TYPE(MAXFILESOPEN)
      COMMON /RBRKXX/ IFCRYS,IFSCAL,ITYP,MATRIX,IFHDOUT,IFNEWCRYS
C
C     .. Save ..
      SAVE /RBRKAA/,/RBRKXX/
C     ..
c
      II = 0

      DO 10 I=1,FILESOPEN
        IF (IUNIT .EQ. UNIT(I)) THEN
          II = I
          GOTO 20
        ENDIF
   10 CONTINUE

      ERRLIN = ' ERROR: in XYZATOM file has not been opened'
      CALL CCPERR(1,ERRLIN)
C
   20 CALL MMDB_F_ATOM(IUNIT,ISER,ATNAM,RESNAM,CHNNAM,IRESN,
     +    RESNO,INSCOD,ALTCOD,SEGID,IZ,ID,IRET)
      IF (IRET.NE.RWBERR_Ok.AND.IRET.NE.RWBWAR_WrongSerial) 
     +  THEN
C...  MMDB error information
        CALL RBERRSTOP(1,IRET,IUNIT,0)
        IF (IAND(IRET,RWBWAR_MASK).EQ.0) THEN
          ERRLIN = ' ERROR: XYZATOM'
          CALL CCPERR(1,ERRLIN) 
        ENDIF
      ENDIF

      RETURN
      END
C
C
C
      SUBROUTINE XYZCOORD(IUNIT,XFLAG,BFLAG,X,Y,Z,OCC,BISO,U)
C     =======================================================
C
C_BEGIN_XYZCOORD
C
C	This subroutine reads or writes x, y, z, occupancy and b from/to 
C the internal buffer. The buffer is updated from the file by 
C XYZADVANCE. The coordinates can be input/output (to the subroutine) 
C as orthogonal or fractional. 
C
C  PDB files contain anisotropic temperature factors as orthogonal Us.
C The anisotropic temperature factors can be input/output to this routine 
C  as orthogonal or as crystallographic Us. 
C  
C  Shelx defines Uf to calculate temperature factor as:
C T(aniso_Uf) = exp (-2PI**2 ( (h*ast)**2 Uf_11 + (k*bst)**2 Uf_22 + ... 
C                            + 2hk*ast*bst*Uf_12 +..)
C
C   Note:   Uo_ji == Uo_ij and  Uf_ji == Uf_ij.
C
C  [Uo_ij] listed on ANISOU card satisfy  the relationship:
C  [Uo_ij] =   [RFu]-1 [Uf_ij] {[RFu]-1}T   C
C        where [Rfu] is the normalised [Rf] matrix read from the SCALEi cards.
C        see code.   [ROu] ==  [RFu]-1
C
C T(aniso_Uo) = U(11)*H**2 + U(22)*K**2 + 2*U(12)*H*K + ...
C where H,K,L are orthogonal reciprocal lattice indecies. ( EJD: I think????)
C
C Biso     = 8*PI**2 (Uo_11 + Uo_22 + Uo_33) / 3.0
C
C   [Uf(symm_j)] = [Symm_j] [Uf] [Symm_j]T
C
C Parameters:
C
C       IUNIT  (I)  Channel number of the input coordinate file
C       XFLAG  (I)  For input file
C                     ='F' will get fractional coords. 
C                     ='O' will get orthogonal coords.
C                   For output file
C                     ='F' passed coordinates are fractional
C                     ='O' passed coordinates are orthogonal
C       BFLAG  (I)  For input file
C                     ='F' will get fractional us
C                     ='O' will get orthogonal Us.
C                   For output file
C                     ='F' have fractional us
C                     ='O' have othogonal Us
C           X (I/O) Coordinates (orthogonal angstrom coordinates as
C           Y (I/O)     "        stored)
C           Z (I/O)     "
C         OCC (I/O) Occupancy
C        BISO  (O)  Isotropic temperature factor, NOT used for output file.
C        U(6) (I/O) Orthogonal Anisotropic temperature factor, unless only U(1) defined.
C
C_END_XYZCOORD
C     
C     .. Paramters ..
      INTEGER MAXFILESOPEN
      PARAMETER (MAXFILESOPEN=90)
      INTEGER RWBERR_Ok,RWBWAR_MASK
      PARAMETER (RWBERR_Ok=0,RWBWAR_MASK=16384)
C     ..
C     .. Arguments ..
      REAL U(6),BISO,X,Y,Z
      INTEGER IUNIT
      CHARACTER*1 BFLAG,XFLAG
C     ..
C     .. Variables in Common ..
      INTEGER FILESOPEN,ITYP,UNIT,TYPE
      CHARACTER LOGUNIT*80
      LOGICAL IFCRYS,IFHDOUT,IFNEWCRYS,IFSCAL,MATRIX
C     ..
C     .. Local Scalars ..
      REAL EIGHTPI2,XX,YY,ZZ
      INTEGER I,II,IRET
      INTEGER IRESN,ISER,IZ
      CHARACTER*100 ERRLIN
      CHARACTER ATNAM*4,RESNAM*4,RESNO*4,ID*4,CHNNAM*1,SEGID*4
C     ..
C     .. External Routines/Functions ..
      EXTERNAL CCPERR,MMDB_F_COORD,RBERRSTOP
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,NINT
C     ..
C     .. Common Blocks ..
      COMMON /RBRKAA/ FILESOPEN,LOGUNIT(MAXFILESOPEN),
     +                UNIT(MAXFILESOPEN),TYPE(MAXFILESOPEN)
      COMMON /RBRKXX/ IFCRYS,IFSCAL,ITYP,MATRIX,IFHDOUT,IFNEWCRYS
C     ..
C     .. Save ..
      SAVE /RBRKAA/,/RBRKXX/
C     ..
C     .. Data Statement ..
      DATA EIGHTPI2 /78.956835/

      II = 0
      DO 10 I=1,FILESOPEN
        IF (IUNIT .EQ. UNIT(I)) THEN
          II = I
          GOTO 20
        ENDIF
   10 CONTINUE

      ERRLIN = ' ERROR: in XYZCOORD has not been opened'
      CALL CCPERR(1,ERRLIN)

  20  CALL MMDB_F_COORD(IUNIT,XFLAG,BFLAG,X,Y,Z,OCC,BISO,U,IRET)
      IF (IRET.NE.RWBERR_Ok) THEN
C...  MMDB error information
        CALL RBERRSTOP(1,IRET,IUNIT,0)
        IF (IOR(IRET,RWBWAR_MASK).EQ.0) THEN
          ERRLIN = ' ERROR: XYZATOM'
          CALL CCPERR(1,ERRLIN)
        ENDIF
      ENDIF

      RETURN
      END
C
C
C
      SUBROUTINE XYZREWD(IUNIT)
C     =========================
C
C_BEGIN_XYZREWD
C
C	This routine is resets pointer to the begining of the file ie.
C rewind the file.
C
C Parameters:
C
C      IUNIT  (I) INTEGER  Channel number for file.
C
C_END_XYZREWD
C
C     .. Parameters ..
      INTEGER MAXFILESOPEN
      PARAMETER (MAXFILESOPEN=90)
      INTEGER RWBWAR_RewOutput
      PARAMETER (RWBWAR_RewOutput=34)
C     ..
C     .. Arguments ..
      INTEGER IUNIT
C     ..
C     .. Variables in Common ..
      INTEGER FILESOPEN,TYPE,UNIT
      CHARACTER*80 LOGUNIT
C     ..
C     .. Local Scalars ..
      INTEGER I,II
      CHARACTER*100 ERRLIN
C     ..
C     .. External Functions/Routines ..
      EXTERNAL CCPERR,MMDB_F_REWD
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS
C     ..
C     .. Common Blocks ..
      COMMON /RBRKAA/ FILESOPEN,LOGUNIT(MAXFILESOPEN),
     +                UNIT(MAXFILESOPEN),TYPE(MAXFILESOPEN)
C     ..
C     .. Save ..
      SAVE /RBRKAA/
C     ..
      II = 0
      DO 10 I=1,FILESOPEN
        IF (IUNIT .EQ. UNIT(I)) THEN
          II = I
          GOTO 20
        ENDIF
   10 CONTINUE

      ERRLIN = ' ERROR: in XYZREWD file has not been opened'
      CALL CCPERR(1,ERRLIN)

   20 CALL MMDB_F_REWD(IUNIT,IRET)
      IF (IRET.EQ. RWBWAR_RewOutput) THEN
        CALL CCPERR(2,
     +    ' WARNING: you are rewinding an output file!!')
      ENDIF

      RETURN
      END
C
C
C
      SUBROUTINE XYZBKSP(IUNIT)
C     =========================
C
C_BEGIN_XYZBKSP
C
C	This routine is the opposite to XYZADVANCE in that it retreats 
C one atom ie. backspacing.
C
C Parameters:
C
C      IUNIT  (I) INTEGER  Channel number for file.
C
C_END_XYZBKSP
C
C     .. Parameters ..
      INTEGER MAXFILESOPEN
      PARAMETER (MAXFILESOPEN=90)
      INTEGER RWBWAR_RewOutput 
      PARAMETER (RWBWAR_RewOutput=34)
C     ..
C     .. Arguments ..
      INTEGER IUNIT
C     ..
C     .. Variables in Common ..
      INTEGER FILESOPEN,TYPE,UNIT
      CHARACTER*80 LOGUNIT
C     ..
C     .. Local Scalars ..
      INTEGER I,II,IRET
      CHARACTER*100 ERRLIN
C     ..
C     .. External Functions/Routines ..
      EXTERNAL CCPERR,MMDB_F_BKSP
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS
C     ..
C     .. Common Blocks ..
      COMMON /RBRKAA/ FILESOPEN,LOGUNIT(MAXFILESOPEN),
     +                UNIT(MAXFILESOPEN),TYPE(MAXFILESOPEN)
C     ..
C     .. Save ..
      SAVE /RBRKAA/
C     ..
      II = 0
      DO 10 I=1,FILESOPEN
        IF (IUNIT .EQ. UNIT(I)) THEN
          II = I
          GOTO 20
        ENDIF
   10 CONTINUE

      ERRLIN = ' ERROR: in XYZBKSP file has not been opened'
      CALL CCPERR(1,ERRLIN)

   20 CALL MMDB_F_BKSP(IUNIT,IRET) 
      IF (IRET .EQ. RWBWAR_RewOutput) THEN
        CALL CCPERR(2,
     +    ' WARNING: you are backspacing an output file!!')
      ENDIF

      RETURN
      END
C
C
C
      SUBROUTINE RBROOK(IUNIT,ISER,ATNAM,RESNAM,CHNNAM,IRESN,RESNO,IS,
     *X,Y,Z,OCC,B,IZ,IOUT,MSG1,MSG2,ITER,*,*)
C     ================================================================
C
C_BEGIN_RBROOK
C
C      This subroutine is obsolete and should be removed. May be 
C PROBLEM in that routine returns orthogonal coordinates and not fractional
C ones.
C
C_END_RBROOK
C
C     .. Scalar Arguments ..
      REAL X,Y,Z,OCC,B
      INTEGER IUNIT,ISER,IRESN,IS,IOUT,IZ,MSG1,MSG2,ITER
      CHARACTER*(*) RESNO
      CHARACTER ATNAM*4,RESNAM*4,CHNNAM*1
C     ..
C     .. Local Scalars ..
      CHARACTER*4 ID,SEGID
      CHARACTER*1 INSCOD,ALTCOD
C     ..
C     .. Local Arrays ..
      REAL U(6)
C     ..
C     .. External Routines ..
      EXTERNAL XYZADVANCE,XYZATOM,XYZCOORD
C     ..
      IS = 0

   10 CALL XYZADVANCE(IUNIT,IOUT,ITER,*1000,*2000)
      CALL XYZCOORD(IUNIT,'O','U',X,Y,Z,OCC,B,U)
C
C---- Skip ANISOU card in PDB. Test on X, Y and Z are not strictly necessary
C     as routines can only read PDB currently.
C
      IF (U(2).NE.0.0 .AND. U(3).NE.0.0) THEN
        IF (X.EQ.0.0 .AND. Y.EQ.0.0 .AND. Z.EQ.0.0) GOTO 10
      ENDIF
      CALL XYZATOM(IUNIT,ISER,ATNAM,RESNAM,CHNNAM,IRESN,RESNO,INSCOD,
     +             ALTCOD,SEGID,IZ,ID)


      RETURN
 1000 RETURN 1
 2000 RETURN 2
      END
C
C
C
      SUBROUTINE WBROOK(IUNIT,ISER,ATNAM,RESNAM,CHNNAM,IRESN,IS,
     *X,Y,Z,OCC,B,IZ)
C     ================================================================
C
C_BEGIN_RBROOK
C
C      This subroutine is obsolete and should be removed. May be 
C PROBLEM in that routine does not cater for IS.
C
C_END_RBROOK
C
C     .. Scalar Arguments ..
      REAL X,Y,Z,OCC,B
      INTEGER IUNIT,ISER,IRESN,IS,IZ
      CHARACTER ATNAM*4,RESNAM*4,CHNNAM*1
C     ..
C     .. Local Scalars ..
      CHARACTER*4 ID,SEGID,RESNO
      CHARACTER*1 INSCOD,ALTCOD
C     ..
C     .. Local Arrays ..
      REAL U(6)
C     ..
C     .. External Routines ..
      EXTERNAL XYZADVANCE,XYZATOM,XYZCOORD
C     ..
      SEGID = ' '
      ID = ' '
      INSCOD = ' '
      ALTCOD = ' '
      RESNO = ' '
      DO 10 I=1,6
        U(I) = 0.0
   10 CONTINUE


      CALL XYZADVANCE(IUNIT,0,0,*1000,*1000)
      CALL XYZCOORD(IUNIT,'O','U',X,Y,Z,OCC,B,U)
      CALL XYZATOM(IUNIT,ISER,ATNAM,RESNAM,CHNNAM,IRESN,RESNO,INSCOD,
     +             ALTCOD,SEGID,IZ,ID)
C
C---- This label is here for completeness but is not used (see XYZADVANCE).
C
 1000 CONTINUE
      RETURN
      END
C
C
C
C     SUBROUTINE PDBREAD(ISER,ATNAM,RESNAM,CHNNAM,IRESN,RESNO,
C    *X,Y,Z,OCC,U,IZ,SEGID,ID)
C     ========================================================
C
C_BEGIN_PDBREAD
C
C      The subroutine PDBREAD is used to read coordinates from a PDB
C format coordinate file. This routine should not be used stand alone 
C but through XYZADVANCE.
C 
C Parameters
C
C        ISER (O) Atom serial number
C       ATNAM (O) Atom name        (character*4 left justified)
C      RESNAM (O) Residue name     (character*4)
C      CHNNAM (O) Chain name       (character*1)
C       IRESN (O) Residue number as an integer
C       RESNO (O) Residue number   (character*4 or character*5)
C                 If character*5 then the 5th character will be the
C                 insertion code.
C           X (O) Coordinates (orthogonal angstrom coordinates as
C           Y (O)     "        stored)
C           Z (O)     "
C         OCC (O) Occupancy
C        U(6) (O) Temperature factor
C          IZ (O) Atomic number (returned as 7 from ambiguous atoms)
C          ID (O) Atomic ID related to atomic number + ionic state. 
C                 (character*4)
C
C  COMMON BLOCKS
C
C  COMMON /RBRKXX/IFCRYS,IFSCAL,ITYP,MATRIX
C
C      IFCRYS   .TRUE. IF 'CRYST1' CARD READ,  OTHERWISE .FALSE.
C      IFSCAL   .TRUE. IF 'SCALE' CARDS READ, OTHERWISE .FALSE.
C       ITYP    TYPE OF LAST CARD READ =1, 'CRYST1'
C                                      =2, 'SCALE'
C                                      =3, 'TER'
C                                      =4, 'ATOM'
C                                      =5, 'HETATM'
C     MATRIX    .TRUE. IF FRACT/ORTHOG MATRICES CALCULATED
C               .FALSE. IF NOT
C
C
C      BROOK    CHARACTER*1 ARRAY WHICH IS THE BUFFER FOR PDB FILES
C
C      COMMON/RBRKZZ/CELL(6),RR(3,3,6),VOL,CELLAS(6)
C
C       CELL    CELL DIMENSIONS FROM 'CRYST1' CARD IF READ
C               (CHECK IFCRYS)
C         RR    STANDARD ORTHOGONALISING MATRICES CALCULATED IF THE
C               'CRYST1' CARD WAS READ (CHECK IFCRYS)
C
C  COMMON /ORTHOG/RO(4,4),RF(4,4),NCODE
C
C        RO    ORTHOGONALISING MATRIX (ONLY SET IF 'CRYST1' OR 'SCALE'
C              CARDS PRESENT - CHECK 'MATRIX' FLAG)
C        RF    FRACTIONALISING MATRIX (ONLY SET IF 'CRYST1' OR 'SCALE'
C              CARDS PRESENT - CHECK 'MATRIX' FLAG)
C     NCODE    FLAG INDICATING SETTING FOUND, 0 IF NOT ONE THAT WAS
C              RECOGNISED
C
C_END_PDBREAD
C
C
C     .. Parameters ..
C     INTEGER MAXIATM, MAXIHATM
C     PARAMETER (MAXIATM=102,MAXIHATM=14)
C     ..
C     .. Arguments ..
C     REAL U(6),OCC,X,Y,Z
C     INTEGER IRESN,ISER,IZ
C     CHARACTER*(*) RESNO
C     CHARACTER ATNAM*4,CHNNAM*1,ID*4,RESNAM*4,SEGID*4
C     ..
C     .. Variables in Common ..
C     REAL CELL,CELLAS,RF,RO,RR,VOL
C     INTEGER ITYP,NCODE
C     CHARACTER BROOK*1,WBROOK*1,WBROOK1*1
C     LOGICAL IFCRYS,IFSCAL,IFTER,MATRIX,IFHDOUT,IFNEWCRYS
C     ..
C     .. Local Scalars ..
C     INTEGER I,II,J
C     CHARACTER*100 ERRLIN
C     CHARACTER*80 BROOKA
C     CHARACTER*4 IRTYPE
C     CHARACTER*2 IAA,IAT,IE
C     CHARACTER*1 ISP
C     ..
C     .. Local Arrays ..
C     INTEGER IU(6)
C     CHARACTER*40 ORTH(5)
C     CHARACTER*2 IATM(MAXIATM),IHATM(MAXIHATM)
C     ..
C     .. External Routines/Functions ..
C     INTEGER LENSTR
C     EXTERNAL CCPERR,CCPUPC,LENSTR
C     ..
C     .. Intrinsic Functions ..
C     INTRINSIC ABS
C     ..
C     .. Common Blocks ..
C     COMMON /RBRKXX/IFCRYS,IFSCAL,ITYP,MATRIX,IFHDOUT,IFNEWCRYS
C     COMMON/RBRKZZ/CELL(6),RR(3,3,6),VOL,CELLAS(6)
C     COMMON /ORTHOG/RO(4,4),RF(4,4),NCODE
C     COMMON /ORTHOGU/ ROU(4,4),RFU(4,4)
C     ..
C     .. Equivalences ..
C     EQUIVALENCE (IRTYPE,BROOK(1)),(IE,BROOK(5)),(BROOKA,BROOK(1))
C     ..
C     .. Save ..
C     SAVE /RBRKXX/,/RBRKZZ/,/ORTHOG/
C     ..
C     .. Data Statement ..
C     DATA IATM/' H','HE','LI','BE',' B',' C',' N',' O',' F','NE',
C    *          'NA','MG','AL','SI',' P',' S','CL','AR',' K','CA',
C    *          'SC','TI',' V','CR','MN','FE','CO','NI','CU','ZN',
C    *          'GA','GE','AS','SE','BR','KR','RB','SR',' Y','ZR',
C    *          'NB','MO','TC','RU','RH','PD','AG','CD','IN','SN',
C    *          'SB','TE',' I','XE','CS','BA','LA','CE','PR','ND',
C    *          'PM','SM','EU','GD','TB','DY','HO','ER','TM','YB',
C    *          'LU','HF','TA',' W','RE','OS','IR','PT','AU','HG',
C    *          'TL','PB','BI','PO','AT','RN','FR','RA','AC','TH',
C    *          'PA',' U','NP','PU','AM','CM','BK','CF','ES','FM',
C    *          ' D','AN'/
C     DATA IHATM/'0H','1H','2H','3H','4H','5H','6H','7H','8H','9H',
C    +           'HH','*H',"'H",'"H'/
C     DATA IAA/' A'/,ISP/' '/
C     DATA ORTH/'A // XO, C* // ZO (STANDARD PDB)',
C    *          'B // XO, A* // ZO',
C    *          'C // XO, B* // ZO',
C    *          'HEX A+B // XO, C* // ZO',
C    *          'A* // XO, C // ZO (ROLLETT)'/
C      DATA ITYPE/'CRYS','SCAL','TER ','ATOM','HETA','ANIS','END'/
C
C
C     IFTER=.FALSE.
C
C---- Atom/hetatm card processing
C
C     IF (IRTYPE.EQ.'ATOM' .OR. IRTYPE.EQ.'HETA' .OR.
C    +    IRTYPE.EQ.'ANIS' .OR. IRTYPE.EQ.'TER ') THEN
C       IF (IRTYPE.EQ.'TER ') THEN
C
C---- 'ter' card found
C
C         ITYP=3
C         IFTER=.TRUE.
C         GO TO 450
C       ENDIF
C       IF(BROOK(13).EQ.ISP) then
C
C----   ATNAM (O) Atom name  (character*4 left justified)
C
C         ATNAM=BROOK(14)//BROOK(15)//BROOK(16)//' '
C
C---- atnam should never had ALTCODE added to it 
C
C        else
C         ATNAM=BROOK(13)//BROOK(14)//BROOK(15)//BROOK(16)
C        end if
C
C
C450    READ(BROOKA,1006)ISER,IRESN
C       RESNAM=BROOK(18)//BROOK(19)//BROOK(20)//ISP
C       RESNO=BROOK(23)//BROOK(24)//BROOK(25)//BROOK(26)
C       IF(LEN(RESNO).GT.4)RESNO(5:5)=BROOK(27)
C       CHNNAM=BROOK(22)
C       IF(IFTER)GO TO 500
C       SEGID = BROOK(73)//BROOK(74)//BROOK(75)//BROOK(76)
C
C---- Find atomic number and ID, ID can be kept in columns 77-80
C
C       ID = BROOK(77)//BROOK(78)//BROOK(79)//BROOK(80)
C       CALL CCPUPC(ID)
C       IAT=BROOK(13)//BROOK(14)
C       CALL CCPUPC(IAT)
C
C---- Fast initial check for C, O, N or H
C       II = 0
C       IF (ID(1:4) .NE. '    ') THEN
C         IF (ID(1:2) .EQ. IATM(6)) THEN
C           II = 6
C           GOTO 480
C         ENDIF
C         IF (ID(1:2) .EQ. IATM(7)) THEN
C           II = 7
C           GOTO 480
C         ENDIF
C         IF (ID(1:2) .EQ. IATM(8)) THEN
C           II = 8
C           GOTO 480
C         ENDIF
C         IF (ID(1:2) .EQ. IATM(1)) THEN
C           II = 1
C           GOTO 480
C         ENDIF
C
C---- Must be a different element - check against all
C     possibilities, which is slower
C         DO 452 I=1,MAXIATM
C           IF (ID(1:2) .EQ. IATM(I)) THEN
C             II = I
C             GOTO 480
C           ENDIF
C452      CONTINUE
C       END IF 
C
C     If no ID match then make sure it is reset to be empty
C
C       ID = '    '
C
C     Check against first characters of atom name:
C
C---- Initial fast check against C, O, N or H
C       IF (IAT.EQ.IATM(6)) THEN
C         II = 6
C         GO TO 480
C       ENDIF
C       IF (IAT.EQ.IATM(7)) THEN
C         II = 7
C         GO TO 480
C       ENDIF
C       IF (IAT.EQ.IATM(8)) THEN
C         II = 8
C         GO TO 480
C       ENDIF
C       IF (IAT.EQ.IATM(1)) THEN
C         II = 1
C         GO TO 480
C       ENDIF
C
C---- Could be a hydrogen? Check for things like 0H, HH, etc
C       II=1
C       DO 454 J=1,MAXIHATM
C         IF (IAT.EQ.IHATM(J)) GO TO 480
C454    CONTINUE
C
C---- Must be a different element - check everything else
C       DO 456 I=1,MAXIATM
C         IF (IAT.EQ.IATM(I)) THEN
C           II = I
C           Should issue a warning if AC or AN to the effect that this
C           is based on ambigious input and should be checked
C           IF (II.EQ.89 .OR. II.EQ.102) THEN
C             WRITE(ERRLIN,2002)ATNAM,RESNAM,RESNO(1:4),IATM(II)
C             CALL CCPERR(2,ERRLIN)
C           END IF
C           GO TO 480
C         ENDIF
C456    CONTINUE
C
C---- No match for ID to anything using the first 2 characters
C     of the atom name
C
C  If the atom name begins with " A" set the atom_type to N
C  " A" is an ambigious atom name so presumably using N is
C  just a default?
C  Otherwise it's completely unknown
C
C       II=0
C       IF(IAT.EQ.IAA) II=7
C
C  Ambigious name...
C       IF (II .EQ. 7) THEN
C         WRITE(ERRLIN,2002)ATNAM,RESNAM,RESNO(1:4),IATM(II)
C         CALL CCPERR(2,ERRLIN)
C       ELSE
C
C---- II is zero so try some other tricks to get a match
C
C     Desperate measure: try to match second character only - 
C     This will deal with the NO7* horrors..
C         IF (IAT(1:1).NE.' ') THEN
C           IAT = ' '//BROOK(14)
C           DO I=1,MAXIATM
C             IF (IAT.EQ.IATM(I)) THEN
C               II = I
C               Issue a warning about this match since it
C               is based on incomplete data and assumptions
C               WRITE(ERRLIN,2002)ATNAM,RESNAM,RESNO(1:4),IATM(II)
C               CALL CCPERR(2,ERRLIN)
C               GO TO 480
C             ENDIF
C           END DO
C         ENDIF
C       END IF
C
C Still completely unrecognised... give up
C
C       IF (II .EQ. 0) THEN
C         WRITE(ERRLIN,2001)ATNAM,RESNAM,RESNO(1:4)
C         CALL CCPERR(2,ERRLIN)
C       END IF
C
C---- Atom number decided
C480    IZ=II
C
C        IF (IZ .EQ. 0) THEN
C          ID = ' '
C       ELSE 
C
C---- Keep the ionic state if valid, OR from atom name.
C
C         IF (ID(1:1) .EQ. ' ') THEN
C           IF (ATNAM(3:3).EQ.'+' .OR. ATNAM(3:3).EQ.'-') 
C    +                                       ID(3:4) = ATNAM(3:4)
C         ELSE
C           IF (ID(3:3).NE.'+' .AND. ID(3:3).NE.'-') ID(3:4) = '  '
C         ENDIF
C         ID(1:2) = IATM(IZ)
C       ENDIF
C
C---- Put elment ID into output buffer.
C
C       DO 485 J=1,4
C         WBROOK(76+J) = ID(J:J)
C         WBROOK1(76+J) = ID(J:J)
C485    CONTINUE
C        IF (IRTYPE .EQ. 'ATOM'.or.IRTYPE.EQ.'HETA') THEN
C  This is the ONLY flag that you have read a ATOM or HETATOM card..
C         DO 40 I=1,6
C           U(I) = 0.0
C  40     CONTINUE
C           IF (IRTYPE.EQ.'ATOM') ITYP=4
C           IF (IRTYPE.EQ.'HETA') ITYP=5
C         READ(BROOKA,1005)X,Y,Z,OCC,U(1)
C
C---- AnisoU cards
C
C       ELSE IF (IRTYPE .EQ. 'ANIS') THEN
C
C       READ(BROOKA,1010)IU(1),IU(2),IU(3),IU(4),IU(5),IU(6)
C       DO 510 I=1,6
C         U(I) = IU(I)/1.0E+04
C510    CONTINUE
C  Get rid of this, sometimes useful to know xyz 
C   use values of U(i) to check for ANISOU 
C       X = 0.0
C       Y = 0.0
C       Z = 0.0
C       ENDIF
C
C       RETURN        
C     ENDIF

C500  RETURN
C
C---- Format statements
C
C1005  FORMAT(30X,3F8.3,2F6.2)
C1006  FORMAT(6X,I5,11X,I4)
C1010  FORMAT(28X,6I7)
C2001  FORMAT(' *UNKNOWN ATOMIC FORMFACTOR ',A4,' IN ',A4,1X,A4,'*')
C2002  FORMAT(' *AMBIGUOUS ATOMIC FORMFACTOR ',A4,' IN ',A4,1X,A4,
C    +     ' ASSIGNED AS ',A2,' *')
C     END
C
C
C
      SUBROUTINE RBFRAC2(A,B,C,AL,BE,GA,ARGNCODE)
C     ===========================================
C
C_BEGIN_RBFRAC2
C
C
C This subroutine is used to calculate the default transformation
C matrices between orthogonal angstrom and fractional coordinates
C The sensible name is for Phil, as RBFRAC2 was changed from the original.
C
C
C PARAMETERS
C
C    A,B,C,AL,BE,GA (I) (REAL)     CELL PARAMETERS IN ANGSTROMS AND DEGREES
C    ARGNCODE       (I) (INTEGER)  ORTHOGONALISATION CODE 1-6
C
C_END_RBFRAC2
C
C     .. Arguments ..
      REAL A,B,C,AL,BE,GA
      INTEGER ARGNCODE
C     ..
C     .. Variables in Common ..
      REAL CELL,CELLAS,RF,RO,RR,VOL
      INTEGER ITYP,NCODE
      LOGICAL IFCRYS,IFSCAL,MATRIX,IFHDOUT,IFNEWCRYS
C     ..
C     .. External Routines ..
      EXTERNAL CCPERR,RBRINV
C     ..
C     .. Common Blocks ..
      COMMON /RBRKXX/IFCRYS,IFSCAL,ITYP,MATRIX,IFHDOUT,IFNEWCRYS
      COMMON /ORTHOG/RO(4,4),RF(4,4),NCODE
      COMMON /RBRKZZ/CELL(6),RR(3,3,6),VOL,CELLAS(6)
C     ..
C     .. Save Statement ..
      SAVE /RBRKXX/,/ORTHOG/,/RBRKZZ/
C     ..
      IF (ARGNCODE.NE.0) NCODE = ARGNCODE
C
C---- Calculate matrices
C

      DO 10 I=1,4
      DO 10 J=1,4
      RO(I,J)=0
      RF(I,J)=0
10    CONTINUE
C
C
      RO(4,4)=1.0
      RF(4,4)=1.0
      CELL(1)=A
      CELL(2)=B
      CELL(3)=C
      CELL(4)=AL
      CELL(5)=BE
      CELL(6)=GA
      CALL RBFROR
C
C
      DO 20 I=1,3
      DO 20 J=1,3
      RO(I,J)=RR(I,J,1)
20    CONTINUE
C
C
      CALL RBRINV(RO,RF)
      MATRIX=.TRUE.
      CALL CCPERR(4,' ')
      CALL CCPERR(4,
     +     ' STANDARD PDB COORDINATE SETTING WILL BE ASSUMED')
      CALL CCPERR(4,
     +     ' IF NO SCALE CARDS PRESENT  IN  INPUT  COORDINATE  FILE')
      CALL CCPERR(4,' ')

      RETURN
      END
C
C
C
      SUBROUTINE RBFRAC(A,B,C,AL,BE,GA,MSG)
C     =====================================
C
C_BEGIN_RBFRAC
C
C	This routine is obsolete and should be removed.
C
C_END_RBFRAC
C
C     .. Scalar Arguments ..
      REAL A,B,C,AL,BE,GA
      INTEGER MSG
C     ..
C     .. External Routines ..
      EXTERNAL RBFRAC2
C     ..
      CALL RBFRAC2(A,B,C,AL,BE,GA,1)

      RETURN
      END
C
C
C
      SUBROUTINE RBRORF(ROO,RFF)
C     ==========================
C
C_BEGIN_RBRORF
C
C	This routine is obsolete and should be removed.
C
C      SUBROUTINE RBRORF(ROO,RFF)
C
C     Subroutine to  fill or return RF (fractionalising) and Ro
C     (orthogonalising) matrices. 
C
C PARAMETERS
C
C          ROO (I) (REAL(4,4))  4*4 MATRIX TO BE INVERTED
C          RFF (O) (REAL(4,4))  INVERSE MATRIX
C
C common blocks
C
C
C
      DIMENSION ROO(4,4),RFF(4,4)
C
      LCODE = 0
      CALL RBRORF2(ROO,RFF,LCODE)
      END
C
C
C
      SUBROUTINE RBRORF2(ROO,RFF,LCODE)
C     ==========================
C
C_BEGIN_RBRORF
C
C      SUBROUTINE RBRORF2(ROO,RFF,LCODE)
C
C     Subroutine to  fill or return RF (fractionalising) and Ro
C     (orthogonalising) matrices. 
C
C PARAMETERS
C
C          ROO (I) (REAL(4,4))  4*4 MATRIX TO BE INVERTED
C          RFF (O) (REAL(4,4))  INVERSE MATRIX
C
C common blocks
C
C      COMMON /RBRKXX/IFCRYS,IFSCAL,ITYP,MATRIX
C      COMMON /ORTHOG/RO(4,4),RF(4,4),NCODE
C
C_END_RBRORF

      LOGICAL IFCRYS,IFSCAL,MATRIX,IFHDOUT,IFNEWCRYS
      COMMON /RBRKXX/IFCRYS,IFSCAL,ITYP,MATRIX,IFHDOUT,IFNEWCRYS
      COMMON /ORTHOG/RO(4,4),RF(4,4),NCODE
      SAVE /ORTHOG/, /RBRKXX/
C
C
      DIMENSION ROO(4,4),RFF(4,4)
C
C---- Get cofactors of 'a' in array 'c'
C
      IF(ROO(1,1) .LE.0.0000000001) THEN 
        DO 40 II=1,4
        DO 30 JJ=1,4
        RFF(II,JJ)=RF(II,JJ)
        ROO(II,JJ)=RO(II,JJ)
30      CONTINUE
40      CONTINUE
        LCODE = NCODE
        RETURN
      END IF
C  FILL...
      IF(ROO(1,1) .GT.0.0000000001) THEN 
        DO 50 II=1,4
        DO 60 JJ=1,4
        RF(II,JJ)=RFF(II,JJ)
        RO(II,JJ)=ROO(II,JJ)
60      CONTINUE
50      CONTINUE
        NCODE = LCODE
        MATRIX = .TRUE.
        RETURN
      END IF
      END
C
C
      SUBROUTINE RBRINV(A,AI)
C     =======================
C
C_BEGIN_RBRINV
C
C      SUBROUTINE RBRINV(A,AI)
C
C
C Subroutine to invert 4*4 matrices for conversion between
C fractional and orthogonal axes. 
C
C
C PARAMETERS
C
C           A (I) (REAL(4,4))  4*4 MATRIX TO BE INVERTED
C          AI (O) (REAL(4,4))  INVERSE MATRIX
C
C_END_RBRINV
C
      REAL A(4,4),AI(4,4),C(4,4),X(3,3)
C
C---- Get cofactors of 'a' in array 'c'
C
      DO 40 II=1,4
      DO 30 JJ=1,4
      I=0
      DO 20 I1=1,4
      IF(I1.EQ.II)GO TO 20
      I=I+1
      J=0
      DO 10 J1=1,4
      IF(J1.EQ.JJ)GO TO 10
      J=J+1
      X(I,J)=A(I1,J1)
10    CONTINUE
20    CONTINUE
      AM=X(1,1)*X(2,2)*X(3,3)-X(1,1)*X(2,3)*X(3,2)+X(1,2)*X(2,3)*X(3,1)
     *  -X(1,2)*X(2,1)*X(3,3)+X(1,3)*X(2,1)*X(3,2)-X(1,3)*X(2,2)*X(3,1)
      C(II,JJ)=(-1)**(II+JJ)*AM
30    CONTINUE
40    CONTINUE
C
C---- Calculate determinant
C
      D=0
      DO 50 I=1,4
      D=D+A(I,1)*C(I,1)
50    CONTINUE
C
C---- Get inverse matrix
C
      DO 70 I=1,4
      DO 60 J=1,4
      AI(I,J)=C(J,I)/D
60    CONTINUE
70    CONTINUE
      RETURN
      END
C
C
C
C
      SUBROUTINE RBFROR
C     =================
C
C_BEGIN_RBFROR
C
C      SUBROUTINE RBFROR
C
C THIS SUBROUTINE CALCULATES MATRICES FOR STANDARD ORTHOGONALISATIONS
c   and cell volume
C
C  this generates the various orthogonalising matrices
C     ' NCODE =1 -  ORTHOG AXES ARE DEFINED TO HAVE'
C                    A PARALLEL TO XO   CSTAR PARALLEL TO ZO'
C     ' NCODE =2 -  ORTHOG AXES ARE DEFINED TO HAVE'
C     '               B PARALLEL TO XO   ASTAR PARALLEL TO ZO'
C     ' NCODE =3 -  ORTHOG AXES ARE DEFINED TO HAVE'
C     '               C PARALLEL TO XO   BSTAR PARALLEL TO ZO'
C     ' NCODE =4 -  ORTHOG AXES ARE DEFINED TO HAVE'
C     '         HEX A+B PARALLEL TO XO   CSTAR PARALLEL TO ZO'
C     ' NCODE =5 -  ORTHOG AXES ARE DEFINED TO HAVE'
C     '           ASTAR PARALLEL TO XO       C PARALLEL TO ZO'
C     ' NCODE =6 -  ORTHOG AXES ARE DEFINED TO HAVE'
C                    A  PARALLEL TO XO   BSTAR PARALLEL TO YO'
C
C   SET UP MATRICES TO ORTHOGONALISE H K L AND X Y Z FOR THIS CELL.
C
C Common Blocks
C
C     .. Scalar Arguments ..
      REAL VOLL
C     ..
C     .. Array Arguments ..
      REAL CEL(6),RRR(3,3,6)
C
C      COMMON/RBRKZZ/CELL(6),RR(3,3,6),VOL,CELLAS(6)
C      COMMON /RBREC/AC(6)
C
C_END_RBFROR
C
      COMMON/RBRKZZ/CELL(6),RR(3,3,6),VOL,CELLAS(6)
      COMMON /RBREC/AC(6)
      SAVE /RBRKZZ/, /RBREC/
C
C---- Initialisations
C
        DO I = 1,6
         CEL(I)=CELL(I)
        END DO
        VOLL = VOL
      CALL RBFRO1(CEL,VOLL,RRR)
C
      RETURN
      END
C
C
C     ===============================
      SUBROUTINE RBFRO1(CEL,VOLL,RRR)
C     ===============================
C
C_BEGIN_RBFRO1
C
C      SUBROUTINE RBFRO1(CEL,VOLL,RRR)
C
C---- This subroutine is a duplicate of rbfror with a different call.
C
C PARAMETERS
C
C   CEL  (I) (REAL(6))     Cell dimensions
C   VOLL (O) (REAL)        Cell volume
C   RRR  (O) (REAL(3,3,6)) Standard orthogonisational matrices
C
C_END_RBFRO1
C
C THIS SUBROUTINE CALCULATES MATRICES FOR STANDARD ORTHOGONALISATIONS
c   and cell volume
C
C  this generates the various orthogonalising matrices
C     ' NCODE =1 -  ORTHOG AXES ARE DEFINED TO HAVE'
C                    A PARALLEL TO XO   CSTAR PARALLEL TO ZO'
C     ' NCODE =2 -  ORTHOG AXES ARE DEFINED TO HAVE'
C     '               B PARALLEL TO XO   ASTAR PARALLEL TO ZO'
C     ' NCODE =3 -  ORTHOG AXES ARE DEFINED TO HAVE'
C     '               C PARALLEL TO XO   BSTAR PARALLEL TO ZO'
C     ' NCODE =4 -  ORTHOG AXES ARE DEFINED TO HAVE'
C     '         HEX A+B PARALLEL TO XO   CSTAR PARALLEL TO ZO'
C     ' NCODE =5 -  ORTHOG AXES ARE DEFINED TO HAVE'
C     '           ASTAR PARALLEL TO XO       C PARALLEL TO ZO'
C     ' NCODE =6 -  ORTHOG AXES ARE DEFINED TO HAVE'
C                    A  PARALLEL TO XO   BSTAR PARALLEL TO YO'
C
C   SET UP MATRICES TO ORTHOGONALISE H K L AND X Y Z FOR THIS CELL.
C
C     .. Scalar Arguments ..
      REAL VOLL
C     ..
C     .. Array Arguments ..
      REAL CEL(6),RRR(3,3,6)
C     ..
C     .. Scalars in Common ..
      REAL VOL
C     ..
C     .. Arrays in Common ..
      REAL AC,CELL,CELLAS,RR
C     ..
C     .. Local Scalars ..
      REAL A,ALPH,ALPHAS,AS,B,BET,BETAS,BS,C,CONV,COSA,COSAS,COSB,COSBS,
     +     COSG,COSGS,CS,FCT,GAMM,GAMMAS,SINA,SINAS,SINB,SINBS,SING,
     +     SINGS,SUM,V
      INTEGER I,J,K,N,NCODE
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ATAN2,COS,SIN,SQRT
C     ..
C     .. Common blocks ..
      COMMON /RBREC/AC(6)
      COMMON /RBRKZZ/CELL(6),RR(3,3,6),VOL,CELLAS(6)
C     ..
C     .. Save statement ..
      SAVE /RBRKZZ/, /RBREC/
C     ..
C
C---- Initialisations
C
      CELDEL = 0.0
      IF (CEL(1).GT.0.0) THEN
        IF (CELL(1).GT.0.0) THEN
          IWARN = 0
          DO 101 I = 1,6
            CELDEL = ABS(CEL(I)-CELL(I))/CEL(I)
            IF (CELDEL.GT.0.01) IWARN = 1
 101      CONTINUE
          IF(IWARN.NE.0) WRITE(6,9876)CELL,CEL
9876      FORMAT(' Inconsistency in Cell Dimensions - replacing old:',
     +      /,' Old cell:',3X,6F10.5,/,' New cell:',3X,6F10.5)
        ENDIF
        DO 10 I = 1,6
          CELL(I) = CEL(I)
          IF (CELL(I).EQ.0.0) call ccperr(1,
     +' **** Incorrect (0.0) CELL element in  subroutine rbfro1?? ****')
   10   CONTINUE
      ENDIF
C
C
      CONV = 3.14159/180.0
      FCT = 8.0*3.14159*3.14159
      ALPH = CELL(4)*CONV
      BET = CELL(5)*CONV
      GAMM = CELL(6)*CONV
      SUM = (ALPH+BET+GAMM)*0.5
      V = SQRT(SIN(SUM-ALPH)*SIN(SUM-BET)*SIN(SUM-GAMM)*SIN(SUM))
      VOL = 2.0*CELL(1)*CELL(2)*CELL(3)*V
      SINA = SIN(ALPH)
      COSA = COS(ALPH)
      SINB = SIN(BET)
      COSB = COS(BET)
      SING = SIN(GAMM)
      COSG = COS(GAMM)
      COSAS = (COSG*COSB-COSA)/ (SINB*SING)
      SINAS = SQRT(1.0-COSAS*COSAS)
      COSBS = (COSA*COSG-COSB)/ (SINA*SING)
      SINBS = SQRT(1.0-COSBS*COSBS)
      COSGS = (COSA*COSB-COSG)/ (SINA*SINB)
      SINGS = SQRT(1.0-COSGS*COSGS)
      A = CELL(1)
      B = CELL(2)
      C = CELL(3)
      AS = B*C*SINA/VOL
      BS = C*A*SINB/VOL
      CS = A*B*SING/VOL
      ALPHAS = ATAN2(SINAS,COSAS)/CONV
      BETAS  = ATAN2(SINBS,COSBS)/CONV
      GAMMAS = ATAN2(SINGS,COSGS)/CONV
      CELLAS(1) = AS
      CELLAS(2) = BS
      CELLAS(3) = CS
      CELLAS(4) = ALPHAS
      CELLAS(5) = BETAS
      CELLAS(6) = GAMMAS
C
C---- Set useful things for calculating dstar
C
      AC(1) = AS*AS
      AC(2) = BS*BS
      AC(3) = CS*CS
      AC(4) = 2.0*BS*CS*COSAS
      AC(5) = 2.0*CS*AS*COSBS
      AC(6) = 2.0*AS*BS*COSGS
C
C---- Zero matrices
C
      DO 40 N = 1,6
        DO 30 I = 1,3
          DO 20 J = 1,3
            RR(I,J,N) = 0.0
   20     CONTINUE
   30   CONTINUE
   40 CONTINUE
C
C---- Calculate matrices
C
C---- XO along a  Zo along c*
C
      NCODE = 1
      RR(1,1,NCODE) = A
      RR(1,2,NCODE) = B*COSG
      RR(1,3,NCODE) = C*COSB
      RR(2,2,NCODE) = B*SING
      RR(2,3,NCODE) = -C*SINB*COSAS
      RR(3,3,NCODE) = C*SINB*SINAS
C
C---- XO along b  Zo along a*
C
      NCODE = 2
      RR(1,1,NCODE) = A*COSG
      RR(1,2,NCODE) = B
      RR(1,3,NCODE) = C*COSA
      RR(2,1,NCODE) = -A*SING*COSBS
      RR(2,3,NCODE) = C*SINA
      RR(3,1,NCODE) = A*SING*SINBS
C
C---- XO along c  Zo along b*
C
      NCODE = 3
      RR(1,1,NCODE) = A*COSB
      RR(1,2,NCODE) = B*COSA
      RR(1,3,NCODE) = C
      RR(2,1,NCODE) = A*SINB
      RR(2,2,NCODE) = -B*SINA*COSGS
      RR(3,2,NCODE) = B*SINA*SINGS
C
C---- trigonal only - XO along a+b  YO alon a-b  Zo along c*
C
      NCODE = 4
      RR(1,1,NCODE) = A/2.0
      RR(1,2,NCODE) = A/2.0
      RR(2,1,NCODE) = -A*SING
      RR(2,2,NCODE) = A*SING
      RR(3,3,NCODE) = C
C
C---- XO along a*   ZO along c
C
      NCODE = 5
      RR(1,1,NCODE) = A*SINB*SINGS
      RR(2,1,NCODE) = -A*SINB*COSGS
      RR(2,2,NCODE) = B*SINA
      RR(3,1,NCODE) = A*COSB
      RR(3,2,NCODE) = B*COSA
      RR(3,3,NCODE) = C
C
C---- Grr*! to  Gerard Bricogne - his setting for P1 in SKEW.
C     XO along a  Yo along b*
C
      NCODE = 6
      RR(1,1,NCODE) = A
      RR(1,2,NCODE) = B*COSG
      RR(1,3,NCODE) = C*COSB
      RR(2,2,NCODE) = B*SING*SINAS
      RR(3,2,NCODE) = -B*SING*COSAS
      RR(3,3,NCODE) = C*SINB
C
C---- copy rr(...) into rrr(...)
C
      DO 11 I=1,6
        CEL(I) = CELL(I)
11    CONTINUE
      DO 70 I = 1,6
        DO 60 J = 1,3
          DO 50 K = 1,3
            RRR(K,J,I) = RR(K,J,I)
   50     CONTINUE
   60   CONTINUE
   70 CONTINUE
C
C
      VOLL = VOL
      IF (CELDEL.GT.0.01) VOLL = -VOL
C
C
      END
C
C
      SUBROUTINE CVFRAC2(X,Y,Z,XX,YY,ZZ,IFLAG)
C     ============================================
C
C_BEGIN_CVFRAC2
C
C      This subroutine is used to convert between the stored  orthogonal  and
C fractional coordinates using the  matrices  set  up  in  the  common  block
C /ORTHOG/ by the subroutine XYZOPEN. If no matrices have been set up then the
C program will stop with an error message.
C                                         
C Call:  CALL CVFRAC2(X,Y,Z,XX,YY,ZZ,IFLAG)
C                                             
C Arguments:
C            
C       X (I)   (REAL)  Input coordinates.
C       Y (I)   (REAL)       "
C       Z (I)   (REAL)       "
C      XX (O)   (REAL)  Output coordinates.
C      YY (O)   (REAL)       "
C      ZZ (O)   (REAL)       "
C   IFLAG (I) (INTEGER)  Flag =0, Convert coordinates from fractional to orthogonal
C                             =1, Convert coordinates from orthogonal to fractional
C
C_END_CVFRAC2
C
      LOGICAL IFCRYS,IFSCAL,MATRIX,IFHDOUT,IFNEWCRYS
      COMMON /RBRKXX/IFCRYS,IFSCAL,ITYP,MATRIX,IFHDOUT,IFNEWCRYS
      COMMON /ORTHOG/RO(4,4),RF(4,4),NCODE
      SAVE /RBRKXX/,/ORTHOG/
C
C---- Check that matrices set up
C
      IF(.NOT.MATRIX)GO TO 800
C
C---- Perform transformation
C
      IF(IFLAG.NE.0)GO TO 10
      XX=RO(1,1)*X + RO(1,2)*Y +RO(1,3)*Z +RO(1,4)
      YY=RO(2,1)*X + RO(2,2)*Y +RO(2,3)*Z +RO(2,4)
      ZZ=RO(3,1)*X + RO(3,2)*Y +RO(3,3)*Z +RO(3,4)
      RETURN
10    XX=RF(1,1)*X + RF(1,2)*Y +RF(1,3)*Z +RF(1,4)
      YY=RF(2,1)*X + RF(2,2)*Y +RF(2,3)*Z +RF(2,4)
      ZZ=RF(3,1)*X + RF(3,2)*Y +RF(3,3)*Z +RF(3,4)
      RETURN
C
C---- Error condition
C
800   CALL CCPERR(4,' **FRACTIONAL/ORTHOGONAL MATRICES NOT SET UP**')
      call ccperr(1,' No knowledge of input orthogonalisation')
C
C---- Format statements
C
      END
C
C
C
      SUBROUTINE CVFRAC(X,Y,Z,XX,YY,ZZ,IFLAG,MSG)
C     ===========================================
C
C_BEGIN_CVFRAC
C
C	Another silly obsolete routine that really should be deleted.
C MSG value is in fact useless. Library output controlled by CCPERR.
C
C_END_CVFRAC
C
C     .. Scalar Arguments ..
      REAL X,Y,Z,XX,YY,ZZ
      INTEGER IFLAG,MSG
C     ..
C     .. External Routines ..
      EXTERNAL CVFRAC2
C     ..
      CALL CVFRAC2(X,Y,Z,XX,YY,ZZ,IFLAG)

      RETURN
      END
C
C
C
      SUBROUTINE CVANISOB(B,IFLAG)
C     THIS SUBROUTINE SHOULD NOT BE USED
C     SEE CVANISOU
      REAL B(6)
      INTEGER IFLAG
      EXTERNAL CVANISOu, CCPERR
      WRITE (6,*) 'ERR: THIS PROGRAM USES S/R CVANISOB'
      WRITE (6,*) 'ERR: IT SHOULD NOT USE THIS ROUTINE'
      WRITE (6,*) 'ERR: CVANISOU IS CALLED AUTOMATICALLY'
      CALL CCPERR(2, 'CHANGE YOUR CODE')
      CALL CVANISOU(B, IFLAG)
      RETURN
      END
C
C
C
C
      SUBROUTINE CVANISOU(U,IFLAG)
C     ============================
C
C_BEGIN_CVANISOU
C
C      This subroutine is used to convert between crystallographic bs and 
C orthogonal Us or the other way round. The orthogonal matrices are 
C required, if no matrices have been set up then the program will stop 
C with an error message. The temperature factors are defined below;
C
C  PDB files contain anisotropic temperature factors as orthogonal Us.
C The anisotropic temperature factors can be input/output to this routine 
C  as orthogonal or as crystallographic Us. 
C  
C  Shelx defines Uf to calculate temperature factor as:
C T(aniso_Uf) = exp (-2PI**2 ( (h*ast)**2 Uf_11 + (k*bst)**2 Uf_22 + ... 
C                            + 2hk*ast*bst*Uf_12 +..)
C
C   Note:   Uo_ji == Uo_ij and  Uf_ji == Uf_ij.
C
C  [Uo_ij] listed on ANISOU card satisfy  the relationship:
C  [Uo_ij] =   [RFu]-1 [Uf_ij] {[RFu]-1}T   
C
C        where [Rfu] is the normalised [Rf] matrix read from the SCALEi cards.
C        see code.   [ROu] ==  [RFu]-1
C  Hence:
C  [Uf_ij] =   [RFu]   [Uo_ij] {[RFu]  }T   
C
C T(aniso_Uo) = U(11)*H**2 + U(22)*K**2 + 2*U(12)*H*K + ...
C where H,K,L are orthogonal reciprocal lattice indecies. ( EJD: I think????)
C
C Biso     = 8*PI**2 (Uo_11 + Uo_22 + Uo_33) / 3.0
C
C   [Uf(symm_j)] = [Symm_j] [Uf] [Symm_j]T
C
C 
C Arguments:
C            
C    U(6) (I/O  (REAL)  Input coordinates.
C   IFLAG (I) (INTEGER)  Flag =0, Convert coordinates from fract. to orthog.
C                             =1, Convert coordinates from orthog. to fract.
C
C_END_CVANISOU
C
C     .. Arguments ..
      REAL U(6)
      INTEGER IFLAG
C     ..
C     .. Variables in Common ..
      REAL RF,RO
      INTEGER NCODE
      LOGICAL IFCRYS,IFSCAL,MATRIX,IFHDOUT,IFNEWCRYS
C     ..
C     .. Local Variables ..
      INTEGER I,J
      REAL TWOPI2
      REAL A(3,3),AT(3,3),TMP(3,3),TMPMAT(3,3)
C     ..
C     .. External Routines ..
      EXTERNAL CCPERR,MATMUL
C     ..
C     .. Common Blocks ..
      COMMON /RBRKXX/IFCRYS,IFSCAL,ITYP,MATRIX,IFHDOUT,IFNEWCRYS
      COMMON /ORTHOG/RO(4,4),RF(4,4),NCODE
      COMMON /ORTHOGU/ ROU(4,4),RFU(4,4)
C     ..
C     .. Save Statement ..
      SAVE /RBRKXX/,/ORTHOG/,/ORTHOGU/
C     ..
C     .. Data Statements ...
      DATA TWOPI2 /19.739209/
C     ..
C
C---- Check that matrices set up
C
      IF(.NOT.MATRIX)GO TO 800
C
C---- Perform transformation
C
        TMP(1,1)=U(1)
        TMP(2,2)=U(2)
        TMP(3,3)=U(3)
        TMP(1,2)=U(4)
        TMP(2,1)=U(4)
        TMP(1,3)=U(5)
        TMP(3,1)=U(5)
        TMP(2,3)=U(6)
        TMP(3,2)=U(6)
C
C   IFLAG (I) (INTEGER)  Flag =0, Convert coordinates from fract. to orthog.
C   IFLAG (I) (INTEGER)  Flag =1, Convert coordinates from orthog. to fract.
C
      IF (IFLAG .EQ. 0) THEN
        DO 10 I=1,3
          DO 10 J=1,3
            A(J,I)=ROU(J,I)
            AT(I,J)=ROU(J,I)
   10   CONTINUE
      ELSE
        DO 20 I=1,3
          DO 20 J=1,3
            A(J,I) = RFU(J,I)
            AT(I,J) = RFU(J,I)
   20   CONTINUE
      ENDIF
C
        CALL MATMUL(TMPMAT,TMP,AT)
        CALL MATMUL(TMP,A,TMPMAT)
        U(1) = TMP(1,1)
        U(2) = TMP(2,2)
        U(3) = TMP(3,3)
        U(4) = TMP(1,2)
        U(5) = TMP(1,3)
        U(6) = TMP(2,3)

      RETURN
C
C---- Error condition
C
800   CALL CCPERR(4,' **FRACTIONAL/ORTHOGONAL MATRICES NOT SET UP**')
      call ccperr(1,' No knowledge of input orthogonalisation')
C
C---- Format statements
C
      END
C
C
C
      SUBROUTINE RBCELL(CELLD,CVOL)
C     ============================
C
C_BEGIN_RBCELL
C
C      SUBROUTINE RBCELL(CELLD,CVOL)
C
C Returns cell dimensions and unit cell  volume.
C
C PARAMETERS
C     CELLD (O)  (REAL(6))  cell dimensions
C     CVOL (O)  (REAL)     cell volume
C
C Common blocks
C
C      COMMON/RBRKZZ/CELL(6),RR(3,3,6),VOL,CELLAS(6)
C
C_END_RBCELL
C
      COMMON/RBRKZZ/CELL(6),RR(3,3,6),VOL,CELLAS(6)
      REAL CELL,RR,VOL,CELLAS
      REAL CELLD(6), CVOL
      SAVE /RBRKZZ/
C
      CVOL = VOL
      DO 1 I=1,6
1       CELLD(I) = CELL(I) 
      END
C
C
C
      SUBROUTINE RBRCEL(RCEL,RVOL)
C     ============================
C
C_BEGIN_RBRCEL
C
C      SUBROUTINE RBRCEL(RCEL,RVOL)
C
C THIS SUBROUTINE RETURNS Reciprocal cell dimensions, and reciprocal
C                       unit cell  volume.
C
C PARAMETERS
C     RCEL (O)  (REAL(6)) reciprocal cell dimensions
C     RVOL (O)  (REAL)    reciprocal cell volume
C
C Common blocks
C
C      COMMON/RBRKZZ/CELL(6),RR(3,3,6),VOL,CELLAS(6)
C
C_END_RBRCEL
C
      COMMON/RBRKZZ/CELL(6),RR(3,3,6),VOL,CELLAS(6)
      REAL RCEL(6),RVOL
      REAL CELL,CELLAS,RR,VOL
      SAVE /RBRKZZ/
C
      IF (VOL.EQ.0.0) THEN
        RVOL = 0.0
      ELSE
        RVOL = 1.0/VOL
      ENDIF
      DO 1 I=1,6
1       RCEL(I) = CELLAS(I) 
      RETURN
      END
C
C
C
      SUBROUTINE RBSPGRP(SPGRP)
C     ============================
C
C_BEGIN_RBSPGRP
C
C      SUBROUTINE SUBROUTINE RBSPGRP(SPGRP)
C
C Returns spacegrpup from pdb
C
C PARAMETERS
C     SPGRP (O) (CHARACTER*15) 
C
C Common blocks
C
C      COMMON /RBRKSPGRP/BRKSPGRP
C
C_END_RBSPGRP
C
      CHARACTER SPGRP*(*)
      CHARACTER BRKSPGRP*15
      INTEGER ILEN,KLEN,J
      COMMON /RBRKSPGRP/BRKSPGRP
      SPGRP = BRKSPGRP
C
C Make sure that the returned name is left-justified
C
      ILEN = LENSTR(SPGRP)
      KLEN = ILEN
C
      DO J = 1,ILEN-1
        IF (SPGRP(1:1) .EQ. ' ') THEN
          SPGRP = SPGRP(2:KLEN)
          KLEN  = KLEN - 1
        END IF
      END DO
C
      END
C
C
C
      SUBROUTINE WBSPGRP(SPGRP)
C     =============================
C
C_BEGIN_WBSPGRP
C
C      SUBROUTINE WBSPGRP(SPGRP)
C
C Sets the internal spacegroup of a pdb file
C
C PARAMETERS
C     SPGRP (I) (CHARACTER*15)
C
C Common Blocks
C
C      COMMON /RBRKSPGRP/BRKSPGRP
C
C_END_WBSPGRP
C
C...  Local scalars
      CHARACTER SPGRP*(*)
C...  Common block
      CHARACTER BRKSPGRP*15
      COMMON /RBRKSPGRP/BRKSPGRP
      BRKSPGRP = SPGRP
C
      END
C
C
C
      SUBROUTINE RES3TO1(RESNM3,RESNM1)
C     ================================
C
C_BEGIN_RES3TO1
C
C      SUBROUTINE RES3TO1(RESNM3,RESNM1)
C
C       FIND 3 CHARACTER RESIDUE NAME FROM 1 CHARACTER CODE OR
C       FIND 1 CHARACTER RESIDUE NAME FROM 3 CHARACTER CODE.
C       SUBROUTINE IS CALLED WITH EITHER RESNM3 OR RESNM1 PREVIOUSLY 
C       ASSIGNED, AND THE OTHER IS ASSIGNED  HERE.
C 
C Parameters
C
C   RESNM3 (I/O)  CHAR*4    3 character residue name
C   RESNM1 (I/O)  CHAR*1    1 character residue name
C
C_END_RES3TO1
C
      CHARACTER*4 RESNM3
      CHARACTER*1 RESNM1
      CHARACTER*4 MAACD3(26)
      CHARACTER*1 MAACD1(26)
      DATA NAACID/26/
      DATA MAACD3/'ALA ','ARG ','ASN ','ASP ','CYS ','CYH ','GLN ',
     1 'GLU ','GLY ','HIS ','ILE ','LEU ','LYS ','MET ','PHE ','PRO ',
     2 'SER ','THR ','TRP ','TYR ','VAL ','HEM ','WAT ','SUL ','END ',
     3 'DUM '/
      DATA MAACD1/'A','R','N','D','C','C','Q',
     1 'E','G','H','I','L','K','M','F','P',
     2 'S','T','W','Y','V','X','O','U','Z','Z'/
C
C---- Routine to find one character amino acid name
C
        IF(RESNM3.NE.' ')THEN
          DO 1 I=1,NAACID
          IF(RESNM3.EQ.MAACD3(I)) GO TO 2
1         CONTINUE
        I=NAACID
2       RESNM1=MAACD1(I)
        RETURN
        ENDIF
C
C---- Routine to find three character amino acid name
C
        IF(RESNM1.NE.' ')THEN
          DO 11 I=1,NAACID
          IF(RESNM1.EQ.MAACD1(I)) GO TO 12
11        CONTINUE
        I=NAACID
12      RESNM3=MAACD3(I)
        RETURN
        ENDIF
      END
C
C
C
        SUBROUTINE RBRECIP(IH,IK,IL,S)
C       ==============================
C
C_BEGIN_BRECIP
C
C        SUBROUTINE RBRECIP(IH,IK,IL,S)
C
C---- This subroutine calculates 4SIN**2/L**2
C
C PARAMETERS
C         IH,IK,IL (I) (INTEGER)  reflection indices
C                S (O) (REAL)     4SIN**2/L**2
C
C_END_BRECIP
C
      COMMON /RBREC/AC(6)
      SAVE /RBREC/
C
      S = 
     .(AC(1)*IH*IH+AC(2)*IK*IK+AC(3)*IL*IL
     .+AC(4)*IK*IL+AC(5)*IL*IH+AC(6)*IH*IK)
      RETURN
      END


C     =====================================================
      SUBROUTINE SFREAD2(ID,NG,A,B,C,IWT,IELEC,CU,MO,Ifail)
C     =====================================================
C
C  Inputs: ID     atom identifier
C          This should match an atom type in the atomsf.lib
C          If an atom is identified as NE2+ say, characters are 
C          subtracted from the ID till a match is found, or there are 
C          no characters left. 
C          EG: Routine tests first NE2+, then NE2, then NE, then N.
C            All matching checks UPPER CASE strings.
C
C          NG     num. of gaussian approximations (2 or 5 (default))
C          IFILFF  .TRUE. if want to open the library file assigned
C                 to ATOMSF (default `atomsf.lib')
C
C  Output: A(4)   coefficient for structure factor calculation
C          B(4)   coefficient for structure factor calculation
C          C      coefficient for structure factor calculation
C          IWT    atomic weight
C          IELEC  number of electrons
C          CU(2)  delta F' and delta F'' for Cu
C          MO(2)  delta F' and delta F'' for Mo
C          Ifail  = -1 if atom not found at all
C                 =  0 OK
C                 =  1 for two gaussian case that does not exist
C
C 20/11/2000 C. Vonrhein
C     fixed problem with one character atom name matching
C     (S, I and B affected)
C
C     .. Scalar Arguments ..
      REAL C
      INTEGER IELEC,Ifail,IWT,NG
      CHARACTER ID*4,IDCHK*4,STRING*200
C     ..
C     .. Array Arguments ..
      REAL A(4),B(4),CU(2),MO(2)
C     ..
C     .. Local Scalars ..
      INTEGER NGauss,IOS
      CHARACTER ID2*6,IDIN*6
      LOGICAL OP
C     ..
C     .. External Subroutines ..
      EXTERNAL CCPDPN,CCPERR
C     ..

      IDCHK = ID
      CALL CCPUPC(IDCHK)
      ID2    = IDCHK//'  '
      NGauss = NG
C
      IF (NGauss.EQ.2) THEN
        ID2(6:6) = '2'
      ELSE
        NGauss = 5
      END IF
C
C---- Check to open file
C
      INQUIRE (UNIT=45, OPENED=OP, IOSTAT=IOS)
      IF (IOS .NE. 0) CALL CCPERR(1,'Error opening ATOMSF file')

      IF (.NOT.OP) THEN
        Ifail  = 1
        CALL CCPDPN(45,'ATOMSF','READONLY','F',0,Ifail)
        IF (Ifail.LT.0) CALL CCPERR(1,'Error opening library file')
      ELSE
        REWIND 45
      END IF
C
C---- Search for atom identifier ID
      IFAIL = -1
      LID = LENSTR(ID)
C  Big loop over possible sub-strings of ID
      DO 25 NID = LID,1,-1
        REWIND 45

C  Small loop over lines in library file
   10   CONTINUE
        READ (45,FMT=6002,END=50,ERR=40) IDIN
C
        CALL CCPUPC(IDIN)
        IF (ID2(1:NID).EQ.IDIN(1:NID)) THEN
c
c       20/11/2000 C. Vonrhein
c
c       special precautions for single character atom types:
c       skip this atom if second character is NOT '+', '-' or ' '.
c
          IF ((NID.NE.1).OR.( (NID.EQ.1).AND.(
     .                      (IDIN(2:2).EQ."+").OR.
     .                      (IDIN(2:2).EQ."-").OR.
     .                      (IDIN(2:2).EQ." ")    )
     .                    )) THEN
            Ifail = 1
            IF (NGauss.NE.2 .OR. IDIN(6:6).NE.' ') GO TO 60
          END IF
        END IF

C  Up for next line of library file
        GO TO 10
C
C---- Error reading library file
C
   40   CALL CCPERR(1,'Error reading library file')
C
C---- No match
C
   50   CONTINUE
        IF (NID.GT.1) THEN
          WRITE(STRING,'(A,A,A)') ' No match for atom ID ',ID2(1:NID),
     +     ' subtracting one character '
          CALL CCPERR(4,STRING(1:LENSTR(STRING)))
          ID2 = ID2(1:NID-1)//' '//ID2(NID+1:6)
          ID  = ID (1:NID-1)//'    '
        ENDIF
C  End of big loop. Back for smaller substring of ID.
  25  CONTINUE

      WRITE(STRING,'(A,A,A)') ' No match for atom ID ',ID2(1:1),
     +   ' giving up! '
      CALL CCPERR(4,STRING(1:LENSTR(STRING)))
      IFAIL = -1
      RETURN
C
C---- Matched atom
C
   60 READ (45,FMT=6006) IWT,IELEC,C
      READ (45,FMT=6008) A(1),A(2),A(3),A(4)
      READ (45,FMT=6008) B(1),B(2),B(3),B(4)
      READ (45,FMT=6008) CU(1),CU(2),MO(1),MO(2)
      Ifail = 0
C
C---- Format statements
C
 6002 FORMAT (A6)
 6006 FORMAT (2X,I8,2X,I8,2X,F14.6)
 6008 FORMAT (4 (2X,F14.6))
      END
C
C
C
      SUBROUTINE SFREAD(ID,NG,A,B,C,IWT,IELEC,CU,MO,IFAIL,IFILFF)
C     ===========================================================
C
C_BEGIN_SFREAD
C
C	Obsolete routine should be deleted. IFILFF not used.
C
C_END_SFREAD
C
C     .. Scalar Arguments ..
      REAL C
      INTEGER IELEC,Ifail,IWT,NG
      LOGICAL IFILFF
      CHARACTER ID*4
C     ..
C     .. Array Arguments ..
      REAL A(4),B(4),CU(2),MO(2)
C     ..
C     .. External Routines ..
      EXTERNAL SFREAD2
C     ..
      CALL SFREAD2(ID,NG,A,B,C,IWT,IELEC,CU,MO,IFAIL)
 
      RETURN
      END
C
C
C
        SUBROUTINE WBCELL(IUNIT,ARGCELL,ARGNCODE)
C       =========================================
C
C_BEGIN_WBCELL
C
C   This subroutine writes out the cell and orthogonalisation matrices, to 
C the output file. If the input parameters are null then the cell etc. are
C taken from the COMMON blocks.
C
C PARAMETERS
C
C            IUNIT (I) (INTEGER)   Channel number for output file.
C
C       ARGCELL(6) (I) (REAL)      crystallographic cell taken from COMMON
C                                  if cell = 0
C         ARGNCODE (I) (INTEGER)   NCODE number taken from COMMON if NCODE=0
C
C_END_WBCELL
C
C     .. Parameters ..
      INTEGER MAXFILESOPEN
      PARAMETER (MAXFILESOPEN=90)
C     ..
C     .. Agruments ..
      REAL ARGCELL(6)
      INTEGER ARGNCODE,IUNIT
C     ..
C     .. Variables in Common ..
      REAL CELL, RO, RF, RR
      INTEGER FILESOPEN, NCODE, TYPE, UNIT
      CHARACTER*80 LOGUNIT
      CHARACTER BRKSPGRP*15
      LOGICAL IFCRYS,IFSCAL,MATRIX,IFHDOUT,IFNEWCRYS
C     ..
C     .. Local Scalars ..
      INTEGER I, II, J, IRET
      CHARACTER*80 ERRLIN
C     ..
C     .. External Routines/Functions ..
      EXTERNAL CCPERR,RBFROR,RBRINV,MMDB_F_WBSPGRP,
     +         MMDB_F_WBCELL
C     ..
C     .. Common Blocks ..
      COMMON /RBRKAA/ FILESOPEN,LOGUNIT(MAXFILESOPEN),
     +                UNIT(MAXFILESOPEN),TYPE(MAXFILESOPEN)
      COMMON /ORTHOG/RO(4,4),RF(4,4),NCODE
      COMMON /RBRKZZ/CELL(6),RR(3,3,6),VOL,CELLAS(6)
      COMMON /RBRKXX/ IFCRYS,IFSCAL,ITYP,MATRIX,IFHDOUT,IFNEWCRYS
      COMMON /RBRKSPGRP/BRKSPGRP
C     ..
      SAVE /ORTHOG/,/RBRKAA/,/RBRKXX/,/RBRKZZ/

      II = 0
      DO 10 I=1,FILESOPEN
        IF (IUNIT .EQ. UNIT(I)) THEN
          II = I
          GOTO 20
        ENDIF
   10 CONTINUE

      ERRLIN = ' ERROR: in WBCELL file has not been opened'
      CALL CCPERR(1,ERRLIN)

   20 IF (ARGCELL(1) .EQ. 0.0) THEN
        IF (IFCRYS) CALL MMDB_F_WBCELL(IUNIT, CELL, ARGNCODE, IRET)
      ELSE
        CALL MMDB_F_WBCELL(IUNIT, ARGCELL, ARGNCODE, IRET)
      ENDIF
C...  update spacegroup information from cache
      CALL MMDB_F_WBSPGRP(IUNIT,BRKSPGRP,IRET)

      IF (ARGNCODE .NE. 0) THEN
        DO 30 I = 1,6
          CELL(I) = ARGCELL(I)
   30   CONTINUE

        CALL RBFROR
        DO 40 I = 1,3
          DO 40 J = 1,3
            RO(J,I) = RR(J,I,ARGNCODE)
   40   CONTINUE

        RO(4,4) = 1.0     
        DO 50 I=1,3
          RO(I,4) = 0.0
   50   CONTINUE

        CALL RBRINV(RO,RF)
      ENDIF

      IFNEWCRYS = .TRUE.
      RETURN
      END
C
C
C
        SUBROUTINE WREMARK(IUNIT,LINE)
C       ==============================
C
C_BEGIN_WREMARK
C
C	This subroutine writes a line to the output file. Its main use is for 
C REMARK statements in PDB.
C
C Parameters:
C
C            IUNIT (I) (CHARACTER*(*))  Channel number
C             LINE (I) (CHARACTER*(*))  line to be written, best
C                                       if declared as *80
C
C_END_WREMARK
C
C     .. Parameters ..
      INTEGER MAXFILESOPEN
      PARAMETER (MAXFILESOPEN=90)
C     ..
C     .. Arguments ..
      INTEGER IUNIT
      CHARACTER*(*) LINE
C     ..
C     .. Variables in Common ..
      INTEGER FILESOPEN,TYPE,UNIT
      CHARACTER*80 LOGUNIT
C     ..
C     .. Locals ..
      INTEGER II, IRET
      CHARACTER OUTLIN*80,ERRLIN*80
C     ..
C     .. Common Blocks ..
      COMMON /RBRKAA/ FILESOPEN,LOGUNIT(MAXFILESOPEN),
     +                UNIT(MAXFILESOPEN),TYPE(MAXFILESOPEN)
C     ..
C     .. Save Statement ..
      SAVE /RBRKAA/
C     ..
C
C---- The remark line will be truncated if it > 80 characters
C     this fits with PDB and CIF syntax.
C
      II = 0
      DO 10 I=1,FILESOPEN
        IF (IUNIT .EQ. UNIT(I)) THEN
          II = I
          GOTO 20
        ENDIF
   10 CONTINUE

      ERRLIN = ' ERROR: in WREMARK file has not been opened'
      CALL CCPERR(1,ERRLIN)

   20 CALL MMDB_F_WREMARK(IUNIT, LINE, IRET)

      RETURN
      END
C
C<FF>
C
      SUBROUTINE RWBFIN(IUN,IOUT)
C     ===========================
C
C_BEGIN_RWBFIN
C
C	This subroutine copies remaining lines straight from input to 
C output. 
C
C_END_RWBFIN
C
C     .. Scalar Arguments ..
      INTEGER IUN,IOUT
C     ..
C     .. External Routines ..
      EXTERNAL XYZADVANCE

   10 CALL XYZADVANCE(IUN,IOUT,0,*1000,*1000)
      CALL XYZADVANCE(IOUT,0,0,*1000,*1000)
      GOTO 10

 1000 RETURN
      END
C
C
C
      SUBROUTINE RWNOHEAD()
C     =====================
C
C_BEGIN_RWNOHEAD
C
C	This subroutine resets the logical variable IFHDOUT in the RWBROOK
C     common block RBRKXX, and should be called once before either
C     XYZADVANCE or WBCELL in order to prevent those routines from writing
C     headers to an output pdb file.
C     Effectively we are fooling the library that the header has already
C     been written.
C
C_END_RWNOHEAD
C
C     .. Arguments in common ..
      INTEGER ITYP
      LOGICAL IFCRYS,IFHDOUT,IFNEWCRYS,IFSCAL,MATRIX
C
C     .. Common blocks ..
      COMMON /RBRKXX/ IFCRYS,IFSCAL,ITYP,MATRIX,IFHDOUT,IFNEWCRYS
C
      IFHDOUT = .TRUE.
C
      RETURN
      END
C
C
      SUBROUTINE NUM_EXPECTED_WATERS(RESO,TEMP,FHOH,SEFHOH)
C     =====================================================
C
C_BEGIN_NUM_EXPECTED_WATERS
C
C Arguments:
C
C         RESO    (I)   REAL           Resolution in A.
C         TEMP    (I)   CHARACTER*4    'ROOM' or 'LOWT' for temperature.
C         FHOH    (O)   REAL           Prediction of N_HOH/N_at
C         SEFHOH  (O)   REAL           Standard error of FHOH
C
C     Given the resolution, this routine returns the number of water
C     molecules expected to be determined by PX (and the associated
C     standard error) as a fraction of the number of protein atoms,
C     as estimated by the statistical analysis of Carugo & Bordo, 
C     Acta Cryst D, 55, 479 (1999). Two expressions are given, one
C     for room temperature structures and one for low temperature
C     structures.
C
C_END_NUM_EXPECTED_WATERS
C
      CHARACTER*4 TEMP,TTEMP
      REAL RESO,FHOH,SEFHOH

      TTEMP = TEMP
      CALL CCPUPC(TTEMP)
      IF (TTEMP.EQ.'ROOM') THEN

        FHOH = 0.301 - 0.095*RESO
        SEFHOH = 0.092 * SQRT(0.00114 + 0.005*(RESO - 2.3)**2)

      ELSEIF (TTEMP.EQ.'LOWT') THEN

        FHOH = 0.334 - 0.110*RESO
        SEFHOH = 0.043 * SQRT(0.030 + 0.167*(RESO - 2.2)**2)

      ENDIF

      RETURN
      END
C
C

C
        SUBROUTINE WBCELLS(IUNIT,ARGCELL,ARGNCODE,NAMSPG_CIF)
C       =========================================
C
C_BEGIN_WBCELL
C
C   This subroutine writes out the cell and orthogonalisation matrices, to 
C the output file. If the input parameters are null then the cell etc. are
C taken from the COMMON blocks.
C
C PARAMETERS
C
C            IUNIT (I) (INTEGER)   Channel number for output file.
C
C       ARGCELL(6) (I) (REAL)      crystallographic cell taken from COMMON
C                                  if cell = 0
C         ARGNCODE (I) (INTEGER)   NCODE number taken from COMMON if NCODE=0
C
C_END_WBCELL
C
C     .. Parameters ..
      INTEGER MAXFILESOPEN
      PARAMETER (MAXFILESOPEN=90)
C     ..
C     .. Agruments ..
      REAL ARGCELL(6)
      INTEGER ARGNCODE,IUNIT
C     ..
C     .. Variables in Common ..
      REAL CELL, RO, RF, RR
      INTEGER FILESOPEN, NCODE, TYPE, UNIT
      CHARACTER*80 LOGUNIT
      CHARACTER BRKSPGRP*15,NAMSPG_CIF*(*)
      LOGICAL IFCRYS,IFSCAL,MATRIX,IFHDOUT,IFNEWCRYS
C     ..
C     .. Local Scalars ..
      INTEGER I, II, J, IRET
      CHARACTER*80 ERRLIN
      CHARACTER*15 SPGRP
C     ..
C     .. External Routines/Functions ..
      EXTERNAL CCPERR,RBFROR,RBRINV,MMDB_F_RBSPGRP
C     ..
C     .. Common Blocks ..
      COMMON /RBRKAA/ FILESOPEN,LOGUNIT(MAXFILESOPEN),
     +                UNIT(MAXFILESOPEN),TYPE(MAXFILESOPEN)
      COMMON /ORTHOG/RO(4,4),RF(4,4),NCODE
      COMMON /RBRKZZ/CELL(6),RR(3,3,6),VOL,CELLAS(6)
      COMMON /RBRKXX/ IFCRYS,IFSCAL,ITYP,MATRIX,IFHDOUT,IFNEWCRYS
      COMMON /RBRKSPGRP/BRKSPGRP
C     ..
      SAVE /ORTHOG/,/RBRKAA/,/RBRKXX/,/RBRKZZ/
C
      II = 0
      DO 10 I=1,FILESOPEN
        IF (IUNIT .EQ. UNIT(I)) THEN
          II = I
          GOTO 20
        ENDIF
   10 CONTINUE

      ERRLIN = ' ERROR: in WBCELL file has not been opened'
      CALL CCPERR(1,ERRLIN)
 
   20 CALL MMDB_F_RBSPGRP(IUNIT,SPGRP,IRET)
C    Has the spacegroup name been set yet?
      ILEN1 = LENSTR(SPGRP)
      ILEN2 = LENSTR(NAMSPG_CIF)
 
       IF(SPGRP.NE.' '.AND.
     +    SPGRP(1:ILEN1).NE.NAMSPG_CIF(1:ILEN2)) then
         WRITE(6,'(A,/,4(A,5x))') '*** Incompatible space group names:',
     +   ' From PDB input:         ',SPGRP,
     +   ' To be written to output:',NAMSPG_CIF
         CALL CCPERR(2,' Incompatible space group names')
      END IF
      BRKSPGRP = NAMSPG_CIF(1:ILEN2)

      CALL WBCELL(IUNIT,ARGCELL,ARGNCODE)
      RETURN
      END
C

C
C     pack_f.f: (de)compress diffraction image files
C     Copyright (C) 1995  Jan P Abrahams
C
C     This library is free software: you can redistribute it and/or
C     modify it under the terms of the GNU Lesser General Public License
C     version 3, modified in accordance with the provisions of the 
C     license to address the requirements of UK law.
C 
C     You should have received a copy of the modified GNU Lesser General 
C     Public License along with this library.  If not, copies may be 
C     downloaded from http://www.ccp4.ac.uk/ccp4license.php
C 
C     This program is distributed in the hope that it will be useful,
C     but WITHOUT ANY WARRANTY; without even the implied warranty of
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C     GNU Lesser General Public License for more details.
c
c
c
      subroutine pack_wordimage (data, x, y, filn)
c     =================================
c
c   Pack data stored in the array DATA with dimensions x * y in file FILN.
c
      implicit none
c
      character*(*) filn
      integer*4 x, y, j
      integer*2 data(x, y)
      integer*4 filnarray(1025)
c
c     ..
c     .. External C-routine
      external pack_wordimage_f

      do 10, j = 1, len(filn)
         if (filn(j:j) .ne. ' ') then
            filnarray(j) = ichar(filn(j:j))
         else
            filnarray(j) = 0
         endif
 10   continue
      filnarray(len(filn) + 1) = 0
      call pack_wordimage_f(data, x, y, filnarray)
      return
      end

c*******************************************************************************
c
c
c
      subroutine v2pack_wordimage (data, x, y, filn)
c     =================================
c
c   Pack data stored in the array DATA with dimensions x * y in file FILN.
c
      implicit none
c
      character*(*) filn
      integer*4 x, y, j
      integer*2 data(x, y)
      integer*4 filnarray(1025)
c
c     ..
c     .. External C-routine
      external v2pack_wordimage_f

      do 10, j = 1, len(filn)
         if (filn(j:j) .ne. ' ') then
            filnarray(j) = ichar(filn(j:j))
         else
            filnarray(j) = 0
         endif
 10   continue
      filnarray(len(filn) + 1) = 0
      call v2pack_wordimage_f(data, x, y, filnarray)
      return
      end

c*******************************************************************************
c
c
c
      subroutine pack_longimage (data, x, y, filn)
c     =================================
c
c   Pack data stored in the array DATA with dimensions x * y in file FILN.
c
      implicit none
c
      character*(*) filn
      integer*4 x, y, j
      integer*4 data(x, y)
      integer*4 filnarray(1025)
c
c     ..
c     .. External C-routine
      external pack_wordimage_f
c
      do 10, j = 1, len(filn)
         if (filn(j:j) .ne. ' ') then
            filnarray(j) = ichar(filn(j:j))
         else
            filnarray(j) = 0
         endif
 10   continue
      filnarray(len(filn) + 1) = 0
      call pack_wordimage_f(data, x, y, filnarray)
      return
      end

c*******************************************************************************
c
c
c
      subroutine v2pack_longimage (data, x, y, filn)
c     =================================
c
c   Pack data stored in the array DATA with dimensions x * y in file FILN.
c
      implicit none
c
      character*(*) filn
      integer*4 x, y, j
      integer*4 data(x, y)
      integer*4 filnarray(1025)
c
c     ..
c     .. External C-routine
      external v2pack_wordimage_f
c
      do 10, j = 1, len(filn)
         if (filn(j:j) .ne. ' ') then
            filnarray(j) = ichar(filn(j:j))
         else
            filnarray(j) = 0
         endif
 10   continue
      filnarray(len(filn) + 1) = 0
      call v2pack_wordimage_f(data, x, y, filnarray)
      return
      end

c*******************************************************************************
c
c
c
      subroutine readpack_word (data, filn)
c     =================================
c
c     Read a packed image from file 'filn' into array 'data'. If you want 
c     to generate the mirror-image, (interchange first and last stripes, etc.)
c     call "mirror_wordimg(data, nfast, nslow)", where nfast and nslow contain
c     the number of fast and slow indices, after reading the packed image.
c
      implicit none
c
      character*(*) filn
      integer*2 data, j
      integer*4 filnarray(1025)
c
c     ..
c     .. External C-routine
      external readpack_word_f
c
      do 10, j = 1, len(filn)
         if (filn(j:j) .ne. ' ') then
            filnarray(j) = ichar(filn(j:j))
         else
            filnarray(j) = 0
         endif
 10   continue
      filnarray(len(filn) + 1) = 0
      call readpack_word_f(data, filnarray)
      return
      end

c*******************************************************************************
c
c
c
      subroutine readpack_long (data, filn)
c     =================================
c
c     Read a packed image from file 'filn' into array 'data'. If you want 
c     to generate the mirror-image, (interchange first and last stripes, etc.)
c     call "mirror_wordimg(data, nfast, nslow)", where nfast and nslow contain
c     the number of fast and slow indices, after reading the packed image.
c
      implicit none
c
      character*(*) filn
      integer*4 data, j
      integer*4 filnarray(1025)
c
c     ..
c     .. External C-routine
      external readpack_long_f
c
      do 10, j = 1, len(filn)
         if (filn(j:j) .ne. ' ') then
            filnarray(j) = ichar(filn(j:j))
         else
            filnarray(j) = 0
         endif
 10   continue
      filnarray(len(filn) + 1) = 0
      call readpack_long_f(data, filnarray)
      return
      end

c*******************************************************************************
c
c
c
      subroutine imsiz (filn, x, y)
c     =================================
c
c     Determines the size of the the packed image "filename" after 
c     unpacking.The dimensions are returned in x and y. 
c     Read a packed image from file 'filn' into array 'data'.
c
      implicit none
c
      character*(*) filn
      integer*4 x, y, j
      integer*4 filnarray(1025)
c
c     ..
c     .. External C-routine
      external imsiz_f
c
      do 10, j = 1, len(filn)
         if (filn(j:j) .ne. ' ') then
            filnarray(j) = ichar(filn(j:j))
         else
            filnarray(j) = 0
         endif
 10   continue
      filnarray(len(filn) + 1) = 0
      call imsiz_f(filnarray, x, y)
      return
      end

c*******************************************************************************

C
C     parser.f: wrappers and utilies for C parser functions
C
C     This library is free software: you can redistribute it and/or
C     modify it under the terms of the GNU Lesser General Public License
C     version 3, modified in accordance with the provisions of the 
C     license to address the requirements of UK law.
C 
C     You should have received a copy of the modified GNU Lesser General 
C     Public License along with this library.  If not, copies may be 
C     downloaded from http://www.ccp4.ac.uk/ccp4license.php
C 
C     This program is distributed in the hope that it will be useful,
C     but WITHOUT ANY WARRANTY; without even the implied warranty of
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C     GNU Lesser General Public License for more details.
C
C          CCP4 PARSER Routines
C          ====================
C
C  Original Author: Based on Mike Levitt's routine of the same name.
C  Modified By: Peter Brick, Phil Evans, Eleanor Dodson, Dave Love
C
C  Martyn Winn: legacy routines retained here. PARSER, PARSE and PARSDL
C    are now wrappers to C functions.
C
C     Library parser.f contains the following subroutines and functions,
C     some of which are currently unsued and commented out.
C
C  SUBROUTINES 
C
C    KEYNUM(N,NSTART,LINE,IBEG,IEND,ITYP,NTOK)
C  [ KEYERR(I,MODE,LINE,IBEG,IEND,ITYP) ] - internal subroutine (KEYNUM)
C    GTNREA(N,M,X,NTOK,ITYP,FVALUE)
C    GTNINT(N,M,J,NTOK,ITYP,FVALUE)
C    GTPREA(N,X,NTOK,ITYP,FVALUE)
C    GTPINT(N,I,NTOK,ITYP,FVALUE)
C    SBLANK(ARRAY,N1,N2)
C    CHKKEY(KEY,WORDS,NWORDS,IKEY)
C    PUTLIN(STROUT,OUTWIN)
C    BLANK(OUTWIN,NLINES)
C    LERROR(ERRFLG,IFAIL,ERRMSG)
C    RDSYMM(JTOK,LINE,IBEG,IEND,ITYP,FVALUE,NTOK,SPGNAM,NUMSGP,PGNAME,
C           NSYM,NSYMP,RSYM)
C    RDHEAD(JTOK,LINE,IBEG,IEND,ITYP,FVALUE,NTOK,MTZPRT,MTZBPR)
C    RDCELL(ITOK,ITYPE,FVALUE,NTOK,CELL)
C    RDRESO(ITOK,ITYPE,FVALUE,NTOK,RESMIN,RESMAX,SMIN,SMAX)
C    RDSCAL(ITOK,LINE,IBEG,IEND,ITYP,FVALUE,NTOK,NLPRGI,LSPRGI,ILPRGI,SCAL,BB)
C    RDRESL(ITOK,ITYPE,FVALUE,CVALUE,NTOK,RESMIN,RESMAX,SMIN,SMAX,ISTAT)
C    RDATOMSELECT(JTOK,INAT0,INAT1,IRES0,IRES1,CHNAM,IMODE,NTOK,LINE,IBEG,
C           IEND,ITYP,IDEC,FVALUE,IFAIL)
C    GTTREA(N,X,LFLAG,NTOK,ITYP,FVALUE)
C    GTTINT(N,I,LFLAG,NTOK,ITYP,FVALUE)
C
C FUNCTIONS
C
C    LOGICAL FUNCTION CMATCH(STRING1,STRING2,NCHAR)
C
C_BEGIN_INTRO
C          CCP4 PARSER Routines
C          ====================
C
C The PARSER module of the CCP4 library contains routines which are
C mainly used for `free-format' `keyworded' input of control data for
C programs.  Most programs have a loop over input records which are
C initially fed to the routine PARSER to tokenise them and extract the
C initial keyword.  PARSER can cope with continued, commented input
C lines and included files.  It calls PARSE to tokenise individual
C records and PARSE is sometimes useful itself to compensate for the
C lack of free-format internal READs in the fortran77 standard.  See
C the entries below for details.
C
C The library also contains routines to decode the parameters
C following the `standard' program keywords SYMMETRY, RESOLUTION,
C SCALE and CELL and to extract real and integer numbers from fields.
C 
C_END_INTRO
C
C
C_BEGIN_KEYNUM
C     ====================================================
      SUBROUTINE KEYNUM(N,NSTART,LINE,IBEG,IEND,ITYP,NTOK)
C     ====================================================
C  Check that correct number of numbers (numeric fields) are present
C
C--- Arguments:
C
C  N      (I) INTEGER        Number of consecutive numeric fields expected
C
C  NSTART (I) INTEGER        Number of first field to check
C
C  LINE   (I) CHARACTER*(*)  Array containing the fields
C
C  IBEG   (I) INTEGER(*)     First column number of fields (from PARSER)
C
C  IEND   (I) INTEGER(*)     Last column number of fields (from PARSER)
C
C  ITYP   (I) INTEGER(*)     =0  null field
C                            =1  character string
C                            =2  number
C                            (from PARSER)
C
C  NTOK   (I) INTEGER        Number of fields (from PARSER)
C
C_END_KEYNUM
C
C     .. Scalar Arguments ..
      INTEGER           N,NSTART,NTOK
      CHARACTER LINE*(*)
C     ..
C     .. Array Arguments ..
      INTEGER           IBEG(*),IEND(*),ITYP(*)
C     ..
C     .. Local Scalars ..
      INTEGER           I
      CHARACTER   LINERR*200
C     ..
C     .. External Subroutines ..
      EXTERNAL          KEYERR, CCPERR
C     ..
C
      DO 10 I = NSTART,NSTART + N - 1
          IF (I.GT.NTOK) THEN
              GO TO 30
          ELSE IF (ITYP(I).NE.2) THEN
              GO TO 20
          END IF
   10 CONTINUE
C
      RETURN
C
C          *******************************
   20 CALL KEYERR(I,2,LINE,IBEG,IEND,ITYP)
C          *******************************
C
      CALL CCPERR(1, 'Keyword error')
   30 CONTINUE
C
          WRITE (LINERR,FMT='(A,I4,A,I4,A)') 
     +     ' *** TOO FEW NUMBERS - ', (I - NSTART),
     +     ' FOUND WHEN ',N,' EXPECTED'
          CALL CCPERR(1, LINERR)
C
      END
C
      SUBROUTINE KEYERR(I,MODE,LINE,IBEG,IEND,ITYP)
C     =============================================
C  Print warning when token not of correct type.
C  Internal subroutine, called from KEYNUM.
C
C     .. Scalar Arguments ..
      INTEGER           I,MODE
      CHARACTER LINE*(*)
C     ..
C     .. Array Arguments ..
      INTEGER           IBEG(*),IEND(*),ITYP(*)
C     ..
C     .. Local Arrays ..
      CHARACTER         TYPE(3)*12
C     ..
C     .. Local Scalars ..
      CHARACTER LINERR*150
C     ..
C     .. External Subroutines ..
      EXTERNAL LERROR
C     ..
C     .. Data statements ..
      DATA              TYPE/'alphanumeric','numeric     ',
     +                  'quoted      '/
C     ..
C
C
      IF (MODE.EQ.0) THEN
          WRITE (LINERR,FMT='(A,A,A)') 
     +  ' ** ERROR : Key word < ',
     +  LINE(IBEG(I) : IEND(I)),
     +  ' > not recognized and has therefore been ignored'
C
C              ****************************
          CALL LERROR(1,0,LINERR)
C              ****************************
C
      ELSE
          WRITE (LINERR,FMT='(A,A,A,A,A,A,A)') 
     + ' ** ERROR: Token < ',
     +  LINE(IBEG(I) : IEND(I)),
     + ' > is ',
     + TYPE(ITYP(I)),
     + ' while a ',TYPE(I),' token was expected'
C
C              ****************************
          CALL LERROR(1,0,LINERR)
C              ****************************
      END IF
C
      END
C
C_BEGIN_GTNREA
C     ========================================
      SUBROUTINE GTNREA(N,M,X,NTOK,ITYP,FVALUE)
C     ========================================
C  Extract M real numbers X starting from N'th value of Parser
C  array FVALUE, if possible. If no value, X = 0.0 .
C  If illegal, write message.
C
C--- Arguments:
C
C N      (I) INTEGER    Number of 1st element of FVALUE to be extracted
C
C M      (I) INTEGER    Number of elements to be extracted
C
C X      (O) REAL(M)    Put extracted elements into this array
C
C NTOK   (I) INTEGER    Total number of fields (from PARSER)
C
C ITYP   (I) INTEGER(*)  =0  null field
C                        =1  character string
C                        =2  number
C
C FVALUE (I) REAL(*)     Array of numbers to be extracted (from PARSER)
C
C_END_GTNREA
C
C     .. Scalar Arguments ..
      INTEGER           M,N,NTOK
C     ..
C     .. Array Arguments ..
      INTEGER           ITYP(*)
      REAL              X(M),FVALUE(*)
C     ..
C     .. Local Scalars ..
      INTEGER           I,K
      CHARACTER LINERR*100
C     ..
C     .. External Subroutines ..
      EXTERNAL LERROR
C     ..
C
      DO 10 I = 1,M
          K = I + N - 1
          X(I) = 0.0
C
          IF (K.LE.NTOK) THEN
              IF (ITYP(K).EQ.2) THEN
                  X(I) = FVALUE(K)
              ELSE IF (ITYP(K).EQ.1) THEN
           WRITE (LINERR,FMT='(A,I4)') 
     +    ' Illegal number in field ',K
C
C              ****************************
          CALL LERROR(1,0,LINERR)
C              ****************************
C
              END IF
          END IF
   10 CONTINUE
      END
C
C_BEGIN_GTNINT
C     ========================================
      SUBROUTINE GTNINT(N,M,J,NTOK,ITYP,FVALUE)
C     ========================================
C Extract M integers J starting from N'th value of Parser array FVALUE,
C if possible. If no value, J = 0 . If illegal, write message
C
C--- Arguments:
C
C N      (I) INTEGER     Number of 1st element of FVALUE to be extracted
C
C M      (I) INTEGER     Number of elements to be extracted
C
C J      (O) INTEGER(M)  Put extracted elements into this array
C
C NTOK   (I) INTEGER     Total number of fields (from PARSER)
C
C ITYP   (I) INTEGER(*)  =0  null field
C                        =1  character string
C                        =2  number
C
C FVALUE (I) REAL(*)     Array of numbers to be extracted (from PARSER)
C
C_END_GTNINT
C
C     .. Scalar Arguments ..
      INTEGER           M,N,NTOK
C     ..
C     .. Array Arguments ..
      INTEGER           J(M),ITYP(*)
      REAL              FVALUE(*)
C     ..
C     .. Local Scalars ..
      INTEGER           I,K
      CHARACTER LINERR*200
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC         NINT
C     ..
C     .. External Subroutines ..
      EXTERNAL LERROR
C     ..
C
      DO 10 I = 1,M
          K = I + N - 1
          J(I) = 0
          IF (K.LE.NTOK) THEN
              IF (ITYP(K).EQ.2) THEN
                  J(I) = NINT(FVALUE(K))
              ELSE IF (ITYP(K).EQ.1) THEN
           WRITE (LINERR,FMT='(A,I4)') 
     +    ' Illegal number in field ',K
C
C              ****************************
          CALL LERROR(1,0,LINERR)
C              ****************************
C
              END IF
          END IF
   10 CONTINUE
C
      END
C
C_BEGIN_GTPREA
C     ======================================
      SUBROUTINE GTPREA(N,X,NTOK,ITYP,FVALUE)
C     ======================================
C Extract real number X from N'th value Parser array FVALUE, if possible
C If no value, leave X unchanged. If illegal, write message
C
C--- Arguments:
C
C N      (I) INTEGER    Number of 1st element of FVALUE to be extracted
C
C X      (O) REAL       Extracted number put here
C
C NTOK   (I) INTEGER    Total number of fields (from PARSER)
C
C ITYP   (I) INTEGER(*)  =0  null field
C                        =1  character string
C                        =2  number
C
C FVALUE (I) REAL(*)     Array of numbers to be extracted (from PARSER)
C
C_END_GTPREA
C
C     .. Scalar Arguments ..
      REAL X
      INTEGER N,NTOK
C     ..
C     .. Array arguments ..
      REAL FVALUE(*)
      INTEGER ITYP(*)
C     ..
C     .. Local Scalars ..
      CHARACTER LINERR*200
C     ..
C     .. External Subroutines ..
      EXTERNAL LERROR
C     ..
C
      IF (N.LE.NTOK) THEN
        IF (ITYP(N).EQ.2) THEN
          X = FVALUE(N)
        ELSE IF (ITYP(N).EQ.1) THEN
           WRITE (LINERR,FMT='(A,I4)') 
     +    ' Illegal number in field ',N
C
C              ****************************
          CALL LERROR(1,0,LINERR)
C              ****************************
C
        END IF
      ELSE
        CALL LERROR (1, 0, 'Real number expected at end of line')
      END IF
C
      END
C
C_BEGIN_GTPINT
C     ======================================
      SUBROUTINE GTPINT(N,I,NTOK,ITYP,FVALUE)
C     ======================================
C Extract integer I from N'th value Parser array FVALUE, if possible
C If no value, leave I unchanged. If illegal, write message
C
C--- Arguments:
C
C N      (I) INTEGER    Number of 1st element of FVALUE to be extracted
C
C I      (O) INTEGER    Extracted number put here
C
C NTOK   (I) INTEGER    Total number of fields (from PARSER)
C
C ITYP   (I) INTEGER(*)  =0  null field
C                        =1  character string
C                        =2  number
C
C FVALUE (I) REAL(*)     Array of numbers to be extracted (from PARSER)
C
C_END_GTPINT
C
C     .. Scalar Arguments ..
      INTEGER I,N,NTOK
C     ..
C     .. Arrays arguments ..
      REAL FVALUE(*)
      INTEGER ITYP(*)
C     ..
C     .. Local Scalars ..
      INTEGER ISTERR,IFGERR
      CHARACTER LINERR*100
C     ..
C     .. External Subroutines ..
      EXTERNAL LERROR
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC NINT
C     ..
C
      IF (N.LE.NTOK) THEN
        IF (ITYP(N).EQ.2) THEN
          I = NINT(FVALUE(N))
        ELSE IF (ITYP(N).EQ.1) THEN
           WRITE (LINERR,FMT='(A,I4)') 
     +    ' Illegal number in field ',N
          ISTERR = 1
          IFGERR = 0
C
C              ****************************
          CALL LERROR(ISTERR,IFGERR,LINERR)
C              ****************************
C
        END IF
      END IF
C
      END
C
C_BEGIN_SBLANK
C     ==============================
      SUBROUTINE SBLANK(ARRAY,N1,N2)
C     ==============================
C Blank characters N1 to N2 of ARRAY
C
C--- Arguments:
C
C ARRAY (I/O)  CHARACTER(*)
C
C N1    (I)    INTEGER
C
C N2    (I)    INTEGER
C
C_END_SBLANK
C
      CHARACTER*1 ARRAY(*)
      INTEGER I,N1,N2
C
      DO 10 I=N1,N2
         ARRAY(I)=' '
10     CONTINUE
C
      RETURN
      END
C
C_BEGIN_CMATCH
C     ==============================================
      LOGICAL FUNCTION CMATCH(STRING1,STRING2,NCHAR)
C     ==============================================
C
C---- Compare nchar character in string1 and string2
C     return cmatch .true. if all match, else .false.
C
C---- Arguments:
C
C STRING1 (I) CHARACTER*(*)  1st string to compare
C
C STRING2 (I) CHARACTER*(*)  2nd string to compare
C
C NCHAR   (I) INTEGER        number of characters to compare
C
C_END_CMATCH
C
      CHARACTER*(*) STRING1,STRING2
      INTEGER NCHAR
C
      IF(STRING1(1:NCHAR).EQ.STRING2(1:NCHAR)) THEN
          CMATCH=.TRUE.
      ELSE
          CMATCH=.FALSE.
      ENDIF
      END
C
C_BEGIN_CHKKEY
C     ========================================
      SUBROUTINE CHKKEY(KEY,WORDS,NWORDS,IKEY)
C     ========================================
C Check keyword KEY against list of NWORDS possible keywords in WORDS.
C Allows abbreviated or extended keys provided they are not ambiguous.
C
C---- Arguments:
C
C KEY    (I) CHARACTER*(*)         Keyword for checking
C
C WORDS  (I) CHARACTER(NWORDS)*(*) List of possible keywords
C
C NWORDS (I) INTEGER               Number of keywords in WORDS
C
C IKEY (I/O) INTEGER               = '?', list all words
C                                  Returns:
C                                  = keyword number found (.gt.0)
C                                  = 0 if not found or null
C                                  = -1 if ambiguous
C
C_END_CHKKEY
C
      INTEGER NFMAX
      PARAMETER (NFMAX=20)
C     .. Scalar Arguments ..
      INTEGER NWORDS, IKEY
      CHARACTER KEY*(*)
C     ..
C     .. Array Arguments ..
      CHARACTER WORDS(NWORDS)*(*)
C     ..
C     .. Local Scalars ..
      INTEGER LK,I,L,NFOUND,JDO
      CHARACTER LINERR*200
C     ..
C     .. Local Arrays ..
      INTEGER LFOUND(20)
C     ..
C     .. External Functions ..
      INTEGER LENSTR
      EXTERNAL LENSTR
C     ..
C     .. External Subroutines ..
      EXTERNAL PUTLIN,LERROR
C     ..
C
C---- Get minimum significant length of KEY 
C     ( function LENSTR returns the length
C     of the character string excluding trailing blanks)
C
      IKEY=0
C
C        ***********
      LK=LENSTR(KEY)
C        ***********
C
C---- Ignore null string
C
      IF(LK.LE.0) RETURN
C
      IF(KEY(1:1).EQ.'?') THEN
C  
C           ****************
       CALL PUTLIN(' Possible keywords are:','HLPWIN')
C           ****************
C
       DO 10 JDO = 1,NWORDS
C
C            ****************
        CALL PUTLIN(WORDS(JDO),'HLPWIN')
C            ****************
C
10      CONTINUE
C
            IKEY=0
            RETURN
      ENDIF
C
      NFOUND=0
C
C---- Check all possible words in case of ambiguities
C
      DO 20 I=1,NWORDS
C
C----  Key may be longer than word in list
C
C              ****************
      L=MIN(LK,LENSTR(WORDS(I)))
C              ****************
C
      IF(L.LE.0) GO TO 20
C
C---- Find out if KEY is an initial substring of this option word
C
      IF(INDEX(WORDS(I),KEY(1:L)).EQ.1) THEN
            NFOUND=NFOUND+1
C
            IF(NFOUND.GT.NFMAX) THEN
          WRITE (LINERR,FMT='(A,I5)') 
     +  ' CHKKEY: too many ambiguities : ',NFMAX
C
C              ****************************
          CALL LERROR(1,0,LINERR)
C              ****************************
C
                  NFOUND=NFMAX
            ELSE
                  LFOUND(NFOUND)=I
            ENDIF
       ENDIF
20     CONTINUE
C
C---- If keyword is ambiguous, list possibilities
C
      IF(NFOUND.GT.1) THEN
          WRITE (LINERR,FMT='(A,A,A)') 
     +   ' Keyword ',
     +   KEY(1:LK),
     +  ' is ambiguous: possibilities are -'
C
C              ****************************
          CALL LERROR(1,0,LINERR)
C              ****************************
C
       DO 30 JDO = 1,NWORDS
C
C            ****************
        CALL PUTLIN(WORDS(JDO),'HLPWIN')
C            ****************
C
30      CONTINUE
            IKEY=-1
      ELSEIF (NFOUND.EQ.1) THEN
C
C---- Success if only 1 found
C
            IKEY=LFOUND(1)
      ENDIF
      END
C
C_BEGIN_PUTLIN
C     ================================
      SUBROUTINE PUTLIN(STROUT,OUTWIN)
C     ================================
C---- This is a dummy PUTLIN to link with the MTZ routines mark 1 -
C     all it does is write the line in STROUT to lun 6. Later the
C     routines will be linked with the Compose-Parser etc. from Kim
C     where PUTLIN does a few more things !
C
C---- Arguments:
C
C STROUT (I) CHARACTER*(*)  Input line
C
C OUTWIN (O) CHARACTER*(*)  Not used
C
C_END_PUTLIN
C
C     .. Scalar Arguments ..
      CHARACTER OUTWIN* (*)
      CHARACTER STROUT* (*)
C     ..
C     .. Local Scalars ..
      INTEGER LUNOUT,LL,LS,LX
C     ..
C     .. External Functions ..
      INTEGER LENSTR
      EXTERNAL LENSTR
C     ..
C     .. Data statements ..
      DATA LUNOUT/6/
C     ..
C
      LL = LENSTR(STROUT)
      IF (LL.GE.132) THEN
      LX = 1
      LS = 131
10    CONTINUE
      WRITE (LUNOUT,FMT=6000) STROUT(LX:LS)
      IF (LS.EQ.LL) GOTO 20
      LX = LS  + 1
      LS = LS + 130
      IF (LS.GT.LL) LS = LL
      GO TO 10
      ELSE
       IF (LL.EQ.0) THEN
           WRITE(LUNOUT,FMT=6000)
            ELSE
      WRITE (LUNOUT,FMT=6000) STROUT(1:LL)
           END IF
      END IF
20    CONTINUE
C
C---- Format statements
C
 6000 FORMAT (' ',A)
C
      END
C
C_BEGIN_BLANK
C     ===============================
      SUBROUTINE BLANK(OUTWIN,NLINES)
C     ===============================
C---- This subroutine calls PUTLIN to output NLINES blank lines to the
C     window OUTWIN
C
C---- Arguments:
C
C     OUTWIN  (I)   CHARACTER*6     output window
C
C     NLINES  (I)   INTEGER         number of blank lines to output
C
C_END_BLANK
C
C     .. Scalar Arguments ..
      INTEGER NLINES
      CHARACTER OUTWIN*(*)
C     ..
C     .. Local Scalars ..
      INTEGER JDO10
C     ..
C     .. External Subroutines ..
      EXTERNAL PUTLIN
C     ..
C
      DO 10 JDO10 = 1,MAX(NLINES,1)
C
C            **************
        CALL PUTLIN(' ',OUTWIN)
C            **************
C
   10 CONTINUE
      END
C
C_BEGIN_LERROR
C     =======================================
      SUBROUTINE LERROR(ERRFLG,IFAIL,ERRMSG)
C     =======================================
C---- General error reporting subroutine, for the MTZ routines, etc
C
C---- Arguments:
C
C     ERRFLG  (I)  INTEGER         =1 output meesage as warning
C                                  =2 output message as fatal
C
C     IFAIL   (I)  INTEGER         =0 return after fatal error
C                                  =-1 STOP after reporting fatal error
C
C     ERRMSG  (I)  CHARACTER*(*)   character string containing error
C                                  message to output
C
C_END_LERROR
C
C     .. Scalar Arguments ..
      INTEGER ERRFLG,IFAIL
      CHARACTER ERRMSG* (*)
C     ..
C     ..
C     .. External Subroutines ..
      EXTERNAL BLANK,PUTLIN
C     ..
C
      IF (ERRFLG.EQ.1) THEN
C
C---- Output a warning message and return
C
        CALL BLANK('ERRWIN',1)
        CALL PUTLIN('***  Warning','ERRWIN')
        CALL PUTLIN(ERRMSG,'ERRWIN')
        CALL BLANK('ERRWIN',1)
C
      ELSE IF (ERRFLG.EQ.2) THEN
C
C---- Output a fatal message, and quit or return depending on IFAIL
C
        CALL BLANK('ERRWIN',1)
        CALL PUTLIN('***  Error','ERRWIN')
        CALL PUTLIN(ERRMSG,'ERRWIN')
        IF (IFAIL.LT.0) THEN
          call ccperr(1,'*** Program Terminated ')
        ELSE
          CALL BLANK('ERRWIN',1)
        END IF
        RETURN
      ELSE
C
C---- Bad errflg, output message and continue
C
        CALL BLANK('ERRWIN',1)
        CALL PUTLIN('*** Unrecognised  error','ERRWIN')
        CALL PUTLIN(ERRMSG,'ERRWIN')
        CALL PUTLIN('Program continuing ...','ERRWIN')
        CALL BLANK('ERRWIN',1)
C
      END IF
      END
C
C
C_BEGIN_RDSYMM
C     =======================================================
      SUBROUTINE RDSYMM(JTOK,LINE,IBEG,IEND,ITYP,FVALUE,NTOK,
     .    SPGNAM,NUMSGP,PGNAME,NSYM,NSYMP,RSYM)
C     =======================================================
C---- Read and decode symmetry specification
C
C---- Arguments:
C
C   JTOK    (I)  INTEGER        Number of first field to interpret
C
C   LINE    (I)  CHARACTER*(*)  Input string (from PARSER)
C
C   IBEG    (I)  INTEGER(*)     1st column number of tokens in field 
C                               (from PARSER)
C
C   IEND    (I)  INTEGER(*)     Last column number of tokens in field
C                               (from PARSER)
C
C   ITYP    (I)  INTEGER(*)     =0  null field
C                               =1  character string
C                               =2  number
C                               (from PARSER)
C
C   FVALUE  (I)  REAL(*)        Array of numbers. (from PARSER)
C
C   NTOK    (I)  INTEGER        The number of fields parsed. (from PARSER)
C
C     
C   NSYM  (I/O)  INTEGER        Number of symmetry operations already read,
C                               including non-primitive.
C                               (should be cleared to 0 at beginning)
C
C   SPGNAM  (I/O) CHARACTER*(*)   Space group name
C
C   NUMSGP  (O) INTEGER         Space group number
C
C   PGNAME  (O) CHARACTER*(*)   Point group name
C
C   NSYMP   (O) INTEGER         Number of primitive symmetry operations
C
C   RSYM    (O) REAL(4,4,*)     Symmetry matrices. * should be at least =NSYM
C
C_END_RDSYMM
C     
      INTEGER JTOK,NTOK
      INTEGER IBEG(*),IEND(*),ITYP(*)
      REAL FVALUE(*)
      CHARACTER*(*)LINE,SPGNAM,PGNAME
      CHARACTER*20 SPGNAMS
      INTEGER NUMSGP,NSYM,NSYMP,LENSTR
      EXTERNAL LENSTR

      REAL RSYM(4,4,*)
C     
C---- Look at next field on line: this can be
C     (a) a space-group number
C     (b) a space-group name, ie a string beginning P,I,R,F,A,B or C
C     (c) a symmetry operation (anything else)
C     
C---- for cases (a) & (b), this is a single field:
C     case (c) is more than 1 field
C     
      SPGNAMS = ' '
      SPGNAM = ' '
      IF (JTOK.GT.NTOK) THEN
         CALL  PUTLIN(' No symmetry data !!!','CURWIN')
      ELSE
         IF (JTOK.EQ.NTOK) THEN
            IF (NSYM.GT.0) THEN
               CALL  PUTLIN('Warning: symmetry already given','CURWIN')
            ENDIF
C     
C---- A single field, see if it is a number or a string
C
            IF (ITYP(JTOK).EQ.2) THEN
C     
C---- it's a number, treat as space-group number
C     
               NUMSGP = NINT(FVALUE(JTOK))
            ELSE
C     
C---- it's a string, treat as space-group name
C     
               SPGNAM = LINE(IBEG(JTOK) :IEND(JTOK))
               CALL  CCPUPC(SPGNAM)
               IF (SPGNAM(1:1).EQ.'R' .AND. 
     +             INDEX(SPGNAM,':H').LE.0) THEN
                 WRITE(6,'(A,A)') 'Warning: rhombohedral axes implied',
     +                  ' - if you have hexagonal axes then use H'
               ENDIF
               NUMSGP = 0
            END IF
C     
C---- Read symmetry (all operations) from SYMOP
C     open symop on channel 24 - closed at end of reading
C     NSYMP returns number of primitive operations
C     
C           CALL  MSYMLB(24,NUMSGP,SPGNAM,PGNAME,NSYMP,NSYM,RSYM)
            nsymp = 0
            nsym = 0 
            CALL  MSYMLB3(24,NUMSGP,SPGNAM,SPGNAMS,PGNAME,NSYMP,NSYM,
     +                    RSYM)
         ELSE
C     
C     
C---- Read symmetry operations
C    
            NSYM = NSYM + 1
            NSYMP = NSYM
            CALL  CCPUPC(LINE)
            CALL  SYMFR2(LINE,IBEG(JTOK),NSYM,RSYM)
            NUMSGP = 0
            PGNAME = ' '
C     
         END IF
      END IF
      END     
C     
C_BEGIN_RDHEAD
C     ======================================================
      SUBROUTINE RDHEAD(JTOK,LINE,IBEG,IEND,ITYP,FVALUE,NTOK,
     .    MTZPRT,MTZBPR)
C     ======================================================
C---- Read and decode HEADER command, to set print flags for MTZ headers
C
C---- Arguments:
C 
C   JTOK   (I) INTEGER       Number of first field to interpret
C
C   LINE   (I) CHARACTER*(*) Input string (from PARSER)
C
C   IBEG   (I) INTEGER(*)    1st column number of tokens in field 
C                            (from PARSER)
C
C   IEND   (I) INTEGER(*)    Last column number of tokens in field
C                            (from PARSER)
C
C   ITYP   (I) INTEGER(*)    =0  null field
C                            =1  character string
C                            =2  number
C                            (from PARSER)
C
C   FVALUE (I) REAL(*)       Array of numbers. (from PARSER)
C
C   NTOK   (I) INTEGER       The number of fields parsed. (from PARSER)
C
C     
C   MTZPRT (O) INTEGER       Flag to control printout from MTZ file header
C                            NONE    sets MTZPRT = 0
C                             no header o/p
C                            BRIEF   sets MTZPRT = 1 (default)
C                             brief header o/p
C                            HISTORY sets MTZPRT = 2
C                             brief + mtz history
C                            ALL     sets MTZPRT = 3
C                             full header o/p from mtz reads
C     
C   MTZBPR (O) INTEGER       Controls printout from BATCH HEADERS
C                            NOBATCH     sets MTZBPR = 0
C                             no batch header o/p
C                            BATCH       sets MTZBPR = 1  (default)
C                             batch titles o/p
C                            ORIENTATION sets MTZBPR = 2
C                             batch orientation also
C
C_END_RDHEAD
C     
      INTEGER JTOK,NTOK
      INTEGER IBEG(*),IEND(*),ITYP(*)
      REAL FVALUE(*)
      CHARACTER*(*) LINE
      INTEGER MTZPRT,MTZBPR
C     
C     Locals
      INTEGER I,IKEY
      CHARACTER KEY*12
C     
      INTEGER NKEYS
      PARAMETER (NKEYS=7)
      CHARACTER*12 KEYS(NKEYS)
      DATA KEYS/'NONE','BRIEF','HISTORY','ALL',
     $     'NOBATCH','BATCH','ORIENTATION'/
C     
C     Set defaults
      MTZPRT = 1
      MTZBPR = 1
C     
C     Loop keywords
      IF (NTOK .GE. JTOK) THEN
         DO 10, I=JTOK,NTOK
            KEY = LINE(IBEG(I):IEND(I))
            CALL CCPUPC(KEY)
            CALL CHKKEY(KEY,KEYS,NKEYS,IKEY)
            IF (IKEY .LE. 0) THEN
              CALL PUTLIN
     +             ('Unrecognized or ambiguous subkeyword to HEADER: '
     +             // KEY,'CURWIN')
            ELSE
               IF (IKEY .EQ. 1) MTZPRT = 0
               IF (IKEY .EQ. 2) MTZPRT = 1
               IF (IKEY .EQ. 3) MTZPRT = 2
               IF (IKEY .EQ. 4) MTZPRT = 3
               IF (IKEY .EQ. 5) MTZBPR = 0
               IF (IKEY .EQ. 6) MTZBPR = 1
               IF (IKEY .EQ. 7) MTZBPR = 2
            ENDIF
 10      CONTINUE 
      ENDIF
      END
C     
C_BEGIN_RDCELL
C     ==============================================
      SUBROUTINE RDCELL(ITOK,ITYPE,FVALUE,NTOK,CELL)
C     ==============================================     
C---- Read and decode cell parameters 
C     
C---- Arguments:
C
C   ITOK   (I) INTEGER     Number of first field to interpret
C
C   ITYPE  (I) INTEGER(*)  =0  null field
C                          =1  character string
C                          =2  number
C                          (from PARSER)
C
C   FVALUE (I) REAL(*)     Array of numbers. (from PARSER)
C
C   NTOK   (I) INTEGER     The number of fields parsed. (from PARSER)
C
C   CELL   (O) REAL(6)     Cell parameters a, b, c, alpha, beta, gamma.
C
C_END_RDCELL
C     
C     .. Scalar Arguments ..
      INTEGER           ITOK,NTOK
C     ..
C     .. Array Arguments ..
      REAL              CELL(6),FVALUE(*)
      INTEGER           ITYPE(*)
C     ..
C     .. External Subroutines ..
      EXTERNAL          GTPREA
C     ..
C     
      IF (NTOK .LT. ITOK+2) THEN
        CALL LERROR (1,0,'Cell a, b and c not given -- ignored')
        RETURN
      END IF
      CELL(4) = 90.0
      CELL(5) = 90.0
      CELL(6) = 90.0
C     
C     ***************************************
      CALL GTPREA(ITOK,CELL(1),NTOK,ITYPE,FVALUE)
      CALL GTPREA(ITOK+1,CELL(2),NTOK,ITYPE,FVALUE)
      CALL GTPREA(ITOK+2,CELL(3),NTOK,ITYPE,FVALUE)
C     ***************************************
C     
C     *********************************************
      IF (ITOK+3.LE.NTOK) CALL GTPREA(ITOK+3,CELL(4),NTOK,ITYPE,FVALUE)
      IF (ITOK+4.LE.NTOK) CALL GTPREA(ITOK+4,CELL(5),NTOK,ITYPE,FVALUE)
      IF (ITOK+5.LE.NTOK) CALL GTPREA(ITOK+5,CELL(6),NTOK,ITYPE,FVALUE)
C     *********************************************
      END
C     
C     
C_BEGIN_RDRESO
C     ================================================
      SUBROUTINE RDRESO(ITOK,ITYPE,FVALUE,NTOK,RESMIN,
     +                  RESMAX,SMIN,SMAX)
C     ================================================
C---- Read and decode resolution limits.
C     
C---- Arguments:
C
C     ITOK    (I) INTEGER     Number of first field to interpret
C     
C     ITYPE   (I) INTEGER(*)  =0  null field
C                             =1  character string
C                             =2  number
C                             (from PARSER)
C
C     FVALUE  (I) REAL(*)     Array of numbers. (from PARSER)
C
C     NTOK    (I) INTEGER     The number of fields parsed. (from PARSER)
C
C     
C     RESMIN  (O) REAL        Minimum resolution (in As)
C
C     RESMAX  (O) REAL        Maximum resolution (in As)
C
C     SMIN    (O) REAL        Minimum resolution ( 4sin**2/lambda**2)
C
C     SMAX    (O) REAL        Maximum resolution ( 4sin**2/lambda**2)
C
C_END_RDRESO
C     .. Scalar Arguments ..
      REAL              RESMAX,RESMIN,SMAX,SMIN
      INTEGER           ITOK,NTOK
C     ..
C     .. Array Arguments ..
      REAL              FVALUE(*)
      INTEGER           ITYPE(*)
C     ..
C     .. Local Scalars ..
      REAL              RESTEM,STEM
C     ..
C     .. External Subroutines ..
      EXTERNAL          GTPREA
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC         SQRT
C     ..
C
C---- Global defaults set here
C
        RESMAX = 10000.0
        RESMIN = .1
        IF (NTOK.LT.ITOK) THEN
          CALL LERROR(1,0,'Resolution missing')
          RETURN
        END IF
C     
C---- Look at next field on line: this can be
C     read resolution limits in A, if only one treat as high
C     resolution limit
C     
C     *************************************
      CALL GTPREA(ITOK,RESMIN,NTOK,ITYPE,FVALUE)
C     *************************************
C     
      IF (ABS(RESMIN).LE.0.000001) RESMIN = 0.00001
C     
C     ***************************************
      IF (NTOK.GT.ITOK)
     +      CALL GTPREA(ITOK+1,RESMAX,NTOK,ITYPE,FVALUE)
C     ***************************************
C     
      IF (ABS(RESMAX).LE.0.0000001) RESMAX = 100.0
C     
C     
      IF (RESMIN.LE.RESMAX) THEN
         RESTEM = RESMAX
         RESMAX = RESMIN
         RESMIN = RESTEM
      END IF
C     
C---- option to read 4sin**2/lamda**2
C     
      IF (RESMIN.LE.1.0 .AND. RESMAX.LE.1.0) THEN
C     
C---- swap over smin and resmin etc
C     
         SMIN = RESMIN
         SMAX = RESMAX
         RESMAX = SQRT(1.0/SMIN)
         RESMIN = SQRT(1.0/SMAX)
      ELSE
         SMIN = 1.0/RESMAX**2
         SMAX = 1.0/RESMIN**2
      END IF
C     
C     
      IF (SMIN.GT.SMAX) THEN
         STEM = SMAX
         SMAX = SMIN
         SMIN = STEM
      END IF
C     
C     
      RETURN
      END
C     
C     
C_BEGIN_RDSCAL     
C     ======================================================
      SUBROUTINE RDSCAL(ITOK,LINE,IBEG,IEND,ITYP,FVALUE,NTOK,
     .    NLPRGI,LSPRGI,ILPRGI,SCAL,BB)
C     ======================================================
C---- Read and decode SCALE .
C     
C---- Arguments:
C
C  ITOK   (I/O) INTEGER     Input: number of first field to interpret
C                           Output: number of next token to interpret (.gt. 0)
C                                  =  0 if line exhausted (SCAL & BB OK)
C                                  = -1 if no scale given
C                                  = -2 unrecognized label
C
C  LINE   (I) CHARACTER*(*) Input string (from PARSER)
C
C  IBEG   (I) INTEGER(*)    1st column number of tokens in field 
C                           (from PARSER)
C
C  IEND   (I) INTEGER(*)    Last column number of tokens in field
C                           (from PARSER)
C
C  ITYP   (I) INTEGER(*)    =0  null field
C                           =1  character string
C                           =2  number
C                           (from PARSER)
C
C  FVALUE (I) REAL(*)       Array of numbers. (from PARSER)
C
C  NTOK   (I) INTEGER       The number of fields parsed. (from PARSER)
C
C  LSPRGI (I) CHARACTER(*)*30  Program label strings.
C                                  L(abel) S(tring) PRG(ram) I(nput)
C
C  NLPRGI (I) INTEGER        Number of label strings in LSPRGI
C
C  ILPRGI (O) INTEGER        Number in array of LSPRGI whose scale has been reset
C
C  SCAL   (O) REAL           Scale factor, no default
C
C  BB     (O) REAL           Temperature factor, default = 0.0
C
C_END_RDSCAL
C     
      INTEGER ITOK,NTOK,ILPRGI,NLPRGI,JDO
      INTEGER IBEG(*),IEND(*),ITYP(*)
      REAL FVALUE(*)
      CHARACTER*(*) LINE
      CHARACTER*30 LSPRGI(*),CWORK
      REAL SCAL,BB
C     
      CWORK = LINE(IBEG(ITOK) :IEND(ITOK))
      DO 10 JDO = 1,NLPRGI
C     
         IF (CWORK.EQ.LSPRGI(JDO)) GO TO 20
C     
 10   CONTINUE
C     
C     ***********************
      CALL PUTLIN('**** Error input assignment does not match'//
     +     ' program labels','ERRWIN')
C     ***********************
C     
      ITOK = -2
      RETURN
C     
 20   ILPRGI = JDO
      IF(ITOK+1.GT.NTOK) THEN
         ITOK = -1
         RETURN
      ELSE
         IF (ITYP(ITOK+1) .EQ. 2) THEN
            CALL GTPREA(ITOK+1,SCAL,NTOK,ITYP,FVALUE)
         ELSE
            ITOK = -1
            RETURN
         ENDIF
      ENDIF
C
      BB = 0
      IF(ITOK+2.LE.NTOK) THEN
         IF (ITYP(ITOK+2) .EQ. 2) THEN
            CALL GTPREA(ITOK+2,BB,NTOK,ITYP,FVALUE)
            ITOK = ITOK + 3
         ELSE
            ITOK = ITOK + 2
         ENDIF
         IF (ITOK .GT. NTOK) ITOK = 0
      ELSE
         ITOK = 0
      ENDIF
C     
      RETURN
      END 
C
C
C_BEGIN_RDRESL
C     ======================================================
      SUBROUTINE RDRESL(ITOK,ITYPE,FVALUE,CVALUE,NTOK,RESMIN,
     +                  RESMAX,SMIN,SMAX,ISTAT)
C     ======================================================     
C---- Read and decode resolution limits.
C     Subkeywords in CVALUE recognized:
C       LOW   read next number as low resolution limit
C       HIGH  read next number as high resolution limit
C
C     If LOW & HIGH are both present, the limits will still be swapped
C     to the correct order
C
C     If only LOW or HIGH are given, the unset limit (ie either RESMAX, SMAX
C     or RESMIN, SMIN) will be set to -1.0. If only one number is given,
C     it is treated as a high resolution limit
C
C     If both limits are given without keywords, and both are .lt. 1.0,
c     it is assumed that the limits are 4(sin theta/lambda)**2 rather than A
C
C---- Arguments:
C
C  ITOK   (I) INTEGER         Number of first field to interpret
C
C  ITYP   (I) INTEGER(*)      =0  null field
C                             =1  character string
C                             =2  number
C                             (from PARSER)
C
C  FVALUE (I) REAL(*)         Array of numbers. (from PARSER)
C
C  NTOK   (I) INTEGER         The number of fields parsed. (from PARSER)
C
C  CVALUE (I) CHARACTER(*)*4  Parsed tokens from program input. (from PARSER)
C
C  RESMIN  (O) REAL           Minimum resolution (in As) (ie low resolution)
C
C  RESMAX  (O) REAL           Maximum resolution (in As) (ie high resolution)
C
C  SMIN    (O) REAL           Minimum resolution ( 4sin**2/lambda**2)
C                                (ie low resolution)
C
C  SMAX    (O) REAL           Maximum resolution ( 4sin**2/lambda**2)
C                                (ie high resolution)
C
C  ISTAT   (O) INTEGER        =0  OK
C                             =-1 illegal subkeyword
C                             =+1 no limits set
C                             =+2 illegal number (probably can't happen)
C_END_RDRESL
C     
C     .. Scalar Arguments ..
      REAL              RESMAX,RESMIN,SMAX,SMIN
      INTEGER           ITOK,NTOK,ISTAT
C     ..
C     .. Array Arguments ..
      REAL              FVALUE(*)
      INTEGER           ITYPE(*)
      CHARACTER*4       CVALUE(*)
C     ..
C     .. Local Scalars ..
      REAL              RESTEM,STEM
      INTEGER           N, KMNMX, NSET, LFLAG, NKEYS, IKEY
      LOGICAL           BOTH, KEYWRD
      CHARACTER*4 SUBKEY(2)
C     ..
C     .. External Subroutines ..
      EXTERNAL          GTTREA, CCPUPC, CHKKEY
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC         SQRT
C     ..
      DATA SUBKEY /'LOW', 'HIGH'/
      DATA NKEYS /2/
C
C---- Global defaults set here
C
      RESMAX = -1.0
      RESMIN = -1.0
      SMIN   = -1.0
      SMAX   = -1.0
      NSET   = 0
      KMNMX  = 1
      ISTAT  = 0
      BOTH = .TRUE.
      KEYWRD = .FALSE.
C     
      N  = ITOK
C
 1    IF (N .LE. NTOK) THEN
C
         IF (ITYPE(N) .EQ. 1) THEN
C String
            CALL CCPUPC(CVALUE(N))
            CALL CHKKEY(CVALUE(N),SUBKEY,NKEYS,IKEY)
            IF(IKEY.LE.0) THEN
               ISTAT = -1
               RETURN
C              ======
            ELSEIF (IKEY .EQ. 1) THEN
C----- subkey LOW
               KMNMX = 1
            ELSEIF (IKEY .EQ. 2) THEN
C----- subkey HIGH
               KMNMX = 2
            ENDIF
            BOTH = .NOT. BOTH
            KEYWRD = .TRUE.
         ELSE
C Number
            RESTEM = 0.0
C                ******************************************
            CALL GTTREA(N,RESTEM,LFLAG,NTOK,ITYPE,FVALUE)
C                ******************************************
            IF (LFLAG .EQ. 0) THEN
               IF (KMNMX .EQ. 1) THEN
                  RESMIN = RESTEM
                  NSET   = NSET+1
                  KMNMX  = 2
               ELSEIF (KMNMX .EQ. 2) THEN
                  RESMAX = RESTEM
                  NSET = NSET+1
                  KMNMX  = 1
               ENDIF
            ELSE
               ISTAT = +2
            ENDIF
         ENDIF
         N = N+1
         GO TO 1
      ENDIF
C
C  Have any numbers been set?
      IF (NSET .EQ. 0) THEN
         ISTAT = +1
         RETURN
C        ======
      ELSEIF (NSET .EQ. 1) THEN
C One only set, if no keywords have been defined, use single number as
C     high resolution limit
         IF (BOTH) THEN
            RESMAX = RESMIN
            RESMIN = -1.0
         ENDIF
      ENDIF
C     
C---- option to read 4sin**2/lamda**2
      IF (.NOT. KEYWRD .AND. NSET .EQ. 2) THEN
         IF (RESMIN .GT. 0.0 .AND. RESMIN .LE. 1.0 .AND.
     $       RESMAX .GT. 0.0 .AND. RESMAX .LE. 1.0) THEN
C---- swap over SMIN and RESMIN
C     
            SMIN = RESMIN
            RESMIN = SQRT(1.0/SMIN)
C---- swap over SMAX and RESMAX 
            SMAX = RESMAX
            RESMAX = SQRT(1.0/SMAX)
         END IF
      ENDIF
C     
      IF (RESMIN .GT. 0.0) THEN
         SMIN = 1.0/RESMIN**2
      END IF
C     
      IF (RESMAX .GT. 0.0) THEN
            SMAX = 1.0/RESMAX**2
      ENDIF
C     
C---- Check that they are in the correct order, if both limits read
C     
      IF (NSET .EQ. 2) THEN
         IF (RESMIN.LE.RESMAX) THEN
            RESTEM = RESMAX
            RESMAX = RESMIN
            RESMIN = RESTEM
         ENDIF
         IF (SMIN.GT.SMAX) THEN
            STEM = SMAX
            SMAX = SMIN
            SMIN = STEM
         ENDIF
      ENDIF
      END
C
C_BEGIN_GTTREA
C     =============================================
      SUBROUTINE GTTREA(N,X,LFLAG,NTOK,ITYP,FVALUE)
C     =============================================
C---- Extract real number X from N'th value of Parser array FVALUE,
C     if possible.
C
C     If no value, leave X unchanged. If illegal, write message
C
C---- Arguments:
C
C  N      (I) INTEGER     Number of 1st element of FVALUE to be extracted
C
C  X      (O) REAL        Put extracted number here
C
C  LFLAG  (O) INTEGER     =  0  OK (valid number or null field)
C                         = -1  beyond end of line
C                         = +1  illegal number
C
C  NTOK   (I) INTEGER     Total number of fields (from PARSER)
C
C  ITYP   (I) INTEGER(*)  =0  null field
C                         =1  character string
C                         =2  number
C                         (from PARSER)
C
C  FVALUE (I) REAL(*)     Array of numbers to be extracted (from PARSER)
C
C_END_GTTREA
C
C     .. Scalar Arguments ..
      REAL X
      INTEGER N,NTOK,LFLAG
C     ..
C     .. Array arguments ..
      REAL FVALUE(*)
      INTEGER ITYP(*)
C     ..
C     .. Local Scalars ..
      CHARACTER LINERR*200
C     ..
C     .. External Subroutines ..
      EXTERNAL LERROR
C     ..
C
      LFLAG = 0
      IF (N.LE.NTOK) THEN
        IF (ITYP(N).EQ.2) THEN
          X = FVALUE(N)
        ELSE IF (ITYP(N).EQ.1) THEN
           WRITE (LINERR,FMT='(A,I4)') 
     +    ' Illegal number in field ',N
C
C              ****************************
          CALL LERROR(1,0,LINERR)
C              ****************************
C
          LFLAG = +1
        END IF
      ELSE
         LFLAG = -1
      END IF
C
      END
C
C_BEGIN_GTTINT
C     =============================================
      SUBROUTINE GTTINT(N,I,LFLAG,NTOK,ITYP,FVALUE)
C     =============================================
C---- Extract integer I from N'th value of Parser array FVALUE,
C     if possible.
C
C     If no value, leave I unchanged. If illegal, write message.
C
C---- Arguments:
C
C  N      (I) INTEGER     Number of 1st element of FVALUE to be extracted
C
C  I      (O) INTEGER     Put extracted number here
C
C  LFLAG  (O) INTEGER     =  0  OK (valid number or null field)
C                         = -1  beyond end of line
C                         = +1  illegal number
C
C  NTOK   (I) INTEGER     Total number of fields (from PARSER)
C
C  ITYP   (I) INTEGER(*)  =0  null field
C                         =1  character string
C                         =2  number
C                         (from PARSER)
C
C  FVALUE (I) REAL(*)     Array of numbers to be extracted (from PARSER)
C
C_END_GTTINT
C
C      IMPLICIT NONE
C     .. Scalar Arguments ..
      INTEGER I,N,NTOK,LFLAG
C     ..
C     .. Arrays arguments ..
      REAL FVALUE(*)
      INTEGER ITYP(*)
C     ..
C     .. Local Scalars ..
      CHARACTER LINERR*100
C     ..
C     .. External Subroutines ..
      EXTERNAL LERROR
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC NINT
C     ..
C
      LFLAG = 0
      IF (N.LE.NTOK) THEN
        IF (ITYP(N).EQ.2) THEN
          I = NINT(FVALUE(N))
        ELSE IF (ITYP(N).EQ.1) THEN
           WRITE (LINERR,FMT='(A,I4)') ' Illegal number in field ',N
C
C              ****************************
          CALL LERROR(1,0,LINERR)
C              ****************************
C
          LFLAG = +1
        END IF
      ELSE
         LFLAG = -1
      END IF
      END
C
C_BEGIN_RDATOMSELECT
C     ==================================================================
      SUBROUTINE RDATOMSELECT(JTOK,INAT0,INAT1,IRES0,IRES1,CHNAM,
     +                        IMODE,NTOK,LINE,IBEG,IEND,ITYP,IDEC,
     +                        FVALUE,IFAIL)
C     ==================================================================
C
C  Subroutine to process atom selection keyword with the following
C  general syntax:
C
C    <Keywords...> ATOM <inat0> [ [TO] <inat1> ] |
C                  RESIDUE [ALL | ONS | CA] [ CHAIN <chnam> ]
C                  <ires0> [ [TO] <ires1> ]
C
C     e.g. kywd atom 1 to 100
C          kywd residue chain A 20 to 30
C          kywd residue all 11 32    etc...
C
C  To be compatible with DISTANG, CONTACT etc the ordering of the
C  RESIDUE subarguments is flexible, eg RESIDUE 1 TO 9 CA CHAIN B
C  is the same as RESIDUE CA CHAIN B 1 TO 9...
C
C  The subroutine returns the selection entered by the user and expects the
C  calling program to deal with the results. The preceeding keywords are
C  relevant for this subroutine
C
C  ARGUMENTS
C  =========
C
C     JTOK    (I) INTEGER       Number of first field to interpret
C     NTOK    (I) INTEGER       The number of fields parsed, from PARSER
C     LINE    (I) CHARACTER*(*) Input string, from PARSER
C     IBEG    (I) INTEGER(*)    1st column number of tokens in field
C                               (from PARSER)
C     IEND    (I) INTEGER(*)    Last column number of tokens in field
C                               (from PARSER)
C     ITYP    (I) INTEGER(*)    =0  null field
C                               =1  character string
C                               =2  number   (from PARSER)
C     IDEC    (I) INTEGER(*)    Number of characters/digits in each token
C                               (from PARSER)
C     FVALUE  (I) REAL(*)       Array of numbers. (from PARSER)
C
C     INAT0   (O) INTEGER       Lower limit of atom range (-99 if not set)
C     INAT1   (O) INTEGER       Upper limit of atom range (-99 if not set)
C     IRES0   (O) INTEGER       Lower limit of residue range (-99 if not set)
C     IRES1   (O) INTEGER       Upper limit of residue range (-99 if not set)
C     CHNAM   (O) CHARACTER*(*) Chain identifier (' ' if not set)
C     IMODE (I/O) INTEGER       On entry: -1 = don't allow MODE
C                                         any other value = allow MODE
C                               On exit:  Type of atoms to include:
C                                          1=ALL   2=ONS   3=CA (see eg CONTACT)
C     IFAIL (I/O) INTEGER       On entry:  0 = suppress warnings
C                                         -1 = print warnings
C                               On exit:   0 = LINE parsed ok
C                                         >0 = error occured parsing line
C                                              (value of IFAIL is no. of bad token)
C
C  RETURNED VALUES
C  ===============
C
C  The subroutine returns either:
C
C  1. first/last atom numbers, defining a range of atoms, or
C  2. first/last residue numbers, defining a range of residues, plus
C        (optionally) chain identifier
C        (optionally) a MODE which specifies which type of atoms to
C        include: all = (default) all atoms in residue range
C                 ons = only oxygen and nitrogen atoms
C                 ca  = only CA atoms
C        (see CONTACT/DISTANG)
C
C  Unset atoms/residue numbers will be returned < 0 (i.e. -99)
C  Unset chain identifier will be returned as a blank, i.e. ' '
C  Mode defaults to 1 = include all types of atoms.
C
C_END_RDATOMSELECT
C
      IMPLICIT NONE
C
C     ..Parameters
      INTEGER MAXTOK
      PARAMETER (MAXTOK=20)
C
C     ..Scalar arguments
      INTEGER   NTOK,JTOK,INAT0,INAT1,IRES0,IRES1,IMODE,IFAIL
      CHARACTER LINE*80,CHNAM*(*)
C
C     ..Array arguments
      INTEGER IBEG(MAXTOK),IEND(MAXTOK),ITYP(MAXTOK),IDEC(MAXTOK)
      REAL    FVALUE(MAXTOK)
C
C     ..Local scalars
      INTEGER ITOK,NLIMIT,TEMP
      CHARACTER KEY*4,ERRLINE*80
      LOGICAL LATOM,LRESI,LCHAIN,LLIMIT
C
C     ..Local arrays
      INTEGER ILIMIT(2)
C
C     ..External subroutines/functions
      EXTERNAL CCPUPC,CCPERR
C
C---- Initial checks
C
      IF (NTOK.GT.MAXTOK) THEN
        ERRLINE = 'RD_KEY_SELECT: too many arguments'
        GO TO 9010
      END IF
C
      IF (JTOK.LT.1 .OR. JTOK.GT.NTOK) THEN
        ERRLINE = 'RD_KEY_SELECT: JTOK out of range'
        GO TO 9010
      END IF
C
C---- Initialise values
C
      INAT0 = -99
      INAT1 = -99
      LATOM = .FALSE.
      IRES0 = -99
      IRES1 = -99
      CHNAM = ' '
C
C---- IMODE
C
      IF (IMODE.NE.-1) IMODE = 0
C
C---- Flags for modes
C
      LATOM  = .FALSE.
      LRESI  = .FALSE.
      LCHAIN = .FALSE.
      LLIMIT = .FALSE.
      NLIMIT = 0
      ERRLINE = ' '
C
C---- Step through line token at a time
C
      ITOK = JTOK
C
 9000 CONTINUE
      KEY  = LINE(IBEG(ITOK):IEND(ITOK))
      CALL CCPUPC(KEY)
C
C---- ATOM
C     ====
      IF (KEY(1:4).EQ.'ATOM') THEN
        IF (LATOM.OR.LRESI) ERRLINE = 'Multiple ATOM/RESidue keywords'
        LATOM = .TRUE.
C
C---- RESIDUE
C     =======
      ELSE IF (KEY(1:3).EQ.'RES') THEN
        IF (LATOM.OR.LRESI) ERRLINE = 'Multiple ATOM/RESidue keywords'
        LRESI = .TRUE.
C
C---- MODE: CA / ONS / ALL
C     ====================
      ELSE IF (KEY(1:3).EQ.'ALL'.OR.
     +         KEY(1:3).EQ.'ONS'.OR.
     +         KEY(1:2).EQ.'CA') THEN
C
        IF (IMODE.EQ.-1)
     +  ERRLINE = 'ALL/ONS/CA: invalid specifiers'
        IF (.NOT.LRESI)
     +  ERRLINE = 'ALL/ONS/CA not allowed without RESidue'
        IF (IMODE.GT.0) ERRLINE = 'Only one of CA/ONS/ALL allowed'
C
        IF (KEY(1:3).EQ.'ALL') IMODE = 1
        IF (KEY(1:3).EQ.'ONS') IMODE = 2
        IF (KEY(1:2).EQ.'CA')  IMODE = 3
C
C---- CHAIN <chnam>
C     =============
      ELSE IF (KEY(1:4).EQ.'CHAI') THEN
        IF (.NOT.LRESI) ERRLINE = 'CHAIN only allowed after RESidue'
        IF (LCHAIN) ERRLINE = 'Only one CHAIN allowed per line'
        ITOK = ITOK + 1
        IF (ITYP(ITOK).EQ.1 .AND. IDEC(ITOK).LE.2) THEN
          CHNAM = LINE(IBEG(ITOK):IEND(ITOK))
          LCHAIN = .TRUE.
        ELSE
          ERRLINE = 'Chain name should be one or two characters'
        END IF
C
C---- Number ...
C     ==========
C
C     These are atom or residue limits ... Process them all together
C     The possibilities are: 1 number, 2 numbers or 2 numbers separated
C     by "TO"
      ELSE IF (ITYP(ITOK).EQ.2) THEN
        IF (.NOT.(LATOM .OR. LRESI))
     +  ERRLINE = ' Missing ATOM or RESIDUE keyword'
        IF (LLIMIT)
     +  ERRLINE = ' Already read a set of atom/residue limits'
        ILIMIT(1) = INT(FVALUE(ITOK))
        ITOK = ITOK + 1
        NLIMIT = NLIMIT + 1
C
C     Check the next argument - is it "TO"?
        IF (ITYP(ITOK).EQ.1) THEN
          KEY = LINE(IBEG(ITOK):IEND(ITOK))
          CALL CCPUPC(KEY)
          IF (KEY(1:2).EQ.'TO') THEN
            IF(ITYP(ITOK+1).NE.2 .OR. ITOK.EQ.NTOK)
     +      ERRLINE = 'TO should be followed by a number'
            ITOK = ITOK + 1
          END IF
        END IF
C
C     Check if the next argument is the second limit
        IF (ITYP(ITOK).EQ.2) THEN
          ILIMIT(2) = INT(FVALUE(ITOK))
          NLIMIT = NLIMIT + 1
        ELSE
C
C     Otherwise, need to step back one token for next round
          ITOK = ITOK - 1
        END IF
        LLIMIT = .TRUE.
C
C---- Check for TO out of place
C
      ELSE IF (KEY(1:2).EQ.'TO') THEN
        ERRLINE = 'TO out of place'
C
C---- Keyword unrecognised otherwise
C
      ELSE
        write(6,*)key
        ERRLINE = 'Unrecognised subkeyword'
      END IF
C
C---- Use ERRLINE to trap errors
C
      IF (ERRLINE.NE.' ') GO TO 9010
C
C---- Parse some more?
C
      ITOK = ITOK + 1
      IF (ITOK.LE.NTOK) GO TO 9000
C
C---- Sort out the input
C
      IF (NLIMIT.EQ.0) THEN
        ERRLINE = 'Atom/residue limits unspecified'
        GO TO 9010
      ELSE IF (NLIMIT.EQ.1) THEN
        ILIMIT(2) = ILIMIT(1)
      ELSE IF (ILIMIT(1).GT.ILIMIT(2)) THEN
        TEMP = ILIMIT(1)
        ILIMIT(1) = ILIMIT(2)
        ILIMIT(2) = TEMP
      END IF
C
      IF (LATOM) THEN
        INAT0 = ILIMIT(1)
        INAT1 = ILIMIT(2)
      ELSE
        IRES0 = ILIMIT(1)
        IRES1 = ILIMIT(2)
      END IF
C
      IF (IMODE.EQ.0) IMODE = 1
C
      IFAIL = 0
      RETURN
C
C---- Errors come to here
C
 9010 IF (IFAIL.LT.0) CALL CCPERR(2, ERRLINE)
      IFAIL = ITOK
      RETURN
C
      END

C
C     keyparse.f: high-level interface to CCP4 parser functions
C     Copyright (C) 1995  Dave Love, Kevin Cowtan
C
C     This library is free software: you can redistribute it and/or
C     modify it under the terms of the GNU Lesser General Public License
C     version 3, modified in accordance with the provisions of the 
C     license to address the requirements of UK law.
C 
C     You should have received a copy of the modified GNU Lesser General 
C     Public License along with this library.  If not, copies may be 
C     downloaded from http://www.ccp4.ac.uk/ccp4license.php
C 
C     This program is distributed in the hope that it will be useful,
C     but WITHOUT ANY WARRANTY; without even the implied warranty of
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C     GNU Lesser General Public License for more details.
C
C     A simplified interface to the %$!$#@$ (so-called) parser:
C
C     The idea is to call a routine (MEMOPARSE) to read a keyworded line
C     into a hidden internal buffer and then have a simple chain of
C     calls to a set of routines which check the appropriate keyword,
C     look for any extra arguments associated with it, and set values in
C     their arguments as appropriate.  No if ... then ... else (or, much
C     worse, assigned goto) is necessary, nor maintaining the parser
C     arrays -- the relevant checking is done internally.  At the end of
C     the checks, call PARSEDIAGNOSE to print any appropriate messages
C     and loop back to MEMOPARSE if PARSEDIAGNOSE's argument is true
C     (otherwise continue and process the data read in).  You don't need
C     to check for `END' or end-of-file.  Geddit?
C
C     Escape hatch: use PARSEKEYARG to get all the tokens after a random
C     keyword and call PARSE (or whatever) to deal with them as
C     necessary.  This is usually deprecated, however -- go for
C     simply-structured input.
C
C     10 call memoparse (.true.)  ! setup and echo i/p
C        call parseint ('IVAL', ival)  ! ival.eq.3 after `IVAL 3'
C        call parsecell (cell)   ! assign cell from `CELL 20 30 40' etc.
C        call parsekeyarg ('FRED', rest)  ! the full horror in REST
C        call parse (rest, ....)
C         [firkle with the `parse'd arrays]
C         ...
C        call parsediagnose (cont) ! check
C        if (cont) goto 10
C   c     now do something useful...
C
C     Fixme: the set of routines below might need extending...
C     Fixme: consider whether more obscure names worthwhile to avoid
C     possible clashes.
C
C     Dave Love $Date$
C     Additions by Kevin Cowtan
C     
      subroutine memoparse (echo)
C
C     Call PARSER and stash the returned values away for later testing
C     when the other entrypoints are called. (OK, so it's not really
C     memoisation...).
C
C     ECHO is set to echo the parser i/p.

      implicit none
C     Args
      character*(*) key, subkey, spgnam, pgname, rest
      character*30 prglab(*)
      character*1 chnam
      logical echo, flag, cont
      integer ival, nsym, numsgp, nsymp, n, ivals (n), nth, mtznum,
     +  nprglab, toks, inat0, inat1, ires0, ires1, imode, ifail
      real rval, cell (6), rsym (4,4,*), resmin, resmax, smin, smax,
     +  rvals(n)

C     Stores for parser stuff
      integer maxtoks, maxline
C     Let's not mess around...
      parameter (maxtoks = 500, maxline=2000)
      integer ibeg(maxtoks), iend(maxtoks), ityp(maxtoks), idec(maxtoks)
      real fvalue (maxtoks)
      character*4 cvalue (maxtoks), memokey, memosubkey
      character line*(maxline)
      integer ntok

C     locals 
      logical someerr, eof, argerr, success(maxtoks)
      integer i, k

      save
      data someerr, eof /2*.false./
      
      ntok=maxtoks
      argerr = .false.
      line = ' '
C     in case of immediate EOF:
      success(1) = .true.
      call parser(memokey, line, ibeg, iend, ityp, fvalue, cvalue, idec,
     +     ntok, eof, echo)
C     END == EOF always
      if (memokey.eq.'END') eof = .true.
C     not sure if necessary:
      if (eof) memokey = ' '
      do i=1,ntok
       success(i) = .false.
      enddo
      return
      
      entry parsekey (key, flag)
C     bare KEY -- set FLAG if found
      if (memokey.eq.key) then
C       matched key
        if (ntok.eq.1) then
          success(1) = .true.
          flag = .true.
        else
          argerr = .true.
          call lerror (1, 0, 'No argument expected')
        end if
      end if
      return

      entry parsekeyarg (key, rest)
C     KEY + rest of line -- rest of line returned in REST
      if (memokey.eq.key) then
C       matched key
        if (ntok.gt.1) then
          do i=1,ntok
           success(i) = .true.
          enddo
          rest = line (ibeg(2):iend(ntok))
        else
          rest = ' '
          success(1) = .true.
C          argerr = .true.
C          call lerror (1, 0, 'Argument expected')
        end if
      end if
      return

      entry parseint (key, ival)
C     KEY + integer -- returned in IVAL
      if (memokey.eq.key) then
C       matched key
        if (ntok.eq.2 .and. ityp (2).eq.2) then
          ival = nint (fvalue(2))
          do i=1,2
           success(i) = .true.
          enddo
        else 
          argerr = .true.
          call lerror (1, 0, 'Integer argument expected')
        end if
      end if
      return
      
      entry parsereal (key, rval)
C     KEY + real -- returned in RVAL
      if (memokey.eq.key) then
C       matched key
        if (ntok.eq.2 .and. ityp (2).eq.2) then
          rval = fvalue(2)
          do i=1,2
           success(i) = .true.
          enddo
        else 
          argerr = .true.
          call lerror (1, 0, 'Real argument expected')
        end if
      end if
      return
      
      entry parsenargs(key, toks)
      toks = 0
      if (memokey .eq. key) toks = ntok
      return

      entry parsenints (key, n, ivals)
C     KEY + upto N integers -- N reset to number found, returned in IVALS
      if (memokey.eq.key) then
       success(1)=.true.
        if (ntok.ge.2 .and. ntok.le. n+1) then
          do i = 1, min (n, ntok-1)
            if (ityp (i+1).ne.2) return
            ivals (i) = nint (fvalue (i+1))
            n = i
            success(i+1) = .true.
          end do
        else
          argerr = .true.
          n = ntok
          call lerror (1, 0, 'Incorrect number of integer arguments')
        end if
      end if
      return
      
      entry parsenreals (key, n, rvals)
C     KEY + upto N reals -- N reset to number found, returned in RVALS
      if (memokey.eq.key) then
       success(1)=.true.
        if (ntok.ge.2 .and. ntok.le. n+1) then
          do i = 1, min (n, ntok-1)
            if (ityp (i+1).ne.2) return
            rvals (i) = fvalue (i+1)
            n = i
            success(i+1) = .true.
          end do
        else
          argerr = .true.
          n = ntok
          call lerror (1, 0, 'Incorrect number of real arguments')
        end if
      end if
      return
      
      entry parsesubkey (key, subkey, flag)
C     KEY + subkeyword SUB -- set FLAG if found
      if (memokey.eq.key) then
C       matched key
       success(1) = .true.
       if (subkey.ne.' ') then
        do k=2,ntok
         memosubkey=cvalue(k)
         call ccpupc(memosubkey)
         if (memosubkey.eq.subkey) then
          flag=.true.
          success(k)=.true.
         endif
        enddo
       else
        flag=.true.
       end if
      end if
      return
      
      entry parsesubkeyarg (key, subkey, nth, rest)
C     KEY + subkey + rest of line -- rest of line returned in REST
      if (memokey.eq.key) then
C       matched key
        success(1) = .true.
        k = 1
        if (subkey .ne. ' ') then
          k = 9999
          do i=2,ntok
            memosubkey=cvalue(i)
            call ccpupc(memosubkey)
            if (memosubkey.eq.subkey) then
             k = i
             goto 90
            endif
          enddo
        endif
   90   if (k.le.ntok) then
          if (ntok.ge.k+nth) then
            rest = line (ibeg(k+nth):iend(ntok))
            do i=2,ntok
              success(i) = .true.
            enddo
          else
            argerr = .true.
            call lerror (1, 0, 'Argument expected after sub-keyword')
          end if
        end if
      end if
      return

      entry parsesubint (key, subkey, nth, flag, ival)
C     KEY + n'th integer after subkey -- returned in IVAL
C     ERROR only if flag=true
      if (memokey.eq.key) then
C  ... matched key
       success(1) = .true.
       k=1
       if (subkey.ne.' ') then
        k=9999
        do i=2,ntok
         memosubkey=cvalue(i)
         call ccpupc(memosubkey)
         if (memosubkey.eq.subkey) then
          k=i
          goto 100
         endif
        enddo
       endif
  100  if (k.le.ntok) then
C  .... matched subkey (if set)
        success(k) = .true.
        if (ntok.ge.nth+k .and. ityp(nth+k).eq.2) then
         ival = nint (fvalue(nth+k))
         success(nth+k) = .true.
        else if (flag) then
         argerr = .true.
         call lerror (1, 0, 'Integer sub-argument expected')
        endif
       endif
      endif
      return
      
      entry parsesubreal (key, subkey, nth, flag, rval)
C     KEY + n'th real after subkey -- returned in RVAL
C     ERROR only if flag=true
      if (memokey.eq.key) then
C  ... matched key
       success(1) = .true.
       k=1
       if (subkey.ne.' ') then
        k=9999
        do i=2,ntok
         memosubkey=cvalue(i)
         call ccpupc(memosubkey)
         if (memosubkey.eq.subkey) then
          k=i
          goto 110
         endif
        end do
       endif
  110  if (k.le.ntok) then
C  .... matched subkey (if set)
        success(k) = .true.
        if (ntok.ge.nth+k .and. ityp(nth+k).eq.2) then
         rval = fvalue(nth+k)
         success(nth+k) = .true.
        else if (flag) then
         argerr = .true.
         call lerror (1, 0, 'Real sub-argument expected')
        endif
       endif
      endif
      return
      
      entry parsesubchar (key, subkey, nth, flag, rest)
C     KEY + n'th string after subkey -- returned in REST
      if (memokey.eq.key) then
C  ... matched key
       success(1) = .true.
       k=1
       if (subkey.ne.' ') then
        k=9999
        do i=2,ntok
         memosubkey=cvalue(i)
         call ccpupc(memosubkey)
         if (memosubkey.eq.subkey) then
          k=i
          goto 120
        endif
        end do
       endif
  120  if (k.le.ntok) then
C  .... matched subkey (if set)
        success(k) = .true.
        if (ntok.ge.nth+k .and. (ityp(nth+k).ne.0 .or. .not.flag) ) then
         rest = line(ibeg(nth+k):iend(nth+k))
         success(nth+k) = .true.
        else if (flag) then
         argerr = .true.
         call lerror (1, 0, 'Character sub-argument expected')
        endif
       endif
      endif
      return
      
      entry parsecell (cell)
C     CELL -- returned in CELL
      if (memokey.eq.'CELL') then
        call rdcell (2, ityp, fvalue, ntok, cell)
        do i=1,ntok
         success(i) = .true.
        enddo
      end if
      return
      
      entry parsesymm (spgnam, numsgp, pgname, nsym, nsymp, rsym)
C     SYMMetry -- usual values returned
      if (memokey.eq.'SYMM') then
        nsym = 0
        call rdsymm(2, line, ibeg, iend, ityp, fvalue, ntok, spgnam,
     +       numsgp, pgname, nsym, nsymp, rsym)
        do i=1,ntok
         success(i) = .true.
        enddo
      end if
      return

      entry parseatomselect(key, inat0, inat1, ires0, ires1, chnam,
     +                      imode)
C     KEYword followed by atom/residue selection syntax
C     key atom <ai> [[to] <aj>] |
C         residue [all|ons|ca] [chain <chn>] <ri> [[to] <rj>]
C     Returns values of <ai>,<aj>,imode...
      if (memokey.eq.key) then
C       matched key
        ifail = -1
        call rdatomselect(2, inat0, inat1, ires0, ires1, chnam, imode,
     +                     ntok, line, ibeg, iend, ityp, idec, fvalue,
     +                     ifail)
        do i=1,ntok
          if (i.ne.ifail) success(i)=.true.
        enddo
      endif
      return

      entry parsereso (resmin, resmax, smin, smax)
C     RESOlution -- usual values returned
      if (memokey.eq.'RESO') then
        call rdreso (2, ityp, fvalue, ntok, resmin, resmax, smin, smax)
        do i=1,ntok
         success(i) = .true.
        enddo
      end if
      return
      
      entry parselabin(mtznum,prglab,nprglab)
C     LABIn -- requires mtz file number, program labels, and number of.
      if (memokey.eq.'LABI') then
        call lkyin(mtznum,prglab,nprglab,ntok,line,ibeg,iend)
        do i=1,ntok
         success(i) = .true.
        enddo
      end if
      return
      
      entry parselabout(mtznum,prglab,nprglab)
C     LABOut -- requires mtz file number, program labels, and number of.
      if (memokey.eq.'LABO') then
        call lkyout(mtznum,prglab,nprglab,ntok,line,ibeg,iend)
        do i=1,ntok
         success(i) = .true.
        enddo
      end if
      return

      entry parsefail()
      do i=1,ntok
       success(i) = .false.
      enddo
      return

      entry parseend(key)
C     KEY -- is treated as input terminator as same as END
      if (memokey .eq. key) eof = .true.
      return
      
      entry parsediagnose (cont)
C     Call at end of tests for possible 'Invalid keyword' diagnostic or
C     abort if at EOF and had an error.  Continue processing (no EOF)
C     if (cont).
      if (.not.argerr .and. .not.eof) then
       if (.not.success(1)) then
        call lerror (1, 0, 'Invalid keyword')
        someerr = .true.
       endif
       do i=2,ntok
        if (.not.success(i)) then
         write (line,950)i
 950     format ('Invalid sub-keyword in position ',i2)
         call lerror (1, 0, line)
         someerr = .true.
        endif
       enddo
      endif
      if (argerr) then
        someerr = .true.
      end if
      argerr = .false.
      if (eof) then
        cont = .false.
        if(someerr) call ccperr (1, 'Input error (see above)')
      else
        cont = .true.
      end if
      do i=1,ntok
       success(i) = .false.
      enddo
      return
C
      end

C
C     fftlib.f: fast-fourier transform library routines
C     Copyright (C)  Lynn Ten Eyck
C
C     This library is free software: you can redistribute it and/or
C     modify it under the terms of the GNU Lesser General Public License
C     version 3, modified in accordance with the provisions of the 
C     license to address the requirements of UK law.
C 
C     You should have received a copy of the modified GNU Lesser General 
C     Public License along with this library.  If not, copies may be 
C     downloaded from http://www.ccp4.ac.uk/ccp4license.php
C 
C     This program is distributed in the hope that it will be useful,
C     but WITHOUT ANY WARRANTY; without even the implied warranty of
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C     GNU Lesser General Public License for more details.
C
C-- FFT81       F77TRNFM.FOR                        13/09/85    JWC
C
C
C**** FOLLOWING ARE ROUTINES USED BY TEN EYCK'S FFT PROGRAMS***
C
C
      SUBROUTINE CMPLFT(X,Y,N,D)
C     ===============================
C
C
C     Complex finite discrete fourier transform
C     transforms one dimension of multi-dimensional data
C     modified by L. F. TEN EYCK from a one-dimensional version written
C     by G. T. SANDE, 1969.
C
C     This program calculates the transform
C               (X(T) + I*Y(T))*(COS(2*PI*T/N) - I*SIN(2*PI*T/N))
C
C     INDEXING -- the arrangement of the multi-dimensional data is
C     specified by the integer array D, the values of which are used as
C     control parameters in do loops.  when it is desired to cover all
C     elements of the data for which the subscript being transformed has
C     the value I0, the following is used.
C
C               I1 = (I0 - 1)*D(2) + 1
C               DO 100 I2 = I1, D(1), D(3)
C               I3 = I2 + D(4) - 1
C               DO 100 I = I2, I3, D(5)
C                  .
C                  .
C           100 CONTINUE
C
C     with this indexing it is possible to use a number of arrangements
C     of the data, including normal fortran complex numbers (d(5) = 2)
C     or separate storage of real and imaginary parts.
C
C
C---- PMAX is the largest prime factor that will be tolerated by this
C     program.
C
C---- TWOGRP is the largest power of two that is treated as a special
C     case.
C
C     .. Scalar Arguments ..
      INTEGER           N
C     ..
C     .. Array Arguments ..
      REAL              X(*),Y(*)
      INTEGER           D(5)
C     ..
C     .. Local Scalars ..
      INTEGER           PMAX,PSYM,TWOGRP
      LOGICAL           ERROR
      CHARACTER EMESS*80
C     ..
C     .. Local Arrays ..
      INTEGER           FACTOR(15),SYM(15),UNSYM(15)
C     ..
C     .. External Subroutines ..
      EXTERNAL          DIPRP,MDFTKD,SRFP
C     ..
      PMAX = 19
      TWOGRP = 8
C
      IF (N.GT.1) THEN
          CALL SRFP(N,PMAX,TWOGRP,FACTOR,SYM,PSYM,UNSYM,ERROR)
          IF (ERROR) THEN
C
              WRITE (EMESS,FMT=9000) N
              call ccperr(1, EMESS)
          ELSE
C
              CALL MDFTKD(N,FACTOR,D,X,Y)
              CALL DIPRP(N,SYM,PSYM,UNSYM,D,X,Y)
          END IF
      END IF
C
C---- Format statements
C
 9000 FORMAT ('FFTLIB: invalid number of points for CMPL FT.  N =',I10)
      END
C
C
      SUBROUTINE SRFP(PTS,PMAX,TWOGRP,FACTOR,SYM,PSYM,UNSYM,ERROR)
C     ==================================================================
C
C
C---- Symmetrized reordering factoring programme
C
C
C     .. Scalar Arguments ..
      INTEGER         PMAX,PSYM,PTS,TWOGRP
      LOGICAL         ERROR
C     ..
C     .. Array Arguments ..
      INTEGER         FACTOR(15),SYM(15),UNSYM(15)
C     ..
C     .. Local Scalars ..
      INTEGER         F,J,JJ,N,NEST,P,PTWO,Q,R
C     ..
C     .. Local Arrays ..
      INTEGER         PP(14),QQ(7)
C     ..
      NEST = 14
C
      N = PTS
      PSYM = 1
      F = 2
      P = 0
      Q = 0
   10 CONTINUE
      IF (N.LE.1) THEN
          GO TO 60
      ELSE
          DO 20 J = F,PMAX
              IF (N.EQ. (N/J)*J) GO TO 30
   20         CONTINUE
          GO TO 40
   30     IF (2*P+Q.GE.NEST) THEN
              GO TO 50
          ELSE
              F = J
              N = N/F
              IF (N.EQ. (N/F)*F) THEN
                  N = N/F
                  P = P + 1
                  PP(P) = F
                  PSYM = PSYM*F
              ELSE
                  Q = Q + 1
                  QQ(Q) = F
              END IF
              GO TO 10
          END IF
      END IF
C
   40 CONTINUE
      WRITE (6,FMT=9000) PMAX,PTS
      ERROR = .TRUE.
      GO TO 100
C
   50 CONTINUE
      WRITE (6,FMT=9010) NEST,PTS
      ERROR = .TRUE.
      GO TO 100
C
   60 CONTINUE
      R = 1
      IF (Q.EQ.0) R = 0
      IF (P.GE.1) THEN
          DO 70 J = 1,P
              JJ = P + 1 - J
              SYM(J) = PP(JJ)
              FACTOR(J) = PP(JJ)
              JJ = P + Q + J
              FACTOR(JJ) = PP(J)
              JJ = P + R + J
              SYM(JJ) = PP(J)
   70         CONTINUE
      END IF
      IF (Q.GE.1) THEN
          DO 80 J = 1,Q
              JJ = P + J
              UNSYM(J) = QQ(J)
              FACTOR(JJ) = QQ(J)
   80         CONTINUE
          SYM(P+1) = PTS/PSYM**2
      END IF
      JJ = 2*P + Q
      FACTOR(JJ+1) = 0
      PTWO = 1
      J = 0
   90 CONTINUE
      J = J + 1
      IF (FACTOR(J).NE.0) THEN
          IF (FACTOR(J).EQ.2) THEN
              PTWO = PTWO*2
              FACTOR(J) = 1
              IF (PTWO.LT.TWOGRP) THEN
                  IF (FACTOR(J+1).EQ.2) GO TO 90
              END IF
              FACTOR(J) = PTWO
              PTWO = 1
          END IF
          GO TO 90
      END IF
      IF (P.EQ.0) R = 0
      JJ = 2*P + R
      SYM(JJ+1) = 0
      IF (Q.LE.1) Q = 0
      UNSYM(Q+1) = 0
      ERROR = .FALSE.
C
  100 CONTINUE
C
C---- Format statements
C
 9000 FORMAT (' FFTLIB: Largest factor exceeds ',I3,'.  N = ',I6,'.')
 9010 FORMAT (' FFTLIB: Factor count exceeds ',I3,'.  N = ',I6,'.')
      END
C
C
      SUBROUTINE MDFTKD(N,FACTOR,DIM,X,Y)
C     ==========================================
C
C
C---- Multi-dimensional complex fourier transform kernel driver
C
C
C     .. Scalar Arguments ..
      INTEGER           N
C     ..
C     .. Array Arguments ..
      REAL              X(*),Y(*)
      INTEGER           DIM(5),FACTOR(15)
C     ..
C     .. Local Scalars ..
      INTEGER           F,M,P,R,S
C     ..
C     .. External Subroutines ..
      EXTERNAL          R2CFTK,R3CFTK,R4CFTK,R5CFTK,R8CFTK,RPCFTK
C     ..
      S = DIM(2)
      F = 0
      M = N
   10 CONTINUE
      F = F + 1
      P = FACTOR(F)
      IF (P.EQ.0) THEN
          RETURN
      ELSE
          M = M/P
          R = M*S
          IF (P.LE.8) THEN
              GO TO (10,20,30,40,50,80,70,60) P
              GO TO 80
C
   20         CONTINUE
              CALL R2CFTK(N,M,X(1),Y(1),X(R+1),Y(R+1),DIM)
              GO TO 10
C
   30         CONTINUE
              CALL R3CFTK(N,M,X(1),Y(1),X(R+1),Y(R+1),X(2*R+1),Y(2*R+1),
     +                    DIM)
              GO TO 10
C
   40         CONTINUE
              CALL R4CFTK(N,M,X(1),Y(1),X(R+1),Y(R+1),X(2*R+1),Y(2*R+1),
     +                    X(3*R+1),Y(3*R+1),DIM)
              GO TO 10
C
   50         CONTINUE
              CALL R5CFTK(N,M,X(1),Y(1),X(R+1),Y(R+1),X(2*R+1),Y(2*R+1),
     +                    X(3*R+1),Y(3*R+1),X(4*R+1),Y(4*R+1),DIM)
              GO TO 10
C
   60         CONTINUE
              CALL R8CFTK(N,M,X(1),Y(1),X(R+1),Y(R+1),X(2*R+1),Y(2*R+1),
     +                    X(3*R+1),Y(3*R+1),X(4*R+1),Y(4*R+1),X(5*R+1),
     +                    Y(5*R+1),X(6*R+1),Y(6*R+1),X(7*R+1),Y(7*R+1),
     +                    DIM)
              GO TO 10
          END IF
C
   70     CONTINUE
          CALL RPCFTK(N,M,P,R,X,Y,DIM)
          GO TO 10
      END IF
C
   80 CONTINUE
      WRITE (6,FMT=9000)
C
C---- Format statements
C
 9000 FORMAT ('0TRANSFER ERROR DETECTED IN MDFTKD',//)
      END
C
C
      SUBROUTINE R2CFTK(N,M,X0,Y0,X1,Y1,DIM)
C     ==============================================
C
C
C---- Radix 2 multi-dimensional complex fourier transform kernel
C
C     .. Scalar Arguments ..
      INTEGER           M,N
C     ..
C     .. Array Arguments ..
      REAL              X0(*),X1(*),Y0(*),Y1(*)
      INTEGER           DIM(5)
C     ..
C     .. Local Scalars ..
      REAL              ANGLE,C,FM2,IS,IU,RS,RU,S,TWOPI
      INTEGER           J,K,K0,K1,K2,KK,L,L1,M2,MM2,MOVER2,NS,NT,SEP,
     +                  SIZE
      LOGICAL           FOLD,ZERO
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC         COS,REAL,SIN
C     ..
C     .. Data statements ..
      DATA              TWOPI/6.283185/
C     ..
C
      NT = DIM(1)
      SEP = DIM(2)
      L1 = DIM(3)
      SIZE = DIM(4) - 1
      K2 = DIM(5)
      NS = N*SEP
      M2 = M*2
      FM2 = REAL(M2)
      MOVER2 = M/2 + 1
      MM2 = SEP*M2
C
      DO 50 J = 1,MOVER2
          FOLD = J .GT. 1 .AND. 2*J .LT. M + 2
          K0 = (J-1)*SEP + 1
          ZERO = j. eq. 1
          IF (.NOT.ZERO) THEN
              ANGLE = TWOPI*REAL(j-1)/FM2
              C = COS(ANGLE)
              S = SIN(ANGLE)
          END IF
   10     CONTINUE
C
          DO 40 KK = K0,NS,MM2
              DO 30 L = KK,NT,L1
                  K1 = L + SIZE
                  DO 20 K = L,K1,K2
                      RS = X0(K) + X1(K)
                      IS = Y0(K) + Y1(K)
                      RU = X0(K) - X1(K)
                      IU = Y0(K) - Y1(K)
                      X0(K) = RS
                      Y0(K) = IS
                      IF (ZERO) THEN
                          X1(K) = RU
                          Y1(K) = IU
                      ELSE
                          X1(K) = RU*C + IU*S
                          Y1(K) = IU*C - RU*S
                      END IF
   20                 CONTINUE
   30             CONTINUE
   40         CONTINUE
          IF (FOLD) THEN
              FOLD = .FALSE.
              K0 = (M+1-J)*SEP + 1
              C = -C
              GO TO 10
          END IF
   50     CONTINUE
C
      END
C
C
      SUBROUTINE R3CFTK(N,M,X0,Y0,X1,Y1,X2,Y2,DIM)
C     ======================================================
C
C
C---- Radix 3 multi-dimensional complex fourier transform kernel
C
C     .. Scalar Arguments ..
      INTEGER           M,N
C     ..
C     .. Array Arguments ..
      REAL              X0(*),X1(*),X2(*),Y0(*),Y1(*),Y2(*)
      INTEGER           DIM(5)
C     ..
C     .. Local Scalars ..
      REAL              A,ANGLE,B,C1,C2,FM3,I0,I1,I2,IA,IB,IS,R0,
     +                  R1,R2,RA,RB,RS,S1,S2,T,TWOPI
      INTEGER           J,K,K0,K1,K2,KK,L,L1,M3,MM3,MOVER2,NS,NT,SEP,
     +                  SIZE
      LOGICAL           FOLD,ZERO
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC         COS,REAL,SIN
C     ..
C     .. Data statements ..
      DATA              TWOPI/6.283185/,A/-0.5/,B/0.86602540/
C     ..
C
      NT = DIM(1)
      SEP = DIM(2)
      L1 = DIM(3)
      SIZE = DIM(4) - 1
      K2 = DIM(5)
      NS = N*SEP
      M3 = M*3
      FM3 = REAL(M3)
      MM3 = SEP*M3
      MOVER2 = M/2 + 1
C
      DO 50 J = 1,MOVER2
          FOLD = J .GT. 1 .AND. 2*J .LT. M + 2
          K0 = (J-1)*SEP + 1
          ZERO = j .eq. 1
          IF (.NOT.ZERO) THEN
              ANGLE = TWOPI*REAL(j-1)/FM3
              C1 = COS(ANGLE)
              S1 = SIN(ANGLE)
              C2 = C1*C1 - S1*S1
              S2 = S1*C1 + C1*S1
          END IF
   10     CONTINUE
C
          DO 40 KK = K0,NS,MM3
              DO 30 L = KK,NT,L1
                  K1 = L + SIZE
                  DO 20 K = L,K1,K2
                      R0 = X0(K)
                      I0 = Y0(K)
                      RS = X1(K) + X2(K)
                      IS = Y1(K) + Y2(K)
                      X0(K) = R0 + RS
                      Y0(K) = I0 + IS
                      RA = RS*A + R0
                      IA = IS*A + I0
                      RB = (X1(K)-X2(K))*B
                      IB = (Y1(K)-Y2(K))*B
                      IF (ZERO) THEN
                          X1(K) = RA + IB
                          Y1(K) = IA - RB
                          X2(K) = RA - IB
                          Y2(K) = IA + RB
                      ELSE
                          R1 = RA + IB
                          I1 = IA - RB
                          R2 = RA - IB
                          I2 = IA + RB
                          X1(K) = R1*C1 + I1*S1
                          Y1(K) = I1*C1 - R1*S1
                          X2(K) = R2*C2 + I2*S2
                          Y2(K) = I2*C2 - R2*S2
                      END IF
   20                 CONTINUE
   30             CONTINUE
   40         CONTINUE
          IF (FOLD) THEN
              FOLD = .FALSE.
              K0 = (M+1-J)*SEP + 1
              T = C1*A + S1*B
              S1 = C1*B - S1*A
              C1 = T
              T = C2*A - S2*B
              S2 = -C2*B - S2*A
              C2 = T
              GO TO 10
          END IF
   50     CONTINUE
C
      END
C
C
      SUBROUTINE R4CFTK(N,M,X0,Y0,X1,Y1,X2,Y2,X3,Y3,DIM)
C     ==============================================================
C
C
C---- Radix 4 multi-dimensional complex fourier transform kernel
C
C     .. Scalar Arguments ..
      INTEGER           M,N
C     ..
C     .. Array Arguments ..
      REAL              X0(*),X1(*),X2(*),X3(*),Y0(*),Y1(*),
     +                  Y2(*),Y3(*)
      INTEGER           DIM(5)
C     ..
C     .. Local Scalars ..
      REAL              ANGLE,C1,C2,C3,FM4,I1,I2,I3,IS0,IS1,IU0,
     +                  IU1,R1,R2,R3,RS0,RS1,RU0,RU1,S1,S2,S3,T,TWOPI
      INTEGER           J,K,K0,K1,K2,KK,L,L1,M4,MM4,MOVER2,NS,NT,SEP,
     +                  SIZE
      LOGICAL           FOLD,ZERO
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC         COS,REAL,SIN
C     ..
C     .. Data statements ..
      DATA              TWOPI/6.283185/
C     ..
C
      NT = DIM(1)
      SEP = DIM(2)
      L1 = DIM(3)
      SIZE = DIM(4) - 1
      K2 = DIM(5)
      NS = N*SEP
      M4 = M*4
      FM4 = REAL(M4)
      MM4 = SEP*M4
      MOVER2 = M/2 + 1
C
      DO 50 J = 1,MOVER2
          FOLD = J .GT. 1 .AND. 2*J .LT. M + 2
          K0 = (J-1)*SEP + 1
          ZERO = j .eq. 1
          IF (.NOT.ZERO) THEN
              ANGLE = TWOPI*REAL(j-1)/FM4
              C1 = COS(ANGLE)
              S1 = SIN(ANGLE)
              C2 = C1*C1 - S1*S1
              S2 = S1*C1 + C1*S1
              C3 = C2*C1 - S2*S1
              S3 = S2*C1 + C2*S1
          END IF
   10     CONTINUE
C
          DO 40 KK = K0,NS,MM4
              DO 30 L = KK,NT,L1
                  K1 = L + SIZE
                  DO 20 K = L,K1,K2
                      RS0 = X0(K) + X2(K)
                      IS0 = Y0(K) + Y2(K)
                      RU0 = X0(K) - X2(K)
                      IU0 = Y0(K) - Y2(K)
                      RS1 = X1(K) + X3(K)
                      IS1 = Y1(K) + Y3(K)
                      RU1 = X1(K) - X3(K)
                      IU1 = Y1(K) - Y3(K)
                      X0(K) = RS0 + RS1
                      Y0(K) = IS0 + IS1
                      IF (ZERO) THEN
                          X2(K) = RU0 + IU1
                          Y2(K) = IU0 - RU1
                          X1(K) = RS0 - RS1
                          Y1(K) = IS0 - IS1
                          X3(K) = RU0 - IU1
                          Y3(K) = IU0 + RU1
                      ELSE
                          R1 = RU0 + IU1
                          I1 = IU0 - RU1
                          R2 = RS0 - RS1
                          I2 = IS0 - IS1
                          R3 = RU0 - IU1
                          I3 = IU0 + RU1
                          X2(K) = R1*C1 + I1*S1
                          Y2(K) = I1*C1 - R1*S1
                          X1(K) = R2*C2 + I2*S2
                          Y1(K) = I2*C2 - R2*S2
                          X3(K) = R3*C3 + I3*S3
                          Y3(K) = I3*C3 - R3*S3
                      END IF
   20                 CONTINUE
   30             CONTINUE
   40         CONTINUE
          IF (FOLD) THEN
              FOLD = .FALSE.
              K0 = (M+1-J)*SEP + 1
              T = C1
              C1 = S1
              S1 = T
              C2 = -C2
              T = C3
              C3 = -S3
              S3 = -T
              GO TO 10
          END IF
   50     CONTINUE
C
      END
C
C
      SUBROUTINE R5CFTK(N,M,X0,Y0,X1,Y1,X2,Y2,X3,Y3,X4,Y4,DIM)
C     =================================================================
C
C
C---- Radix 5 multi-dimensional complex fourier transform kernel
C
C     .. Scalar Arguments ..
      INTEGER           M,N
C     ..
C     .. Array Arguments ..
      REAL              X0(*),X1(*),X2(*),X3(*),X4(*),Y0(*),
     +                  Y1(*),Y2(*),Y3(*),Y4(*)
      INTEGER           DIM(5)
C     ..
C     .. Local Scalars ..
      REAL              A1,A2,ANGLE,B1,B2,C1,C2,C3,C4,FM5,I0,I1,I2,
     +                  I3,I4,IA1,IA2,IB1,IB2,IS1,IS2,IU1,IU2,R0,R1,R2,
     +                  R3,R4,RA1,RA2,RB1,RB2,RS1,RS2,RU1,RU2,S1,S2,S3,
     +                  S4,T,TWOPI
      INTEGER           J,K,K0,K1,K2,KK,L,L1,M5,MM5,MOVER2,NS,NT,SEP,
     +                  SIZE
      LOGICAL           FOLD,ZERO
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC         COS,REAL,SIN
C     ..
C     .. Data statements ..
      DATA              TWOPI/6.283185/,A1/0.30901699/,B1/0.95105652/,
     +                  A2/-0.80901699/,B2/0.58778525/
C     ..
C
      NT = DIM(1)
      SEP = DIM(2)
      L1 = DIM(3)
      SIZE = DIM(4) - 1
      K2 = DIM(5)
      NS = N*SEP
      M5 = M*5
      FM5 = REAL(M5)
      MM5 = SEP*M5
      MOVER2 = M/2 + 1
C
      DO 50 J = 1,MOVER2
          FOLD = J .GT. 1 .AND. 2*J .LT. M + 2
          K0 = (J-1)*SEP + 1
          ZERO = j .eq. 1
          IF (.NOT.ZERO) THEN
              ANGLE = TWOPI*REAL(j-1)/FM5
              C1 = COS(ANGLE)
              S1 = SIN(ANGLE)
              C2 = C1*C1 - S1*S1
              S2 = S1*C1 + C1*S1
              C3 = C2*C1 - S2*S1
              S3 = S2*C1 + C2*S1
              C4 = C2*C2 - S2*S2
              S4 = S2*C2 + C2*S2
          END IF
   10     CONTINUE
C
          DO 40 KK = K0,NS,MM5
              DO 30 L = KK,NT,L1
                  K1 = L + SIZE
                  DO 20 K = L,K1,K2
                      R0 = X0(K)
                      I0 = Y0(K)
                      RS1 = X1(K) + X4(K)
                      IS1 = Y1(K) + Y4(K)
                      RU1 = X1(K) - X4(K)
                      IU1 = Y1(K) - Y4(K)
                      RS2 = X2(K) + X3(K)
                      IS2 = Y2(K) + Y3(K)
                      RU2 = X2(K) - X3(K)
                      IU2 = Y2(K) - Y3(K)
                      X0(K) = R0 + RS1 + RS2
                      Y0(K) = I0 + IS1 + IS2
                      RA1 = RS1*A1 + R0 + RS2*A2
                      IA1 = IS1*A1 + I0 + IS2*A2
                      RA2 = RS1*A2 + R0 + RS2*A1
                      IA2 = IS1*A2 + I0 + IS2*A1
                      RB1 = RU1*B1 + RU2*B2
                      IB1 = IU1*B1 + IU2*B2
                      RB2 = RU1*B2 - RU2*B1
                      IB2 = IU1*B2 - IU2*B1
                      IF (ZERO) THEN
                          X1(K) = RA1 + IB1
                          Y1(K) = IA1 - RB1
                          X2(K) = RA2 + IB2
                          Y2(K) = IA2 - RB2
                          X3(K) = RA2 - IB2
                          Y3(K) = IA2 + RB2
                          X4(K) = RA1 - IB1
                          Y4(K) = IA1 + RB1
                      ELSE
                          R1 = RA1 + IB1
                          I1 = IA1 - RB1
                          R2 = RA2 + IB2
                          I2 = IA2 - RB2
                          R3 = RA2 - IB2
                          I3 = IA2 + RB2
                          R4 = RA1 - IB1
                          I4 = IA1 + RB1
                          X1(K) = R1*C1 + I1*S1
                          Y1(K) = I1*C1 - R1*S1
                          X2(K) = R2*C2 + I2*S2
                          Y2(K) = I2*C2 - R2*S2
                          X3(K) = R3*C3 + I3*S3
                          Y3(K) = I3*C3 - R3*S3
                          X4(K) = R4*C4 + I4*S4
                          Y4(K) = I4*C4 - R4*S4
                      END IF
   20                 CONTINUE
   30             CONTINUE
   40         CONTINUE
          IF (FOLD) THEN
              FOLD = .FALSE.
              K0 = (M+1-J)*SEP + 1
              T = C1*A1 + S1*B1
              S1 = C1*B1 - S1*A1
              C1 = T
              T = C2*A2 + S2*B2
              S2 = C2*B2 - S2*A2
              C2 = T
              T = C3*A2 - S3*B2
              S3 = -C3*B2 - S3*A2
              C3 = T
              T = C4*A1 - S4*B1
              S4 = -C4*B1 - S4*A1
              C4 = T
              GO TO 10
          END IF
   50     CONTINUE
C
      END
C
C
      SUBROUTINE R8CFTK(N,M,X0,Y0,X1,Y1,X2,Y2,X3,Y3,X4,Y4,X5,Y5,X6,Y6,
     +                  X7,Y7,DIM)
C      ===============================================================
C
C
C---- Radix 8 multi-dimensional complex fourier transform kernel
C
C     .. Scalar Arguments ..
      INTEGER           M,N
C     ..
C     .. Array Arguments ..
      REAL              X0(*),X1(*),X2(*),X3(*),X4(*),X5(*),
     +                  X6(*),X7(*),Y0(*),Y1(*),Y2(*),Y3(*),
     +                  Y4(*),Y5(*),Y6(*),Y7(*)
      INTEGER           DIM(5)
C     ..
C     .. Local Scalars ..
      REAL              ANGLE,C1,C2,C3,C4,C5,C6,C7,E,FM8,I1,I2,I3,
     +                  I4,I5,I6,I7,IS0,IS1,IS2,IS3,ISS0,ISS1,ISU0,ISU1,
     +                  IU0,IU1,IU2,IU3,IUS0,IUS1,IUU0,IUU1,R1,R2,R3,R4,
     +                  R5,R6,R7,RS0,RS1,RS2,RS3,RSS0,RSS1,RSU0,RSU1,
     +                  RU0,RU1,RU2,RU3,RUS0,RUS1,RUU0,RUU1,S1,S2,S3,S4,
     +                  S5,S6,S7,T,TWOPI
      INTEGER           J,K,K0,K1,K2,KK,L,L1,M8,MM8,MOVER2,NS,NT,SEP,
     +                  SIZE
      LOGICAL           FOLD,ZERO
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC         COS,REAL,SIN
C     ..
C     .. Data statements ..
      DATA              TWOPI/6.283185/,E/0.70710678/
C     ..
C
      NT = DIM(1)
      SEP = DIM(2)
      L1 = DIM(3)
      SIZE = DIM(4) - 1
      K2 = DIM(5)
      NS = N*SEP
      M8 = M*8
      FM8 = REAL(M8)
      MM8 = SEP*M8
      MOVER2 = M/2 + 1
C
      DO 50 J = 1,MOVER2
          FOLD = J .GT. 1 .AND. 2*J .LT. M + 2
          K0 = (J-1)*SEP + 1
          ZERO = j .eq. 1
          IF (.NOT.ZERO) THEN
              ANGLE = TWOPI*REAL(j-1)/FM8
              C1 = COS(ANGLE)
              S1 = SIN(ANGLE)
              C2 = C1*C1 - S1*S1
              S2 = S1*C1 + C1*S1
              C3 = C2*C1 - S2*S1
              S3 = S2*C1 + C2*S1
              C4 = C2*C2 - S2*S2
              S4 = S2*C2 + C2*S2
              C5 = C4*C1 - S4*S1
              S5 = S4*C1 + C4*S1
              C6 = C4*C2 - S4*S2
              S6 = S4*C2 + C4*S2
              C7 = C4*C3 - S4*S3
              S7 = S4*C3 + C4*S3
          END IF
   10     CONTINUE
C
          DO 40 KK = K0,NS,MM8
              DO 30 L = KK,NT,L1
                  K1 = L + SIZE
                  DO 20 K = L,K1,K2
                      RS0 = X0(K) + X4(K)
                      IS0 = Y0(K) + Y4(K)
                      RU0 = X0(K) - X4(K)
                      IU0 = Y0(K) - Y4(K)
                      RS1 = X1(K) + X5(K)
                      IS1 = Y1(K) + Y5(K)
                      RU1 = X1(K) - X5(K)
                      IU1 = Y1(K) - Y5(K)
                      RS2 = X2(K) + X6(K)
                      IS2 = Y2(K) + Y6(K)
                      RU2 = X2(K) - X6(K)
                      IU2 = Y2(K) - Y6(K)
                      RS3 = X3(K) + X7(K)
                      IS3 = Y3(K) + Y7(K)
                      RU3 = X3(K) - X7(K)
                      IU3 = Y3(K) - Y7(K)
                      RSS0 = RS0 + RS2
                      ISS0 = IS0 + IS2
                      RSU0 = RS0 - RS2
                      ISU0 = IS0 - IS2
                      RSS1 = RS1 + RS3
                      ISS1 = IS1 + IS3
                      RSU1 = RS1 - RS3
                      ISU1 = IS1 - IS3
                      RUS0 = RU0 - IU2
                      IUS0 = IU0 + RU2
                      RUU0 = RU0 + IU2
                      IUU0 = IU0 - RU2
                      RUS1 = RU1 - IU3
                      IUS1 = IU1 + RU3
                      RUU1 = RU1 + IU3
                      IUU1 = IU1 - RU3
                      T = (RUS1+IUS1)*E
                      IUS1 = (IUS1-RUS1)*E
                      RUS1 = T
                      T = (RUU1+IUU1)*E
                      IUU1 = (IUU1-RUU1)*E
                      RUU1 = T
                      X0(K) = RSS0 + RSS1
                      Y0(K) = ISS0 + ISS1
                      IF (ZERO) THEN
                          X4(K) = RUU0 + RUU1
                          Y4(K) = IUU0 + IUU1
                          X2(K) = RSU0 + ISU1
                          Y2(K) = ISU0 - RSU1
                          X6(K) = RUS0 + IUS1
                          Y6(K) = IUS0 - RUS1
                          X1(K) = RSS0 - RSS1
                          Y1(K) = ISS0 - ISS1
                          X5(K) = RUU0 - RUU1
                          Y5(K) = IUU0 - IUU1
                          X3(K) = RSU0 - ISU1
                          Y3(K) = ISU0 + RSU1
                          X7(K) = RUS0 - IUS1
                          Y7(K) = IUS0 + RUS1
                      ELSE
                          R1 = RUU0 + RUU1
                          I1 = IUU0 + IUU1
                          R2 = RSU0 + ISU1
                          I2 = ISU0 - RSU1
                          R3 = RUS0 + IUS1
                          I3 = IUS0 - RUS1
                          R4 = RSS0 - RSS1
                          I4 = ISS0 - ISS1
                          R5 = RUU0 - RUU1
                          I5 = IUU0 - IUU1
                          R6 = RSU0 - ISU1
                          I6 = ISU0 + RSU1
                          R7 = RUS0 - IUS1
                          I7 = IUS0 + RUS1
                          X4(K) = R1*C1 + I1*S1
                          Y4(K) = I1*C1 - R1*S1
                          X2(K) = R2*C2 + I2*S2
                          Y2(K) = I2*C2 - R2*S2
                          X6(K) = R3*C3 + I3*S3
                          Y6(K) = I3*C3 - R3*S3
                          X1(K) = R4*C4 + I4*S4
                          Y1(K) = I4*C4 - R4*S4
                          X5(K) = R5*C5 + I5*S5
                          Y5(K) = I5*C5 - R5*S5
                          X3(K) = R6*C6 + I6*S6
                          Y3(K) = I6*C6 - R6*S6
                          X7(K) = R7*C7 + I7*S7
                          Y7(K) = I7*C7 - R7*S7
                      END IF
   20                 CONTINUE
   30             CONTINUE
   40         CONTINUE
          IF (FOLD) THEN
              FOLD = .FALSE.
              K0 = (M+1-J)*SEP + 1
              T = (C1+S1)*E
              S1 = (C1-S1)*E
              C1 = T
              T = S2
              S2 = C2
              C2 = T
              T = (-C3+S3)*E
              S3 = (C3+S3)*E
              C3 = T
              C4 = -C4
              T = - (C5+S5)*E
              S5 = (-C5+S5)*E
              C5 = T
              T = -S6
              S6 = -C6
              C6 = T
              T = (C7-S7)*E
              S7 = - (C7+S7)*E
              C7 = T
              GO TO 10
          END IF
   50     CONTINUE
C
      END
C
C
      SUBROUTINE RPCFTK(N,M,P,R,X,Y,DIM)
C     ==========================================
C
C
C---- Radix prime multi-dimensional complex fourier transform kernel
C
CMDW: Note, routine works beyond the nominal bounds of X and Y.
C     We think this is deliberate, so don't be tempted to "fix" it.
C     This routine is therefore incompatible with "bounds-checking" 
C     options of compilers.
C
C     .. Scalar Arguments ..
      INTEGER           M,N,P,R
C     ..
C     .. Array Arguments ..
      REAL              X(R,P),Y(R,P)
      INTEGER           DIM(5)
C     ..
C     .. Local Scalars ..
      REAL              ANGLE,FMP,FP,FU,IS,IU,RS,RU,T,TWOPI,XT,YT
      INTEGER           J,JJ,K,K0,K1,K2,KK,L,L1,MMP,MOVER2,MP,NS,NT,PM,
     +                  PP,SEP,SIZE,U,V
      LOGICAL           FOLD,ZERO
C     ..
C     .. Local Arrays ..
      REAL              A(18),AA(9,9),B(18),BB(9,9),C(18),IA(9),IB(9),
     +                  RA(9),RB(9),S(18)
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC         COS,REAL,SIN
C     ..
C     .. Data statements ..
      DATA              TWOPI/6.283185/
C     ..
C
C
      NT = DIM(1)
      SEP = DIM(2)
      L1 = DIM(3)
      SIZE = DIM(4) - 1
      K2 = DIM(5)
      NS = N*SEP
      MOVER2 = M/2 + 1
      MP = M*P
      FMP = REAL(MP)
      MMP = SEP*MP
      PP = P/2
      PM = P - 1
      FP = REAL(P)
      FU = 0.0
      DO 10 U = 1,PP
          FU = FU + 1.0
          ANGLE = TWOPI*FU/FP
          JJ = P - U
          A(U) = COS(ANGLE)
          B(U) = SIN(ANGLE)
          A(JJ) = A(U)
          B(JJ) = -B(U)
   10     CONTINUE
      DO 30 U = 1,PP
          DO 20 V = 1,PP
              JJ = U*V - U*V/P*P
              AA(V,U) = A(JJ)
              BB(V,U) = B(JJ)
   20         CONTINUE
   30     CONTINUE
C
      DO 140 J = 1,MOVER2
          FOLD = J .GT. 1 .AND. 2*J .LT. M + 2
          K0 = (J-1)*SEP + 1
          ZERO = j .eq. 1
          IF (.NOT.ZERO) THEN
              ANGLE = TWOPI*REAL(j-1)/FMP
              C(1) = COS(ANGLE)
              S(1) = SIN(ANGLE)
              DO 40 U = 2,PM
                  C(U) = C(U-1)*C(1) - S(U-1)*S(1)
                  S(U) = S(U-1)*C(1) + C(U-1)*S(1)
   40             CONTINUE
          END IF
   50     CONTINUE
C
          DO 120 KK = K0,NS,MMP
              DO 110 L = KK,NT,L1
                  K1 = L + SIZE
                  DO 100 K = L,K1,K2
                      XT = X(K,1)
                      YT = Y(K,1)
                      RS = X(K,2) + X(K,P)
                      IS = Y(K,2) + Y(K,P)
                      RU = X(K,2) - X(K,P)
                      IU = Y(K,2) - Y(K,P)
                      DO 60 U = 1,PP
                          RA(U) = AA(U,1)*RS + XT
                          IA(U) = AA(U,1)*IS + YT
                          RB(U) = BB(U,1)*RU
                          IB(U) = BB(U,1)*IU
   60                     CONTINUE
                      XT = XT + RS
                      YT = YT + IS
                      DO 80 U = 2,PP
                          JJ = P - U
                          RS = X(K,U+1) + X(K,JJ+1)
                          IS = Y(K,U+1) + Y(K,JJ+1)
                          RU = X(K,U+1) - X(K,JJ+1)
                          IU = Y(K,U+1) - Y(K,JJ+1)
                          XT = XT + RS
                          YT = YT + IS
                          DO 70 V = 1,PP
                              RA(V) = AA(V,U)*RS + RA(V)
                              IA(V) = AA(V,U)*IS + IA(V)
                              RB(V) = BB(V,U)*RU + RB(V)
                              IB(V) = BB(V,U)*IU + IB(V)
   70                         CONTINUE
   80                     CONTINUE
                      X(K,1) = XT
                      Y(K,1) = YT
                      DO 90 U = 1,PP
                          JJ = P - U
                          IF (ZERO) THEN
                              X(K,U+1) = RA(U) + IB(U)
                              Y(K,U+1) = IA(U) - RB(U)
                              X(K,JJ+1) = RA(U) - IB(U)
                              Y(K,JJ+1) = IA(U) + RB(U)
                          ELSE
                              XT = RA(U) + IB(U)
                              YT = IA(U) - RB(U)
                              X(K,U+1) = C(U)*XT + S(U)*YT
                              Y(K,U+1) = C(U)*YT - S(U)*XT
                              XT = RA(U) - IB(U)
                              YT = IA(U) + RB(U)
                              X(K,JJ+1) = C(JJ)*XT + S(JJ)*YT
                              Y(K,JJ+1) = C(JJ)*YT - S(JJ)*XT
                          END IF
   90                     CONTINUE
  100                 CONTINUE
  110             CONTINUE
  120         CONTINUE
          IF (FOLD) THEN
              FOLD = .FALSE.
              K0 = (M+1-J)*SEP + 1
              DO 130 U = 1,PM
                  T = C(U)*A(U) + S(U)*B(U)
                  S(U) = -S(U)*A(U) + C(U)*B(U)
                  C(U) = T
  130             CONTINUE
              GO TO 50
          END IF
  140     CONTINUE
C
      END
C
C
      SUBROUTINE HERMFT(X,Y,N,DIM)
C     ==================================
C
C
C
C---- Hermitian symmetric fourier transform
C
C     Given the unique terms of a hermitian symmetric sequence of length
C     2N this subroutine calculates the 2N real numbers which are its
C     fourier transform.  The even numbered elements of the transform
C     (0, 2, 4, . . ., 2n-2) are returned in X and the odd numbered
C     elements (1, 3, 5, . . ., 2n-1) in Y.
C
C     A finite hermitian sequence of length 2n contains n + 1 unique
C     real numbers and n - 1 unique imaginary numbers.  For convenience
C     the real value for X(n) is stored at Y(0).
C
C
C     .. Scalar Arguments ..
      INTEGER           N
C     ..
C     .. Array Arguments ..
      REAL              X(*),Y(*)
      INTEGER           DIM(5)
C     ..
C     .. Local Scalars ..
      REAL              A,ANGLE,B,C,CO,D,E,F,SI,TWON,TWOPI
      INTEGER           D2,D3,D4,D5,I,I0,I1,I2,J,K,K1,NOVER2,NT
C     ..
C     .. External Subroutines ..
      EXTERNAL          CMPLFT
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC         COS,REAL,SIN
C     ..
      TWOPI = 6.283185
      TWON = REAL(2*N)
C
      NT = DIM(1)
      D2 = DIM(2)
      D3 = DIM(3)
      D4 = DIM(4) - 1
      D5 = DIM(5)
C
      DO 20 I0 = 1,NT,D3
          I1 = I0 + D4
          DO 10 I = I0,I1,D5
              A = X(I)
              B = Y(I)
              X(I) = A + B
              Y(I) = A - B
   10         CONTINUE
   20     CONTINUE
C
      NOVER2 = N/2 + 1
      IF (NOVER2.GE.2) THEN
          DO 50 I0 = 2,NOVER2
              ANGLE = REAL(I0-1)*TWOPI/TWON
              CO = COS(ANGLE)
              SI = SIN(ANGLE)
              K = (N+2-2*I0)*D2
              K1 = (I0-1)*D2 + 1
              DO 40 I1 = K1,NT,D3
                  I2 = I1 + D4
                  DO 30 I = I1,I2,D5
                      J = I + K
                      A = X(I) + X(J)
                      B = X(I) - X(J)
                      C = Y(I) + Y(J)
                      D = Y(I) - Y(J)
                      E = B*CO + C*SI
                      F = B*SI - C*CO
                      X(I) = A + F
                      X(J) = A - F
                      Y(I) = E + D
                      Y(J) = E - D
   30                 CONTINUE
   40             CONTINUE
   50         CONTINUE
C
          CALL CMPLFT(X,Y,N,DIM)
      END IF
C
C
      END
C
C
      SUBROUTINE INV21(X,Y,N,D)
C      =========================
C
C
C
C---- Inverts fourier transform along a screw
C     diad. the result is scaled by n.
C
C
C     .. Scalar Arguments ..
      INTEGER          N
C     ..
C     .. Array Arguments ..
      REAL             X(*),Y(*)
      INTEGER          D(5)
C     ..
C     .. Local Scalars ..
      REAL             A,B,C,C1,PI,R,S,S1
      INTEGER          D1,D2,D3,D4,D5,I,J,J1,J2,J3,K,KK,L,LL,M,NOVER2
C     ..
C     .. External Subroutines ..
      EXTERNAL         CMPLFT
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC        COS,REAL,SIN
C     ..
      PI = 3.141593
C
      D1 = D(1)
      D2 = D(2)
      D3 = D(3)
      D4 = D(4) - 1
      D5 = D(5)
C
      NOVER2 = N/2
      LL = N*D2
      KK = NOVER2*D2
      DO 20 J1 = 1,D1,D3
          J2 = J1 + D4
          DO 10 J = J1,J2,D5
              L = LL + J
              K = KK + J
              X(L) = X(J) + X(K)
              X(K) = X(K) + Y(K)
              Y(L) = 0.0
              Y(K) = 0.0
   10         CONTINUE
   20     CONTINUE
C
      C1 = COS(PI/REAL(N))
      S1 = SIN(PI/REAL(N))
      C = 1.0
      S = 0.0
      DO 50 I = 2,NOVER2
          KK = (N+2-2*I)*D2
          LL = (N+1-I)*D2
          R = C*C1 - S*S1
          S = C*S1 + S*C1
          C = R
          J1 = (I-1)*D2 + 1
          DO 40 J2 = J1,D1,D3
              J3 = J2 + D4
              DO 30 J = J2,J3,D5
                  L = J + LL
                  K = J + KK
                  X(L) = X(L) + X(J) + X(K)
                  X(J) = Y(J)*S + X(J)
                  X(K) = Y(K)*S + X(K)
                  Y(J) = Y(J)*C
                  Y(K) = -Y(K)*C
   30             CONTINUE
   40         CONTINUE
   50     CONTINUE
C
      CALL CMPLFT(X,Y,N,D)
C
      DO 80 I = 1,NOVER2
          KK = (N+1-2*I)*D2
          LL = I*D2 + KK
          J1 = (I-1)*D2 + 1
          DO 70 J2 = J1,D1,D3
              J3 = J2 + D4
              DO 60 J = J2,J3,D5
                  K = J + KK
                  L = J + LL
                  A = X(J) - X(L)
                  B = Y(J) + Y(L)
                  X(J) = X(L)
                  Y(J) = -Y(L)
                  X(L) = X(K) + A
                  Y(L) = Y(K) - B
                  X(K) = A
                  Y(K) = B
   60             CONTINUE
   70         CONTINUE
   80     CONTINUE
C
      M = N - 2
      DO 130 I = 1,M
          K = I
   90     CONTINUE
          J = K
          K = J/2
          IF (2*K.NE.J) K = N - 1 - K
          IF (K-I) 90,130,100
  100     KK = (K-I)*D2
          J1 = I*D2 + 1
          DO 120 J2 = J1,D1,D3
              J3 = J2 + D4
              DO 110 J = J2,J3,D5
                  K = J + KK
                  A = X(K)
                  B = Y(K)
                  X(K) = X(J)
                  Y(K) = Y(J)
                  X(J) = A
                  Y(J) = B
  110             CONTINUE
  120         CONTINUE
  130     CONTINUE
C
C
      END
C
C
      SUBROUTINE REALFT(EVEN,ODD,N,DIM)
C      ======================================
C
C
C
C     REAL FOURIER TRANSFORM
C
C     Given a real sequence of length 2n this subroutine calculates the
C     unique part of the fourier transform.  The fourier transform has
C     n + 1 unique real parts and n - 1 unique imaginary parts.  Since
C     the real part at x(n) is frequently of interest, this subroutine
C     stores it at x(n) rather than in y(0).  Therefore x and y must be
C     of length n + 1 instead of n.  Note that this storage arrangement
C     is different from that employed by the hermitian fourier transform
C     subroutine.
C
C     For convenience the data is presented in two parts, the first
C     containing the even numbered real terms and the second containing
C     the odd numbered terms (numbering starting at 0).  On return the
C     real part of the transform replaces the even terms and the
C     imaginary part of the transform replaces the odd terms.
C
C
C     .. Scalar Arguments ..
      INTEGER           N
C     ..
C     .. Array Arguments ..
      REAL              EVEN(*),ODD(*)
      INTEGER           DIM(5)
C     ..
C     .. Local Scalars ..
      REAL              A,ANGLE,B,C,CO,D,E,F,SI,TWON,TWOPI
      INTEGER           D2,D3,D4,D5,I,I0,I1,I2,J,K,L,NOVER2,NT
C     ..
C     .. External Subroutines ..
      EXTERNAL          CMPLFT
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC         COS,REAL,SIN
C     ..
      TWOPI = 6.283185
      TWON = REAL(2*N)
C
      CALL CMPLFT(EVEN,ODD,N,DIM)
C
      NT = DIM(1)
      D2 = DIM(2)
      D3 = DIM(3)
      D4 = DIM(4) - 1
      D5 = DIM(5)
      NOVER2 = N/2 + 1
C
      IF (NOVER2.GE.2) THEN
          DO 30 I = 2,NOVER2
              ANGLE = REAL(I-1)*TWOPI/TWON
              CO = COS(ANGLE)
              SI = SIN(ANGLE)
              I0 = (I-1)*D2 + 1
              J = (N+2-2*I)*D2
              DO 20 I1 = I0,NT,D3
                  I2 = I1 + D4
                  DO 10 K = I1,I2,D5
                      L = K + J
                      A = (EVEN(L)+EVEN(K))/2.0
                      C = (EVEN(L)-EVEN(K))/2.0
                      B = (ODD(L)+ODD(K))/2.0
                      D = (ODD(L)-ODD(K))/2.0
                      E = C*SI + B*CO
                      F = C*CO - B*SI
                      EVEN(K) = A + E
                      EVEN(L) = A - E
                      ODD(K) = F - D
                      ODD(L) = F + D
   10                 CONTINUE
   20             CONTINUE
   30         CONTINUE
      END IF
C
      IF (N.GE.1) THEN
          J = N*D2
          DO 50 I1 = 1,NT,D3
              I2 = I1 + D4
              DO 40 K = I1,I2,D5
                  L = K + J
                  EVEN(L) = EVEN(K) - ODD(K)
                  ODD(L) = 0.0
                  EVEN(K) = EVEN(K) + ODD(K)
                  ODD(K) = 0.0
   40             CONTINUE
   50         CONTINUE
      END IF
C
C
      END
C
C
      SUBROUTINE RSYMFT(X,N,DIM)
C      ===============================
C
C
C
C     REAL SYMMETRIC MULTIDIMENSIONAL FOURIER TRANSFORM
C
C     N must be a multiple of 4.  The two unique elements are stored at
C     X(1) and X(n+1).
C
C     Decimation in frequency applied to a real symmetric sequence of
C     length 2n gives a real symmetric sequence of length n, the
C     transform of which gives the even numbered fourier coefficients,
C     and a hermitian symmetric sequence of length n, the transform of
C     which gives the odd numbered fourier coefficients.  The sum of
C     the two sequences is a hermitian symmetric sequence of length n,
C     which may be stored in n/2 complex locations.  The transform of
C     this sequence is n real numbers representing the term by term sum
C     of the even and odd numbered fourier coefficients.  This symmetric
C     sequence may be solved if any of the fourier coefficients are
C     known.  For this purpose x0, which is simply the sum of the
C     original sequence, is computed and saved in x(n+1).
C
C
C     .. Scalar Arguments ..
      INTEGER           N
C     ..
C     .. Array Arguments ..
      REAL              X(*)
      INTEGER           DIM(5)
C     ..
C     .. Local Scalars ..
      REAL              A,ANGLE,B,C,CO,D,SI,TWON,TWOPI
      INTEGER           D1,D2,D3,D4,D5,I,I0,I1,I2,II,J,J0,J1,K,K0,K1,
     +                  K2,L,M,MJ,MK,ML,MM,NN,NOVER2,NOVER4,
     +                  TWOD2
      CHARACTER EMESS*80
C     ..
C     .. External Subroutines ..
      EXTERNAL          HERMFT
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC         COS,REAL,SIN
C     ..
      IF (N.NE.1) THEN
          NOVER2 = N/2
          NOVER4 = N/4
          IF (4*NOVER4.NE.N) THEN
C
              WRITE (EMESS,FMT=9000) N
              call ccperr(1, EMESS)
          ELSE
              D1 = DIM(1)
              D2 = DIM(2)
              D3 = DIM(3)
              D4 = DIM(4) - 1
              D5 = DIM(5)
              TWOPI = 6.283185
              TWON = REAL(2*N)
              TWOD2 = 2*D2
C
              K0 = N*D2 + 1
              DO 20 K1 = K0,D1,D3
                  K2 = K1 + D4
                  DO 10 K = K1,K2,D5
                      X(K) = X(K)/2.0
   10                 CONTINUE
   20             CONTINUE
C
              DO 50 I = 2,NOVER2
                  ANGLE = REAL(I-1)*TWOPI/TWON
                  CO = COS(ANGLE)
                  SI = SIN(ANGLE)
                  K0 = (I-1)*D2 + 1
                  J0 = (N+2-2*I)*D2
                  J1 = (N+1-I)*D2
                  DO 40 K1 = K0,D1,D3
                      K2 = K1 + D4
                      DO 30 K = K1,K2,D5
                          L = K + J0
                          NN = K + J1
                          A = X(L) + X(K)
                          B = X(L) - X(K)
                          X(K) = A - B*CO
                          X(L) = B*SI
                          X(NN) = X(NN) + A
   30                     CONTINUE
   40                 CONTINUE
   50             CONTINUE
C
              IF (NOVER4.NE.1) THEN
                  J0 = NOVER4 - 1
                  DO 80 I = 1,J0
                      K0 = (NOVER2+I)*D2 + 1
                      J1 = (NOVER2-2*I)*D2
                      DO 70 K1 = K0,D1,D3
                          K2 = K1 + D4
                          DO 60 K = K1,K2,D5
                              L = K + J1
                              A = X(K)
                              X(K) = X(L)
                              X(L) = A
   60                         CONTINUE
   70                     CONTINUE
   80                 CONTINUE
              END IF
C
              J0 = NOVER2*D2
              J1 = N*D2
              DO 100 K1 = 1,D1,D3
                  K2 = K1 + D4
                  DO 90 K = K1,K2,D5
                      I = K + J0
                      L = K + J1
                      X(I) = X(I)*2.0
                      X(L) = X(K) + X(I) + X(L)*2.0
                      X(K) = X(K)*2.0
   90                 CONTINUE
  100             CONTINUE
C
              K = NOVER2*D2 + 1
              CALL HERMFT(X(1),X(K),NOVER2,DIM)
C
C---- Solve the equations for all of the sequences
C
              I0 = 1 - D2
              MK = NOVER2*D2
              MJ = MK + D2
              ML = N*D2 + D2
              MM = ML
              DO 130 II = 1,NOVER4
                  I0 = I0 + D2
                  MJ = MJ - TWOD2
                  ML = ML - TWOD2
                  MM = MM - D2
                  DO 120 I1 = I0,D1,D3
                      I2 = I1 + D4
                      DO 110 I = I1,I2,D5
                          J = I + MJ
                          K = I + MK
                          L = I + ML
                          M = I + MM
                          A = X(I) - X(M)
                          B = X(L) - A
                          C = X(K) - B
                          D = X(J) - C
                          X(I) = X(M)
                          X(J) = A
                          X(K) = B
                          X(L) = C
                          X(M) = D
  110                     CONTINUE
  120                 CONTINUE
  130             CONTINUE
C
C---- The results are now in a scrambled digit reversed order, i.e.
C     x(1), x(5), x(9), ..., x(10), x(6), x(2), ..., x(3), x(7), x(11),
C     ..., x(12), x(8), x(4).  the following section of program follows
C     the permutation cycles and does the necessary interchanges.
C
              IF (NOVER4.NE.1) THEN
                  NN = N - 2
                  DO 170 I = 1,NN
                      K = I
  140                 CONTINUE
C
                      K0 = K/4
                      L = K - K0*4
                      IF (L.NE. (L/2)*2) K0 = NOVER4 - 1 - K0
                      K = L*NOVER4 + K0
                      IF (K.LT.I) GO TO 140
                      IF (K.NE.I) THEN
C
                          K0 = I*D2 + 1
                          J0 = (K-I)*D2
                          DO 160 K1 = K0,D1,D3
                              K2 = K1 + D4
                              DO 150 K = K1,K2,D5
                                  L = K + J0
                                  A = X(K)
                                  X(K) = X(L)
                                  X(L) = A
  150                             CONTINUE
  160                         CONTINUE
                      END IF
  170                 CONTINUE
              END IF
          END IF
      END IF
C
C---- Format statements
C
 9000 FORMAT ('FFTLIB: N not a multiple of 4 in R SYM FT.  N =',I10,//)
      END
C
C
      SUBROUTINE SDIAD(X,Y,N,DIM)
C      ===============================
C
C
C
C     This subroutine computes half the fourier synthesis along a screw
C     diad lying along a crystallographic axis given half the fourier
C     coefficients.  That is, it assumes that f(t) = conjg(f(-t)) for t
C     even and f(t) = -conjg(f(-t)) for t odd.  n is the length of the
C     desired half of the transform.  The location x(n+1) is required as
C     a scratch location and therefore a value is also returned in
C     x(n+1) and y(n+1).  The value of the second half of the transform
C     may be generated from the first half by the formula x(n+t) = x(t),
C     y(n+t) = -y(t).  In other words, the last half of the transform is
C     the complex conjugate of the first half.
C
C     The transform is calculated by forming the sum of the even terms
C     and the odd terms in place, using the symmetry relations to
C     obtain the values for negative subscripts.  The transform of the
C     resulting sequence may be separated by using the fact that the
C     transform of the even terms is real, while the prodct of the
C     transform of the odd terms and (cos(pi*t/n) - i*sin(pi*t/n)) is
C     imaginary.  The scratch location is required because the formula
C     for separating the two transforms breaks down when t = n/2.
C
C
C Corrections from A.D.MCLACHLAN 1980, put here sep 1985
C errors in original algorithm for the scratch location which
C assumed f(n)=0
C
C
C
C     .. Scalar Arguments ..
      INTEGER          N
C     ..
C     .. Array Arguments ..
      REAL             X(*),Y(*)
      INTEGER          DIM(5)
C     ..
C     .. Local Scalars ..
      REAL             A,ANGLE,C,S,TWON,TWOPI
      INTEGER          D1,D2,D3,D4,D5,I,J,K,K0,K1,K2,L,M,MN,NN,NOVER2
      LOGICAL          FOLD
      CHARACTER EMESS*80
C     ..
C     .. External Subroutines ..
      EXTERNAL         CMPLFT
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC        COS,REAL,SIN
C     ..
      NOVER2 = N/2
      IF (2*NOVER2.NE.N) THEN
C
          WRITE (EMESS,FMT=9000) N
          call ccperr(1, EMESS)
      ELSE
          TWON = REAL(2*N)
          TWOPI = 6.2831852
          D1 = DIM(1)
          D2 = DIM(2)
          D3 = DIM(3)
          D4 = DIM(4) - 1
          D5 = DIM(5)
C
          S = -1.0
          IF (NOVER2.EQ. (2* (NOVER2/2))) S = -S
          K0 = (N-1)*D2 + 1
          DO 20 K1 = K0,D1,D3
              K2 = K1 + D4
              DO 10 K = K1,K2,D5
                  L = K + D2
                  Y(L) = X(K)*S
   10             CONTINUE
   20         CONTINUE
          S = 1.0
          NN = N - 2
          DO 50 I = 1,NN,2
              S = -S
              MN = (N+1-I)*D2
              K0 = (I-1)*D2 + 1
              DO 40 K1 = K0,D1,D3
                  K2 = K1 + D4
                  DO 30 K = K1,K2,D5
                      J = K + D2
                      L = 2*D2 + K
                      M = K + MN
                      Y(M) = X(J)*S + Y(M)
                      X(K) = X(K) + X(J)
                      X(J) = X(L) - X(J)
                      Y(K) = Y(K) + Y(J)
                      Y(J) = Y(J) - Y(L)
   30                 CONTINUE
   40             CONTINUE
   50         CONTINUE
          K0 = (N-2)*D2 + 1
          DO 70 K1 = K0,D1,D3
              K2 = K1 + D4
              DO 60 K = K1,K2,D5
                  L = K + D2
                  X(K) = X(K) + X(L)
                  Y(K) = Y(K) + Y(L)
                  J = L + D2
                  X(L) = X(J) - X(L)
   60             CONTINUE
   70         CONTINUE
C
C---- Reorder scrambled fourier coefficients
C
          DO 110 I = 1,NN
              K = I
   80         CONTINUE
              K = 2*K
              IF (K.GT.N-1) K = 2*N - 1 - K
              IF (K.LT.I) GO TO 80
              IF (K.NE.I) THEN
                  J = (K-I)*D2
                  K0 = I*D2 + 1
                  DO 100 K1 = K0,D1,D3
                      K2 = K1 + D4
                      DO 90 K = K1,K2,D5
                          L = K + J
                          A = X(K)
                          X(K) = X(L)
                          X(L) = A
                          A = Y(K)
                          Y(K) = Y(L)
                          Y(L) = A
   90                     CONTINUE
  100                 CONTINUE
              END IF
  110         CONTINUE
C
          CALL CMPLFT(X,Y,N,DIM)
C
          M = NOVER2 - 1
          DO 150 I = 1,M
              ANGLE = REAL(I)*TWOPI/TWON
              C = COS(ANGLE)
              S = SIN(ANGLE)
              K0 = I*D2 + 1
              FOLD = .TRUE.
  120         CONTINUE
C
              DO 140 K1 = K0,D1,D3
                  K2 = K1 + D4
                  DO 130 K = K1,K2,D5
                      A = Y(K)/C
                      X(K) = X(K) + S*A
                      Y(K) = A
  130                 CONTINUE
  140             CONTINUE
              IF (FOLD) THEN
C
                  C = -C
                  K0 = (N-I)*D2 + 1
                  FOLD = .FALSE.
                  GO TO 120
              END IF
  150         CONTINUE
C
          M = NOVER2*D2
          K0 = M + 1
          DO 170 K1 = K0,D1,D3
              K2 = K1 + D4
              DO 160 K = K1,K2,D5
                  J = K - M
                  L = K + M
                  A = Y(L)*2.0
                  X(K) = X(K) + A
                  Y(K) = A
                  X(L) = X(J)
                  Y(L) = -Y(J)
  160             CONTINUE
  170         CONTINUE
C
      END IF
C
C---- Format statements
C
 9000 FORMAT ('FFT error: SDIAD: N odd.  N =',I10)
      END
C
C
      SUBROUTINE DIPRP(PTS,SYM,PSYM,UNSYM,DIM,X,Y)
C     =================================================
C
C
C---- Double in place reordering programme
C
C
C     .. Scalar Arguments ..
      INTEGER          PSYM,PTS
C     ..
C     .. Array Arguments ..
      REAL             X(*),Y(*)
      INTEGER          DIM(5),SYM(15),UNSYM(15)
C     ..
C     .. Local Scalars ..
      REAL             T
      INTEGER          A,AL,B,BL,BS,C,CL,CS,D,DELTA,DK,DL,DS,E,EL,ES,F,
     +                 FL,FS,G,GL,GS,H,HL,HS,I,IL,IS,J,JJ,JL,JS,K,KK,KL,
     +                 KS,L,LK,LL,LS,M,ML,MODS,MS,MULT,N,NEST,NL,NS,NT,
     +                 P,P0,P1,P2,P3,P4,P5,PUNSYM,SEP,SIZE,TEST
      LOGICAL          ONEMOD
C     ..
C     .. Local Arrays ..
      INTEGER          MODULO(14),S(14),U(14)
C     ..
C     .. Equivalences ..
      EQUIVALENCE      (AL,U(1)), (BS,S(2)), (BL,U(2))
      EQUIVALENCE      (CS,S(3)), (CL,U(3)), (DS,S(4)), (DL,U(4))
      EQUIVALENCE      (ES,S(5)), (EL,U(5)), (FS,S(6)), (FL,U(6))
      EQUIVALENCE      (GS,S(7)), (GL,U(7)), (HS,S(8)), (HL,U(8))
      EQUIVALENCE      (IS,S(9)), (IL,U(9)), (JS,S(10)), (JL,U(10))
      EQUIVALENCE      (KS,S(11)), (KL,U(11)), (LS,S(12)), (LL,U(12))
      EQUIVALENCE      (MS,S(13)), (ML,U(13)), (NS,S(14)), (NL,U(14))
C     ..
      NEST = 14
C
      NT = DIM(1)
      SEP = DIM(2)
      P2 = DIM(3)
      SIZE = DIM(4) - 1
      P4 = DIM(5)
      IF (SYM(1).NE.0) THEN
          DO 10 J = 1,NEST
              U(J) = 1
              S(J) = 1
   10         CONTINUE
          N = PTS
          DO 20 J = 1,NEST
              IF (SYM(J).EQ.0) THEN
                  GO TO 30
              ELSE
                  JJ = NEST + 1 - J
                  U(JJ) = N
                  S(JJ) = N/SYM(J)
                  N = N/SYM(J)
              END IF
   20         CONTINUE
C
   30     JJ = 0
          DO 190 A = 1,AL
              DO 180 B = A,BL,BS
                  DO 170 C = B,CL,CS
                      DO 160 D = C,DL,DS
                          DO 150 E = D,EL,ES
                              DO 140 F = E,FL,FS
                                  DO 130 G = F,GL,GS
                                      DO 120 H = G,HL,HS
                                          DO 110 I = H,IL,IS
                                              DO 100 J = I,JL,JS
                                                 DO 90 K = J,KL,KS
                                                 DO 80 L = K,LL,LS
                                                 DO 70 M = L,ML,MS
                                                 DO 60 N = M,NL,NS
                                                 JJ = JJ + 1
                                                 IF (JJ.LT.N) THEN
                                                 DELTA = (N-JJ)*SEP
                                                 P1 = (JJ-1)*SEP + 1
                                                 DO 50 P0 = P1,NT,P2
                                                 P3 = P0 + SIZE
                                                 DO 40 P = P0,P3,P4
                                                 P5 = P + DELTA
                                                 T = X(P)
                                                 X(P) = X(P5)
                                                 X(P5) = T
                                                 T = Y(P)
                                                 Y(P) = Y(P5)
                                                 Y(P5) = T
   40                                            CONTINUE
   50                                            CONTINUE
                                                 END IF
   60                                            CONTINUE
   70                                            CONTINUE
   80                                            CONTINUE
   90                                            CONTINUE
  100                                            CONTINUE
  110                                         CONTINUE
  120                                     CONTINUE
  130                                 CONTINUE
  140                             CONTINUE
  150                         CONTINUE
  160                     CONTINUE
  170                 CONTINUE
  180             CONTINUE
  190         CONTINUE
      END IF
C
      IF (UNSYM(1).NE.0) THEN
          PUNSYM = PTS/PSYM**2
          MULT = PUNSYM/UNSYM(1)
          TEST = (UNSYM(1)*UNSYM(2)-1)*MULT*PSYM
          LK = MULT
          DK = MULT
          DO 200 K = 2,NEST
              IF (UNSYM(K).EQ.0) THEN
                  GO TO 210
              ELSE
                  LK = UNSYM(K-1)*LK
                  DK = DK/UNSYM(K)
                  U(K) = (LK-DK)*PSYM
                  MODS = K
              END IF
  200         CONTINUE
  210     ONEMOD = MODS .LT. 3
          IF (.NOT.ONEMOD) THEN
              DO 220 J = 3,MODS
                  JJ = MODS + 3 - J
                  MODULO(JJ) = U(J)
  220             CONTINUE
          END IF
          MODULO(2) = U(2)
          JL = (PUNSYM-3)*PSYM
          MS = PUNSYM*PSYM
C
          DO 290 J = PSYM,JL,PSYM
              K = J
  230         CONTINUE
C
              K = K*MULT
              IF (.NOT.ONEMOD) THEN
                  DO 240 I = 3,MODS
                      K = K - (K/MODULO(I))*MODULO(I)
  240                 CONTINUE
              END IF
              IF (K.GE.TEST) THEN
                  K = K - (K/MODULO(2))*MODULO(2) + MODULO(2)
              ELSE
                  K = K - (K/MODULO(2))*MODULO(2)
              END IF
              IF (K.LT.J) GO TO 230
C
              IF (K.NE.J) THEN
                  DELTA = (K-J)*SEP
                  DO 280 L = 1,PSYM
                      DO 270 M = L,PTS,MS
                          P1 = (M+J-1)*SEP + 1
                          DO 260 P0 = P1,NT,P2
                              P3 = P0 + SIZE
                              DO 250 JJ = P0,P3,P4
                                  KK = JJ + DELTA
                                  T = X(JJ)
                                  X(JJ) = X(KK)
                                  X(KK) = T
                                  T = Y(JJ)
                                  Y(JJ) = Y(KK)
                                  Y(KK) = T
  250                             CONTINUE
  260                         CONTINUE
  270                     CONTINUE
  280                 CONTINUE
              END IF
  290         CONTINUE
      END IF
C
      END
C
C Obscure routines only used by SFALL
C     ===============================
      SUBROUTINE PRMVCI(PERM,JV,N,N1)
C     ===============================
C
C---- Permute vector JV(N,3) by permutation matrix PERM
C      N1 is first dimension of JV
C
C     .. Scalar Arguments ..
      INTEGER N,N1
C     ..
C     .. Array Arguments ..
      REAL PERM(4,4)
      INTEGER JV(N1,3)
C     ..
C     .. Local Scalars ..
      INTEGER I
C     ..
C     .. Local Arrays ..
      REAL BV(3)
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC NINT
C     ..
C
C---- Permute
C
      DO 10 I = 1,3
        BV(I) = PERM(I,1)*FLOAT(JV(N,1)) + PERM(I,2)*FLOAT(JV(N,2)) +
     +          PERM(I,3)*FLOAT(JV(N,3))
   10 CONTINUE
C
C---- Copy back
C
      DO 20 I = 1,3
        JV(N,I) = NINT(BV(I))
   20 CONTINUE
C
      END
C
C     ===============================
      SUBROUTINE PRMVCR(PERM,AV,N,N1)
C     ===============================
C
C---- Permute vector AV(N,3) by permutation vector KP
C           N1 is first dimension of AV
C
C     .. Scalar Arguments ..
      INTEGER N,N1
C     ..
C     .. Array Arguments ..
      REAL AV(N1,3),PERM(4,4)
C     ..
C     .. Local Scalars ..
      INTEGER I
C     ..
C     .. Local Arrays ..
      REAL BV(3)
C     ..
C
C---- Permute
C
      DO 10 I = 1,3
        BV(I) = PERM(I,1)*AV(N,1) + PERM(I,2)*AV(N,2) +
     +          PERM(I,3)*AV(N,3)
   10 CONTINUE
C
C---- Copy back
C
      DO 20 I = 1,3
        AV(N,I) = BV(I)
   20 CONTINUE
C
      END
C

      INTEGER*2 IFHT(150,4),IFSTRT(150,4),IFWID(150,4),IFX0(150,4),
     +     IFY0(150,4),LENGF(150,4)
      INTEGER*1 NFONTS(4,3000,4)
      INTEGER IUNITF
      DATA IUNITF/11/
C
C
      IFAIL = 0
      ITEROP = -IUNITF
      CALL CCPDPN (-10,'font84.ascii','OLD','F',0,IFAIL)
      CALL CCPDPN (ITEROP,'font84.dat','NEW','U',80,IFAIL)
      READ(10,2000) IFSTRT,LENGF,IFX0,IFY0,IFWID,IFHT,NFONTS
 2000 FORMAT(10I5)
      WRITE (IUNITF) IFSTRT,LENGF,IFX0,IFY0,IFWID,IFHT,NFONTS
      CLOSE (UNIT=IUNITF)
      END

C
C     dna_output.f: write output for the DNA project
C     Copyright (C) 2004  CCLRC, Graeme Winter
C
C     This library is free software: you can redistribute it and/or
C     modify it under the terms of the GNU Lesser General Public License
C     version 3, modified in accordance with the provisions of the 
C     license to address the requirements of UK law.
C 
C     You should have received a copy of the modified GNU Lesser General 
C     Public License along with this library.  If not, copies may be 
C     downloaded from http://www.ccp4.ac.uk/ccp4license.php
C 
C     This program is distributed in the hope that it will be useful,
C     but WITHOUT ANY WARRANTY; without even the implied warranty of
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C     GNU Lesser General Public License for more details.
C
c     dna_output.f
c     maintained by G.Winter
c     "standard" DNA output XML subroutines for 
c     fortran programs - these will create named tables, lists and items
c     
c     tables containeth lists, which in turn containeth items.
c     
c     These may be applied to programs other than Mosflm - so long
c     as I can code up a clever way of handling this output!
c     
c     
c     
c     
c     
c     $Id$
c     

c     set no output flag - this is the alternative to starting the output
c     and should be called for good form - an alternative would be to
c     call dna_start with filename = ' ' - which I could interpret
c     appropriately

      subroutine dna_set_no_output
      implicit none
      include 'dna_header.fh'
      dnaout = .false.
      return
      end

c     
c     start writing the dna output - this takes a program name, 
c     for instance 'mosflm' - this should be called as soon as
c     the file is opened
c     

      subroutine dna_start(filename, progname)
      implicit none
      include 'dna_header.fh'
      character*(*) progname, filename
      integer ifail, lenstr
      external lenstr
      dnainlist = .false.
      dnaintable = .false.
      dna_image = ' '
      ifail = 1
      call ccpdpn(dnafd, filename, 'UNKNOWN', 'F' ,0 , ifail)
      if (ifail.ne.1) then
        call ccperr(2, 'dna_start: error opening file')
        dnaout = .false.
      else
        dnaout = .true.
      endif
 1    format('<?xml version="1.0"?><!DOCTYPE dna_tables>')
 2    format('<dna_tables program="', a, '">')
      if(dnaout) write(dnafd, 1)
      if(dnaout) write(dnafd, 2) progname(1:lenstr(progname))
      return
      end

c     
c     finish writing dna output - this should go at the end of the 
c     program
c     

      subroutine dna_end
      implicit none
      include 'dna_header.fh'
 1    format('</dna_tables>')

c     close any ongoing tables
      if (dnainlist) call dna_list_end
      if (dnaintable) call dna_table_end

      if(dnaout) write(dnafd, 1)
      if(dnaout) close(dnafd)
      dnaout = .false.
      return
      end

c     
c     write an item containing a "real"
c     

      subroutine dna_real_item(name, value)      
      implicit none
      include 'dna_header.fh'
      character *(*) name
      real value
      integer lenstr
      external lenstr
 1    format('      <item name="', a, '">', e15.6, '</item>')
      if(dnaout) write(dnafd, 1) name(1:lenstr(name)), value
      return
      end

      subroutine dna_double_item(name, value)      
      implicit none
      include 'dna_header.fh'
      character *(*) name
      double precision value
      integer lenstr
      external lenstr
 1    format('      <item name="', a, '">', e15.6, '</item>')
      if(dnaout) write(dnafd, 1) name(1:lenstr(name)), value
      return
      end

c     
c     as above sed 's/real/integer/'
c     


      subroutine dna_integer_item(name, value)
      implicit none
      include 'dna_header.fh'
      character *(*) name
      integer value, lenstr
      external lenstr
 1    format('      <item name="', a, '">', i15, '</item>')
      if(dnaout) write(dnafd, 1) name(1:lenstr(name)), value
      return
      end

c     
c     as above sed 's/real/character*(*)/'
c     

      subroutine dna_character_item(name, value)
      implicit none
      include 'dna_header.fh'
      character *(*) name
      character *(*) value
      integer lenstr
      external lenstr
 1    format('      <item name="', a, '">', a, '</item>')
      if(dnaout) write(dnafd, 1) name(1:lenstr(name)), value
      return
      end

c     
c     start a named list
c     

      subroutine dna_list_start(name)
      implicit none
      include 'dna_header.fh'
      character *(*) name
 1    format('    <list name="', a, '">')

c     check that we are not already in a list, and if we are
c     close it!

      if (dnainlist) call dna_list_end
      dnainlist = .true.

      if(dnaout) write(dnafd, 1) name
      return
      end

      subroutine dna_ilist_start(name, index)
c     this is the same as the above but with an integer index
c     so that you can have any lists with the same name - very 
c     important for tabular output.
      implicit none
      include 'dna_header.fh'
      character *(*) name
      integer index
 1    format('    <list name="', a, '" index="', i5, '">')

c     check that we are not already in a list, and if we are
c     close it!

      if (dnainlist) call dna_list_end
      dnainlist = .true.

      if(dnaout) write(dnafd, 1) name, index
      return
      end

c     
c     finish a named list
c     

      subroutine dna_list_end
      implicit none
      include 'dna_header.fh'

 1    format('    </list>')

c     check that we are in a list
      if (dnainlist) then
         if(dnaout) write(dnafd, 1)
      end if
      dnainlist = .false.
      return
      end

c     
c     start a named table
c     

      subroutine dna_table_start(name)
      implicit none
      include 'dna_header.fh'
      character *(*) name
      integer lenstr
      external lenstr
 1    format('  <table name="', a, '" image="', a, '">')
 2    format('  <table name="', a, '">')

c     check that we are not already inside a table
      if (dnaintable) call dna_table_end
      dnaintable = .true.

      if (dna_image .eq. ' ') then
         if(dnaout) write(dnafd, 2) name(1:lenstr(name))
      else
         if(dnaout) write(dnafd, 1) name(1:lenstr(name)), 
     +        dna_image(1:lenstr(dna_image))
      end if         
      return
      end

c     
c     finish a named table
c     

      subroutine dna_table_end
      implicit none
      include 'dna_header.fh'
 1    format('  </table>')

c     check we are not still inside a list

      if (dnainlist) then
         call dna_list_end
      end if

      if (dnaintable) then
         if(dnaout) write(dnafd, 1)
      end if
      dnaintable = .false.
      return
      end

      subroutine dna_error(message)
      implicit none
      character*(*) message
      integer lenstr
      external lenstr

      call dna_table_start('error')
      call dna_list_start('error')
      call dna_character_item('message', message(1:lenstr(message)))
      call dna_list_end
      call dna_table_end

      return
      end

      subroutine dna_warning(message)
      implicit none
      character*(*) message
      integer lenstr
      external lenstr

      call dna_table_start('warning')
      call dna_list_start('warning')
      call dna_character_item('message', message(1:lenstr(message)))
      call dna_list_end
      call dna_table_end

      return
      end

C
C     sorting_main.f: sorting function library
C     Copyright (C) 2001  Garib Murshudov
C
C     This library is free software: you can redistribute it and/or
C     modify it under the terms of the GNU Lesser General Public License
C     version 3, modified in accordance with the provisions of the 
C     license to address the requirements of UK law.
C 
C     You should have received a copy of the modified GNU Lesser General 
C     Public License along with this library.  If not, copies may be 
C     downloaded from http://www.ccp4.ac.uk/ccp4license.php
C 
C     This program is distributed in the hope that it will be useful,
C     but WITHOUT ANY WARRANTY; without even the implied warranty of
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C     GNU Lesser General Public License for more details.
C
                                !
                                !   A module to arrange memory for sorting
                                !   records (allocate, reallocate, deallocate)
      module sorting_commons
      implicit none
      integer :: nmax_rec = 2000000
      INTEGER NKEYS_S,NRECORD_S,KEY_ADDRESS,RECORD_ADDRESS
      integer  NRECORD_NOW,NRECORD_RETURN,INDEX_ADDRESS
      integer NRECORD_IN_RUNS,NRECORD_IN_THIS_RUN
      integer  NMAX_RECORD
      integer nkeys_l,nrec_l
      INTEGER SAVE_KEYS(5),SAVE_RECORD(200),ASCEND_DESCEND(5)
      REAL, allocatable :: keys_mem(:)
      real, allocatable :: array_mem(:)
      real, allocatable :: index_mem(:)


      contains

      subroutine sorting_allocate_this()


      if(nmax_rec.le.0)nmax_rec = 2000000

      allocate(keys_mem(nkeys_l*nmax_rec))
      allocate(array_mem(max(1,(nrec_l-nkeys_l)*nmax_rec)))
      allocate(index_mem(nmax_rec))

      end subroutine

      subroutine sorting_reallocate_this()

      integer nk1,nr1,ni1
      real, allocatable :: temp_keys(:)
      real, allocatable :: temp_recs(:)
      real, allocatable :: temp_inds(:)

      nk1 = nkeys_l*nmax_rec
      nr1 = max(1,(nrec_l-nkeys_l)*nmax_rec)
      ni1 = nmax_rec

      allocate(temp_keys(nk1))
      allocate(temp_recs(nr1))
      allocate(temp_inds(ni1))

      temp_keys(1:nk1) = keys_mem(1:nk1)
      temp_recs(1:nr1) = array_mem(1:nr1)
      temp_inds(1:ni1) = index_mem(1:ni1)

      nmax_rec = nint(nmax_rec*1.5)
      deallocate(keys_mem)
      deallocate(array_mem)
      deallocate(index_mem)

      allocate(keys_mem(nkeys_l*nmax_rec))
      allocate(array_mem(max(1,(nrec_l-nkeys_l)*nmax_rec)))
      allocate(index_mem(nmax_rec))
      
      keys_mem(1:nk1) = temp_keys(1:nk1)
      array_mem(1:nr1) = temp_recs(1:nr1)
      index_mem(1:ni1) = temp_inds(1:ni1)

      deallocate(temp_keys)
      deallocate(temp_recs)
      deallocate(temp_inds)


      return
      end subroutine

      subroutine sorting_deallocate_this()

      deallocate(keys_mem)
      deallocate(array_mem)
      deallocate(index_mem)

      end subroutine

      end module sorting_commons
                                !
                                !  now sorting bit
      INTEGER FUNCTION SRTBEG(NKEYS,KEYBUF,NRECL,ISS)
      use sorting_commons
C
      IMPLICIT NONE
      INTEGER NKEYS,NRECL,KEYBUF(*),ISS
C
      INTEGER IK,IREC,J,IRECORD_POSITIONS
      logical found
C
C----Find out how many records could be sorted. We need memory for
C----NRECL = NKEYS + NRECORDS number of fields and one field for
C----index of records which is going to be sorted.
      nkeys_l = nkeys
      nrec_l = nrecl/4
C
C---allocate enough memory (if it is not enough then we will reallocate)
      call sorting_allocate_this()

C
C----Save positions of keys and remaining records in an array
C----It would be easier if keybuf would have only info about 
C----ascending or descending and position of key. As it stands
C----it is a bit more comlicated to derive. To minimise 
C----change in the calling subroutine use previous binsort style
C----keybuf. 
      DO   IK=1,NKEYS
         J = (IK-1)*5+1
         SAVE_KEYS(IK) = KEYBUF(J+2)/4 + 1
         ASCEND_DESCEND(IK) = 1
         IF(KEYBUF(J+1).NE.0) ASCEND_DESCEND(IK) = -1
      ENDDO
      NKEYS_S = NKEYS
      IRECORD_POSITIONS = 0
      NRECORD_S = 0
      DO    IREC=1,NREC_L
         found = .FALSE.
         DO   IK=1,NKEYS
            IF(SAVE_KEYS(IK).EQ.IREC) then 
               found = .TRUE.
               exit
            endif
         ENDDO
         if(.not.found) then
            IRECORD_POSITIONS = IRECORD_POSITIONS + 1
            SAVE_RECORD(IRECORD_POSITIONS) = IREC
            NRECORD_S = NRECORD_S + 1
         endif
      ENDDO
c
C---Now we are ready to accept records. It will be done by another 
C---routine.
C---If external merging is necessary it should be initialised here.
C
      NRECORD_NOW = 0
      NRECORD_RETURN = 0
      SRTBEG = 0
      RETURN
      END
C
      INTEGER FUNCTION SRTRLS(ADATA)
      use sorting_commons
      IMPLICIT NONE

C
C----Recieve one record and save it in the list.
C----For large number of records if number of current records
C----is equal to maximum number of records then they should be 
C----sorted and then written to external files taken care of
C----distribution. (polyphase merging is possible option to use)
      REAL ADATA(*)

C
      INTEGER IKEY_NOW,IREC_NOW,IK,IR
C
C---First save keys.
      NRECORD_NOW = NRECORD_NOW + 1
      IF(NRECORD_NOW.GT.NMAX_REC) THEN
                                ! Memory is not sufficient. Reallocate
         call sorting_reallocate_this()
      ELSEIF(NRECORD_NOW.EQ.NMAX_REC) THEN
C
C---Memory is not enough for internal sorting. External sorting
C---part should be written. In that case available records 
C---should be sorted and written to file with distribution
c---which is going to be used. (polyphase distribution is one possibility)
C
Cmdw  binsort uses 4 scratch files (T=4)
Cmdw  Reads from stdin (see fillworka).
Cmdw  Each time buffer is full, do sort (see top of readrun; later
Cmdw  fwrite is only if all data fits into first buffer and disk not needed).
Cmdw  Write sorted buffer to scratch file (see writerun).
Cmdw  Read more, and write to next scratch file - see D2-D4 in merge().
Cmdw  When finished, rewind scratch files and go to merge step D5.

Cmdw  Open scratch files here (with QOPEN) iff necessary.
Cmdw  When finished, need to rewind with QSEEK.

      ENDIF

      IKEY_NOW = (NRECORD_NOW-1)*NKEYS_S
      DO   IK=1,NKEYS_S
         keys_mem(ikey_now+ik) = adata(save_keys(ik))*ascend_descend(ik)
      ENDDO
      IREC_NOW = (NRECORD_NOW-1)*NRECORD_S

      DO  IR=1,NRECORD_S
         array_mem(irec_now + ir) = adata(save_record(ir))
      ENDDO
      index_mem(nrecord_now) = nrecord_now
C
C---Normal return. No disaster.
      SRTRLS = 0
      RETURN
      END
C
      INTEGER FUNCTION SRTMRG()
      use sorting_commons
C
      IMPLICIT NONE
C
C---This function should do merging. But here we use only sorting
C---It will have to be expanded for merging for large number of records
C
      CALL HEAP_SORT(NRECORD_NOW,NKEYS_S,keys_mem,index_mem)
C
C---Records have been sorted. They should be distributed. 
C---But it is next stage. 
      SRTMRG = 0
      RETURN
      END
C
      INTEGER FUNCTION SRTRET(ADATA)
      use sorting_commons
      IMPLICIT NONE
C
C----Retrieve next record from the sorted list of the records.
      REAL ADATA(*)
C
C---This function should do merging. But here we use only sorting
C---It will have to be expanded for merging for large number of records
C
      INTEGER IK,IR,IKEY_REC,IREC_R
      integer kk
C
C----Take keys first.
      NRECORD_RETURN = NRECORD_RETURN + 1
      IF(NRECORD_RETURN.GT.NRECORD_NOW) THEN
C
C----In case of external search read from file new set of records
C----and then check if everything is o.k
C
C---Distaster. Calling subroutine wants more than it has given.
         SRTRET = -1
         RETURN
      ENDIF
C
C---Take keys.
      IKEY_REC = (NRECORD_RETURN-1)*NKEYS_S
      DO   IK=1,NKEYS_S
         kk = save_keys(ik)
        ADATA(kk) = keys_mem(ikey_rec + kk)*ascend_descend(ik)
      ENDDO
C
C--Now take records.
      IREC_R = (nint(index_mem(NRECORD_RETURN))-1)*nrecord_s
      DO   IR=1,NRECORD_S
         ADATA(SAVE_RECORD(IR)) = array_mem(IREC_R +  IR)
      ENDDO
C
C---Succesful retrieval
      SRTRET = 0
      RETURN
      END
C
C---Internal sorting part. It could be improved
C-----------
      SUBROUTINE  HEAP_SORT(N,NKEYS,A_KEY,INDEX_R)
      IMPLICIT NONE
C
C----Sorting using heapsort. 
C----A        contains keys
C----INDEX_R  index of records to be sorted
C----N        number of records
C----NKEYS    number of keys
C
C---Reference
C
c---Knuth, The art of computer programming Volume 3
C---1998
C
      INTEGER    N,NKEYS
      REAL       INDEX_R(*)
      REAL       A_KEY(*)
C
      REAL    T_KEY(5),T1_KEY(5)
C
      REAL      INDEX_C
      INTEGER   L,M,I_TEMP,L1,MKEY1_ADD,MKEY2_ADD,I_KEY,N1
C
C--------------------------------------------------------------
      L1 = N/2
C
C---Create heap. everybody tends to reach his level of incomptence
c      WRITE(*,*)'In heap_sort'

      DO   L=L1,1,-1
        CALL SIFT_UP(N,L,NKEYS,A_KEY,INDEX_R)
      ENDDO
C
c--Remove heaps  one after another
      N1 = N-1
      DO   M=N1,1,-1
        INDEX_C = INDEX_R(1)
        INDEX_R(1) = INDEX_R(M+1)
        INDEX_R(M+1) = INDEX_C
        MKEY1_ADD = M*NKEYS
        DO   I_KEY=1,NKEYS
          MKEY2_ADD = MKEY1_ADD + I_KEY
          T_KEY(I_KEY) = A_KEY(I_KEY)
          A_KEY(I_KEY) = A_KEY(MKEY2_ADD)
          A_KEY(MKEY2_ADD) = T_KEY(I_KEY)
        ENDDO

        CALL SIFT_UP(M,1,NKEYS,A_KEY,INDEX_R)
      ENDDO
      END
C
      SUBROUTINE SIFT_UP(M,L,NKEYS,A_KEY,INDEX_R)
c
c---Sift ip process in heap sort. This implementation is 
C---intended to work for multykey cases. I am not sure this treatment is best
C---for multy key cases. Other idea will have to be tested.
      IMPLICIT NONE
      INTEGER M,L,NKEYS
      REAL INDEX_R(*)
      REAL A_KEY(*)
C
      INTEGER I,J,IKEY_ADD,NKEYS1,JKEY_ADD,JKEY1_ADD,LKEY_ADD,
     &        I_KEY,J_KEY,I1_KEY
      REAL KEY_T(5),INDEX_C
C
C---Intitialise sift up (in Knuth's terminology H2)
      INDEX_C = INDEX_R(L)
      NKEYS1  = -NKEYS
      LKEY_ADD = L*NKEYS+NKEYS1
      DO  I_KEY=1,NKEYS
        KEY_T(I_KEY) = A_KEY(LKEY_ADD + I_KEY)
      ENDDO
c
C---H3
      J = L
 40   CONTINUE
C
c---Start sift up. Compare I with 2*I or 2*I+1
C---H4
      I = J
      J = J + J
C
C---If(J.GT.M) then return time
      IKEY_ADD = I*NKEYS + NKEYS1
      JKEY_ADD = J*NKEYS + NKEYS1
      IF(J.LE.M) THEN
         IF(J.LT.M) THEN
C
c---J.lt.M find maximum of J and J + 1 (which is 2*I, 2*I+1)
           JKEY1_ADD = JKEY_ADD + NKEYS
C
C---H5 
           DO   I_KEY=1,NKEYS
             IF(A_KEY(JKEY_ADD+I_KEY).LT.A_KEY(JKEY1_ADD+I_KEY)) THEN
C
c---Next record is smaller, Take it
               J = J + 1
               JKEY_ADD = JKEY1_ADD
               GOTO 55
             ELSE IF(A_KEY(JKEY_ADD+I_KEY).GT.
     &                                A_KEY(JKEY1_ADD+I_KEY))THEN
C
c--Next record is greater. No need to proceed
               GOTO 55
             ENDIF
C
c----Cannot decide yet. Check another key
           ENDDO
         ENDIF
 55      CONTINUE
         DO   I_KEY = 1,NKEYS
C
C---compare saved record in initialisation with record J. If
C---saved is smaller than current then then put for i (2*I or 2*I+1)
           IF(KEY_T(I_KEY).LT.A_KEY(JKEY_ADD + I_KEY)) THEN
C
C---H6 above H7 below
             INDEX_R(I) = INDEX_R(J)
             DO   I1_KEY=1,NKEYS
               A_KEY(IKEY_ADD+I1_KEY) = A_KEY(JKEY_ADD+I1_KEY)
             ENDDO
             GOTO 40
           ELSE IF(KEY_T(I_KEY).GT.A_KEY(JKEY_ADD + I_KEY)) THEN
             GOTO 80
           ENDIF
         ENDDO
       ENDIF
 80    CONTINUE
C
c---Put saved record to i-th and exit from sift up
C---H8
       INDEX_R(I) = INDEX_C
       DO   I_KEY=1,NKEYS
         A_KEY(IKEY_ADD+I_KEY) = KEY_T(I_KEY)
       ENDDO
       RETURN
       END

C
C     lgglib.f: functions used by Guoguang Lu's programs
C     Copyright (C) 1999  Guoguang Lu
C
C     This library is free software: you can redistribute it and/or
C     modify it under the terms of the GNU Lesser General Public License
C     version 3, modified in accordance with the provisions of the 
C     license to address the requirements of UK law.
C 
C     You should have received a copy of the modified GNU Lesser General 
C     Public License along with this library.  If not, copies may be 
C     downloaded from http://www.ccp4.ac.uk/ccp4license.php
C 
C     This program is distributed in the hope that it will be useful,
C     but WITHOUT ANY WARRANTY; without even the implied warranty of
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C     GNU Lesser General Public License for more details.
C
      function angle(v1,v2)
c calculate the angle between two vectors v1, and v2
c v1, v2 are the input 3*vectors
c angle is the output angle between them (in degrees)
      real*4 v1(3),v2(3)
c
      external acosd
c	write(7,*) 'v1,v2',v1,v2
c	write(7,*) 'vem v1,v2',vem(3,v1),vem(3,v2)
c	write(7,*) 'poimut',poimult(3,3,v1,v2)
      arc = poimult(3,3,v1,v2)/(vem(3,v1)*vem(3,v2))
c	write(7,*) 'arc=',arc
      if (abs(arc).gt.1.) then
       if (abs(arc)-1.gt.1e-5) write(7,*)'Warning arccosd > 1'
       if (arc.gt.1.) arc = 1.
       if (arc.lt.-1.) arc = -1.
      end if
      angle = acosd(arc)
      end
c
c
      SUBROUTINE ANGLZ(CELL,V,A)
      DIMENSION CELL(6),V(3),A(3)
      DO 10 I=1,3
10	A(I)=CELL(I)*V(I)
      END
c
c
      SUBROUTINE ANTIARR(IM,IN,A1,A)
c    Transpose an array
      DIMENSION A1(IM,IN),A(IN,IM)
      DO 10 II=1,IM
      DO 10 IJ=1,IN
10	A(IJ,II)=A1(II,IJ)
      END
c
c
      SUBROUTINE ARRAD(IM,IN,A1,A2,OUT)
c    Add two arrays      
      DIMENSION A1(IM,IN),A2(IM,IN),OUT(IM,IN)
      DO 10 II=1,IM
      DO 10 IJ=1,IN
10	OUT(II,IJ)=A1(II,IJ)+A2(II,IJ)
      END
c
c
      SUBROUTINE ARRGIVE(N,XYZ0,XYZ)
C    Copy an N-dimensional real array XYZ0 to another one XYZ.
      REAL*4 XYZ(N),XYZ0(N)
      DO I = 1, N
       XYZ(I) = XYZ0(I)
      END DO
      END
c
c
      SUBROUTINE ARRI(IM,IN,A,V,I)
c    Extract the i'th row of an array       
      INTEGER IM,IN
      DIMENSION A(IM,IN)
      DIMENSION V(IN)
      DO 20 I1=1,IN
20	V(I1)=A(I,I1)
      RETURN
      END
c
c
      SUBROUTINE ARRJ(IM,IN,A,VJ,IJ)
c    Extract the j'th column of an array  
      DIMENSION A(IM,IN)
      DIMENSION VJ(IM)
      DO 20 I1=1,IM
20	VJ(I1)=A(I1,IJ)
      RETURN
      END
c
c
C------MULTIPLY A REAL ARRAY BY A CONSTANT
      SUBROUTINE ARRMC(IM,IN,A1,C,A)
      DIMENSION A1(IM,IN),A(IM,IN)
      DO 10 I1=1,IM
      DO 10 I2=1,IN
10	A(I1,I2)=A1(I1,I2)*C
      END
c
c
C-------A STANDARD SUBPROGRAM TO MULTIPLY TWO ARRAYS
C	A1(IM1,IN1)*A2(IM2,IN2)=RSLT(IM1,IN2)
      SUBROUTINE ARRMULT(IM1,IN1,IM2,IN2,A1,A2,RSLT,V1,V2)
      INTEGER IM1,IM2,IN1,IN2
      DIMENSION A1(IM1,IN1),A2(IM2,IN2),RSLT(IM1,IN2)
      DIMENSION V1(IN1),V2(IM2)
      IF (IN1.NE.IM2) WRITE(6,*) 'The two arrays cannot be multiplied'
      DO 50 I=1,IM1
      CALL ARRI(IM1,IN1,A1,V1,I)
      DO 40 IJ=1,IN2
      CALL ARRJ(IM2,IN2,A2,V2,IJ)
40	RSLT(I,IJ)=POIMULT(IN1,IM2,V1,V2)
50	CONTINUE
      RETURN
      END

      SUBROUTINE ARRPS(IM,IN,A1,A2,OUT)
      DIMENSION OUT(IM,IN),A1(IM,IN),A2(IM,IN)
      DO 10 II=1,IM
      DO 10 IJ=1,IN
10	OUT(II,IJ)=A1(II,IJ)-A2(II,IJ)
      END
c
c
      subroutine arrrtoi(im,in,rmat,imat,err)
c    convert a matrix from real to integer
c      IM and IN are the dimensions.
c     rmat is input real IM*IN-dimension matrix
c     imat is output integer IM*IN-dimension matrix
c     err: if difference between real and integer values is bigger than
c           this parameter program will warn you
      real*4 rmat(im,in)
      integer imat(im,in)
c
      do j = 1, in
      do i = 1, im
      if (rmat(i,j).ge.0) then
       imat(i,j) = int(rmat(i,j)+0.5)
      else
       imat(i,j) = int(rmat(i,j)-0.5)
      end if
      if (abs(rmat(i,j)-float(imat(i,j))).gt.err) then
c	 WRITE(6,*) 'Warning: r-i > ',err
c	 WRITE(6,*)  'i,j,real,integer',i,j,rmat(i,j),imat(i,j)
      end if
      end do
      end do
      end
c      
c
      subroutine arrvalue(n,array,value)
c    initialise an n-dimensional array
      real array(n)
      do i = 1, n
        array(i) = value
      end do
      end
c
c
      SUBROUTINE AVERG(M,N,XIN,AVE)
C A routine to calculate the row averages of an M*N array XIN.
C The mean M-dimensional array is AVE which average the N data in XIN.
      DIMENSION XIN(M,N),AVE(M)
      XN = N
      DO I = 1, M
      AVE(I) = 0.
      DO J = 1, N
      AVE(I) = AVE(I) + XIN(I,J)
      END DO
      AVE(I) = AVE(I)/ XN
      END DO
      END 
c
c
      function bondangle(xyz1,xyz2,xyz3)
c subroutine to calculate a bond angle by giving 3 atoms. the output angle
c will be vector 2-1 and 2-3
c  1     3
c   \   /
c    \2/
c   bondangle
c xyz1,xyz2,xyz3 are the 3 atom positions and bondangle is shown in the fig
c	real xyz1(3),xyz2(3),xyz3(3)
      real xyz1(3),xyz2(3),xyz3(3)
      real b1(3),b2(3)
      call arrps(3,1,xyz1,xyz2,b1)
      call arrps(3,1,xyz3,xyz2,b2)
      bondangle = angle(b1,b2)
      end 
c
c
      function bonddihed(xyz1,xyz2,xyz3,xyz4)
c subroutine to calculate a dihedral angle by giving 4 atoms. 
c the output angle will be between plane of 1-2-3 and 2-3-4
c  1         4                      1        
c   \       /                        \       
c    \2---3/                          \2---3\  bonddihed=180 in this case
c   bonddihed= 0 in this case                \
c                                             4
c xyz1,xyz2,xyz3 xyz4 are the 4 atom positions and bonddihed is 
c shown in the fig
c	real xyz1(3),xyz2(3),xyz3(3),xyz4(3)
      real xyz1(3),xyz2(3),xyz3(3),xyz4(3)
c	real b1(3),b2(3)
      real b321(3),b432(3)
      real b23(3),b32(3),b34(3),b21(3)
      real by(3),bdih(3),bd(2)
      real view(3,3),views(3,3)
      external acosd, asind
c
      call arrps(3,1,xyz3,xyz2,b23)
      call arrps(3,1,xyz1,xyz2,b21)
      call veccrsmlt(b23,b21,b321)
      call arrps(3,1,xyz2,xyz3,b32)
      call arrps(3,1,xyz4,xyz3,b34)
      call veccrsmlt(b34,b32,b432)
c	call arrgive(3,b321,view(1,1))
c	call arrgive(3,b23,view(1,3))
      call veccrsmlt(b32,b321,by)
      call arrmc(3,1,b321,1./vem(3,b321),view(1,1))
      call arrmc(3,1,b32,1./vem(3,b32),view(1,3))
      call arrmc(3,1,by,1./vem(3,by),view(1,2))
      call antiarr(3,3,view,views)
      call matmult(3,3,3,1,views,b432,bdih)
      if (bdih(3).gt.1.0e-5) then
       WRITE(6,*) 'Warning in dihedral',bdih
      end if
c
      call arrmc(2,1,bdih,1./vem(2,bdih),bd)
c
c dump here
c	WRITE(6,*) 'views',views
c	WRITE(6,*) 'bdih',bdih
c	WRITE(6,*) 'bd',bd
c
      if (bd(1).ge.0. .and. bd(2).ge. 0.) then
       bonddihed = acosd(bd(1))
      else if (bd(1).ge.0. .and. bd(2).lt.0) then
       bonddihed = asind(bd(2))
      else if (bd(1).lt.0. .and. bd(2).ge.0) then
       bonddihed = acosd(bd(1))
      else if (bd(1).lt.0. .and. bd(2).lt.0) then
       bonddihed = -acosd(bd(1))
c	else
c	 stop ' what could be?'
      end if
      end
c
c
      subroutine caseres(res1,res2)
c A subroutine to change the case of amino acid e.g. PHE to Phe
c res1 input residue name
c res2 output residue name
c
      character*3 res1,res2,nam1(20),nam2(20)
c...  data statements.  Separate declaration and init required for f2c
      data nam1 /
     1 'ALA','ARG','ASN','ASP','CYS','GLN','GLU','GLY','HIS','ILE',
     2 'LEU','LYS','MET','PHE','PRO','SER','THR','TRP','TYR','VAL'/
      data nam2 /
     1 'Ala','Arg','Asn','Asp','Cys','Gln','Glu','Gly','His','Ile',
     2 'Leu','Lys','Met','Phe','Pro','Ser','Thr','Trp','Tyr','Val'/
c
      do i = 1,20
       if (res1.eq.nam1(i)) then
        res2 = nam2(i)
        return
       end if
      end do
      res2 = res1
      end
c
c
      SUBROUTINE CLLZ(NSYM,SYM,CELL)
      DIMENSION SYM(3,4,NSYM),CELL(6)
      DO 20 IS=1,NSYM
      DO 20 IC=1,3
20	SYM(IC,4,IS)=SYM(IC,4,IS)*CELL(IC)
      END	
c
c
      SUBROUTINE COMPARE ( NATM, XYZ1, XYZ2, A, T )
C	DIMENSION XYZ1(3,NATM), XYZ2(3,NATM), A(3,3), T(3)
C A subroutine to compare two structure without superposition.
c MOL2 i.e. XYZ2(3*NATM) = A(3*3) * XYZ1(3*NATM) + T(3)
C Where    NATM represents the number of the atoms in each molecule
c                which will be superimposed.
c          XYZ1(3,NATM) represents the coordinates of MOL1
c          XYZ2(3,NATM) represents the coordinates of MOL2
C          A(3*3)       represents the output matrix.
c          T(3*3)       represents the output vector.
c
C NATM can not be larger than NATM0 (currently 50000) or the parameter NATM0
C should be modified in this routine. 
c
C	COMMON/SHIFS/ SCALR,SCALT
c 	DATA SCALR/1./,SCALT/1./
C Note: There should be a scale of the shifts. i.e. Shift= scale * shifts
c Here SCALR is the rotation shiftscale
c Here SCALT is the translation shiftscale
c The initial and suggested SCALR is 1.
c The initial and suggested SCALt is 1.
C
C	COMMON/RMS/ RMS,SMEAN,NREF,NREF1
C RMS is the final R.M.S between two molecules.
C SMEAN is the mean distance.
c NREF is the number of cycles of rotation refinement
c NREF1 is not used by this routine.
c They could be used to judge the SCALR and SCALS
c
C	COMMON/IAT/ IAT1,IAT2,IAT3,IAT
C	DATA SCALR/1./,IAT/0/
c                                           by Guoguang Lu
C                                               01/31/1995 at Purdue
C
      COMMON/RMS/ RMS,SMEAN,NREF,NREF1
c	COMMON/SHIFS/ SCALR,SCALS
c	COMMON/IAT/ IAT1,IAT2,IAT3,IAT
c	DATA SCALR/1./,SCALS/1./,IAT/0/,IAT1/1/,IAT2/2/,IAT3/3/
      PARAMETER (NATM0 = 50000)
c   NATM0 is the largest number of atoms.
      DIMENSION XYZ1(3,NATM), XYZ2(3,NATM), A(3,3), T(3)
      DIMENSION X1(3,NATM0),X2(3,NATM0),DIS(3,NATM0)
      DIMENSION CEN1(3),CEN2(3)
      DIMENSION B1(3),B2(3),B3(3),T0(3)
c
c	DEG=180./3.14159265359
c
C Number of atoms cannot be more than NATM0 or less than 3.
c
C
      CALL RTMOV(NATM,XYZ1,A,T,DIS)
      CALL ARRPS(3,NATM,DIS,XYZ2,DIS)
C
      ATM = NATM
      SMEAN = 0
      DO I=1, NATM
      D = VEM(3,DIS(1,I))
      SMEAN = SMEAN + D
      END DO
      SMEAN = SMEAN /ATM
C
c SMEAN = SIGMA (DISTANCE) / N
C           i        i
      RMS = SQRT ( DOSQ(NATM*3,DIS) / ATM )
C
c RMS   = SQRT( SIGMA (DISTANCE^2) / N )
C           i              i
c 
      WRITE(6,*)
      WRITE(6,*) 'R.M.S.'
      WRITE(6,*) '       natm'
      WRITE(6,*) 'SQRT( SIGMA (Distance(i)^2)/natm ) = ',RMS
      WRITE(6,*) '       i=1'
C
      WRITE(6,*)
      WRITE(6,*) 'Mean Distance:'
      WRITE(6,*) ' natm'
      WRITE(6,*) 'SIGMA (Distance(i)) /natm = ',SMEAN
      WRITE(6,*) ' i=1'
C
      WRITE(6,*)
      WRITE(6,*) 'Mol1 is superposed to Mol2.'
      WRITE(6,*) 'The matrix and the vector are:'
      WRITE(6,*) 
      WRITE(6,1) (A(1,J),J=1,3),CEN1(1),T0(1)
      WRITE(6,2) (A(2,J),J=1,3),CEN1(2),T0(2)
      WRITE(6,1) (A(3,J),J=1,3),CEN1(3),T0(3)
1	FORMAT(1X,'      (',3F10.6,' )   (     ',f10.5,' )   ('
     1 ,f10.5,' )')
2	FORMAT(1X,' X2 = (',3F10.6,' ) * ( X1 -',f10.5,' ) + ('
     1 ,f10.5,' )')
C
      CALL MATMULT(3,3,3,1,A,CEN1,B3)
      CALL ARRPS(3,1,T0,B3,B3)
      CALL ARRAD(3,1,CEN1,B3,T)
C
      WRITE(6,*) 
      WRITE(6,*) 
      WRITE(6,4) (A(1,J),J=1,3),T(1)
      WRITE(6,5) (A(2,J),J=1,3),T(2)
      WRITE(6,4) (A(3,J),J=1,3),T(3)
4	FORMAT(1X,'      (',3F10.6,' )   (    )   (',f10.5,' )')
5	FORMAT(1X,' X2 = (',3F10.6,' ) * ( X1 ) + (',f10.5,' )')
C
      END 
c
c
      SUBROUTINE CRSTLARR(CELL,CRST,CRIS)
      DIMENSION CRST(3,3),CRIS(3,3),BUF1(3),BUF2(3),
     1IUF(3),CELL(6)
      INTEGER IUF
      external cosd, sind
      AP=CELL(4)
      BA=CELL(5)
      GA=CELL(6)
      CALL ARRMC(3,1,CRIS,0.,CRIS)
      COASTAR=(COSD(BA)*COSD(GA)-COSD(AP))/(SIND(BA)
     1*SIND(GA))
      SIASTAR=SQRT(1.-COASTAR*COASTAR)
      CRIS(1,1)=1.	
      CRIS(1,2)=COSD(GA)
      CRIS(1,3)=COSD(BA)
      CRIS(2,2)=SIND(GA)
      CRIS(2,3)=-SIND(BA)*COASTAR
      CRIS(3,3)=SIND(BA)*SIASTAR
      CALL ARRMC(3,3,CRIS,1.,CRST)
      CALL IVSN(3,CRST,BUF1,BUF2,IUF,VAL,1E-6)
      RETURN
      END
c
c
      SUBROUTINE CRTMOVE(NATM,XIN,A,T0,T,XOUT)
C A routine to compute: XOUT = A * (XIN-T0) + T
C        where   XIN is the input 3*NATM array
C                XOUT is the output 3*NATM array
c                A(3,3) is a 3*3 rotation matrix
c                T0(3) is a 3-dimensional translational vector.
c                T(3) is a 3-dimensional translational vector.
C Note: XIN has been changed into XIN-T0 after this subroutine.
c 89/11/06, BMC,UU,SE
c	DIMENSION XIN(3,NATM),XOUT(3,NATM),A(3,3),T(3)
C
      DIMENSION XIN(3,NATM),XOUT(3,NATM),A(3,3),T(3),T0(3)
      DO I = 1, NATM
      CALL ARRPS(3,1,XIN(1,I),T0,XIN(1,I))
      END DO
      CALL MATMULT(3,3,3,NATM,A,XIN,XOUT)
      DO I = 1, NATM
      CALL ARRAD(3,1,XOUT(1,I),T,XOUT(1,I))
      END DO
      END
c
c
      SUBROUTINE LGG_CRYSTAL(CELL,CELLS,DEOR,ORTH,DEORS,ORTHS)
C PJX - renamed from CRYSTAL to avoid clashes with similarly named
C common block in mapmask, ncsmask and dm
C
C this is a routine which inputs a cell parameter, CELL and calculates
c CELLS*6 --- cell dimensions in reciprocal space
c DEOR3*3 --- Deorthogonalization matrix in real space 
c ORTH3*3 --- Orthogonalization matrix in recepical space.
c DEORS3*3 --- Deorthogonalization matrix in reciprocal space 
c ORTHS3*3 --- Orthogonalization matrix in reciprocal space.
c All the matrices have cell dimension information in them.
c Guoguang 931118
c
      REAL DEOR(3,3),ORTH(3,3),CELL(6)
      REAL DEORS(3,3),ORTHS(3,3),CELLS(6)
      REAL BUFF(3,3)
      DIMENSION B1(3),B2(3),IUF(3)
      external cosd, sind
      AP=CELL(4)
      BA=CELL(5)
      GA=CELL(6)
      COASTAR=(COSD(BA)*COSD(GA)-COSD(AP))/(SIND(BA)
     1*SIND(GA))
      SIASTAR=SQRT(1.-COASTAR*COASTAR)
      CALL ARRVALUE(9,ORTH,0.)
      ORTH(1,1)=CELL(1)	
      ORTH(1,2)=CELL(2)*COSD(GA)
      ORTH(2,2)=CELL(2)*SIND(GA)
      ORTH(1,3)=CELL(3)*COSD(BA)
      ORTH(2,3)=-CELL(3)*SIND(BA)*COASTAR
      ORTH(3,3)=CELL(3)*SIND(BA)*SIASTAR
C
      CALL ARRGIVE(9,ORTH,DEOR)
      CALL IVSN(3,DEOR,B1,B2,IUF,DE,1.0E-6)
      CALL ANTIARR(3,3,ORTH,DEORS)
      CALL ANTIARR(3,3,DEOR,ORTHS)
C
      DO I = 1, 3
      CELLS(I) = VEM(3,orths(1,I))
      END DO
C
      CELLS(4) = ANGLE(ORTHS(1,2),ORTHS(1,3))	
      CELLS(5) = ANGLE(ORTHS(1,3),ORTHS(1,1))	
      CELLS(6) = ANGLE(ORTHS(1,1),ORTHS(1,2))	
      RETURN
      END
c
c
      SUBROUTINE CRYSTREC(CELL,CELLS,DEOR,ORTH,DEORS,ORTHS)
C this is a routine which inputs a cell parameter, CELL and calculates
c matrices for deorthogonalization and orthgonalization
c The convention in this routine is x=a* y in plane of a*-b*, z is C direction
c CELLS*6 --- cell dimensions in reciprocal space
c DEOR3*3 --- Deorthogonalization matrix in real space 
c ORTH3*3 --- Orthogonalization matrix in reciprocal space.
c DEORS3*3 --- Deorthogonalization matrix in reciprocal space 
c ORTHS3*3 --- Orthogonalization matrix in reciprocal space.
c All the matrices have cell dimension information in them.
c Guoguang 950914
c
      REAL DEOR(3,3),ORTH(3,3),CELL(6)
      REAL DEORS(3,3),ORTHS(3,3),CELLS(6)
      REAL BUFF(3,3),CELL1(6)
      DIMENSION B1(3),B2(3),IUF(3)
c Get a PDB convention 
      CALL LGG_CRYSTAL(CELL,CELLS,DEOR,ORTH,DEORS,ORTHS)
      CALL LGG_CRYSTAL(CELLS,CELL1,DEORS,ORTHS,DEOR,ORTH)
c
      end
c
c
c This is a subroutine to split one line into multiple lines by detecting
c a separation character for example ; | and so on
c the multiple lines will be written to unit iout
c iout -- unit to be written to
c il   -- length of the line
c line -- the line of characters to be split
c sep  -- "separation character"
c iline -- output number of lines after splitting.
c guoguang 940616
      subroutine cutline(iout,line,sep,iline)
      character*(*) line
      character*1 sep
      iline = 0
      is = 1
c	WRITE(6,*)  line
c	WRITE(6,*)  'sep ',sep
      il = lenstr(line)
      do it=il,1,-1
       if (ichar(line(it:it)).le.31) then
        line(it:it) = ' '
       else
        goto 9
       end if
      end do
9	il = it 
c	WRITE(6,*)  'il',il,line(1:il)
      rewind (iout)
      if (il.eq.0) return
10	ip = index(line(is:il),sep)
      if (ip.eq.0) then
       il1 = lenstr(line(is:il))
       if (il1.gt.0) then
        do isps = is, is+il1-1
         if (line(isps:isps).ne.' ') then
          write(iout,'(a)') line(isps:is+il1-1) 
          iline = iline + 1
          rewind (iout)
          return
         end if
        end do
        stop 'Strange'
       end if
      else 
       if (ip.gt.1) then
        il1 = lenstr(line(is:ip-2+is))
        if (il1.gt.0) then
         do isps = is, is+il1-1
          if (line(isps:isps).ne.' ') then
           write(iout,'(a)') line(isps:is+il1-1)
           iline = iline + 1
           is = ip + is
           if (is.le.il) goto 10
           rewind (10)
           return
          end if
         end do
         stop 'Strange'
        end if
       end if
       is = ip + is
       if (is.le.il) goto 10
       rewind (10)
       return
      end if
C	stop 'CUTLINE'
      end
c
c
      function dedx2(x1,x2,x3,y1,y2,y3,abc)
c   this is a program which calculates dy/dx(x2) by fitting 
c   a quadratic through 3 points. 
c   y = a*x^2 + b*x + c
c   dy/dx = 2*a*x + b
c  Here dedv = dy/dx(x2) = 2*a*x2 + b
c  When there are 3 points x1,y1, x2,y2, x3,y3, the coefficients a,b,c
c  can be obtained from a linear equation and dy/dx(x2) can thus be 
c  obtained.
c
c 
      dimension abc(3),y(3),arr(3,3)
      dimension b1(3),b2(3),m(3)
c
      y(1) = y1
      y(2) = y2
      y(3) = y3
      arr(1,1) = x1 * x1
      arr(2,1) = x2 * x2
      arr(3,1) = x3 * x3
      arr(1,2) = x1 
      arr(2,2) = x2 
      arr(3,2) = x3
      arr(1,3) = 1.
      arr(2,3) = 1.
      arr(3,3) = 1.
      call ivsn(3,arr,b1,b2,m,de,1e-5)
      call matmult(3,3,3,1,arr,y,abc)
      dedx2 = 2.*abc(1)*x2 + abc(2)
      return
      end
c
c
c a subroutine to convert denzo missetting angle to a matrix
c definition [rot]=[rotx]*[roty]*[rotz]
c 
      subroutine denmis(phi,rot)
      real phi(3),rot(3,3)
      external cosd, sind
      sinx = sind(phi(1))
      cosx = cosd(phi(1))
      siny = sind(phi(2))
      cosy = cosd(phi(2))
      sinz = sind(phi(3))
      cosz = cosd(phi(3))
      rot(1,1) =  cosy*cosz
      rot(2,1) = -cosx*sinz+sinx*siny*cosz
      rot(3,1) =  sinx*sinz+cosx*siny*cosz
      rot(1,2) =  cosy*sinz
      rot(2,2) =  cosx*cosz+sinx*siny*sinz
      rot(3,2) = -sinx*cosz+cosx*siny*sinz
      rot(1,3) = -siny
      rot(2,3) =  sinx*cosy
      rot(3,3) =  cosx*cosy
      end	
c
c
      function dihedral(x1,x2,x3,x4)
c calculate the dihedral angle of four input positions
c x1, x2, x3, x4 are the four input positions
c dihedral is the output dihedral angle in degrees
      real*4 x1(3),x2(3),x3(3),x4(3)
      real*4 b1(3),b2(3),b3(3),b4(3)
c
      call arrps(3,1,x1,x2,b1)	
      call arrps(3,1,x3,x2,b2)	
      call veccrsmlt(b1,b2,b3)
      call arrps(3,1,x2,x3,b1)	
      call arrps(3,1,x4,x3,b2)
      call veccrsmlt(b1,b2,b4)
      dihedral = angle(b3,b4)
      end
c
c
      FUNCTION DIST(XYZ1,XYZ2)
c Subroutine to calculate distance between two positions
      REAL xyz1(3),xyz2(3)
      DX = XYZ1(1)-XYZ2(1)
      DY = XYZ1(2)-XYZ2(2)
      DZ = XYZ1(3)-XYZ2(3)
      DIST = SQRT(DX*DX + DY*DY + DZ*DZ)
      END 
c
c
      FUNCTION DOSQ(N,V)
c	DIMENSION V(N)
C DOSQ = SIGMA ( V(i)^2 )
C          i
      DIMENSION V(N)
      DOSQ = 0.
      DO 10 I=1,N
10	DOSQ = DOSQ + V(I)*V(I)
      RETURN
      END
c
c
c------------------------------------------------------------
      subroutine down(txt,len)
c
c convert character string to lower case
c
      character*(*) txt
      character*80 save
      character*26 ualpha,lalpha
      data lalpha /'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      data ualpha /'abcdefghijklmnopqrstuvwxyz'/

      do 9000 i=1,len
        if((txt(i:i).ge.'A').and.(txt(i:i).le.'Z')) then
          match = index(lalpha,txt(i:i))
          save(i:i) = ualpha(match:match)
        else
          save(i:i) = txt(i:i)
        end if
c      end do
9000	continue

      txt = save
      return
      end
c
c
      SUBROUTINE DRVRBD(ITH,ROH,A)
C This is a subroutine to calculate the matrix of deriv(E)/deriv(theta i)
c where E is a 3*3 rotation matrix and theta i (i=1,2,3) is Eulerian Angle
c in ROH system.
C	DIMENSION A(3,3),ROH(3)
c parameter description:
c ITH:  when ITH = 1
c                     the output matrix is deriv(E) /deriv(theta1)
c       when ITH = 2
c                     the output matrix is deriv(E) /deriv(theta2)
c       when ITH = 3
c                     the output matrix is deriv(E) /deriv(theta3)
c ROH are the three Eulerian angles
c A  is the output deriv matrix. i.e. A = deriv(E) /deriv)(theta i)
c                               written by Guoguang Lu
c
      DIMENSION A(3,3),ROH(3)
      DIMENSION A1(3,3)
      ARC=3.14159265359/180.0
      SIPS = SIN(ROH(1)*ARC)
      COPS = COS(ROH(1)*ARC)
      SITH = SIN(ROH(2)*ARC)
      COTH = COS(ROH(2)*ARC)
      SIPH = SIN(ROH(3)*ARC)
      COPH = COS(ROH(3)*ARC)
c
c	Rossmann & Blow Matrix
c
c	E(1,1) =-SIPS*COTH*SIPH + COPS*COPH
c	E(1,2) =-SIPS*COTH*COPH - COPS*SIPH
c	E(1,3) =                  SIPS*SITH
c	E(2,1) = COPS*COTH*SIPH + SIPS*COPH
c	E(2,2) = COPS*COTH*COPH - SIPS*SIPH
c	E(2,3) =                - COPS*SITH
c	E(3,1) =                  SITH*SIPH
c	E(3,2) =                  SITH*COPH
c	E(3,3) = COTH


      IF (ITH.EQ.1) THEN
      A(1,1) =-coPS*COTH*SIPH - siPS*COPH
      A(1,2) =-coPS*COTH*COPH + siPS*SIPH
      A(1,3) =                  coPS*SITH
      A(2,1) =-siPS*COTH*SIPH + coPS*COPH
      A(2,2) =-siPS*COTH*COPH - coPS*SIPH
      A(2,3) =                + siPS*SITH
      A(3,1) = 0.
      A(3,2) = 0.
      A(3,3) = 0.
      ELSE IF (ITH.EQ.2) THEN
      A(1,1) =+SIPS*siTH*SIPH
      A(1,2) =+SIPS*siTH*COPH
      A(1,3) =                  SIPS*coTH
      A(2,1) =-COPS*siTH*SIPH
      A(2,2) =-COPS*siTH*COPH
      A(2,3) =                - COPS*coTH
      A(3,1) =                  coTH*SIPH
      A(3,2) =                  coTH*COPH
      A(3,3) = -siTH
      ELSE IF (ITH.EQ.3) THEN
      A(1,1) =-SIPS*COTH*coPH - COPS*siPH
      A(1,2) =+SIPS*COTH*siPH - COPS*coPH
      A(1,3) = 0.
      A(2,1) = COPS*COTH*coPH - SIPS*siPH
      A(2,2) =-COPS*COTH*siPH - SIPS*coPH
      A(2,3) = 0.
      A(3,1) =                  SITH*coPH
      A(3,2) =                 -SITH*siPH
      A(3,3) = 0.
      ELSE
      STOP 'invalid parameter ITH '
      END IF
C SINCE ROH IS IN DEGREES, THE MATRIX HAS TO BE MULTIPLIED BY ARC
      CALL ARRMC(3,3,A,ARC,A1)
      call arrgive(9,a1,a)
      END
c
c
      SUBROUTINE DRVROHTH(ITH,ROH,A)
C This is a subroutine to calculate the matrix of deriv(E)/deriv(theta i)
c where E is a 3*3 rotation matrix and theta i (i=1,2,3) is Eulerian Angle
c in ROH system.
C	DIMENSION A(3,3),ROH(3)
c parameter description:
c ITH:  when ITH = 1
c                     the output matrix is deriv(E) /deriv(theta1)
c       when ITH = 2
c                     the output matrix is deriv(E) /deriv(theta2)
c       when ITH = 3
c                     the output matrix is deriv(E) /deriv(theta3)
c ROH are the three Eulerian angles
c A  is the output deriv matrix. i.e. A = deriv(E) /deriv)(theta i)
c                               written by Guoguang Lu
c
      DIMENSION A(3,3),ROH(3)
      ARC=3.14159265359/180.0
      SIPS = SIN(ROH(1)*ARC)
      COPS = COS(ROH(1)*ARC)
      SITH = SIN(ROH(2)*ARC)
      COTH = COS(ROH(2)*ARC)
      SIPH = SIN(ROH(3)*ARC)
      COPH = COS(ROH(3)*ARC)
C
C
C *  ROH - MATRIX
C
C  110 E(1,1) = COPS*COPH - SIPS*SIPH*SITH
C      E(1,2) =-SIPS*COTH
C      E(1,3) = COPS*SIPH + SIPS*SITH*COPH
C      E(2,1) = SIPS*COPH + COPS*SITH*SIPH
C      E(2,2) = COPS*COTH
C      E(2,3) = SIPS*SIPH - COPS*SITH*COPH
C      E(3,1) =-COTH*SIPH
C      E(3,2) = SITH
C      E(3,3) = COTH*COPH

      IF (ITH.EQ.1) THEN
      A(1,1) = -SIPS*COPH - COPS*SIPH*SITH
      A(1,2) = -COPS*COTH
      A(1,3) = -SIPS*SIPH + COPS*SITH*COPH
      A(2,1) = COPS*COPH - SIPS*SITH*SIPH
      A(2,2) = -SIPS*COTH
      A(2,3) = COPS*SIPH + SIPS*SITH*COPH
      A(3,1) = 0.
      A(3,2) = 0.
      A(3,3) = 0.
      ELSE IF (ITH.EQ.2) THEN
      A(1,1) = - SIPS*SIPH*COTH
      A(1,2) = SIPS*SITH
      A(1,3) = SIPS*COTH*COPH
      A(2,1) = COPS*COTH*SIPH
      A(2,2) = -COPS*SITH
      A(2,3) = - COPS*COTH*COPH
      A(3,1) = SITH*SIPH
      A(3,2) = COTH
      A(3,3) = -SITH*COPH
      ELSE IF (ITH.EQ.3) THEN
      A(1,1) = -COPS*SIPH - SIPS*COPH*SITH
      A(1,2) = 0.
      A(1,3) = COPS*COPH - SIPS*SITH*SIPH
      A(2,1) =- SIPS*SIPH + COPS*SITH*COPH
      A(2,2) = 0.
      A(2,3) = SIPS*COPH + COPS*SITH*SIPH
      A(3,1) =-COTH*COPH
      A(3,2) = 0.
      A(3,3) = - COTH*SIPH
      ELSE
      STOP 'invalid parameter ITH '
      END IF
      END
c
c
      SUBROUTINE DRVROHTHARC(ITH,ROH,A)
C This is a subroutine to calculate the matrix of deriv(E)/deriv(theta i)
c where E is a 3*3 rotation matrix and theta i (i=1,2,3) is Eulerian Angle
c in ROH system.
C	DIMENSION A(3,3),ROH(3)
c parameter description:
c ITH:  when ITH = 1
c                     the output matrix is deriv(E) /deriv(theta1)
c       when ITH = 2
c                     the output matrix is deriv(E) /deriv(theta2)
c       when ITH = 3
c                     the output matrix is deriv(E) /deriv(theta3)
c ROH are the three Eulerian angles
c A  is the output deriv matrix. i.e. A = deriv(E) /deriv)(theta i)
c                               written by Guoguang Lu
c
      DIMENSION A(3,3),ROH(3)
C	ARC=3.14159265359/180.0
C	ARC= 1.0
      SIPS = SIN(ROH(1))
      COPS = COS(ROH(1))
      SITH = SIN(ROH(2))
      COTH = COS(ROH(2))
      SIPH = SIN(ROH(3))
      COPH = COS(ROH(3))
C
C
C *  ROH - MATRIX
C
C  110 E(1,1) = COPS*COPH - SIPS*SIPH*SITH
C      E(1,2) =-SIPS*COTH
C      E(1,3) = COPS*SIPH + SIPS*SITH*COPH
C      E(2,1) = SIPS*COPH + COPS*SITH*SIPH
C      E(2,2) = COPS*COTH
C      E(2,3) = SIPS*SIPH - COPS*SITH*COPH
C      E(3,1) =-COTH*SIPH
C      E(3,2) = SITH
C      E(3,3) = COTH*COPH

      IF (ITH.EQ.1) THEN
      A(1,1) = -SIPS*COPH - COPS*SIPH*SITH
      A(1,2) = -COPS*COTH
      A(1,3) = -SIPS*SIPH + COPS*SITH*COPH
      A(2,1) = COPS*COPH - SIPS*SITH*SIPH
      A(2,2) = -SIPS*COTH
      A(2,3) = COPS*SIPH + SIPS*SITH*COPH
      A(3,1) = 0.
      A(3,2) = 0.
      A(3,3) = 0.
      ELSE IF (ITH.EQ.2) THEN
      A(1,1) = - SIPS*SIPH*COTH
      A(1,2) = SIPS*SITH
      A(1,3) = SIPS*COTH*COPH
      A(2,1) = COPS*COTH*SIPH
      A(2,2) = -COPS*SITH
      A(2,3) = - COPS*COTH*COPH
      A(3,1) = SITH*SIPH
      A(3,2) = COTH
      A(3,3) = -SITH*COPH
      ELSE IF (ITH.EQ.3) THEN
      A(1,1) = -COPS*SIPH - SIPS*COPH*SITH
      A(1,2) = 0.
      A(1,3) = COPS*COPH - SIPS*SITH*SIPH
      A(2,1) =- SIPS*SIPH + COPS*SITH*COPH
      A(2,2) = 0.
      A(2,3) = SIPS*COPH + COPS*SITH*SIPH
      A(3,1) =-COTH*COPH
      A(3,2) = 0.
      A(3,3) = - COTH*SIPH
      ELSE
      STOP 'invalid parameter ITH '
      END IF
      END
c
c
      SUBROUTINE DRVROHTHD(ITH,ROH,A)
C This is a subroutine to calculate the matrix of deriv(E)/deriv(theta i)
c where E is a 3*3 rotation matrix and theta i (i=1,2,3) is Eulerian Angle
c in ROH system.
C	DIMENSION A(3,3),ROH(3)
c parameter description:
c ITH:  when ITH = 1
c                     the output matrix is deriv(E) /deriv(theta1)
c       when ITH = 2
c                     the output matrix is deriv(E) /deriv(theta2)
c       when ITH = 3
c                     the output matrix is deriv(E) /deriv(theta3)
c ROH are the three Eulerian angles
c A  is the output deriv matrix. i.e. A = deriv(E) /deriv)(theta i)
c                               written by Guoguang Lu
c
      DIMENSION A(3,3),ROH(3)
      DIMENSION A1(3,3)
      ARC=3.14159265359/180.0
      SIPS = SIN(ROH(1)*ARC)
      COPS = COS(ROH(1)*ARC)
      SITH = SIN(ROH(2)*ARC)
      COTH = COS(ROH(2)*ARC)
      SIPH = SIN(ROH(3)*ARC)
      COPH = COS(ROH(3)*ARC)
C
C
C *  ROH - MATRIX
C
C  110 E(1,1) = COPS*COPH - SIPS*SIPH*SITH
C      E(1,2) =-SIPS*COTH
C      E(1,3) = COPS*SIPH + SIPS*SITH*COPH
C      E(2,1) = SIPS*COPH + COPS*SITH*SIPH
C      E(2,2) = COPS*COTH
C      E(2,3) = SIPS*SIPH - COPS*SITH*COPH
C      E(3,1) =-COTH*SIPH
C      E(3,2) = SITH
C      E(3,3) = COTH*COPH

      IF (ITH.EQ.1) THEN
      A(1,1) = -SIPS*COPH - COPS*SIPH*SITH
      A(1,2) = -COPS*COTH
      A(1,3) = -SIPS*SIPH + COPS*SITH*COPH
      A(2,1) = COPS*COPH - SIPS*SITH*SIPH
      A(2,2) = -SIPS*COTH
      A(2,3) = COPS*SIPH + SIPS*SITH*COPH
      A(3,1) = 0.
      A(3,2) = 0.
      A(3,3) = 0.
      ELSE IF (ITH.EQ.2) THEN
      A(1,1) = - SIPS*SIPH*COTH
      A(1,2) = SIPS*SITH
      A(1,3) = SIPS*COTH*COPH
      A(2,1) = COPS*COTH*SIPH
      A(2,2) = -COPS*SITH
      A(2,3) = - COPS*COTH*COPH
      A(3,1) = SITH*SIPH
      A(3,2) = COTH
      A(3,3) = -SITH*COPH
      ELSE IF (ITH.EQ.3) THEN
      A(1,1) = -COPS*SIPH - SIPS*COPH*SITH
      A(1,2) = 0.
      A(1,3) = COPS*COPH - SIPS*SITH*SIPH
      A(2,1) =- SIPS*SIPH + COPS*SITH*COPH
      A(2,2) = 0.
      A(2,3) = SIPS*COPH + COPS*SITH*SIPH
      A(3,1) =-COTH*COPH
      A(3,2) = 0.
      A(3,3) = - COTH*SIPH
      ELSE
      STOP 'invalid parameter ITH '
      END IF
C SINCE ROH IS IN DEGREES, THE MATRIX HAS TO MULTIPLIED BY ARC
      CALL ARRMC(3,3,A,ARC,A1)
      CALL arrgive(9,A1,A1)
      END
c
c
      function dstll2(x1,x2,y1,y2)
c a routine to calculate the line-line distance.
c input:
c x1 and x2 are two positions on line X
c y1 and y2 are two positions on line Y
c output
c  dstll1 is the distance between x and y 
      real x1(3),x2(3)
      real y1(3),y2(3)
      real b1(3),b2(3),b3(3),b4(3),b5(3),b6(3)
c
      call arrps(3,1,x2,x1,b1)
      call arrps(3,1,y2,y1,b2)
      call veccrsmlt(b1,b2,b3)
      if (vem(3,b3).ge.1e-6) then
       dstll2 = dstps1(b3,x1,y1)
      else
       call arrps(3,1,y1,x1,b5)
       call arrmc(3,1,b1,1./vem(3,b1),b4)
       d1 = poimult(3,3,b5,b4)
       d2 = vem(3,b5)
       dstll2 = sqrt(d2*d2-d1*d1)
      end if
      end 
c
c
      FUNCTION DSTPL1(VL,XYZ0,XYZ,VPL)
C-----------DISTANCE FROM A POINT TO LINE	
c	FUNCTION DSTPL1(VL,XYZ0,XYZ,VPL)
c  VL -3- is the input direction vector of the line
c  XYZ0 -3- is the input position of a point on the line
c  XYZ -3-  is the input coordinates of the point.
c  VPL -3-  is the output vector from the point to the line which is
c           perpendicular to the direction vector of the line.
c  DISTPL1 is the output distance from the point to the line i.e. /VPL(3)/
C  so the equation of the line should be 
C         x-XYZ0(1)      y-XYZ0(2)       z-XYZ0(3)
C        ----------- =  -----------  =  -----------
C          VL(1)          VL(2)           VL(3)
C        where x,y,z is any position on the line
c

      DIMENSION VL(3),XYZ0(3),XYZ(3),VPL(3)
      DIMENSION B(3),BUF(3)
      CALL ARRPS(3,1,XYZ,XYZ0,BUF)
      T=POIMULT(3,3,BUF,VL)/POIMULT(3,3,VL,VL)
      CALL ARRMC(3,1,VL,T,BUF)
      CALL ARRAD(3,1,BUF,XYZ0,B)
      CALL ARRPS(3,1,XYZ,B,VPL)
      DSTPL1=VEM(3,VPL)
      RETURN
      END
c
c
      FUNCTION DSTPL2(VL,XYZ0,XYZ,VP0,VPL)
C-----------DISTANCE FROM A POINT TO LINE	
c	FUNCTION DSTPL1(VL,XYZ0,XYZ,VP0,VPL)
c  VL -3- is the input directional vector of the line
c  XYZ0 -3- is the a input position which belong to the line
c  XYZ -3-  is the input coordinate of the point.
c  VP0 -3-  is the output coordinate whis is the image of the point in the
c  line 
C  VPL -3- is the vector from VP0 to XYZ
c  DISTPL1 is the output distance from the point to the line i.e. /VPL(3)/
C  so the equation of the line should be 
C         x-XYZ0(1)      y-XYZ0(2)       z-XYZ0(3)
C        ----------- =  -----------  =  -----------
C          VL(1)          VL(2)           VL(3)
C        where the x,y,z is any position of the line
c

      DIMENSION VL(3),XYZ0(3),XYZ(3),VP0(3)
      DIMENSION VPL(3),BUF(3)
      CALL ARRPS(3,1,XYZ,XYZ0,BUF)
      DVL = VEM(3,VL)
      T= POIMULT(3,3,BUF,VL)/DVL*DVL
      CALL ARRMC(3,1,VL,T,BUF)
      CALL ARRAD(3,1,BUF,XYZ0,VP0)
      CALL ARRPS(3,1,XYZ,VP0,VPL)
      DSTPL2=VEM(3,VPL)
      RETURN
      END
c
c
      FUNCTION DSTPLROTR(A,T,XYZ)
C-----------DISTANCE FROM A POINT TO A ROTATION axis defined by ROT,T
c	FUNCTION DSTPL1(VL,XYZ0,XYZ,VPL)
c  A 3*3 is the rotation matrix which defines the axis
c  T  3 is the translation vector which defines the axis
c When there is a non-crystallographic rotation and translation
c x2 = A*x1 + t
c where A(3,3) is the 3*3 matrix
c 	t(3) is translation vector.
c  XYZ -3-  is the input coordinate of the point.
c  DISTPLROTR is the output distance from the point to the line i.e. /VPL(3)/
C  so the equation of the line should be 
C        where the x,y,z is any position of the line
c		Guoguang 970921
c
      real a(3,3),t(3),xyz(3),POL(3),xyz0(3),vpl(3)
      real B(3),BUF(3),vl(3),vl0(3)
      real b1(3),b2(3),x1(3),x2(3)
      external sind
c
      call arrvalue(3,xyz0,0.)
      call mtovec(a,vl,vkapa)
      vlm = vem(3,vl)
      if (vlm.lt.1.e-4) then
       WRITE(6,*) 'a',a
       WRITE(6,*) 'vlm',vlm
       stop 'something strange in dstplrotr'
      end if
      if (abs(vlm-1.).gt.1.e-5) then
       call arrmc(3,1,vl,1./vlm,vl0)
       call arrgive(3,vl0,vl)
      end if
      if (abs(vkapa).lt.1e-4) then
       go = vem(3,t)
       dstplrotr=9999.
      else 
       go = poimult(3,3,t,vl)
      end if
      call arrmc(3,1,vl,go,b1)
      call rtmov(3,xyz,a,t,x1)
      call arrps(3,1,x1,b1,x2)
      dstplrotr = dist(x2,xyz)/(2.*sind(vkapa/2.))
      end
c
c
      FUNCTION DSTPS1(VS,XYZ0,XYZ)
C------DISTANCE FROM A POINT TO A SECTION
c	FUNCTION DSTPS1(VL,XYZ0,XYZ,VPL)
c  VL -3- is the input directional vector of the plane section
c  XYZ0 -3- is the a input position which belong to the section
c  XYZ -3-  is the input coordinate of the point.
c  DISTPL1 is the output distance from the point to the section
C  so the equation of the section should be 
C
c VS(1) * ( x - XYZ0(1) ) + VS(2) * ( y - XYZ0(2) ) + VS(3) ( z - XYZ0(3) ) = 0
C
C        where the x,y,z is any position of the section
c
      DIMENSION VS(3),XYZ0(3),XYZ(3),BUF(3)
      CALL ARRPS(3,1,XYZ,XYZ0,BUF)
      DSTPS1=POIMULT(3,3,VS,BUF)/VEM(3,VS)
      RETURN
      END
c
c
c----------------------------------------------------------
      subroutine elb(txt,len)
c
c eliminate leading blanks from a character string
c
      character*(*) txt
      character*80 save

      do 9000 i=1,len
        if(txt(i:i).ne.' ') then
          nonb = i
          go to 100
        end if
9000  continue
      return
100   continue
      save = txt(nonb:len)
      txt = save
      return
      end
c
c
      SUBROUTINE ELIZE(N,E)
      DIMENSION E(N,N)
      DO 10 I=1,N
      E(I,I)=1.
c	WRITE(6,*) I,E
      DO 5 IJ=1,N
      IF (I.NE.IJ) E(I,IJ)=0.
5	CONTINUE
10	CONTINUE
      RETURN
      END
c
c
      function error2d(xy1,xy2)
      real xy1(2),xy2(2)
      e1 = xy2(1)-xy1(1)
      e2 = xy2(2)-xy1(2)
      error2d = sqrt(e1*e1+e2*e2)
      end
c
c
c read in a file and copy to another file
c nin --- unit of input file
c nout -- unit of output file
c file -- name of the input file
      subroutine filein(nin,nout,file)
      character*(*) file
      character*132 line
      call ccpdpn(nin,file,'readonly','F',0,0)
5	read(nin,'(a)',end=10) line
      il = lenstr(line)
      write(nout,'(a)') line(1:il)
      goto 5
10	continue
      end
c
c
      SUBROUTINE FMATIN(N,X)
      REAL X(N)
      DO I = 1, N
       CALL FRCINSIDE(X(i))
      END DO
      END
c
c
      SUBROUTINE FRAC2ANG(XYZ)
C A subroutine to convert fractional coordinates xyz into orthogonal 
c coordinates in Angstrom units.
C 
C	SUBROUTINE FRAC2ANG(XYZ)
C	COMMON/CELL/ CELL,DEOR,ORTH
C	DIMENSION CELL(6),DEOR(3,3),ORTH(3,3),XYZ(3)
C XYZ is an input fractional coordinate 3-dim array.
c CELL: 6-dim array to save the cell constants
c DEOR is 3*3 array, representing the deorthogonalizing array.
c ORTH is 3*3 array, representing the orthogonalizing array.
c
      COMMON/CELL/ CELL,DEOR,ORTH
      DIMENSION CELL(6),DEOR(3,3),ORTH(3,3),XYZ(3)
      DIMENSION B1(3),B2(3),B3(3)
      B3(1) = XYZ(1) * CELL(1)
      B3(2) = XYZ(2) * CELL(2)
      B3(3) = XYZ(3) * CELL(3)
C
      CALL matmult(3,3,3,1,ORTH,B3,XYZ,B1)
      END
c
c
      SUBROUTINE FRCINSIDE(X)
10	CONTINUE
      IF (X.GE.1.) THEN
      X = MOD(X,1.) 
      ELSE IF (X.LT.0.) THEN
      X = MOD(X,1.) + 1.
      END IF
      END
c
c
      SUBROUTINE FRCTOANG(XYZ)
C A subroutine to convert fractional coordinates xyz into orthogonal 
c coordinates in Angstrom units.
C 
C	SUBROUTINE FRAC2ANG(XYZ)
C	COMMON/CELL/ CELL,DEOR,ORTH
C	DIMENSION CELL(6),DEOR(3,3),ORTH(3,3),XYZ(3)
C XYZ is an input fractional coordinate 3-dim array.
c CELL: 6-dim array to save the cell constants
c DEOR is 3*3 array, representing the deorthogonalizing array.
c ORTH is 3*3 array, representing the orthogonalizing array.
c obs: different from frac2ang, the deor and orth must be from 
c 	subroutine crystal
c
      COMMON/CELL/ CELL,DEOR,ORTH
      DIMENSION CELL(6),DEOR(3,3),ORTH(3,3),XYZ(3)
      DIMENSION B1(3),B2(3),B3(3)
c	B3(1) = XYZ(1) * CELL(1)
c	B3(2) = XYZ(2) * CELL(2)
c	B3(3) = XYZ(3) * CELL(3)
C
      B3(1) = XYZ(1)
      B3(2) = XYZ(2)
      B3(3) = XYZ(3)
      CALL matmult(3,3,3,1,ORTH,B3,XYZ,B1)
      END
      character*80 function getnam(filnam)
      character*(*) filnam
c	character*80 cmd
c	call spstrunct(filnam)
c	il = lenstr(filnam)
c	write(cmd,'(3a)') 'printenv ',filnam(1:il),' > GETNAM'
cc	call system(cmd)
c       call ccpdpn(31,'GETNAM','old','F',0,0)
c	read(31,'(a)') getnam
c	call spstrunct(getnam)
c	close (31)
      getnam = ' '
      call ugtenv(filnam,getnam)
      end
c
c
      SUBROUTINE GETPDB(X,ATOM,RES,SEQ,NATM,FILNAM)
C A subroutine to read the Protein data bank format coordinate file
c X 3*21000 arrays, output xyz coordinates
c ATOM 21000 character*4 arrays, output atom names
c RES 21000 character*4 arrays, output residue number e.g. A101 A103...
C  If residue number is like A   1 then it will become A1
c SEQ 21000 character*4 arrays, output peptide name. e.g. PHE TRY ....
C NATM is the number of atoms in the coordinate file
c FILNAT is the file name of the coordinate.
c
      DIMENSION X(3,21000)
      CHARACTER*4 ATOM(21000),RES(21000),SEQ(21000),RES2
      CHARACTER FILNAM*80,HEAD*6,RES1*5
C	DATA FILNAM/'DIAMOND'/
C
      CALL SPSTRUNCT(FILNAM)
        call ccpdpn(3,FILNAM,'READONLY','F',0,0)
C
      NATM = 1
5	READ(3,10,ERR=5,END=20) HEAD, ATOM(NATM), SEQ(NATM), RES1
     1 , (X(I,NATM),I=1,3)
10	FORMAT(A6,7X,2A4,A5,4X,3F8.3)
      IF (HEAD.NE.'ATOM  '.AND.HEAD.NE.'HEDATM') GOTO 5
C
      IF (RES1(1:1).NE.' '.AND.RES1(2:2).EQ.' ') THEN
      RES2(1:1) = RES1(1:1)
      RES2(2:4) = RES1(3:5)
      ELSE
      RES2 = RES1(2:5)
      END IF
C
      call spstrunct(atom(natm))
      call spstrunct(seq(natm))
      call spstrunct(RES2)
      res(natm)=res2
C
12	CONTINUE
C
      NATM = NATM + 1
      IF (NATM.GT.21000) STOP 'Atoms can not be more than 21000.'
      GOTO 5
20	CONTINUE
      NATM = NATM - 1
      CLOSE (3)
C
      END
c
c
      SUBROUTINE GETPDB1(X,ATOM,SEQ,RES,BFAC,OCC,NATM,FILNAM)
C A subroutine to read the Protein data bank format coordinate file
c X 3*15000 arrays, output xyz coordinates
c ATOM 15000 character*4 arrays, output atom names
c RES 15000 character*4 arrays, output residue number e.g. A101 A103...
C  If residue number is like A   1 then it will become A1
c SEQ 15000 character*4 arrays, output peptide name. e.g. PHE TRY ....
C NATM is the number of atoms in the coordinate file
c FILNAT is the file name of the coordinate.
c
c in this subroutine, hydrogen atoms were excluded.
c
      PARAMETER (MAXATM = 25000)
      DIMENSION X(3,MAXATM)
      real bfac(MAXATM),occ(MAXATM)
      CHARACTER*4 ATOM(MAXATM),RES(MAXATM),SEQ(MAXATM),RES2
      CHARACTER FILNAM*80,HEAD*6,RES1*5
C	DATA FILNAM/'DIAMOND'/
C
      CALL SPSTRUNCT(FILNAM)
c	WRITE(6,*)  'open file'
c:	WRITE(6,*)  filnam
        call ccpdpn(3,FILNAM,'READONLY','F',0,0)
C
      NATM = 1
5	READ(3,10,ERR=5,END=20) HEAD, ATOM(NATM), SEQ(NATM), RES1
     1 , (X(I,NATM),I=1,3),occ(natm),bfac(natm)
c normal format
c10	FORMAT(A6,7X,2A4,A5,4X,3F8.3,2f6.2)
c xplor format
10	FORMAT(A6,6X,2A4,1X,A5,4X,3F8.3,2f6.2)
      IF (HEAD.NE.'ATOM  '.AND.HEAD.NE.'HETATM') GOTO 5
      IF (ATOM(NATM)(1:1).EQ.'H'.or.ATOM(NATM)(1:2).EQ.' H') goto 5
C
      IF (RES1(1:1).NE.' '.AND.RES1(2:2).EQ.' ') THEN
      RES2(1:1) = RES1(1:1)
      RES2(2:4) = RES1(3:5)
      ELSE
      RES2 = RES1(2:5)
      END IF
C
      call spstrunct(atom(natm))
      call spstrunct(seq(natm))
      call spstrunct(RES2)
      res(natm)=res2
C
12	CONTINUE
C
      NATM = NATM + 1
      IF (NATM.GT.MAXATM) STOP 'Atoms can not be more than MAXATM.'
      GOTO 5
20	CONTINUE
      NATM = NATM - 1
      CLOSE (3)
C
      END
c
c
      SUBROUTINE GETPDB2(X,ATOM,SEQ,RES,BFAC,OCC,NATM,FILNAM)
C A subroutine to read the Protein data bank format coordinate file
c X 3*maxatom arrays, output xyz coordinates
c ATOM maxatom character*4 arrays, output atom names
c RES maxatom character*4 arrays, output residue number e.g. A101 A103...
C  If residue number is like A   1 then it will become A1
c SEQ maxatom character*4 arrays, output peptide name. e.g. PHE TRY ....
C NATM is the number of atoms in the coordinate file
c FILNAT is the file name of the coordinate.
c
c in this subroutine, hydrogen atoms were included.
c
c	getpdb1 is for xplor file and exclude Hydrogen
c	getpdb2 is for any file
      parameter (maxatom = 50000)
      DIMENSION X(3,maxatom)
      real bfac(maxatom),occ(maxatom)
      CHARACTER*4 ATOM(maxatom),RES(maxatom),SEQ(maxatom),RES2
      CHARACTER FILNAM*80,HEAD*6,RES1*5
C	DATA FILNAM/'DIAMOND'/
C
      CALL SPSTRUNCT(FILNAM)
c	WRITE(6,*)  'open file'
c:	WRITE(6,*)  filnam
        call ccpdpn(3,FILNAM,'READONLY','F',0,0)
C
      NATM = 1
5	READ(3,10,ERR=5,END=20) HEAD, ATOM(NATM), SEQ(NATM), RES1
     1 , (X(I,NATM),I=1,3),occ(natm),bfac(natm)
c normal format
c10	FORMAT(A6,7X,2A4,A5,4X,3F8.3,2f6.2)
c xplor format
10	FORMAT(A6,6X,2A4,1X,A5,4X,3F8.3,2f6.2)
      IF (HEAD.NE.'ATOM  '.AND.HEAD.NE.'HETATM') GOTO 5
c	IF (ATOM(NATM)(1:1).EQ.'H'.or.ATOM(NATM)(1:2).EQ.' H') goto 5
C
      IF (RES1(1:1).NE.' '.AND.RES1(2:2).EQ.' ') THEN
      RES2(1:1) = RES1(1:1)
      RES2(2:4) = RES1(3:5)
      ELSE
      RES2 = RES1(2:5)
      END IF
C
      call spstrunct(atom(natm))
      call spstrunct(seq(natm))
      call spstrunct(RES2)
      res(natm)=res2
C
12	CONTINUE
C
      NATM = NATM + 1
      IF (NATM.GT.maxatom) STOP 'Atoms can not be more than maxatom.'
      GOTO 5
20	CONTINUE
      NATM = NATM - 1
      CLOSE (3)
C
      END
c
c
      SUBROUTINE GETPDB3(X,ATOM,SEQ,CH,RES,BFAC,OCC,NATM,FILNAM)
C A subroutine to read the Protein data bank format coordinate file
c X 3*15000 arrays, output xyz coordinates
c ATOM 15000 character*4 arrays, output atom names
c RES 15000 character*4 arrays, output residue number e.g. A101 A103...
C  If residue number is like A   1 then it will become A1
c SEQ 15000 character*4 arrays, output peptide name. e.g. PHE TRY ....
C NATM is the number of atoms in the coordinate file
c FILNAT is the file name of the coordinate.
c
c in this subroutine, hydrogen atoms were included.
c
c	getpdb1 is for xplor file and exclude Hydrogen
c	getpdb2 is for any file
      parameter (maxpro = 50000)
      DIMENSION X(3,maxpro)
      real bfac(maxpro),occ(maxpro)
      CHARACTER*4 ATOM(maxpro),RES(maxpro),SEQ(maxpro),RES2
      character*1 ch(maxpro)
      CHARACTER FILNAM*80,HEAD*6,RES1*5
C
      CALL SPSTRUNCT(FILNAM)
c	WRITE(6,*)  'open file'
c:	WRITE(6,*)  filnam
        call ccpdpn(3,FILNAM,'READONLY','F',0,0)
C
      NATM = 1
5	READ(3,10,ERR=5,END=20) HEAD, ATOM(NATM), SEQ(NATM), ch(natm),
     1  res(natm), (X(I,NATM),I=1,3),occ(natm),bfac(natm)
c normal format
c10	FORMAT(A6,7X,2A4,A5,4X,3F8.3,2f6.2)
c xplor format
10	FORMAT(A6,6X,2A4,1X,a1,A4,4X,3F8.3,2f6.2)
      IF (HEAD.NE.'ATOM  '.AND.HEAD.NE.'HETATM') GOTO 5
c	IF (ATOM(NATM)(1:1).EQ.'H'.or.ATOM(NATM)(1:2).EQ.' H') goto 5
C
c	IF (RES1(1:1).NE.' '.AND.RES1(2:2).EQ.' ') THEN
c	RES2(1:1) = RES1(1:1)
c	RES2(2:4) = RES1(3:5)
c	ELSE
c	RES2 = RES1(2:5)
c	END IF
C
      call spstrunct(atom(natm))
      call spstrunct(seq(natm))
c	call spstrunct(RES2)
c	res(natm)=res2
C
12	CONTINUE
C
      NATM = NATM + 1
      IF (NATM.GT.maxpro) then
       WRITE(6,*)  'Error: atom number is',natm
       WRITE(6,*)  'Error.. Atoms cannot be more than',maxpro
       stop
      end if
      GOTO 5
20	CONTINUE
      NATM = NATM - 1
      CLOSE (3)
C
      END
c
c
      SUBROUTINE GETPDBCA(X,ATOM,RES,SEQ,NATM,FILNAM)
C A subroutine to read the Protein data bank format coordinate file
c In this version only Ca atoms are read. -- Guoguang 950922
c X 3*50000 arrays, output xyz coordinates
c ATOM 50000 character*4 arrays, output atom names
c RES 50000 character*4 arrays, output residue number e.g. A101 A103...
C  If residue number is like A   1 then it will become A1
c SEQ 50000 character*4 arrays, output peptide name. e.g. PHE TRY ....
C NATM is the number of atoms in the coordinate file
c FILNAT is the file name of the coordinate.
c
      DIMENSION X(3,50000)
      CHARACTER*4 ATOM(50000),RES(50000),SEQ(50000),RES2
      CHARACTER FILNAM*80,HEAD*6,RES1*5
C	DATA FILNAM/'DIAMOND'/
C
      CALL SPSTRUNCT(FILNAM)
        call ccpdpn(3,FILNAM,'READONLY','F',0,0)
C
      NATM = 1
5	READ(3,10,ERR=5,END=20) HEAD, ATOM(NATM), SEQ(NATM), RES1
     1 , (X(I,NATM),I=1,3)
10	FORMAT(A6,7X,2A4,A5,4X,3F8.3)
      IF (HEAD(1:3).EQ.'END') GOTO 20
      IF (HEAD.NE.'ATOM  '.AND.HEAD.NE.'HEDATM') GOTO 5
      IF (ATOM(NATM).NE.'CA  ') GOTO 5
C
      IF (RES1(1:1).NE.' '.AND.RES1(2:2).EQ.' ') THEN
      RES2(1:1) = RES1(1:1)
      RES2(2:4) = RES1(3:5)
      ELSE
      RES2 = RES1(2:5)
      END IF
C
      call spstrunct(atom(natm))
      call spstrunct(seq(natm))
      call spstrunct(RES2)
      res(natm)=res2
C
12	CONTINUE
C
      NATM = NATM + 1
      IF (NATM.GT.50000) STOP 'Atoms cannot be more than 50000.'
      GOTO 5
20	CONTINUE
      NATM = NATM - 1
      CLOSE (3)
C
      END
c
c
      SUBROUTINE GETRDI(X,ATOM,RES,SEQ,NATM,FILNAM)
C A subroutine to read the Diamond format coordinate file
c X 3*5500 arrays, output xyz coordinates
c ATOM 5500 character*4 arrays, output atom names
c RES 5500 character*4 arrays, output residue number e.g. A101 A103...
C  If res is 'A  1'  then it will be truncated to 'A1  '
c SEQ 5500 character*4 arrays, output peptide name. e.g. PHE TRY ....
C NATM is the number of atoms in the coordinate file
c FILNAT is the file name of the coordinate.
c
      DIMENSION X(3,5500)
      CHARACTER*4 ATOM(5500),RES(5500),SEQ(5500),RES1*4
      CHARACTER FILNAM*80
C	DATA FILNAM/'DIAMOND'/
C
      CALL SPSTRUNCT(FILNAM)
        call ccpdpn(2,FILNAM,'READONLY','F',0,0)
C
      READ(2,'(A)') ATOM(1),ATOM(1),ATOM(1)	
C
      NATM = 1
5	READ(2,10,ERR=5,END=20) (X(I,NATM),I=1,3),
     1 SEQ(NATM), RES(NATM), ATOM(NATM)
10	FORMAT(3F10.4,35X,A3,A4,3X,A4)
      IF (RES(NATM).EQ.'END '.OR.RES(natm).EQ.'CAST') GOTO 5
C
      CALL SPSTRUNCT(ATOM(NATM))
      CALL SPSTRUNCT(SEQ(NATM))
      CALL SPSTRUNCT(RES(NATM))
C
12	NATM = NATM + 1
      GOTO 5
20	CONTINUE
      NATM = NATM - 1
      I = 1
      CLOSE (2)
C
25	IF (I.LE.NATM.AND.SEQ(I).NE.'    ') THEN
C
      DO J = I-1, 1, -1
      IF (J.LT.1) GOTO 30
      IF (RES(I).EQ.RES(J)) THEN
      SEQ(J) = SEQ(I)
      ELSE
      GOTO 30
      END IF
      END DO
C
30	DO J = I+1, NATM
      IF (RES(I).EQ.RES(J)) THEN
      SEQ(J) = SEQ(I)
      ELSE 
      GOTO 40
      END IF
      END DO
C
40	CONTINUE
      I = J 
      GOTO 25
      ELSE IF (I.LT.NATM) THEN
      I = I + 1
      GOTO 25
      ELSE
      RETURN
      END IF

      END
c
c
      SUBROUTINE GETSHELX ( X, ATOM, NATM, FILNAM )
c A routine to get coordinates and atom names from a SHELXX format
c file.
c X is 3*500 array to save the coordinates.
c ATOM is 4 bytes 500-dim array to represent the atom names
c NATM represents the number of atoms
c FILNAM is the SHELXX format file name.
c Sample coordinate format:
c FVAR   0.90195
c ND      5   0.59828   0.24644  10.24980  11.00000   0.01625   0.00675 =
c         0.03496   0.00372   0.00326   0.00215
c O1      4   0.58560   0.24368   0.55481  11.00000   0.02699   0.04010 =
c         0.01761   0.00117   0.00328   0.01509
c   ......
c   ......
c END
c 
      PARAMETER (MAXATM = 500 )
      CHARACTER FILNAM*80,ATOM(MAXATM)*4,KEY*80
      DIMENSION X(3,MAXATM)
C
C Open the SHELXX format coordinate file.
C
        call ccpdpn(1,FILNAM,'READONLY','F',0,0)
C	
      NATM = 0
      READ(1,*)
C
5	NATM = NATM + 1
      IF (NATM.GT.MAXATM) 
     +   STOP 'Atoms of Shelxx cannot be more than 500.'
      READ(1,10) ATOM(NATM),(X(I,NATM),I=1,3)
C	WRITE(6,*) NATM,ATOM(NATM),(X(I,NATM),I=1,3)
10	FORMAT(A4,5X,3F10.5)
      IF (ATOM(NATM).EQ.'END '.OR. ATOM(NATM).EQ.'    ') GOTO 20
      READ(1,*)
      GOTO 5
20	NATM = NATM -1
      CLOSE (1)
      RETURN
      END
C
C *  ROH - MATRIX
C
c
      SUBROUTINE HUBER(ROT,E)

      DIMENSION E(3,3),ROT(3)
c	EQUIVALENCE  (PS,AL,PA), (TH,BE,PB), (PH,GA,PC)
c	EQUIVALENCE  (S1,SIPS),  (S2,SITH),  (S3,SIPH)
c	1   ,(C1,COPS),  (C2,COTH),  (C3,COPH)

      PS=ROT(1)
      TH=ROT(2)
      PH=ROT(3)

      ARC=3.14159265359/180.0
      SIPS = SIN(PS*ARC)
      COPS = COS(PS*ARC)
      SITH = SIN(TH*ARC)
      COTH = COS(TH*ARC)
      SIPH = SIN(PH*ARC)
      COPH = COS(PH*ARC)
      E(1,1) = COPS*COPH - SIPS*SIPH*SITH
      E(1,2) =-SIPS*COTH
      E(1,3) = COPS*SIPH + SIPS*SITH*COPH
      E(2,1) = SIPS*COPH + COPS*SITH*SIPH
      E(2,2) = COPS*COTH
      E(2,3) = SIPS*SIPH - COPS*SITH*COPH
      E(3,1) =-COTH*SIPH
      E(3,2) = SITH
      E(3,3) = COTH*COPH
      END
C
C
C *  ROH - MATRIX
C
      SUBROUTINE HUBERARC(ROT,E)

      DIMENSION E(3,3),ROT(3)
      EQUIVALENCE  (PS,AL,PA), (TH,BE,PB), (PH,GA,PC)
      EQUIVALENCE  (S1,SIPS),  (S2,SITH),  (S3,SIPH)
     1   ,(C1,COPS),  (C2,COTH),  (C3,COPH)

      PS=ROT(1)
      TH=ROT(2)
      PH=ROT(3)

C	ARC=3.14159265359/180.0
C	ARC= 1.0
      SIPS = SIN(PS)
      COPS = COS(PS)
      SITH = SIN(TH)
      COTH = COS(TH)
      SIPH = SIN(PH)
      COPH = COS(PH)
      E(1,1) = COPS*COPH - SIPS*SIPH*SITH
      E(1,2) =-SIPS*COTH
      E(1,3) = COPS*SIPH + SIPS*SITH*COPH
      E(2,1) = SIPS*COPH + COPS*SITH*SIPH
      E(2,2) = COPS*COTH
      E(2,3) = SIPS*SIPH - COPS*SITH*COPH
      E(3,1) =-COTH*SIPH
      E(3,2) = SITH
      E(3,3) = COTH*COPH
      END
c
c
      SUBROUTINE IARRGIVE(N,XYZ0,XYZ)
C    Copy an N-dimensional integer array XYZ0 to another one XYZ.
      INTEGER*4 XYZ(N),XYZ0(N)
      DO I = 1, N
       XYZ(I) = XYZ0(I)
      END DO
      END
c
c
C------MULTIPLY AN INTEGER ARRAY BY A CONSTANT
      SUBROUTINE IARRMC(IM,IN,A1,C,A)
      INTEGER A1(IM,IN),A(IM,IN),C
      DO 10 I1=1,IM
      DO 10 I2=1,IN
10	A(I1,I2)=A1(I1,I2)*C
      END
c
c
      subroutine imatext(isym0,sout,ss1,ss2,ss3,trans)
c A subroutine to transfer a symmetric matrix into a string.
c isym0 is 3*3 symmetric matrix.
c in is 3-dimensional strings of the input like 'x''y''z' or 'h''k''l'
c trans is true. recognize the matrix as a transpose one.
c sout is a 3-dimensional output string
c
c Guoguang 91-02-06
      character sout(3)*12,ss1*1,ss2*1,ss3*1
      logical*1 trans
      integer isym0(3,3)
      integer isym(3,3)
      character out(3,3)*4,temp*4,in(3)*1
c	equivalence (sout,out)
c
      in(1) = ss1
      in(2) = ss2
      in(3) = ss3
C
      if (trans) then
       do j = 1,3
       do i = 1,3
        isym(i,j) = isym0(j,i)
       end do
       end do
      else 
       do j = 1, 3
       do i = 1, 3
        isym(i,j) = isym0(i,j)
       end do
       end do
      end if
c
      do i = 1,3
      do j = 1,3
       out(i,j)(4:4) = in(j)
       if (isym(i,j).eq.0) then
        out(i,j)(1:4) = '    '
       else if(abs(isym(i,j)).ge.10) then
        write(6,*) 'isym(',i,j,')=',isym(i,j),' > 10'
        stop 'error'
       else
        if (isym(i,j).gt.0) out(i,j)(1:1) = '+'
        if (isym(i,j).lt.0) out(i,j)(1:1) = '-'
        if (abs(isym(i,j)).ne.1) then
         write(out(i,j)(2:3),'(i1,a1)') abs(isym(i,j)),'*'
        else
         out(i,j)(2:3) = '  '
        end if
       end if
      end do
      end do
c
      do i = 1, 3
       write(sout(i),'(3a4)') (out(i,j),j=1,3)
c	 write(6,*) sout(i)
c	 if (sout(i)(1:1).eq.'+') sout(i)(1:1) = ' '
c make the text shorter
       il = lenstr(sout(i))
       if (il.gt.1) then
        iln = il
        do j = il-1, 1, -1
         if (sout(i)(j:j).eq.' ') then
         lg = iln - j
         sout(i)(j:iln-1) = sout(i)(j+1:iln)
         sout(i)(iln:iln) = ' '
         iln = iln - 1
         end if
        end do
       end if
       if (sout(i)(1:1).eq.'+') sout(i)(1:1) = ' '
      end do
c
      end
c
c
C-------A STANDARD SUBPROGRAM TO MULTIPLY TWO ARRAYS (a new quick version
C --- this is for I4 version
C) BMC 91/02/11/ Guoguang
C	A1(IM1,IN1)*A2(IM2,IN2)=RSLT(IM1,IN2)
      SUBROUTINE IMATMULT(IM1,IN1,IM2,IN2,A1,A2,RSLT)
      INTEGER A1(IM1,IN1),A2(IM2,IN2),RSLT(IM1,IN2)
      IF (IN1.NE.IM2) THEN
      stop 'The two arrays cannot be multiplied'
      end if
      DO I = 1, IM1
      DO J = 1, IN2
      RSLT(I,J) = 0.
      DO k = 1, in1
      RSLT(I,J) = RSLT(I,J) + A1(I,K)*A2(K,J)
      END DO
      END DO
      END DO
      RETURN
      END
c
c
c if you have a rigid movement x2=R*x1+1
c where R(3,3) is the rotation and t(3) is the translation
c then x1 =R2*x1-t2
c where R2=R-1
c       t2 =R-1*t
c The program reads in R,T matrix (3,4) and returns a inversed RT2
c nmat is the number of matrix
c
      subroutine invrt(nmat,rt,rt2)
      real rt(3,4,nmat),rt2(3,4,nmat)
      real b1(3),b2(3)
      integer me(3)
c
      do i = 1, nmat
       call arrgive(9,rt(1,1,i),rt2(1,1,i))
       call ivsn(3,rt2(1,1,i),b1,b2,me,de,1.e-4)
       call arrmc(3,1,rt(1,4,i),-1.,b1)
       call matmult(3,3,3,1,rt2(1,1,i),b1,rt2(1,4,i))
      end do
c
      end
c
c
C--------- IN PLACE MATRIX INVERSION ---------

      SUBROUTINE IVSN(N,A,B,C,ME,DE,EP)
      
C----  N is the dimension of the matrix A with N rows and N columns
c----  A-N,N- is the input matrix with N rows and N columns.
c---   ME(N), B(N) AND C(N) are the buffer of N-dimensional array.
c---   DE could any value
c      EP is the least value of the pivot i.e. when |A| < EP, the program
c      will stop.

c  on output, DE is the determinant of the original matrix
c  on output, A is the inverse of the original input A
c  ME is an index array which keeps track of row swaps

      DIMENSION A(N,N),ME(N),B(N),C(N)
      INTEGER I,J,K,ME
      
      DE = 1.0
      
      DO 10 J=1,N
10	    ME(J)=J

      DO 20 I=1,N
          Y=0.
          DO 30 J=I,N
              IF (ABS(A(I,J)).LE.ABS(Y)) GOTO 30
              K=J
              Y=A(I,J)
30	    CONTINUE
          DE = DE*Y
          IF (ABS(Y).LT.EP) then
              write(6,*) 'Ill conditioned matrix:'
              write(6,'(3f12.6)') a
              WRITE(6,*)  'the pivot of the matrix is ', y, ' N = ',N
              STOP 4444
          end if
          Y = 1.0/Y
          DO 40 J=1,N
              C(J) = A(J,K)
              A(J,K) = A(J,I)
              A(J,I) = -C(J)*Y
              B(J) = A(I,J)*Y
40	        A(I,J) = A(I,J)*Y
          A(I,I) = Y
          J = ME(I)
          ME(I) = ME(K)
          ME(K) = J
          DO 11 K=1,N
              IF(K.EQ.I) GOTO 11
              DO 12 J=1,N
                  IF (J.EQ.I) GOTO 12
                  A(K,J) = A(K,J) - B(J)*C(K)
12	        CONTINUE
11	    CONTINUE

20	CONTINUE

      DO 33 I=1,N
          DO 44 K=1,N
              IF(ME(K).EQ.I) GOTO 55
44	    CONTINUE
55	    IF(K.EQ.I) GOTO 33
          DO 66 J=1,N
              W = A(I,J)        ! swap rows k and i
              A(I,J) = A(K,J)
66	        A(K,J) = W
          IW = ME(I)            ! keep track of index changes 
          ME(I) = ME(K)
          ME(K) = IW
          DE = -DE  ! determinant changes sign when two rows swapped
33	CONTINUE
      RETURN
      END
c
c
      SUBROUTINE KABMOD(TH1,TH2,TH3,TH11,TH12,TH13)
      DIMENSION TH(6)
C
C --- ERRECHNET EULERWINKEL IM BEREICH -180<TH<180
C
      TH(1) = TH1
      TH(2) = TH2
      TH(3) = TH3
      TH(4) = TH11
      TH(5) = TH12
      TH(6) = TH13
      DO 1 I=1,6
      IF (TH(I).LE.-180.) TH(I) = TH(I) + 360.
    1 IF (TH(I).GT.180.) TH(I) = TH(I) - 360.
      TH1 = TH(1)
      TH2 = TH(2)
      TH3 = TH(3)
      TH11 = TH(4)
      TH12 = TH(5)
      TH13 = TH(6)
      RETURN
      END
c
c
      SUBROUTINE LATTIC(NSYM,SYM,LAT)
C A subroutine to add the translation vector to the symmetry arrays 
c and modify the number of symmetry operations according to the
c Bravais Lattice.
C	CHARACTER*1 LAT
C	DIMENSION SYM(3,4,192)
c Parameter description: 
c NSYM are the number of the symmetric operation. The input value do
c   not include the non-1 translation operation. But output includes it.
c SYM(3,4,NSYM) is the symmetry op arrays. 
c LAT is the Bravais lattice. It could be "P", "A", "B", "C", "I",
c "F",or "R"
C                                  Written by      Guoguang Lu
c                                                 27/02/88
      CHARACTER*1 LAT
      DIMENSION SYM(3,4,192),TR(3,4)
c
      IF (LAT.EQ.'P') RETURN
      CALL ARRMC(3,4,TR,0.,TR)
      IF (LAT.EQ.'A') THEN
      NTR = 2
      TR(2,2) = .5
      TR(3,2) = .5
      ELSE IF (LAT.EQ.'B') THEN
      NTR = 2
      TR(1,2) = .5
      TR(3,2) = .5
      ELSE IF (LAT.EQ.'C') THEN
      NTR = 2
      TR(2,2) = .5
      TR(1,2) = .5
      ELSE IF (LAT.EQ.'I') THEN
      NTR = 2
      TR(1,2) = .5
      TR(2,2) = .5
      TR(3,2) = .5
      ELSE IF (LAT.EQ.'F') THEN
      NTR = 4
      TR(1,2) = .5
      TR(2,2) = .5
      TR(2,3) = .5
      TR(3,3) = .5
      TR(3,4) = .5
      TR(1,4) = .5
      ELSE IF (LAT.EQ.'R') THEN
      NTR = 3
      TR(1,2) = 1./3.
      TR(2,2) = 2./3.
      TR(3,2) = 2./3.
      TR(1,3) = 2./3.
      TR(2,3) = 1./3.
      TR(3,3) = 1./3.
      ELSE 
      WRITE(6,*)  'Error Lattice>> No lattice ',LAT
      WRITE(6,*)  'Only P,A,B,C,I,F and R are allowed.'
      END IF
      DO ISYM = 1, NSYM
      DO ITR = 2, NTR
      I = (ITR-1)*NSYM + ISYM
      CALL ARRMC(3,3, SYM(1,1,ISYM), 1., SYM(1,1,I) )
      CALL ARRAD(3,1, TR(1,ITR), SYM(1,4,ISYM), SYM(1,4,I) )
      DO J = 1, 3
5	IF (SYM(J,4,I).GE.1.) THEN
      SYM(J,4,I) = SYM(J,4,I) - 1.
      GOTO 5
      END IF
6	IF (SYM(J,4,I).LT.-1.) THEN
      SYM(J,4,I) = SYM(J,4,I) + 1.
      GOTO 6
      END IF
      END DO		! J
      END DO		! ITR
      END DO		! ISYM
      NSYM = NSYM * NTR
      RETURN	
      END
c
c
      SUBROUTINE LSQEQ(M,N,A,PHI,DETA,ATA,B1)
C	DIMENSION A(M,N),PHI(M),DETA(N),ATA(N,N)
C	DIMENSION B1(N)
C This is a subroutine to compute the solution of least square equation
C of a normal matrix. i.e. AT*A*DETA = AT*PHI ==> DETA = (AT*A)^(-1)*AT*PHI
C It could be get the deta the make the SIGMA (phi)^2 = minimum
c        where  there are M equations
c                   .......
c                  phi i = 0
c                   .......
c
c  Note:  In the program parameter PHI(I) = - phi0 i  in the equation.
c
C                                             written by Guoguang Lu
c                                               23/01/1989
c parameter description:
c M is the number of equations. i.e. PHIi = 0 (i=1,...M)
C N is the number of the variables.
C           (N should be less than 3*N0 given in parameter statement.)
C           (At this moment, N0 is 6000.)
c (A,PHI) is a M*(N+1) normal  matrix
c A is a M*N array
c PHI is a M-dimensional vector. Here, PHI should be -phi0 in the equation.
c DETA is the output shift.
c ATA(N,N ) is a N*N buffer array.
c B1(N)     is a N-dimensional buffer array.
c Note :   M must not be less than N.
      PARAMETER (N0 = 6000 )
      DIMENSION A(M,N),PHI(M),DETA(N),ATA(N,N)
      DIMENSION B1(N),ME(3*N0)
      IF (M.LT.N) THEN
      STOP 'Equation number is not enough'
      else if (M.EQ.N) THEN
      CALL IVSN(M,A,B1,DETA,ME,DE,1.E-5)
c	CALL ARRMC(N,1,DETA,0.,DETA)
      call arrvalue(n,deta,0.)
      DO 50 I = 1, N
      DO 50 J = 1, N
50	DETA(I) = DETA(I) + ATA(I,J)*PHI(J)
      ELSE
C
C        T
C ATA = A * A
C
      call arrvalue(n*n,ata,0.)
c	CALL ARRMC(N,N,ATA,0.,ATA)
      DO 10 I = 1,N
      DO 10 J = I,N
      DO 10 K = 1,M
10	ATA(I,J) = ATA(I,J) + A(K,I)*A(K,J)
      IF (N.GE.2) THEN
      DO 20 I = 1, N
      DO 20 J = 1, I-1
20	ATA(I,J) = ATA(J,I)
      END IF
C
C
C ATA = ATA^-1
C
      CALL IVSN (N,ATA,B1,DETA,ME,DE,1.E-5)
C
C       T
C B1 = A * PHI
C
c	CALL ARRMC(N,1,B1,0.,B1)
      call arrvalue(n,b1,0.)
      DO 30 I = 1, N
30	B1(I) = POIMULT(M, M, A(1,I), PHI)
C
C  DETA = ATA^-1 * B1
C
C                T        T
C i.e. DETA  = (A * A) * A * PHI
C
c	CALL ARRMC(N,1,DETA,0.,DETA)
      call arrvalue(n,deta,0.)
      DO 40 I = 1, N
      DO 40 J = 1, N
40	DETA(I) = DETA(I) + ATA(I,J)*B1(J)
C
      END IF
C
      END
c
c
      subroutine matitor(im,in,imat,rmat)
c    Convert a matrix from integer*2 to real*4
c
      real*4 rmat(im,in)
      integer imat(im,in)
c
      do j = 1, in
      do i = 1, im
      rmat(i,j) = imat(i,j)
      end do
      end do
      end
c
c
C-------A STANDARD SUBPROGRAM TO MULTIPLY TWO ARRAYS (a new quick version
C) BMC 89/11/05/ Guoguang
C	A1(IM1,IN1)*A2(IM2,IN2)=RSLT(IM1,IN2)
      SUBROUTINE MATMULT(IM1,IN1,IM2,IN2,A1,A2,RSLT)
      DIMENSION A1(IM1,IN1),A2(IM2,IN2),RSLT(IM1,IN2)
      IF (IN1.NE.IM2) THEN
      stop 'The two arrays cannot be multiplied'
      end if
      DO I = 1, IM1
      DO J = 1, IN2
      RSLT(I,J) = 0.
      DO k = 1, in1
      RSLT(I,J) = RSLT(I,J) + A1(I,K)*A2(K,J)
      END DO
      END DO
      END DO
      RETURN
      END
c
c
      subroutine matrtoi(im,in,rmat,imat)
c    Convert a matrix from real to integer
c
      real*4 rmat(im,in)
      integer imat(im,in)
c
      do j = 1, in
      do i = 1, im
      imat(i,j) = rmat(i,j)
      end do
      end do
      end
c
c
      FUNCTION MATSYM(S,TEXT,ICOL) 
C 
C A FORTRAN FUNCTION SUBPROGRAM TO SCAN A SYMMETRY CARD AND BUILD 
C THE CORRESPONDING SYMMETRY-OPERATION MATRIX.  THE CONTENTS OF THE 
C CARD AND ERRORS ENCOUNTERED ARE WRITTEN OFF-LINE IN THE CALLING 
C PROGRAM.  THE FUNCTIONAL VALUE IS NORMALLY ZERO, WHEN AN ERROR HAS
C BEEN DETECTED THE NUMBERS 1-4 ARE GIVEN BACK: 
C ERROR-NUMBER 1:  INVALID CHARACTER AT POSITION .... 
C              2:  SYNTAX ERROR AT NONBLANK POSITION .... 
C              3:  BAD COMMAS 
C              4:  DETERMINANT OF ROTATION MATRIX NOT +1 OR -1
C 
C EXPLANATION OF ARGUMENTS
C S IS THE 1ST ELEMENT OF THE 3X4 ARRAY WHERE THE SYM. OP. IS TO BE 
C STORED. 
C TEXT  IS THE ARRAY OF THE TEXT RECORD WHICH IS TO BE SCANNED  (LENGTH:
C 36 CHARACTERS, CONTIGUOUSLY)
C ICOL POINTS - IN CASE OF ERRORS - TO THE POSITION OF AN INVALID 
C CHARACTER OR AN SYNTAX ERROR WITHIN THE SYMMETRY CARD 
C 
C     MODIFIED FOR PDP-11 06/JAN/78 S.J. REMINGTON
C ***** LAST UPDATE 07/10/76   MRS                WRS:PR2.MATSYM
C ***** PREVIOUS UPDATES                              07/07/75  06/11/72
C 
C 
      DIMENSION S(3,4), ICHAR(36)
      CHARACTER*1 CHAR,VALID(14),BLANK
      CHARACTER*36 TEXT
      EQUIVALENCE (BLANK,VALID(14))
      DATA VALID/'1','2','3','4','5','6','X','Y','Z','-','+','/',',',
     . ' '/
C 
C----INITIALIZE SIGNALS 
      ICOL = 0
      IFIELD = 0
C----CLEAR SYMOP ARRAY
      DO 4 J=1,4
      DO 4 I=1,3
 4    S(I,J) = 0.0
C 
C----TEST THE SYMMETRY TEXT (TEXT) FOR ILLEGAL CHARACTERS
C 
C      THE STATEMENT IS SCANNED AND ARRAY ICHAR IS FILLED WITH THE INDICES
C      OF EACH ELEMENT OF TEXT INTO THE ARRAY 'VALID' (I.E. IF THE SEVENTH
C      CHAR OF 'TEXT' -IGNORING BLANKS- IS 'Y', ICHAR(7)=8)
C
      ICOLMX = 0
      DO 20 I=1,36
      CHAR = TEXT(I:I)
      IF(CHAR .EQ. BLANK) GO TO 20
      ICOLMX = ICOLMX + 1
      DO 10 J=1,13
      IF( VALID(J) .NE. CHAR) GO TO 10
      ICHAR(ICOLMX) = J
      GO TO 20
   10 CONTINUE
C--IF GOT TO HERE, THE CHAR ISN'T IN 'VALID'
      JTXTSC = I
      GO TO 9975
   20 CONTINUE
C
C----BEGIN FIELD LOOP 
C 
 101  IFIELD = IFIELD + 1 
      IF(IFIELD-3) 104,104,103
C  HAVE ALL CHARACTERS  BEEN ANALYSED IN 3 FIELDS?
 103  IF(ICOL-ICOLMX) 9987,1000,1000
C---NO MORE THAN THREE FIELDS PERMITTED 
 104  SIGN = 1.0
      ICOL = ICOL+1 
C----MARCH ON, FIND WHAT'S NEXT
      IFNUM=ICHAR(ICOL) 
      IF (11-IFNUM) 9980,110,110
C----TEST FOR SIGNS 
 110  IF (10-IFNUM) 118,115,112 
C----TEST TO DISTINGUISH BETWEEN NUMBERS AND LETTERS
 112  IF (6-IFNUM) 125,130,130
C----FOUND A SIGN 
C     COME HERE FOR MINUS 
 115  SIGN = -1.0 
C     COME HERE FOR PLUS
 118  ICOL = ICOL + 1 
C----NEXT CHARACTER MUST BE A NUMBER OR LETTER
      IFNUM=ICHAR(ICOL) 
      IF (IFNUM-9) 122,122,9980 
 122  IF (IFNUM-6) 130,130,125
C----A LETTER 
 125  IFNUM = IFNUM - 6 
      S(IFIELD,IFNUM) = SIGN
      GO TO 150 
C----A NUMBER, FLOAT IT INTO DIGIT
 130  DIGIT = IFNUM 
      ICOL = ICOL + 1 
C----IS NEXT CHARACTER A SLASH
      IF(ICHAR(ICOL).EQ.12)  GO TO 135
C----NO SLASH, TRANSLATION TERM COMPLETE
      ICOL=ICOL-1 
      GO TO  140
C----A SLASH IS NEXT, IS THERE A NUMBER AFTER IT
 135  ICOL = ICOL + 1 
      IFNUM=ICHAR(ICOL) 
      IF (IFNUM-6) 138,138,9980 
C----MAKE FRACTION;   '5' NOT ALLOWED IN DENOMINATOR
  138 IF(IFNUM.EQ.5) GO TO 9980 
      DIGIT = DIGIT/FLOAT(IFNUM)
C----ACCUMULATE THE VECTOR COMPONENT
 140  S(IFIELD,4) = S(IFIELD,4) + SIGN*DIGIT
C----TEST TO SEE IF THERE ARE MORE CHARACTERS IN THIS SUBFIELD
C    OR A NEW SUBFIELD
 150  ICOL = ICOL + 1 
      SIGN = 1.0
C----TEST IF ALL DONE 
      IF(ICOL - ICOLMX) 151,151,1000
 151  CONTINUE
C----A SUBFIELD BEGINS WITH A PLUS OR MINUS 
      IF(ICHAR(ICOL).EQ.11)  GO TO 118
      IF(ICHAR(ICOL).EQ.10)  GO TO 115
C----A COMMA MUST BE NEXT UNLESS ICOL IS ICOLMX+1 WHICH MEANS THE END 
      IF(ICHAR(ICOL).EQ.13)   GO TO 101 
 163  IF (ICOLMX+1-ICOL) 9980,1000,9980 
C----EVERYTHING SEEMS OK SEE IF DETERMINANT IS A NICE + OR - 1. 
 1000 CONTINUE
      D=S(1,1)*S(2,2)*S(3,3)
     $ -S(1,2)*S(2,1)*S(3,3)
     $ -S(1,1)*S(2,3)*S(3,2)
     $ -S(1,3)*S(2,2)*S(3,1)
     $ +S(1,2)*S(2,3)*S(3,1)
     $ +S(1,3)*S(2,1)*S(3,2)
      IF(ABS(ABS(D) - 1.0) -.0001) 1001,9985,9985 
 1001 CONTINUE
      IF(IFIELD - 3) 9987,1002,9987 
 1002 CONTINUE
C----LEGAL RETURN 
      MATSYM = 0
 2005 RETURN
C 
C 
C----ILLEGAL CHARACTER ON SYMMETRY CARD 
 9975 MATSYM = 1
      ICOL = JTXTSC 
      GO TO 2005
C 
C----SYNTAX ERROR AT NONBLANK CHARACTER ICOL
 9980 MATSYM = 2
      GO TO 2005
C 
C----DETERMINANT IS NOT + OR - 1. 
 9985 MATSYM = 4
      GO TO 2005
C 
C----INCORRECT NUMBER OF COMMAS 
 9987 MATSYM = 3
      GO TO 2005
      END 
c
c
c this is subroutine to transfer missetting angle to matrix
c  ROT = (phiz)*(phiy)*(phix)
      subroutine misseting(phi,rot)
      real phi(3),rot(3,3)
      external cosd, sind
      sinx = sind(phi(1))
      cosx = cosd(phi(1))
      siny = sind(phi(2))
      cosy = cosd(phi(2))
      sinz = sind(phi(3))
      cosz = cosd(phi(3))
      rot(1,1) = cosz*cosy
      rot(2,1) = sinz*cosy
      rot(3,1) = -siny
      rot(1,2) = cosz*siny*sinx - sinz*cosx
      rot(2,2) = sinz*siny*sinx + cosz*cosx
      rot(3,2) = cosy*sinx
      rot(1,3) = cosz*siny*cosx + sinz*sinx
      rot(2,3) = sinz*siny*cosx - cosz*sinx
      rot(3,3) = cosy*cosx
      end	
c if you have a rigid movement x2=R*x1+1
c where R(3,3) is the rotation and t(3) is the translation
c then x1 =R2*x1-t2
c where R2=R-1
c       t2 =R-1*t
c The program reads in R,T matrix (3,4) 1 and 2, then returns an RT
c which is rt = rt1*rt2
c
c 
c
      subroutine morert(rt1,rt2,rt)
      real rt(3,4),rt2(3,4),rt1(3,4)
      real gt(4,4),gt2(4,4),gt1(4,4)
      real extr(4)
      real b1(3),b2(3)
      integer me(3)
c...  data statements.  Separate declaration and init required for f2c
      data extr /0.,0.,0.,1./
c
      do i = 1, 4
       gt1(i,4) = extr(i)
       gt2(i,4) = extr(i)
      end do
c
      do j = 1, 3
       do i = 1, 3
        gt1(i,j) = rt1(i,j)
        gt2(i,j) = rt2(i,j)
       end do
      end do
c
      do j = 1, 3
       gt1(4,j) = rt1(j,4)
       gt2(4,j) = rt2(j,4)
      end do
c
      call matmult(4,4,4,4,gt1,gt2,gt)
c
      do j = 1, 3
       do i = 1, 3
        rt(i,j) = rt(i,j)
       end do
      end do
c
      do j = 1, 4
       rt(j,4) = gt(4,j)
      end do
c
c	WRITE(6,*) 'gt'
c	write(6,'(4f10.5)') gt1
c	write(6,'(4f10.5)') gt2
c	write(6,'(4f10.5)') gt
c
      end
c
c
c a subroutine to transfer a normalized matrix to denzo missetting angle 
c definition [rot]=[rotx]*[roty]*[rotz]
c  GuoGuang 930706
      subroutine mtodenmis(rot0,phi)
      real rot0(3,3)
      real rot(3,3),phi(3)
      external asind, atand, cosd
c 	sinx = sind(phi(1))
c 	cosx = cosd(phi(1))
c 	siny = sind(phi(2))
c 	cosy = cosd(phi(2))
c 	sinz = sind(phi(3))
c 	cosz = cosd(phi(3))
c	rot0(1,1) =  cosy*cosz
c	rot0(2,1) = -cosx*sinz+sinx*siny*cosz
c	rot0(3,1) =  sinx*sinz+cosx*siny*cosz
c	rot0(1,2) =  cosy*sinz
c	rot0(2,2) =  cosx*cosz+sinx*siny*sinz
c	rot0(3,2) = -sinx*cosz+cosx*siny*sinz
c	rot0(1,3) = -siny
c	rot0(2,3) =  sinx*cosy
c	rot0(3,3) =  cosx*cosy
c
      call antiarr(3,3,rot0,rot)
c 	sinx = sind(phi(1))
c 	cosx = cosd(phi(1))
c 	siny = sind(phi(2))
c 	cosy = cosd(phi(2))
c 	sinz = sind(phi(3))
c 	cosz = cosd(phi(3))
c	rot(1,1) = cosz*cosy
c	rot(2,1) = sinz*cosy
c	rot(3,1) = -siny
c	rot(1,2) = cosz*siny*sinx - sinz*cosx
c	rot(2,2) = sinz*siny*sinx + cosz*cosx
c	rot(3,2) = cosy*sinx
c	rot(1,3) = cosz*siny*cosx + sinz*sinx
c	rot(2,3) = sinz*siny*cosx - cosz*sinx
c	rot(3,3) = cosy*cosx
      phi(2) = asind(-rot(3,1))
      if (abs(phi(2)).ne.90.) then
       if (rot(1,1).eq.0.) then
        phi(3) = 90.
       else
        phi(3) = atand(rot(2,1)/rot(1,1))
        if (phi(3).gt.0..and.rot(1,1)/cosd(phi(2)).lt.0.)
     1  phi(3) = 180. + phi(3)
        if (phi(3).lt.0..and.rot(2,1)/cosd(phi(2)).gt.0.) 
     1 phi(3) = 180. + phi(3)
       end if
       if (rot(3,3).eq.0.) then
        phi(1) = 90.
       else
        phi(1) = atand(rot(3,2)/rot(3,3))
        if (phi(1).gt.0..and.rot(3,3)/cosd(phi(2)).lt.0.)
     1  phi(1) = 180. + phi(1)
        if (phi(1).lt.0..and.rot(3,2)/cosd(phi(2)).gt.0.) 
     1 phi(1) = 180. + phi(1)
       end if
      else
       WRITE(6,*)  'not implemented yet'
      end if
      end 
c
c
      SUBROUTINE MTOHUBER(E,HB,HB1)
      DIMENSION E(3,3),HB(3),HB1(3)
C
C * ROH ANGLES:  -180 < PSI < 180
C                 -90 < TH  <  90
C                -180 < PHI < 180
C
      ARC=3.14159265359/180.0
      if (e(3,2).gt.1.0) e(3,2) = 1.0
      if (e(3,2).lt.-1.0) e(3,2) = -1.0
210	TH = ASIN(E(3,2))
      COSTH = COS(TH)
c	IF (COSTH.GE.0.01) GO TO 212
      if (costh.lt.1.0e-6) then
       ph = 0.
       ps = acos(e(1,1))
       if (e(2,1).lt.0) ps = -ps
       goto 1500
      end if
c	WRITE (6,1212) COSTH
c1212	FORMAT('-*** WARNING :  COS(THETA) = ', E8.2, ' ***')
212	PH = E(3,3)/COSTH
C	IF (PH.GT.1.0.OR.PH.LT.-1.0) WRITE(6,1291) PH
c	IF (ABS(PH).GT.(1.00001)) WRITE(6,1291) PH
1291	FORMAT(' ARCOS(E33/COSTH)=',F12.5)
1020	FORMAT(' *** ERROR IN ROH *** ',2F10.4/)
      IF (PH.GT.1.0) PH=1.0
      IF (PH.LT.-1.0) PH=-1.0
      PH=ACOS(PH)
      TST=-COSTH*SIN(PH)
      IF (TST*E(3,1).LT.0.0) PH=-PH
      PS = E(2,2)/COSTH
c	IF (PS.GT.1.0.OR.PS.LT.-1.0) WRITE(6,1292) PS
c	if (abs(ps).gt.1.0001) write(6,1292) ps
1292 	FORMAT(' ARCOS(E22/COSTH)=',F12.5)
      IF (PS.GT.1.0) PS=1.0
      IF (PS.LT.-1.0) PS=-1.0
      PS=ACOS(PS)
      TST=-COSTH*SIN(PS)
      IF (TST*E(1,2).LT.0.0) PS=-PS
      TST = -SIN(PS)*SIN(PH)*SIN(TH) + COS(PS)*COS(PH)
c	IF (ABS(TST-E(1,1)) .GT. 0.1) WRITE (6,1020) TST,E(1,1)
      TST = -COS(PS)*SIN(TH)*COS(PH) + SIN(PS)*SIN(PH)
c	IF (ABS(TST-E(2,3)) .GT. 0.1) WRITE (6,1020) TST,E(2,3)
1500	continue
      PS = PS/ARC
      TH = TH/ARC
      PH = PH/ARC
      PS1 = 180. + PS
      TH1 = 180. - TH
      PH1 = 180. + PH
      CALL KABMOD(PS,TH,PH,PS1,TH1,PH1)
      HB(1)=PS
      HB(2)=TH
      HB(3)=PH
      HB1(1)=PS1
      HB1(2)=TH1
      HB1(3)=PH1
      END
c
c
      SUBROUTINE MTOHUBERARC(E,HB,HB1)
      DIMENSION E(3,3),HB(3),HB1(3)
C
C * ROH ANGLES:  -180 < PSI < 180
C                 -90 < TH  <  90
C                -180 < PHI < 180
C
C	ARC=3.14159265359/180.0
C	ARC=1.0
210	TH = ASIN(E(3,2))
      COSTH = COS(TH)
      IF (COSTH.GE.0.01) GO TO 212
      WRITE (6,1212) COSTH
1212	FORMAT('-*** WARNING :  COS(THETA) = ', E8.2, ' ***')
212	PH = E(3,3)/COSTH
c	IF (PH.GT.1.0.OR.PH.LT.-1.0) WRITE(6,1291) PH
1291	FORMAT(' ARCOS(E33/COSTH)=',F12.5)
1020	FORMAT(' *** ERROR IN ROH *** ',2F10.4/)
      IF (PH.GT.1.0) PH=1.0
      IF (PH.LT.-1.0) PH=-1.0
      PH=ACOS(PH)
      TST=-COSTH*SIN(PH)
      IF (TST*E(3,1).LT.0.0) PH=-PH
      PS = E(2,2)/COSTH
c	IF (PS.GT.1.0.OR.PS.LT.-1.0) WRITE(6,1292) PS
1292 	FORMAT(' ARCOS(E22/COSTH)=',F12.5)
      IF (PS.GT.1.0) PS=1.0
      IF (PS.LT.-1.0) PS=-1.0
      PS=ACOS(PS)
      TST=-COSTH*SIN(PS)
      IF (TST*E(1,2).LT.0.0) PS=-PS
      TST = -SIN(PS)*SIN(PH)*SIN(TH) + COS(PS)*COS(PH)
c	IF (ABS(TST-E(1,1)) .GT. 0.1) WRITE (6,1020) TST,E(1,1)
      TST = -COS(PS)*SIN(TH)*COS(PH) + SIN(PS)*SIN(PH)
c	IF (ABS(TST-E(2,3)) .GT. 0.1) WRITE (6,1020) TST,E(2,3)
C	PS = PS/ARC
C	TH = TH/ARC
C	PH = PH/ARC
      PS1 = 180. + PS
      TH1 = 180. - TH
      PH1 = 180. + PH
      CALL KABMOD(PS,TH,PH,PS1,TH1,PH1)
      HB(1)=PS
      HB(2)=TH
      HB(3)=PH
      HB1(1)=PS1
      HB1(2)=TH1
      HB1(3)=PH1
      END
c
c
c this is subroutine to transfer missetting angle to matrix
c  ROT = (phiz)*(phiy)*(phix)
      subroutine mtomisset(rot,phi)
      real phi(3),rot(3,3)
      external asind, atand, cosd
c 	sinx = sind(phi(1))
c 	cosx = cosd(phi(1))
c 	siny = sind(phi(2))
c 	cosy = cosd(phi(2))
c 	sinz = sind(phi(3))
c 	cosz = cosd(phi(3))
c	rot(1,1) = cosz*cosy
c	rot(2,1) = sinz*cosy
c	rot(3,1) = -siny
c	rot(1,2) = cosz*siny*sinx - sinz*cosx
c	rot(2,2) = sinz*siny*sinx + cosz*cosx
c	rot(3,2) = cosy*sinx
c	rot(1,3) = cosz*siny*cosx + sinz*sinx
c	rot(2,3) = sinz*siny*cosx - cosz*sinx
c	rot(3,3) = cosy*cosx
      phi(2) = asind(-rot(3,1))
      if (abs(phi(2)).ne.90.) then
       if (rot(1,1).eq.0.) then
        phi(3) = 90.
       else
        phi(3) = atand(rot(2,1)/rot(1,1))
        if (phi(3).gt.0..and.rot(1,1)/cosd(phi(2)).lt.0.)
     1  phi(3) = 180. + phi(3)
        if (phi(3).lt.0..and.rot(2,1)/cosd(phi(2)).gt.0.) 
     1 phi(3) = 180. + phi(3)
       end if
       if (rot(3,3).eq.0.) then
        phi(1) = 90.
       else
        phi(1) = atand(rot(3,2)/rot(3,3))
        if (phi(1).gt.0..and.rot(3,3)/cosd(phi(2)).lt.0.)
     1  phi(1) = 180. + phi(1)
        if (phi(1).lt.0..and.rot(3,2)/cosd(phi(2)).gt.0.) 
     1 phi(1) = 180. + phi(1)
       end if
      else
       WRITE(6,*)  'not implemented yet'
      end if
      end 
c
C
C * POLAR ANGLES
C
      SUBROUTINE MTOPOLOR(E,POL,POL1)
      DIMENSION E(3,3), POL(3),POL1(3)
      ARC=3.14159265359/180.0
230	COSPC = (E(1,1)+E(2,2)+E(3,3)-1.0)/2.0
      IF (COSPC .LT.-1.0)
     1 WRITE(6,1290)
1290	FORMAT(1X,' SUM OF DIAGONAL-ELEMENTS LESS
     1 THAN -1./IS SET TO -1.')
      IF (COSPC .LT.-1.0) COSPC=-1.0
C --- PC == KAPPA (ALIAS CHI)
      PC = ACOS(COSPC)
      ARG = (E(2,2)-COSPC)/(1.0-COSPC)
      IF (ARG .GE. 0.0) GO TO 235
      WRITE(6,1235) ARG
1235	FORMAT('-*** ARG = ',E10.4, ' * ARG=0 ASSUMED ***')
      ARG = 0.0
235	COSPA = SQRT(ARG)
C --- PA == THETA (ALIAS PSI)
      PA = ACOS(COSPA)
      SINPA = SIN(PA)
      TST = 2*COSPA*SIN(PC)
      IF ((E(1,3)-E(3,1))*TST .LT. 0.0) PC=-PC
      SINPC = SIN(PC)
      IF (SINPA.NE.0.0) GO TO 237
      WRITE (6,1237)
1237	FORMAT('-*** SIN(THETA) = 0;  PHI UNDETERMINED ***')
      PB = 0.
      GO TO 250
C --- PB == PHI
237	IF(ABS(SINPC) .LT. 0.0001 .AND. 
     1 ABS(COSPA) .LT. 0.0001) GOTO 245
      IF ( ABS(SINPA*SINPC) .LT. 0.001) GO TO 240
      PB = ACOS( (E(3,2)-E(2,3)) / (2*SINPA*SINPC) )
      TST = 2.0*SINPA*SIN(PB)*SINPC
      IF (TST*(E(1,2)-E(2,1)) .LT. 0.0) PB=-PB
      GO TO 250
240	FAC = 2.0*SINPA*COSPA*(1.0-COSPC)
      PB  = ACOS((E(1,2)+E(2,1))/FAC)
      TST = FAC*SIN(PB)
      IF (-(E(2,3)+E(3,2))*TST .LT. 0.0) PB = -PB
      GO TO 250
245	DENOM = (1.0-ARG)*(COSPC-1.0)
      PB = 0.5*ASIN((E(1,3)+E(3,1))/DENOM)
      SINSPB = (COSPC-E(3,3))/DENOM
      IF (SIN(PB)**2 .LT. SINSPB) PB = 90.*ARC - PB
250	PA = PA/ARC
      PB = PB/ARC
      PC = PC/ARC
      TH1 = 180. - PA
      PH1 = 180. + PB
      PK1 =      - PC
      CALL KABMOD(PA,PB,PC,TH1,PH1,PK1)
      POL(1)=PA
      POL(2)=PB
      POL(3)=PC
      POL1(1)=TH1
      POL1(2)=PH1
      POL1(3)=PK1

      END
c
c
      subroutine mtopolors(e,p1,p2)
      dimension e(3,3),p1(3),p2(3)
      dimension b1(3),b2(3)
      external acosd

      call mtovec(e,b1,p1(3))
C
      if (p1(3).eq.0.) then
      p1(1) = 0.
      p1(2) = 0.
      p2(1) = 0.
      p2(2) = 0.
      p2(3) = 0.
      return
      end if
C
      p1(1) = acosd(b1(2))
      dos = sqrt(b1(1)*b1(1)+b1(3)*b1(3))
      if (dos.eq.0.) then
       if (vem(3,b1).eq.0.and.p1(3).ne.0.) then
       WRITE(6,*)  'vec:',b1,'kapa:',p1(3)
       end if
      p1(2) = 0.
      p2(2) = 0.
      p2(1) = 180. - p1(1)
      if (p2(1).ge.360.) p2(1) = 0.
      return
      end if
c
c
      p1(2) = acosd( b1(1)/dos )
c	b22 = asind( b1(3)/sqrt(b1(1)*b1(1)+b1(3)*b1(3)) )
      if (b1(3).gt.0.) p1(2) = -p1(2)
c
      p2(3) = -p1(3)
      p2(2) = 180. + p1(2)
      if (p2(2).gt.180) p2(2) = p2(2) -360.
      p2(1) = 180. - p1(1)
      end
c
c
      subroutine mtopolorz(e,p1,p2)
c 
      real e(3,3),p1(3),p2(3)
      real b1(3),b2(3)
      external acosd
      call mtovec(e,b1,p1(3))
c
      if (abs(p1(3)).lt.1e-3) then
      p1(1) = 0
      p2(1) = 0
      p1(2) = 0
      p2(2) = 0
      p2(3) = 0
      return
      end if

c	p1(1) = acosd(b1(2))
c	p1(2) = acosd( b1(1)/sqrt(b1(1)*b1(1)+b1(3)*b1(3)) )
c	b22 = asind( b1(3)/sqrt(b1(1)*b1(1)+b1(3)*b1(3)) )
      p1(1) = acosd(b1(3))
c
      if (p1(1).eq.0.or.p1(1).eq.180.) then
      p1(2) = 0.
      p2(2) = 0.
      p2(1) = p1(1) + 180.
      if (p2(1).ge.360) p2(1) = p2(1) - 360.
      p2(3) = -p1(3)
      return
      end if
c
      p1(2) = acosd( b1(1)/sqrt(b1(1)*b1(1)+b1(2)*b1(2)) )
c	b22 = asind( b1(2)/sqrt(b1(1)*b1(1)+b1(3)*b1(3)) )
c	if (b22.gt.0.) p1(2) = -p1(2)
      if (b1(2).lt.0.) p1(2) = -p1(2)
c
      p2(3) = -p1(3)
      p2(1) = 180. - p1(1)
      p2(2) = 180. + p1(2)
      if (p2(2).gt.180) p2(2) = p2(2) -360.
      end
c
c
      SUBROUTINE MTOR_B(IOPT2,E,ROT1,ROT2)
C
C * R&B ANGLES:  -180 < AL < 180
C                   0 < BE < 180
C                -180 < GA < 180
C
      EQUIVALENCE  (PS,AL,PA), (TH,BE,PB), (PH,GA,PC)
      EQUIVALENCE  (S1,SIPS),  (S2,SITH),  (S3,SIPH)
     *            ,(C1,COPS),  (C2,COTH),  (C3,COPH)
      DIMENSION   E(3,3),E1(3,3),E2(3,3),X(3),X1(3)
      DIMENSION ROT1(3),ROT2(3)
      DATA        E2 / 1., 3*0., 1., 3*0., 1./
      ARC=3.14159265359/180.0
  220 BE = ACOS(E(3,3))
      GA = E(3,2)/SIN(BE)
c      IF (GA.GT.1.0.OR.GA.LT.-1.0) WRITE(6,1293) GA
1293  FORMAT(' ARCOS(E32/SINBE)=',F12.5)
      IF (GA.GT.1.0) GA=1.0
      IF (GA.LT.-1.0) GA=-1.0
      GA=ACOS(GA)
      TST= SIN(BE)*SIN(GA)
      IF (TST*E(3,1).LT.0.0) GA=-GA
      AL = -E(2,3)/SIN(BE)
c      IF (AL.GT.1.0.OR.AL.LT.-1.0) WRITE(6,1294) AL
1294  FORMAT(' ARCOS(-E23/SINBE)=',F12.5)
      IF (AL.GT.1.0) AL=1.0
      IF (AL.LT.-1.0) AL=-1.0
      AL=ACOS(AL)
      TST= SIN(BE)*SIN(AL)
      IF (TST*E(1,3).LT.0.0) AL=-AL
      TST = -SIN(AL)*COS(BE)*SIN(GA) + COS(AL)*COS(GA)
      IF (ABS(TST-E(1,1)) .GT. 0.1) WRITE (6,1010) TST,E(1,1)
      TST = COS(AL)*COS(BE)*COS(GA) - SIN(AL)*SIN(GA)
      IF (ABS(TST-E(2,2)) .GT. 0.1) WRITE (6,1010) TST,E(2,2)
 1010 FORMAT(' *** ERROR IN R&B *** ',2F10.4/)
      AL = AL/ARC
      BE = BE/ARC
      GA = GA/ARC
      IF (IOPT2.NE.4) GO TO 225
      AL=AL-90.0
      GA=GA+90.0
  225 CONTINUE
      AL1 = 180. + AL
      BE1 =      - BE
      GA1 = 180. + GA
      CALL KABMOD(AL,BE,GA,AL1,BE1,GA1)
C      IF (IOPT2.EQ.2) WRITE (6,1220) AL,BE,GA,AL1,BE1,GA1
C      IF (IOPT2.EQ.4) WRITE (6,1221) AL,BE,GA,AL1,BE1,GA1
C      GO TO 100
      ROT1(1)=AL
      ROT1(2)=BE
      ROT1(3)=GA
      ROT2(1)=AL1
      ROT2(2)=BE1
      ROT2(3)=GA1
      END
c
c
      subroutine mtovec(a,vec,vkapa)
c this is a subroutine which give a transfer a orthogonal matrix
c to a polar angle rotate a direction of a vector which is 1.
c a is the input 3*3  orthogonal matrix.
c vec is the output 3-dim vector which indicate the axis direction
c kappa is the output polar angle.
c Guoguang 901001 bmc
      dimension a(3,3),vec(3),a1(3,3),a2(9),vec1(3)
      integer*2 sgn(3,8)
      external acosd
      data sgn/ 1,1,1,  1,1,-1,  1,-1,1,  1,-1,-1,
     1 	 -1,1,1, -1,1,-1, -1,-1,1, -1,-1,-1/

c
      trace = a(1,1) + a(2,2) + a(3,3)
c	write(6,*),' trace ', trace
      if (trace .gt.3.) then
        if ( (trace-3.) .gt. 1e-4) write(6,*) 'The trace of the '//
     1 'matrix is',trace,' more than 3. I set to 3 here.'
         trace = 3.
      else if (trace .lt.-1.) then
         if (( trace+1 ) .lt. -1e-4) write(6,*) 'The trace of the '//
     1 'matrix is',trace,' less than -1. I set to -1 here.'
         trace = -1.
      end if
      
      coskapa = (trace - 1.) / 2.
      vkapa = acosd(coskapa)
c	write(6,*),' coskapa, kapa ', coskapa, kapa
c
      if (abs(vkapa).lt.0.03) then
       vec(1) = 0.
       vec(2) = 0.
       vec(3) = 0.
       return
      else
       do i = 1, 3
        temp = (a(i,i)-coskapa)/(1.-coskapa)
        if (temp.lt.0.) then
         if (temp.lt.-1e-4.and.(coskapa.ne.-1.)) then
          write(6,*) 'Warning: your matrix might be not a orthogonal'//
     1 ' one'
          write(6,'(a,i1,a,i1,a)') 'vec(',i,')**2 ='
          write(6,*) temp,' coskapa,kapa,trace',coskapa,vkapa,trace
         end if
         temp = 0.
        end if
        vec1(i) = sqrt(temp)
       end do
       vv = vem(3,vec1)
cc	 if (abs(vv-1.).gt.1e-4) then
c	  write(6,*) 'Warning: modulus of vector is not 0, but',vv
c	 end if
       call arrmc(3,1,vec1,1./vv,vec1)
      end if
c
c	if (coskapa.eq.-1.) return
      errmin = 1.0
      ireal = 0
      do is = 1, 8
        do i =1, 3
         vec(i) = vec1(i) * sgn(i,is)
        end do
c
        call rotvsvec(vec,vkapa,a1)
        call arrps(3,3,a1,a,a2)
c
        err = 0.
        do ip = 1,9
         err = abs(a2(ip)) + err
        end do
      if (err.lt.errmin) ireal = is
      errmin = min(errmin,err)
c
10	end do
c
      if (ireal. eq. 0) then
c
       write(6,*) 'something wrong in this program a,a1'
       do is = 1, 8
        do i =1, 3
         vec(i) = vec1(i) * sgn(i,is)
        end do
c
        call rotvsvec(vec,vkapa,a1)
        call arrps(3,3,a1,a,a2)
        write(6,*) 'a',a
        write(6,*) 'a1',a1
        write(6,*) 'a2',a2
        err = 0.
        do ip = 1,9
         err = abs(a2(ip)) + err
        end do
        write(6,*) vec,vkapa,'vk'
        write(6,*) 'Error',err
c
       end do
       stop ' '
      else 
        do i =1, 3
         vec(i) = vec1(i) * sgn(i,ireal)
        end do
        if (errmin.gt.0.01) then
         write(6,*) 'ireal =', ireal
         call rotvsvec(vec,vkapa,a1)
         call arrps(3,3,a1,a,a2)
         write(6,*) a
         write(6,*) a1
         write(6,*) a2
         write(6,*) vec
        end if
      end if
c check
c	v2 = asind(sinkapa)
c	if (coskapa.lt.0) v2 = -180. - v2
c
c	WRITE(6,*)  'kapa1,kapa2,error',v2,vkapa,abs(v2-vkapa)
c
      end
c
c
      subroutine nodir(name1,name2,len2)
c a subroutine which extracts the file name from a complete filename.
c e.g. input name1 = /nfs/pdb/full/1cnd.pdb
c      output name2 = 1cnd.pdb
c      len2 is the length of the second word
      character*(*) name1,name2
c	i1 = index(name1,'.pdb')
      i1 = lenstr(name1)
      do i = i1, 1, -1
       if (name1(i:i).eq.'/') goto 20
      end do
      i = 0
20	continue
      len2 = i1 - i
      name2(1:len2) = name1(i+1:i1)
      end
c
c
      SUBROUTINE ORIEN ( NATM, XYZ1, XYZ2, A )
c The subroutine selects three atoms to calculate the initial superposing
c matrix A from two molecules in 3*4 array XYZ1 and XYZ2 individually.
c Parameter description:
c NATM is the number of the atoms
c	DIMENSION XYZ1(3,NATM), XYZ2(3,NATM), A(3,3)
c XYZ1(3,NATM) represent the XYZ of molecule 1
c XYZ2(3,NATM) represent the XYZ of molecule 2
c A is the output superposing matrix.
c	COMMON/IAT/ IAT1,IAT2,IAT3,IAT
c	DATA IAT/0/
c Atom IAT1, IAT2 and IAT3 is used to calculate the matrix. It could be
c decided outside the routine if IAT not eq 0.
c
c 
      COMMON/IAT/ IAT1,IAT2,IAT3,IAT
c	DATA IAT/0/,IAT1/1/,IAT2/2/,IAT3/3/
      DIMENSION XYZ1(3,NATM), XYZ2(3,NATM), A(3,3)
      DIMENSION V11(3),V12(3)
      DIMENSION V21(3),V22(3)
      DIMENSION C1(3,3),C2(3,3),C1P(3,3)
      DIMENSION B1(3),B2(3)
c local elements
      REAL T(3)
c
c If IAT = 0, define the three atoms used to calculate the 
c  initial orientation matrix
c
      IF (IAT.EQ.0) THEN
       IAT1 = 1
       IF (NATM.GE.6) THEN
        IAT2 = INT(NATM/3) + 1
        IAT3 = 2*INT(NATM/3) + 1
       ELSE
        IAT2 = 2
c	  IAT3 = 3
        IAT3 = NATM
       END IF
      END IF
c
15	if (dist(xyz1(1,iat1),xyz1(1,iat2)).lt.1.e-3.or.
     +      dist(xyz2(1,iat1),xyz2(1,iat2)).lt.1.e-3) then
       iat1=iat1+1
       if (iat1.lt.iat2) goto 15
       call elize(3,a)
       print*, 'Warning: not give any matrix: -orien'
       return
      end if
16	if (dist(xyz1(1,iat2),xyz1(1,iat3)).lt.1.e-3.or.
     +      dist(xyz2(1,iat2),xyz2(1,iat3)).lt.1.e-3) then
       iat2=iat2+1
       if (iat2.lt.iat3) goto 15
       call elize(3,a)
       print*, 'Warning: not give any matrix: -orien'
      end if
C
C Calculate the initial matrix and the Eulerian angle.
c 
C
C  calculate the matrix 1
20	continue
      CALL ARRPS(3,1,XYZ1(1,IAT2),XYZ1(1,IAT1),V11)  
      CALL ARRPS(3,1,XYZ1(1,IAT2),XYZ1(1,IAT3),V12)
      IF (VEM(3,V12).LT.1E-2) GOTO 50
      CALL ARRMC (3,1,V12,1./VEM(3,V12),C1(1,1))
      CALL VECCRSMLT (V12,V11,B1)
      IF (VEM(3,B1).LT.1E-2) GOTO 50
      CALL ARRMC(3,1,B1,1./VEM(3,B1),C1(1,3))
      CALL VECCRSMLT (C1(1,3),C1(1,1),C1(1,2))

C  calculate the matrix 2
      CALL ARRPS(3,1,XYZ2(1,IAT2),XYZ2(1,IAT1),V21)
      CALL ARRPS(3,1,XYZ2(1,IAT2),XYZ2(1,IAT3),V22)
      IF (VEM(3,V12).LT.1E-2) GOTO 50
      CALL ARRMC (3,1,V22,1./VEM(3,V22),C2(1,1))
      CALL VECCRSMLT (V22,V21,B1)
      IF (VEM(3,B1).LT.1E-2) GOTO 50
      CALL ARRMC(3,1,B1,1./VEM(3,B1),C2(1,3))
      CALL VECCRSMLT (C2(1,3),C2(1,1),C2(1,2))

c calculate the matrix A = c2 * c1^-1  (x2= A * x1)
      call ANTIARR(3,3,C1,C1P)
c	print*, 'iat1,iat2,iat3',iat1,iat2,iat3
      CALL MATMULT(3,3,3,3,C2,C1P,A)
C
      return
50	iat2 = iat2 + 1
      if (iat2.ne.iat3.and.iat2.le.natm) goto 20
      WRITE(6,*) 'warning: cannot give the orientation here'
      WRITE(6,*) 'natm,iat,iat1,iat2,iat3',natm,iat,iat1,iat2,iat3
      call elize(3,a)
      call arrvalue(3,t,0.)
      END
c
c
C-----------APPENDIX PROGRAM FOR THE NEWGIN SYSTEM ANGLE
C              WHEN INOPT1=8
      SUBROUTINE OXFORD(ROT,E)
      DIMENSION E(3,3),ROT(3)
      external cosd, sind
2000	A1=ROT(1)
        A2=ROT(2)
        A3=ROT(3)
      E(1,1)=COSD(A1)*COSD(A2)*COSD(A3)-SIND(A1)
     1*SIND(A3)
      E(2,1)=SIND(A1)*COSD(A2)*COSD(A3)+COSD(A1)
     1*SIND(A3)
      E(3,1)=-(SIND(A2)*COSD(A3))
      E(1,2)=-COSD(A1)*COSD(A2)*SIND(A3)-SIND(A1)
     1*COSD(A3)
      E(2,2)=-SIND(A1)*COSD(A2)*SIND(A3)+COSD(A1)
     1*COSD(A3)
      E(3,2)=SIND(A2)*SIND(A3)
      E(1,3)=COSD(A1)*SIND(A2)
      E(2,3)=SIND(A1)*SIND(A2)
      E(3,3)=COSD(A2)
      END
c
c
      subroutine packexpnd(cell,natom,xyz,nsym,sym)
      parameter(maxatm=25000)
      real xyz(3,maxatm),sym(3,4,160)
      real cell(6),deor(3,3),orth(3,3)
      real cells(6),deors(3,3),orths(3,3)
      real sym1(3,4,160)
      real tmove0(3),ave(3)
      real b1(3),b2(3),b3(3),b4(3),b5(3)
      real tmove(3,27)
c...  data statements.  Separate declaration and init required for f2c
      data tmove
     1 /-1.,-1.,-1.,   -1.,-1.,0.,   -1.,-1.,1.,
     2  -1., 0.,-1.,   -1., 0.,0.,   -1., 0.,1.,
     3  -1., 1.,-1.,   -1., 1.,0.,   -1., 1.,1.,
     4   0.,-1.,-1.,   -0.,-1.,0.,   -0.,-1.,1.,
     5   0., 0.,-1.,    0. ,0.,0.,    0., 0.,1.,
     6   0., 1.,-1.,    0., 1.,0.,    0., 1.,1.,
     7   1.,-1.,-1.,    1.,-1.,0.,    1.,-1.,1.,
     8   1., 0.,-1.,    1., 0.,0.,    1., 0.,1.,
     9   1., 1.,-1.,    1., 1.,0.,    1., 1.,1./
c
      nmove = 1
      call lgg_crystal(CELL,CELLS,DEOR,ORTH,deors,orths)
      call averg(3,natom,xyz,ave)
c	WRITE(6,*)  'Average xyz',ave
      do isym = 1, nsym
       call matmult(3,3,3,1,deor,ave,b1)
       call matmult(3,3,3,1,sym(1,1,isym),b1,b2)
       call arrad(3,1,b2,sym(1,4,isym),b3)
       call arrgive(3,b3,b4)
c	 WRITE(6,*) 'b3',b4
       do i = 1, 3
        call frcinside(b4(i))
        b5(i) = b4(i) - b3(i)
       end do
c	 WRITE(6,*) 'b4-b5',b4,b5
       call arrad(3,1,b5,sym(1,4,isym),tmove0)
c	 WRITE(6,*)  'tmove0',tmove0
       call arrgive(9,sym(1,1,isym),sym1(1,1,nmove))
       call arrgive(3,tmove0,sym1(1,4,nmove))
c	 write(6,*) 'Operation:',nmove
c	 write(6,11) ((sym1(i,j,nmove),j=1,4),i=1,3)
       nmove = nmove + 1
       call arrgive(12,sym(1,1,isym),sym1(1,1,nmove))
       do jmove = 1,27
        if (jmove.eq.14) goto 40
        call arrad(3,1,tmove(1,jmove),tmove0,sym1(1,4,nmove))
        do iatom = 1, natom
         call matmult(3,3,3,1,deor,xyz(1,iatom),b1)
         call matmult(3,3,3,1,sym1(1,1,nmove),b1,b2)
         call arrad(3,1,b2,sym1(1,4,nmove),b3)
         if (b3(1).ge.0. .and. b3(1).lt.1. .and.
     1      b3(2).ge.0. .and. b3(2).lt.1. .and.
     2      b3(3).ge.0. .and. b3(3).lt.1. ) then
c	    write(6,*) 'move-iele-iatom',jmove,iele,iatom
c	    WRITE(6,*) 'xyz-iatom',xyz(1,iatom),xyz(3,iatom),xyz(3,iatom)
c	    WRITE(6,*) 'b1-deor',b1
c	    WRITE(6,*) 'b2-symrot',b2
c	    WRITE(6,*) 'b3-jmove',b3
c	    write(6,*) 'Operation:',nmove
c	    write(6,11) ((sym1(i,j,nmove),j=1,4),i=1,3)
          nmove = nmove + 1
          call arrgive(12,sym(1,1,isym),sym1(1,1,nmove))
          goto 40
         end if
30	  end do
40	 end do
      end do
11	format(4f10.4)
c
      nsym = nmove - 1
c	write(6,*) 'Total',nsym,' operations can put the molecule into
c	1 the unit cell'
      call arrgive(nsym*12,sym1,sym)
c
      end
c
c
      CHARACTER*16 FUNCTION PLTNAM(IDUM3)
c	CALL SYSTEM('printenv USER > PLTNAM')
c       call ccpdpn(55,'PLTNAM','UNKNOWN','F',0,0)
c	read(55,'(a)') pltnam
c	do i = 1, 16
c	if (pltnam(i:i).eq.' ') goto 10
c	end do
cc10	continue
c	do j = i,16
c	 pltnam(j:j) = ' '
c	end do
      call getlog(pltnam)
      call up(pltnam,16)
      END
c
c
C------------STANDARD FUNCTION SUBPROGRAM FOR
C----------------DOT PRODUCT OF TWO VECTORS
      FUNCTION POIMULT(N1,N2,V1,V2)
      DIMENSION V1(N1),V2(N2)
      POIMULT=0.
      IF (N1.NE.N2) GOTO 90
      DO 10 I=1,N1
10	POIMULT=V1(I)*V2(I)+POIMULT
      RETURN
90	PRINT*,'POIMULT> Two vectors do not have same dimension'
      END
c
c
      SUBROUTINE POLOR(POL,E)
      DIMENSION E(3,3),POL(3)
      EQUIVALENCE  (S1,SIPS),  (S2,SITH),  (S3,SIPH)
     1  ,(C1,COPS),  (C2,COTH),  (C3,COPH)

C
C * POLAR ANGLE MATRIX  (TRANSPOSED ACCORDING TO TOLLIN, ERRATA OF R&B)
C
      ARC=3.14159265359/180.0
      PS=POL(1)
      TH=POL(2)
      PH=POL(3)

      SIPS = SIN(PS*ARC)
      COPS = COS(PS*ARC)
      SITH = SIN(TH*ARC)
      COTH = COS(TH*ARC)
      SIPH = SIN(PH*ARC)
      COPH = COS(PH*ARC)

130	S1SQ = S1*S1
      C1SQ = C1*C1
      CPC  = 1.0 - C3
      E(1,1) = C3             + S1SQ*C2*C2*CPC
      E(2,1) = S1*C1*C2*CPC   - S1*S2*S3
      E(3,1) =-S1SQ*C2*S2*CPC - C1*S3
      E(1,2) = S1*C1*C2*CPC   + S1*S2*S3
      E(2,2) = C3             + C1SQ*CPC
      E(3,2) =-S1*C1*S2*CPC   + S1*C2*S3
      E(1,3) =-S1SQ*S2*C2*CPC + C1*S3
      E(2,3) =-S1*C1*S2*CPC   - S1*C2*S3
      E(3,3) = C3             + S1SQ*S2*S2*CPC
      END
c
c
      subroutine polors(pol,e)
c my program to calculate matrix from polar angle
c pol is psi phi kappa
c where psi is angle between axis and Y
c 	phi is angle between image of axis in XZ and X
c	kappa is rotating angle

      dimension e(3,3),pol(3)
      dimension b1(3)
      external cosd, sind
      b1(2) = cosd(pol(1))	
      b1(1) = sind(pol(1))*cosd(pol(2))	
      b1(3) = - sind(pol(1))*sind(pol(2))
      call rotvsvec(b1,pol(3),e)
      end
c
c
      subroutine polorz(pol,e)
c my program to calculate matrix from polar angle (z system)
c pol is psi phi kappa
c where psi is angle between axis and Z
c 	phi is angle between image of axis in XY and X
c	kappa is rotating angle

      real e(3,3),pol(3)
      real b1(3)
      external cosd, sind
c	b1(2) = cosd(pol(1))	
c	b1(1) = sind(pol(1))*cosd(pol(2))	
c	b1(3) = - sind(pol(1))*sind(pol(2))
      b1(3) = cosd(pol(1))	
      b1(1) = sind(pol(1))*cosd(pol(2))	
      b1(2) = sind(pol(1))*sind(pol(2))
      call rotvsvec(b1,pol(3),e)
      end
c
c
      SUBROUTINE POS2VEC(NATM,POS,VEC)
C This subroutine is to calculate the center-atom vector from the 
c coordinate. NATM vector will be produced from NATM atoms when NATM >= 3. 
c The NATM vectors is CEN->atom2, CEN->atom3,....CEN->atomN, where
C CEN is the centre of the NATM atoms It is used to superimpose the 
c orientation of two molecules.
c                                  written by Guoguang Lu
c 
C	DIMENSION POS(3,NATM), VEC(3,NATM)
C Parameter description:
C       NATM is the number of atoms
c       POS(1->3,i) is the coordinate of the i'th atom
c       VEC  is the output vectors
c
      DIMENSION POS(3,NATM), VEC(3,NATM),C(3)
      IF (NATM.LT.3) STOP 'Number of the atoms is less than 3'
      CALL AVERG(3,NATM,POS,C)
C  C is the center coordinate of the atoms
      DO I=1,NATM
      CALL ARRPS(3,1,POS(1,I),C,VEC(1,I))
C	CALL ARRMC (3,1,VEC(1,I),1./VEM(3,VEC(1,I)),VEC(1,I))
      END DO
      END
c
C
C *  R&B - MATRIX
C
      SUBROUTINE R_B(ROT,E,IOTP)
      DIMENSION E(3,3),ROT(3)
      EQUIVALENCE  (PS,AL,PA), (TH,BE,PB), (PH,GA,PC)
      EQUIVALENCE  (S1,SIPS),  (S2,SITH),  (S3,SIPH)
     1   ,(C1,COPS),  (C2,COTH),  (C3,COPH)

      PS=ROT(1)
      TH=ROT(2)
      PH=ROT(3)

      IF (IOTP.EQ.4) THEN
      PS=PS+90.0
      PH=PH-90.0
      END IF

      ARC=3.14159265359/180.0
      SIPS = SIN(PS*ARC)
      COPS = COS(PS*ARC)
      SITH = SIN(TH*ARC)
      COTH = COS(TH*ARC)
      SIPH = SIN(PH*ARC)
      COPH = COS(PH*ARC)

120	E(1,1) =-S1*C2*S3 + C1*C3
      E(2,1) = C1*C2*S3 + S1*C3
      E(3,1) =            S2*S3
      E(1,2) =-S1*C2*C3 - C1*S3
      E(2,2) = C1*C2*C3 - S1*S3
      E(3,2) =            S2*C3
      E(1,3) =            S1*S2
      E(2,3) =          - C1*S2
      E(3,3) = C2
      END 
c
c
      real function lgg_radii(natm,xyz)
c pjx: renamed from radii to avoid clash with common block
c of same name in refmac4
c Explicitly typed to real
c
c--calculate average radii of a group of atoms.
c first calculate the center of gravity
c then the mean distance from each atom to this center.
c
      real xyz(3,natm)
      real b1(3),b2(3)
c
      lgg_radii = 0.
      call averg(3,natm,xyz,b1)
      do i = 1, natm
       call arrps(3,1,xyz(1,i),b1,b2)
       lgg_radii = lgg_radii + vem(3,b2)
      end do
      lgg_radii = lgg_radii/float(natm)
      end
c
c
c this is a subroutine to change orthogonalization matrix according to
c cell dimension raxis spindle and xray axis 
c input 
c character cell(6)   ------ cell dimensions
c character aspin*3   ------ raxis spindle axis
c character axray*2   ------ raxis xray axis
c output
c CELLS*6 --- cell dimensions in reciprocal space
c DEOR3*3 --- Deorthogonalization matrix in real space
c ORTH3*3 --- Orthogonalization matrix in receprocal space.
c DEORS3*3 --- Deorthogonalization matrix in reciprocal space
c ORTHS3*3 --- Orthogonalization matrix in reciprocal space.
c AND COMMON/DET/ DET 3*3 MATRIX transfer from statnd X-a orthogonal matrix
c
c Guoguang 930723
c
c PJX 010125 renamed common block det to lggdet to avoid
c clash with subroutine det in rsps.
c This common block doesn't appear to be used anywhere else?
c
      subroutine raxcrystl(cell,aspin,axray,cells,deor,orth,deors,orths)
      common/lggdet/ det
      real det(3,3),buf(3,3),buf2(3,3)
      real cell(6),cells(6)
      real deor(3,3),orth(3,3)
      real deors(3,3),orths(3,3)
      real pdir(3,6)
      INTEGER IC(6)
      real cof(6)
      character*3 aspin,pspin(6)
      character*2 axray,pxray(6)
      DIMENSION B1(3),B2(3),IUF(3)
c...  data statements.  Separate declaration and init required for f2c
      data pdir /1.,0.,0.,0.,1.,0.,0.,0.,1.,
     1	-1.,0.,0.,0.,-1.,0.,0.,0.,-1./
      data ic /1,2,3,1,2,3/
      data cof /1.,1.,1.,-1.,-1.,-1./
      data pspin /'+a*','+b*','+c*','-a*','-b*','-c*'/
      data pxray /'+a','+b','+c','-a','-b','-c'/
c
c standard orthogonalization matrix
c
      call lgg_crystal(cell,cells,deor,orth,deors,orths)
c
c transferring matrix from new system to old det
c
c xray axis
      do i = 1, 6
       if (axray.eq.pxray(i)) then
        call arrmc(3,1,orth(1,ic(i)),
     1  cof(i)/vem(3,orth(1,ic(i))),det(1,1))
        goto 30
       end if
      end do
        WRITE(6,*) 'X-ray axis',(pxray(i),' ',i=1,6)
      WRITE(6,*) 'but you have ',axray
        stop 'wrong xray  axis'
30	continue
c spindle axis
        do i = 1, 6
         if (aspin.eq.pspin(i)) then
        call arrmc(3,1,orths(1,ic(i)),
     1   cof(i)/vem(3,orths(1,ic(i))),det(1,3))
        goto 40
       end if
      end do
        WRITE(6,*) 'spindle axis',(pspin(i),' ',i=1,6)
      WRITE(6,*) 'but you have ',aspin
        stop 'wrong xray  axis'
c
40	continue
      call veccrsmlt(det(1,3),det(1,1),det(1,2))
c
      call arrgive(9,orth,buf)
      call antiarr(3,3,det,buf2)
      call matmult(3,3,3,3,buf2,buf,orth)
c
      CALL ARRGIVE(9,ORTH,DEOR)
      CALL IVSN(3,DEOR,B1,B2,IUF,DE,1.0E-6)
      CALL ANTIARR(3,3,ORTH,DEORS)
      CALL ANTIARR(3,3,DEOR,ORTHS)
C
c	DO I = 1, 3
c	CELLS(I) = VEM(3,orths(1,I))
c	END DO
C
c	CELLS(4) = ANGLE(ORTHS(1,2),ORTHS(1,3))	
c	CELLS(5) = ANGLE(ORTHS(1,3),ORTHS(1,1))	
c	CELLS(6) = ANGLE(ORTHS(1,1),ORTHS(1,2))	
c
      end
c
c
c this is a subroutine to change raxis spindle and xray axis into U matrix
c input 
c character aspin*3   ------ raxis spindle axis
c character axray*2   ------ raxis xray axis
c real*4 umat(3,3)     ------ raxis U matrix
c Guoguang 930723
c
      subroutine raxumat(aspin,axray,umat)
      real umat(3,3)
      real rmat(3,3)
      real pdir(3,6)
      character*3 aspin,pspin(6)
      character*2 axray,pxray(6)
c...  data statements.  Separate declaration and init required for f2c
      data pdir /1.,0.,0.,0.,1.,0.,0.,0.,1.,
     1	-1.,0.,0.,0.,-1.,0.,0.,0.,-1./
      data pspin /'+a*','+b*','+c*','-a*','-b*','-c*'/
      data pxray /'+a','+b','+c','-a','-b','-c'/
c
      do i = 1, 6
       if (aspin.eq.pspin(i)) then
        call arrgive(3,pdir(1,i),umat(1,3))
        goto 20
       end if 
      end do
      WRITE(6,*) ' allowed Spindle axis',(pspin(i),' ',i=1,6)
      stop 'wrong spindle axis'
20	continue
c
      do i = 1, 6
       if (axray.eq.pxray(i)) then
        call arrgive(3,pdir(1,i),umat(1,1))
        goto 30
       end if 
      end do
      WRITE(6,*) 'X-ray axis',(pxray(i),' ',i=1,6)
      stop 'wrong xray  axis'
30	continue
      call veccrsmlt(umat(1,3),umat(1,1),umat(1,2))
      call antiarr(3,3,umat,rmat)
      call arrgive(9,rmat,umat)
c
      end
c
c
      SUBROUTINE RECEPICAL(CELL,DEOR,ORTH)
C This is a routine which inputs cell parameters, CELL and converts 
c them into reciprocal cell parameters. It then gives a deorthogonalization
c and orthogonalization matrix in reciprocal space.
c
      DIMENSION DEOR(3,3),ORTH(3,3),CELL(6)
      DIMENSION BUFF(3,3)
      DIMENSION B1(3),B2(3),IUF(3)
      external acosd, cosd, sind
      AP=CELL(4)
      BA=CELL(5)
      GA=CELL(6)
      CALL ARRMC(3,3,BUFF,0.,BUFF)
      COASTAR=(COSD(BA)*COSD(GA)-COSD(AP))/(SIND(BA)
     1*SIND(GA))
      SIASTAR=SQRT(1.-COASTAR*COASTAR)
      BUFF(1,1)=1.	
      BUFF(1,2)=COSD(GA)
      BUFF(2,2)=SIND(GA)
      BUFF(1,3)=COSD(BA)
      BUFF(2,3)=-SIND(BA)*COASTAR
      BUFF(3,3)=SIND(BA)*SIASTAR
C
      DO I =1, 3
      CALL ARRMC(3,1,BUFF(1,I),CELL(I),BUFF(1,I))
      END DO
c
c	WRITE(6,*)  buff
C
      VOLUM = VLDIM3(BUFF)
C
      CALL VECCRSMLT(BUFF(1,2),BUFF(1,3),DEOR(1,1))
      CALL VECCRSMLT(BUFF(1,3),BUFF(1,1),DEOR(1,2))
      CALL VECCRSMLT(BUFF(1,1),BUFF(1,2),DEOR(1,3))
      CALL ARRMC(3,3,DEOR,1./VOLUM,DEOR)
C
c	WRITE(6,*) volum
c	WRITE(6,*) i,cell(i),vem(3,deor(1,i))
      DO I = 1, 3
      CELL(I) = VEM(3,DEOR(1,I))
c	WRITE(6,*) CELL(I)
c	WRITE(6,*) DEOR
      CALL ARRMC(3,1,DEOR(1,I),1./CELL(I),DEOR(1,i))
      END DO
C
      CELL(4) = ACOSD(POIMULT(3,3,DEOR(1,2),DEOR(1,3)))
      CELL(5) = ACOSD(POIMULT(3,3,DEOR(1,3),DEOR(1,1)))
      CELL(6) = ACOSD(POIMULT(3,3,DEOR(1,1),DEOR(1,2)))
      
C
      CALL ARRMC(3,3,DEOR,1.,ORTH)
      CALL IVSN(3,ORTH,B1,B2,IUF,VAL,1E-6)
      RETURN
      END
c
c
      SUBROUTINE RECEPICAL0(CELL,DEOR,ORTH)
C This is a routine which inputs cell parameters, CELL and converts 
c them into reciprocal cell parameters. It then gives a deorthogonalization
c and orthogonalization matrix in reciprocal space.
c
      DIMENSION DEOR(3,3),ORTH(3,3),CELL(6)
      DIMENSION BUFF(3,3)
      DIMENSION B1(3),B2(3),IUF(3)
      external acosd, cosd, sind
      AP=CELL(4)
      BA=CELL(5)
      GA=CELL(6)
      CALL ARRVALUE(3*3,BUFF,0.)
      COASTAR=(COSD(BA)*COSD(GA)-COSD(AP))/(SIND(BA)
     1*SIND(GA))
      SIASTAR=SQRT(1.-COASTAR*COASTAR)
      BUFF(1,1)=1.	
      BUFF(1,2)=COSD(GA)
      BUFF(2,2)=SIND(GA)
      BUFF(1,3)=COSD(BA)
      BUFF(2,3)=-SIND(BA)*COASTAR
      BUFF(3,3)=SIND(BA)*SIASTAR
C
      DO I =1, 3
      CALL ARRMC(3,1,BUFF(1,I),CELL(I),BUFF(1,I))
      END DO
c
c	WRITE(6,*)  buff
C
      VOLUM = VLDIM3(BUFF)
C
      CALL VECCRSMLT(BUFF(1,2),BUFF(1,3),ORTH(1,1))
      CALL VECCRSMLT(BUFF(1,3),BUFF(1,1),ORTH(1,2))
      CALL VECCRSMLT(BUFF(1,1),BUFF(1,2),ORTH(1,3))
      CALL ARRMC(3,3,ORTH,1./VOLUM,ORTH)
C
c	WRITE(6,*) volum
c	WRITE(6,*) i,cell(i),vem(3,ORTH(1,i))
      DO I = 1, 3
      CELL(I) = VEM(3,ORTH(1,I))
c	WRITE(6,*) CELL(I)
c	WRITE(6,*) ORTH
      CALL ARRMC(3,1,ORTH(1,I),1./CELL(I),DEOR(1,i))
      END DO
C
      CELL(4) = ACOSD(POIMULT(3,3,DEOR(1,2),DEOR(1,3)))
      CELL(5) = ACOSD(POIMULT(3,3,DEOR(1,3),DEOR(1,1)))
      CELL(6) = ACOSD(POIMULT(3,3,DEOR(1,1),DEOR(1,2)))
      
C
      CALL ARRGIVE(3*3,ORTH,DEOR)
      CALL IVSN(3,DEOR,B1,B2,IUF,VAL,1E-6)
      RETURN
      END
c
c
      SUBROUTINE REDSTRIN(NUNIT,NCHA,TXT,NPAR)
C A subroutine to write a string of characters in unit NUNIT according 
c to the spaces in the string. It is used to change a character into 
c parameters under help of a file NUNIT.
c NUNIT is the unit number.
c NCHA is length of character string.
c TXT is the NCHA bytes character.
C NPAR is how many parameters in this string.
      CHARACTER*120 TXT
      NPAR = 0
      REWIND (NUNIT)
      I = 1
10	IF (I.LE.NCHA) THEN
         IF (TXT(I:I).NE.' ') THEN
            J = I
20	      IF (J.GE.NCHA) THEN
               WRITE(NUNIT,'(A)') TXT(I:J)
               NPAR = NPAR + 1
            ELSE IF (TXT(J+1:J+1).EQ.' ') THEN
               WRITE(NUNIT,'(A)') TXT(I:J)
               NPAR = NPAR + 1         
            ELSE	
               J = J + 1
               GOTO 20
            END IF
            I = J + 1
            GOTO 10
         ELSE IF (I.LT.NCHA) THEN
            I = I + 1
            GOTO 10
         END IF
      END IF
C
      REWIND(NUNIT)
      END
c
c
      subroutine refmtoroh(amat,roh,roh2,rms)
c This is a subroutine to calculate from a matrix to Eulerian angles in
c Rober O Huber system and refine ROH angles to minimize 
c Sigma((Aroh(i,j)-Amat(i,j)**2). The output will include two
c symmetric ROH angles a rms value of input matrix and the matrix
c from ROH angles.
c Input:	amat(3,3) --- Input matrix
c Output:	roh(3,3) --- output ROH angle
c		roh2(3,3) --- output ROH angle
c		rms       --- rms value between amat and mat from ROH angle.
c Guoguang Lu, 950831. Purdue Univ
c
      real amat(3,3),roh(3),roh2(3)
      real bmat(3,3),b1(3),b2(3),cmat(9)
      real rohnew(3)
      real vt(9,3),vvv(3,3),delta(3),det(3)
c	real droh(3,3,3)
c
      ncyc = 0
      deg = 180./3.141592654
      call mtohuber(amat,roh,roh2)
      call huber(roh,bmat)
      call arrps(9,1,bmat,amat,cmat)
c	WRITE(6,*) 'cmat',cmat
      rms = vem(9,cmat)
c11	format(3f10.7)
c	write(6,*) 'bmat'
c	write(6,11) bmat
c
10	continue
c	WRITE(6,*) 'cycle,rms',rms,ncyc
c	WRITE(6,*) 'roh',roh
      ncyc = ncyc + 1
c
      call drvrohthd(1,roh,vt(1,1))
      call drvrohthd(2,roh,vt(1,2))
      call drvrohthd(3,roh,vt(1,3))
c
c	write(6,*) 'vt'
c	write(6,'(3f12.7,2x,f12.7)') ((vt(i,j),j=1,3),cmat(i),i=1,9)
      call lsqeq(9,3,vt,cmat,det,vvv,b1)
c	WRITE(6,*) 'det',det
      call arrps(3,1,roh,det,rohnew)
c	WRITE(6,*) 'rohnew',rohnew
      call huber(rohnew,bmat)
c	write(6,*) 'bmatnew'
c	write(6,11) bmat
      call arrps(9,1,bmat,amat,cmat)
c	WRITE(6,*) 'cmatnew',cmat
      rms1 = vem(9,cmat)
      if (rms1.lt.rms) then
       call arrgive(3,rohnew,roh)
       rms = rms1
       goto 10
      else
c	 WRITE(6,*) 'Refinement finished with rms,rms1:',rms,rms1
       roh2(1) = 180. + roh(1)
       roh2(2) = 180. - roh(2)
       roh2(3) = 180. + roh(3)
      end if
c
      end
c
c
      SUBROUTINE REFORN ( NATM, XYZ1, XYZ2, A, VT, DIS )
C	DIMENSION XYZ1(3,NATM), XYZ2(3,NATM), A(3,3)
C	DIMENSION VT(3*NATM,3), DIS(NATM,3)
C A subroutine to give the superimpose matrix and vector from MOL1 to 
c MOL2 i.e. XYZ2(3*NATM) = A(3*3) * XYZ1(3*NATM) + T(3)
C Where    NATM represents the number of the atoms in each molecule
c                which will be superimposed.
c          XYZ1(3,NATM) represents the coordinates of MOL1
c          XYZ2(3,NATM) represents the coordinates of MOL2
C          A(3*3)       represents the input initial matrix and 
c                       output matrix.
C          VT(3*6*NATM)   is a 6*NATM-dimensional buffer array
C          DIS(3*NATM)  is a 3*NATM-dimensional buffer array
c
C	COMMON/SHIFS/ SCALR,SCALT
C Note: There should be a scale of the shifts. i.e. Shift= scale * shifts
c Here SCALR is the rotation shiftscale
c Here SCALT is the translation shiftscale
c The initial and suggested SCALR is 1.
c The initial and suggested SCALt is 1.
C
C	COMMON/RMS/ RMS,SMEAN,NREF,NREF1
C RMS is the final R.M.S between two molecules.
C SMEAN is the mean distance.
c NREF is the number of cycles of rotation refinement
c NREF1 is the number of cycles of translation refinement
c They could be used to judge the SCALR and SCALS
c
c The routine uses the atom-atom vector to perform the Eulerian angle least 
c square refinement. Testing shows that that this method might be more
c accurate than others at least in orientation.
c
C SUPOS1 is almost same with SUPOS, but used as a subroutine as a first
c step of the refinement by subroutine SUPRIMP.
c
c                                           by Guoguang Lu
cv
c     added an upper limit for number of refinement cycles to do.
c     C. Vonrhein
cv
C                                               30/01/1989
C
C
      COMMON/RMS/ RMS,SMEAN,NREF,NREF1
c	COMMON/SHIFS/ SCALR,SCALS
      PARAMETER (NATM0 = 50000)
c   NATM0 is the largest number of atoms.
      DIMENSION XYZ1(3,NATM), XYZ2(3,NATM), A(3,3)
      DIMENSION VT(3*NATM,3), DIS(3,NATM)
      DIMENSION VEC1(3,NATM0),VEC2(3,NATM0),VEC1P(3,NATM0)
C
      DIMENSION DA(3,3,3),VVV(3,3)
      DIMENSION B1(3),B2(3),ROHOLD(3),ROH(3),DETAROH(3),TOLD(3)
C MAXREF = maximum number of refinements to do
C
      INTEGER MAXREF
      PARAMETER (MAXREF=100)
C
c...  data statements.  Separate declaration and init required for f2c
      DATA SCALR/1./,SCALT/1./
C
      DEG=180./3.14159265359
      NREF=0
c	NREF1=0
C
      CALL MTOHUBER(A,ROH,B1)
c
c calculate the atom-atom vector
c
      CALL POS2VEC(NATM,XYZ1,VEC1)
      CALL POS2VEC(NATM,XYZ2,VEC2)
C
      CALL MATMULT(3,3,3,NATM,A,VEC1,VEC1P)
      CALL ARRPS(3,NATM,VEC1P,VEC2,DIS)
C                                  A*V1 - V2
      RMS1= DOSQ( 3*NATM, DIS )
      RMS = sqrt(RMS1)/float(NATM)
C
50	CONTINUE
C 
C  Refine the superimposing Eulerian Angle'
c
C	WRITE(6,'(A)') '0'
C	WRITE(6,*) 'Cycle of Eulerian angle refinement ',NREF
C	WRITE(6,*) 'Superimposing matrix'
C	WRITE(6,10) ((A(I,J),J=1,3),I=1,3)
C	WRITE(6,*) 'Eulerian Angle', ROH
C10	format (3F10.5)
C	WRITE(6,*) 'SIGMA (Deta vector)^2 =', RMS
C
C
c
C COMPUTE THE DETATH1,DETATH2,DETATH3 than the normal matrix
C
      DO I = 1, 3
      CALL DRVROHTH(I,ROH,DA(1,1,I))
      CALL MATMULT(3,3,3,NATM,DA(1,1,I),VEC1,VT(1,I))
C                                (DERIV(A)/DERIV(THETAi))*VEC1
      END DO
c
      CALL LSQEQ(NATM*3,3,VT,DIS,DETAROH,VVV,B1)
C To change it into degree from arc unit
      CALL ARRMC(3,1,DETAROH,DEG,DETAROH)
C
      CALL ARRMC(3,1,DETAROH,-SCALR,DETAROH)
C	WRITE(6,*) 'DetaROH = ',DETAROH	
      CALL ARRMC(3,1,ROH,1.,ROHOLD)
C                            SAVE THE PREVIOUS ROH
      CALL ARRAD(3,1,ROHOLD,DETAROH,ROH)
C                                     ROH=ROHOLD+DETAROH
      CALL HUBER(ROH,A)
C                       NEW MATRIX
      CALL MATMULT(3,3,3,NATM,A,VEC1,VEC1P)
      CALL ARRPS(3,NATM,VEC1P,VEC2,DIS)
C                                  A*V1 - V2
      RMS=dosq(3*NATM,DIS)
C
C     do only a maximum of MAXREF refinement cycles
C
      IF ((NREF.LE.MAXREF).AND.(RMS.LT.RMS1)) THEN
c
        RMS1=RMS
        NREF=NREF+1
        GOTO 50
      END IF

C	WRITE(6,'(A)') '0'
C	WRITE(6,*) 'That is the final rotation result.'
C	WRITE(6,'(A)') '0'
      CALL ARRMC(3,1,ROHOLD,1.,ROH)
      CALL HUBER(ROH,A)

      END 
c
c
      SUBROUTINE REFORNFIN ( NATM, XYZ1, XYZ2, A, VT, DIS )
C	DIMENSION XYZ1(3,NATM), XYZ2(3,NATM), A(3,3)
C	DIMENSION VT(3*NATM,3), DIS(NATM,3)
C A subroutine to give the superimpose matrix and vector from MOL1 to 
c MOL2 i.e. XYZ2(3*NATM) = A(3*3) * XYZ1(3*NATM) + T(3)
C Where    NATM represents the number of the atoms in each molecule
c                which will be superimposed.
c          XYZ1(3,NATM) represents the coordinates of MOL1
c          XYZ2(3,NATM) represents the coordinates of MOL2
C          A(3*3)       represents the input initial matrix and 
c                       output matrix.
C          VT(3*6*NATM)   is a 6*NATM-dimensional buffer array
C          DIS(3*NATM)  is a 3*NATM-dimensional buffer array
c
C	COMMON/SHIFS/ SCALR,SCALT
c 	DATA SCALR/1./,SCALT/1./
C Note: There should be a scale of the shifts. i.e. Shift= scale * shifts
c Here SCALR is the rotation shiftscale
c Here SCALT is the translation shiftscale
c The initial and suggested SCALR is 1.
c The initial and suggested SCALt is 1.
C
C	COMMON/RMS/ RMS,SMEAN,NREF,NREF1
C RMS is the final R.M.S between two molecules.
C SMEAN is the mean distance.
c NREF is the number of cycles of rotation refinement
c NREF1 is the number of cycles of translation refinement
c They could be used to judge the SCALR and SCALS
c
c The program use the atom-atom vector to perform the Eulerian angle least 
c square refinement. Testing shows that this method might be more
c accurate than others at least in orientation.
c
C SUPOS1 is almost the same as SUPOS, but used as a subroutine as a first
c step of the refinement by subroutine SUPRIMP.
c
c                                           by Guoguang Lu
C                                               30/01/1989
C
C
      COMMON/RMS/ RMS,SMEAN,NREF,NREF1
C	COMMON/SHIFS/ SCALR,SCALS
      PARAMETER (NATM0 = 50000)
c   NATM0 is the largest number of atoms.
      DIMENSION XYZ1(3,NATM), XYZ2(3,NATM), A(3,3)
      DIMENSION VT(3*NATM,3), DIS(3,NATM)
      DIMENSION VEC1(3,NATM0),VEC2(3,NATM0),VEC1P(3,NATM0)
C
      DIMENSION DA(3,3,3),VVV(3,3)
      DIMENSION B1(3),B2(3),ROHOLD(3),ROH(3),DETAROH(3),TOLD(3)
C
C
C	DEG=180./3.14159265359
C
      SCALR = 1.
      NREF=0
c	NREF1=0
C
      CALL MTOHUBERARC(A,ROH,B1)
c
c calculate the atom-atom vector
c
      CALL POS2VEC(NATM,XYZ1,VEC1)
      CALL POS2VEC(NATM,XYZ2,VEC2)
C
      CALL MATMULT(3,3,3,NATM,A,VEC1,VEC1P)
      CALL ARRPS(3,NATM,VEC1P,VEC2,DIS)
C                                  A*V1 - V2
      RMS1= DOSQ( 3*NATM, DIS )
      RMS = RMS1
C
50	CONTINUE
C 
C  Refine the superimposing Eulerian Angle'
c
C	WRITE(6,'(A)') '0'
C	WRITE(6,*) 'Cycle of Eulerian angle refinement ',NREF
C	WRITE(6,*) 'Superimposing matrix'
C	WRITE(6,10) ((A(I,J),J=1,3),I=1,3)
C	WRITE(6,*) 'Eulerian Angle', ROH
C10	format (3F10.5)
C	WRITE(6,*) 'SIGMA (Deta vector)^2 =', RMS
C
C
c
C COMPUTE THE DETATH1,DETATH2,DETATH3 than the normal matrix
C
      DO I = 1, 3
      CALL DRVROHTHARC(I,ROH,DA(1,1,I))
      CALL MATMULT(3,3,3,NATM,DA(1,1,I),VEC1,VT(1,I))
C                                (DERIV(A)/DERIV(THETAi))*VEC1
      END DO
c
      CALL LSQEQ(NATM*3,3,VT,DIS,DETAROH,VVV,B1)
C To change it into degree from arc unit
C	CALL ARRMC(3,1,DETAROH,DEG,DETAROH)
C
30	CONTINUE
      CALL ARRMC(3,1,DETAROH,-SCALR,DETAROH)
C	WRITE(6,*) 'SCALR ',SCALR
C	WRITE(6,*) 'DetaROH = ',DETAROH	
      CALL ARRMC(3,1,ROH,1.,ROHOLD)
C                            SAVE THE PREVIOUS ROH
      CALL ARRAD(3,1,ROHOLD,DETAROH,ROH)
C                                     ROH=ROHOLD+DETAROH
      CALL HUBERARC(ROH,A)
C                       NEW MATRIX
      CALL MATMULT(3,3,3,NATM,A,VEC1,VEC1P)
      CALL ARRPS(3,NATM,VEC1P,VEC2,DIS)
C                                  A*V1 - V2
      RMS=dosq(3*NATM,DIS)
C
C	WRITE(6,*)  'RMS NEW AND OLD', RMS,RMS1
      IF (RMS.LT.RMS1) THEN
      RMS1=RMS
      NREF=NREF+1
      GOTO 50
      ELSE IF(SCALR.GT.1E-4) THEN
      CALL ARRMC(3,1,DETAROH,-1./SCALR,DETAROH)
      SCALR = SCALR*0.5
      CALL ARRMC(3,1,ROHOLD,1.,ROH)
      CALL HUBERARC(ROH,A)
      GOTO 30
      END IF

C	WRITE(6,'(A)') '0'
C	WRITE(6,*) 'That is the final rotation result.'
C	WRITE(6,'(A)') '0'
      CALL ARRMC(3,1,ROHOLD,1.,ROH)
      CALL HUBERARC(ROH,A)

      END 
c
c
      SUBROUTINE REFRT ( NATM, X1, X2, A, T, VT, DIS )
C	DIMENSION X1(3,NATM), X2(3,NATM), A(3,3), T(3)
C	DIMENSION VT(3*NATM,6),DIS(3,NATM)
C A subroutine to refine the superimpose matrix and vector from MOL1 to 
c MOL2 i.e. XYZ2(3*NATM) = A(3*3) * XYZ1(3*NATM) + T(3)
C Where    NATM represents the number of the atoms in each molecule
c                which will be superimposed.
c          XYZ1(3,NATM) represents the coordinates of MOL1
c          XYZ2(3,NATM) represents the coordinates of MOL2
C          A(3*3)       represents the input initial matrix and 
c                       output matrix.
c          T(3*3)       represents the input initial translation vector
c                       output vector.
C          VT(3*6*NATM)   is a 6*NATM-dimensional buffer array
C          DIS(3*NATM)  is a 3*NATM-dimensional buffer array
c
C	COMMON/SHIFS/ SCALR,SCALT
c 	DATA SCALR/1./,SCALT/1./
C Note: There should be a scale of the shifts. i.e. Shift= scale * shifts
c Here SCALR is the rotation shiftscale
c Here SCALT is the translation shiftscale
c The initial and suggested SCALR is 60.
c The initial and suggested SCALt is 1.
C
C	COMMON/RMS/ RMS,SMEAN,NREF,NREF1
C RMS is the final R.M.S between two molecules.
C SMEAN is the mean distance.
c NREF is the number of cycles of refinement
c NREF1 is not useful.
c They could be used to judge the SCALR and SCALS
c
c The program use translation linear to least square refinement. Testing 
c shows that it works quite well. The function of this routine is similar
c to SUPOS but the r.m.s. is less and the orientation might be more dangerous.
c
c
c                                           by Guoguang Lu
C                                               27/01/1989
C
      COMMON/RMS/ RMS,SMEAN,NREF1,NREF
c	COMMON/SHIFS/ SCALR,SCALT
c	DATA SCALR/1./,SCALT/1./,IAT/0/
C
      DIMENSION X1(3,NATM), X2(3,NATM), A(3,3), T(3)
      DIMENSION VT(NATM*3,6),DIS(3,NATM)
      DIMENSION VVV(6,6), VV1(6)
C
      DIMENSION DA(3,3,3),DROH(3),DT(3),DETA(6)
      DIMENSION B1(3),B2(3),ROHOLD(3),ROH(3),TOLD(3)
      REAL EMT(3,3)
      EQUIVALENCE (DETA,DROH)
      EQUIVALENCE (DETA(4),DT)
      data emt /1.,0.,0.,0.,1.,0.,0.,0.,1./
C
      DEG=180./3.14159265359
      SCALR = 1.
      SCALT = 1.
      iat = 0.
      NREF=0
      epsilon = 1.
C
      CALL MTOHUBER(A,ROH,B1)
c
      CALL RTMOV(NATM,X1,A,T,DIS)
      CALL ARRPS(3,NATM,DIS,X2,DIS)
      RMS = DOSQ(NATM*3, DIS)
      RMS1 = RMS
        DO 5 I = 1, 3
         DO 5 J = 1, NATM
 5	CALL ARRGIVE(3,EMT(1,I),VT((J-1)*3+1,I+3))
C
C   Refine th1, th2, th3, tx, ty and tz
c
10	CONTINUE
c
      if ( (nref.gt.99) .or. (abs(epsilon).le.1.0e-5) ) goto 25
C	WRITE(6,*)
c	WRITE(6,*) 'Cycle of refinement:',NREF
C	WRITE(6,*) 'Matrix'
C	WRITE(6,20) A
C20	FORMAT(3F10.5)
C	WRITE(6,*) 'Eulerian Angle:',ROH
C	WRITE(6,*) 'Translation:   ',T
C	WRITE(6,*)  'SIGMA (distance^2)=',RMS
C
C compute the normal matrix
      DO I =1, 3
      CALL DRVROHTH(I,ROH,DA(1,1,I))
      CALL MATMULT(3,3,3,NATM,DA(1,1,I),X1,VT(1,I))
C
c	CALL ARRMC(3,1,B1,0.,B1)
c	B1(I) = 1.
c	DO J = 1, NATM
c	CALL ARRMC(3,1,B1, 1., VT((J-1)*3+1,I+3) )
c	END DO
C
      END DO
C
      CALL LSQEQ(3*NATM,6,VT,DIS,DETA,VVV,VV1)
C
C SHIFT = SHIFT * SCALE
      CALL ARRMC(3,1,DROH,-SCALR*deg,DROH)
      CALL ARRMC(3,1,DT,-SCALT,DT)
C	TYPE *, 'Shift ROH',DROH
C	TYPE *, 'Shift T  ',DT
C SAVE THE OLD ANGLE AND TRANSLATION VECTOR
      CALL ARRMC(3,1,ROH,1.,ROHOLD)
      CALL ARRMC(3,1,T,1.,TOLD)
C
      CALL ARRAD(3,1,ROH,DROH,ROH)
      CALL ARRAD(3,1,T,DT,T)
C
      CALL HUBER(ROH,A)
C
      CALL RTMOV(NATM,X1,A,T,DIS)
      CALL ARRPS(3,NATM,DIS,X2,DIS)
C
      RMS = DOSQ(NATM*3, DIS)
c	TYPE *, 'rms new and old ',rms, rms1 
C
      IF (RMS.LT.RMS1) THEN
      epsilon = (rms1-rms)/rms1
      NREF = NREF+1
      RMS1=RMS
      GOTO 10
      END IF
C
   25 continue
      CALL ARRMC(3,1,ROHOLD,1.,ROH)
      CALL ARRMC(3,1,TOLD,1.,T)
      CALL HUBER(ROH,A)
C
      CALL RTMOV(NATM,X1,A,T,DIS)
      CALL ARRPS(3,NATM,DIS,X2,DIS)
C
      ATM = NATM
      SMEAN = 0
      DO I=1, NATM
      D = VEM(3,DIS(1,I))
      SMEAN = SMEAN + D
      END DO
      SMEAN = SMEAN /ATM
C
c SMEAN = SIGMA (DISTANCE) / N
C           i        i
      RMS = SQRT( RMS1/ATM )
C
c RMS   = SQRT( SIGMA (DISTANCE^2) / N )
C           i              i
c 
c
      END
c
c
      SUBROUTINE REFRTFIN ( NATM, X1, X2, A, T, VT, DIS )
C	DIMENSION X1(3,NATM), X2(3,NATM), A(3,3), T(3)
C	DIMENSION VT(3*NATM,6),DIS(3,NATM)
C A subroutine to refine the superimpose matrix and vector from MOL1 to 
c MOL2 i.e. XYZ2(3*NATM) = A(3*3) * XYZ1(3*NATM) + T(3)
C Where    NATM represents the number of the atoms in each molecule
c                which will be superimposed.
c          XYZ1(3,NATM) represents the coordinates of MOL1
c          XYZ2(3,NATM) represents the coordinates of MOL2
C          A(3*3)       represents the input initial matrix and 
c                       output matrix.
c          T(3*3)       represents the input initial translation vector
c                       output vector.
C          VT(3*6*NATM)   is a 6*NATM-dimensional buffer array
C          DIS(3*NATM)  is a 3*NATM-dimensional buffer array
c
C	COMMON/SHIFS/ SCALR,SCALT
c 	DATA SCALR/1./,SCALT/1./
C Note: There should be a scale of the shifts. i.e. Shift= scale * shifts
c Here SCALR is the rotation shiftscale
c Here SCALT is the translation shiftscale
c The initial and suggested SCALR is 60.
c The initial and suggested SCALt is 1.
C
C	COMMON/RMS/ RMS,SMEAN,NREF,NREF1
C RMS is the final R.M.S between two molecules.
C SMEAN is the mean distance.
c NREF is the number of cycles of refinement
c NREF1 is not useful.
c They could be used to judge the SCALR and SCALS
c
c The routine uses translation linear to least square refinement. Testing
c shows that it works quite well. The function of this routine is similar
c to SUPOS but the r.m.s. is less and the orientation might be more dangerous.
c
c
c                                           by Guoguang Lu
C                                               27/01/1989
C
      COMMON/RMS/ RMS,SMEAN,NREF1,NREF
c	COMMON/SHIFS/ SCALR,SCALT
C
      DIMENSION X1(3,NATM), X2(3,NATM), A(3,3), T(3)
      DIMENSION VT(NATM*3,6),DIS(3,NATM)
      DIMENSION VVV(6,6), VV1(6)
C
      DIMENSION DA(3,3,3),DROH(3),DT(3),DETA(6)
      DIMENSION B1(3),B2(3),ROHOLD(3),ROH(3),TOLD(3)
      EQUIVALENCE (DETA,DROH)
      EQUIVALENCE (DETA(4),DT)
c...  data statements.  Separate declaration and init required for f2c
      DATA SCALR/1./,SCALT/1./,IAT/0/
C
      DEG=180./3.14159265359
      NREF=0
C
      CALL MTOHUBERARC(A,ROH,B1)
c
      CALL RTMOV(NATM,X1,A,T,DIS)
      CALL ARRPS(3,NATM,DIS,X2,DIS)
      RMS = DOSQ(NATM*3, DIS)
      RMS1 = RMS
C
C   Refine th1, th2, th3, tx, ty and tz
c
10	CONTINUE
c
C	WRITE(6,*)
c	WRITE(6,*) 'Cycle of refinement:',NREF
C	WRITE(6,*) 'Matrix'
C	WRITE(6,20) A
C20	FORMAT(3F10.5)
C	WRITE(6,*) 'Eulerian Angle:',ROH
C	WRITE(6,*) 'Translation:   ',T
C	WRITE(6,*)  'SIGMA (distance^2)=',RMS
C
C compute the normal matrix
      DO I =1, 3
      CALL DRVROHTHARC(I,ROH,DA(1,1,I))
      CALL MATMULT(3,3,3,NATM,DA(1,1,I),X1,VT(1,I))
C
      CALL ARRMC(3,1,B1,0.,B1)
      B1(I) = 1.
      DO J = 1, NATM
      CALL ARRMC(3,1,B1, 1., VT((J-1)*3+1,I+3) )
      END DO
C
      END DO
C
      CALL LSQEQ(3*NATM,6,VT,DIS,DETA,VVV,VV1)
C
C SHIFT = SHIFT * SCALE
C	CALL ARRMC(3,1,DROH,-SCALR*deg,DROH)
30	continue
      CALL ARRMC(3,1,DROH,-SCALR,DROH)
      CALL ARRMC(3,1,DT,-SCALT,DT)
C	TYPE *, 'scalr,scalt',scalr,scalt
C	TYPE *, 'Shift ROH',DROH
C	TYPE *, 'Shift T  ',DT
C SAVE THE OLD ANGLE AND TRANSLATION VECTOR
      CALL ARRMC(3,1,ROH,1.,ROHOLD)
      CALL ARRMC(3,1,T,1.,TOLD)
C
      CALL ARRAD(3,1,ROH,DROH,ROH)
      CALL ARRAD(3,1,T,DT,T)
C
      CALL HUBERARC(ROH,A)
C
      CALL RTMOV(NATM,X1,A,T,DIS)
      CALL ARRPS(3,NATM,DIS,X2,DIS)
C
      RMS = DOSQ(NATM*3, DIS)
C	TYPE *, 'refrt rms new and old ',rms, rms1
C
      IF (RMS.LT.RMS1) THEN
      NREF = NREF+1
      RMS1=RMS
      GOTO 10
      else if (scalr.gt.1.e-4) then
      CALL ARRMC(3,1,DROH,-1./SCALR,DROH)
      CALL ARRMC(3,1,DT,-1./SCALT,DT)
      scalr = scalr*0.5
      scalt = scalt*0.5
      CALL ARRMC(3,1,ROHOLD,1.,ROH)
      CALL ARRMC(3,1,TOLD,1.,T)
      CALL HUBERARC(ROH,A)
      goto 30
c
      END IF
C
      CALL ARRMC(3,1,ROHOLD,1.,ROH)
      CALL ARRMC(3,1,TOLD,1.,T)
      CALL HUBERARC(ROH,A)
C
      CALL RTMOV(NATM,X1,A,T,DIS)
      CALL ARRPS(3,NATM,DIS,X2,DIS)
C
      ATM = NATM
      SMEAN = 0
      DO I=1, NATM
      D = VEM(3,DIS(1,I))
      SMEAN = SMEAN + D
      END DO
      SMEAN = SMEAN /ATM
C
c SMEAN = SIGMA (DISTANCE) / N
C           i        i
      RMS = SQRT( RMS1/ATM )
C
c RMS   = SQRT( SIGMA (DISTANCE^2) / N )
C           i              i
c 
c
      END
c
c
      SUBROUTINE REFRTFIN1 ( NATM, X1, X2, A, T, VT, DIS, DIST )
C	DIMENSION X1(3,NATM), X2(3,NATM), A(3,3), T(3)
C	DIMENSION VT(NATM,6),DIS(3,NATM)
C A subroutine to refine the superimpose matrix and vector from MOL1 to 
c MOL2 i.e. XYZ2(3*NATM) = A(3*3) * XYZ1(3*NATM) + T(3)
C Where    NATM represents the number of the atoms in each molecule
c                which will be superimposed.
c          XYZ1(3,NATM) represents the coordinates of MOL1
c          XYZ2(3,NATM) represents the coordinates of MOL2
C          A(3*3)       represents the input initial matrix and 
c                       output matrix.
c          T(3*3)       represents the input initial translation vector
c                       output vector.
C          VT(6*NATM)   is a 6*NATM-dimensional buffer array
C          DIS(3*NATM)  is a 3*NATM-dimensional buffer array
C          DIST(NATM)  is a 3*NATM-dimensional buffer array
c
C	COMMON/SHIFS/ SCALR,SCALT
c 	DATA SCALR/1./,SCALT/1./
C Note: There should be a scale of the shifts. i.e. Shift= scale * shifts
c Here SCALR is the rotation shiftscale
c Here SCALT is the translation shiftscale
c The initial and suggested SCALR is 60.
c The initial and suggested SCALt is 1.
C
C	COMMON/RMS/ RMS,SMEAN,NREF,NREF1
C RMS is the final R.M.S between two molecules.
C SMEAN is the mean distance.
c NREF is the number of cycles of refinement
c NREF1 is not useful.
c They could be used to judge the SCALR and SCALS
c
c The routine uses translation linear to least square refinement. Testing
c shows that it works quite well. The function of this routine is similar
c to SUPOS but the r.m.s. is less and the orientation might be more dangerous.
c
c
c                                           by Guoguang Lu
C                                               27/01/1989
C
      COMMON/RMS/ RMS,SMEAN,NREF1,NREF
c	COMMON/SHIFS/ SCALR,SCALT
c	DATA SCALR/1./,SCALT/1./,IAT/0/
C
      DIMENSION X1(3,NATM), X2(3,NATM), A(3,3), T(3)
      DIMENSION VT(NATM,6),DIS(3,NATM),DIST(NATM)
      DIMENSION VVV(6,6), VV1(6)
C
      DIMENSION DA(3,3,3),DROH(3),DT(3),DETA(6)
      DIMENSION B1(3),B2(3),ROHOLD(3),ROH(3),TOLD(3)
      EQUIVALENCE (DETA,DROH)
      EQUIVALENCE (DETA(4),DT)
C
c	DEG=180./3.14159265359
      scalr = 1.0
      scalt = 1.0
      NREF=0
C
      CALL MTOHUBERarc(A,ROH,B1)
c
      CALL RTMOV(NATM,X1,A,T,DIS)
      CALL ARRPS(3,NATM,DIS,X2,DIS)
      DO I =1, NATM
      DIST(I) = VEM(3,DIS(1,I))
      END DO
      RMS = DOSQ(NATM*3, DIS)
      RMS1 = RMS
C
C   Refine th1, th2, th3, tx, ty and tz
c
10	CONTINUE
c
c	WRITE(6,*)
c	WRITE(6,*) 'Cycle of refinement:',NREF
c	WRITE(6,*) 'Matrix'
c	WRITE(6,20) A
c20	FORMAT(3F10.5)
c	WRITE(6,*) 'Eulerian Angle:',ROH
c	WRITE(6,*) 'Translation:   ',T
c	WRITE(6,*)  'SIGMA (distance^2)=',RMS
C
C compute the normal matrix
      DO I =1, 3
      CALL DRVROHTHarc(I,ROH,DA(1,1,I))
C
      DO J = 1, NATM
      CALL MATMULT(3,3,3,1,DA(1,1,I),X1(1,J),B1)
      VT(J,I) = POIMULT(3,3,DIS(1,J),B1) / DIST(J)
      VT(J,I+3) = DIS(I,J) / DIST(J)
      END DO
C
      END DO
      CALL LSQEQ(NATM,6,VT,DIST,DETA,VVV,VV1)
C	TYPE *, 'Shift ', DETA
C SHIFT = SHIFT * SCALe
c	CALL ARRMC(3,1,DROH,-SCALR*deg,DROH)
30	continue
C	TYPE *, 'SCALR, SCALT ', SCALR, SCALT
      CALL ARRMC(3,1,DROH,-SCALR,DROH)
      CALL ARRMC(3,1,DT,-SCALT,DT)
C	TYPE *, 'Shift ROH',DROH
C	TYPE *, 'Shift T  ',DT
C SAVE THE OLD ANGLE AND TRANSLATION VECTOR
      CALL ARRMC(3,1,ROH,1.,ROHOLD)
      CALL ARRMC(3,1,T,1.,TOLD)
C
      CALL ARRAD(3,1,ROH,DROH,ROH)
      CALL ARRAD(3,1,T,DT,T)
C
      CALL HUBERarc(ROH,A)
C
      CALL RTMOV(NATM,X1,A,T,DIS)
      CALL ARRPS(3,NATM,DIS,X2,DIS)
      DO I =1, NATM
      DIST(I) = VEM(3,DIS(1,I))
      END DO
C
      RMS = DOSQ(NATM*3, DIS)
C	TYPE *, 'rms new and old ',rms, rms1
C
      IF (RMS.LT.RMS1) THEN
      NREF = NREF+1
      RMS1=RMS
      GOTO 10
c	else IF (RMS.ge.0) THEN
      else IF (scalr.Gt.1.e-4) THEN
      CALL ARRMC(3,1,DROH,-1./SCALR,DROH)
      CALL ARRMC(3,1,DT,-1./SCALT,DT)
      scalr = scalr*0.5
      scalt = scalt*0.5
C
      CALL ARRMC(3,1,ROHOLD,1.,ROH)
      CALL ARRMC(3,1,TOLD,1.,T)
      CALL HUBERarc(ROH,A)
      goto 30
      END IF
C
      CALL ARRMC(3,1,ROHOLD,1.,ROH)
      CALL ARRMC(3,1,TOLD,1.,T)
      CALL HUBERarc(ROH,A)
      CALL RTMOV(NATM,X1,A,T,DIS)
      CALL ARRPS(3,NATM,DIS,X2,DIS)
      DO I =1, NATM
      DIST(I) = VEM(3,DIS(1,I))
      END DO

c	RMS = DOSQ(NATM*3, DIS)
c	TYPE *, 'rms repeat and old ',rms, rms1


c	TYPE *, 'ending rms ',rms
      ATM = NATM
      SMEAN = 0
      DO I=1, NATM
      D = VEM(3,DIS(1,I))
      SMEAN = SMEAN + D
      END DO
      SMEAN = SMEAN /ATM
c
c SMEAN = SIGMA (DISTANCE) / N
C           i        i
      RMS = SQRT( RMS1/ATM )
C
c RMS   = SQRT( SIGMA (DISTANCE^2) / N )
C           i              i
c 
c
      END
c
c
      function gg_res3to1(rin)
      character gg_res3to1*1,rin*3
      character*3 res(20),abr(20)
c...  data statements.  Separate declaration and init required for f2c
      data RES /'ALA','GLU','GLN','ASP','ASN','LEU','GLY'
     1 ,'LYS','SER','VAL','ARG','THR'
     2 ,'PRO','ILE','MET','PHE','TYR','CYS','TRP','HIS'/
      data ABR /'A  ','E  ','Q  ','D  ','N  ','L  ','G  '
     1 ,'K  ','S  ','V  ','R  ','T  '
     2 ,'P  ','I  ','M  ','F  ','Y  ','C  ','W  ','H  '/
c
      do i = 1, 20
       if (rin.eq.res(i)) then
        gg_res3to1 = abr(i)(1:1)
        return
       end if
      end do
      if (rin.eq.'   ') then
       gg_res3to1 = ' '
       return
      end if
c	write(6,*) 'Warning: no such residues ',rin
      gg_res3to1 = ' '
      end
c
c
      subroutine rotvsvec(vec,vkapa,a)
c a subroutine to give a matrix when you know there is a rotation
c which angle is vkapa along the vector vec as axis.
c vec is the input 3-dimensional vector where the rotation axis is
c vkapa is the rotating angle
c  a is the output 3*3 rotating matrix.
c
      real vec(3),a(3,3)
      external sind
c	WRITE(6,*)  'vec,vkapa'
C	WRITE(6,*)  vec,vkapa
c There is a strange bug on Alpha, ---- cosd(vkapa) has the wrong sign!!!!
c Instead I have to have cos(vkapa*pai/180.)
      pai = 3.141592654
c
      sinkapa = sind(vkapa)
      coskapa = cos(vkapa*pai/180.)
c
      a(1,1) = (1.-vec(1)*vec(1))*coskapa+vec(1)*vec(1)
      a(2,2) = (1.-vec(2)*vec(2))*coskapa+vec(2)*vec(2)
      a(3,3) = (1.-vec(3)*vec(3))*coskapa+vec(3)*vec(3)
c
      a(1,2) = vec(1)*vec(2)*(1.-coskapa) -vec(3)*sinkapa
      a(2,1) = vec(1)*vec(2)*(1.-coskapa) +vec(3)*sinkapa
c
      a(1,3) = vec(3)*vec(1)*(1.-coskapa) +vec(2)*sinkapa
      a(3,1) = vec(3)*vec(1)*(1.-coskapa) -vec(2)*sinkapa
c
      a(2,3) = vec(2)*vec(3)*(1.-coskapa) -vec(1)*sinkapa
      a(3,2) = vec(2)*vec(3)*(1.-coskapa) +vec(1)*sinkapa
c
      end
c
c
      SUBROUTINE RTMOV(NATM,XIN,A,T,XOUT)
C A routine to compute: XOUT = A * XIN + T
C        where   XIN is the input 3*NATM array
C                XOUT is the Output 3*NATM array
c                A(3,3) is a 3*3 rotation matrix
c                T(3) is a 3-dimensional translation vector.
c	DIMENSION XIN(3,NATM),XOUT(3,NATM),A(3,3),T(3)
C
      DIMENSION XIN(3,NATM),XOUT(3,NATM),A(3,3),T(3)
      CALL MATMULT(3,3,3,NATM,A,XIN,XOUT)
      DO I = 1, NATM
      CALL ARRAD(3,1,XOUT(1,I),T,XOUT(1,I))
      END DO
      END
c
c
      function screw(a,t)
c	dimension a(3,3),t(3),POL(3),xyz0(3)
C this is a routine to calculate how much the movement is along the
c the rotation axis.
c When there is a non-crystallographic rotation and translation
c x2 = A*x1 + t
c where A(3,3) is the 3*3 matrix
c 	t(3) is translation vector.
c the routine output POL(3) (psi, phi and kappa), go and xyz0(3)
c where psi (POL(1))  is the angle between the rotation axis and y axis
c	phi is the angle between X axis and the image of the rotation axis
c	kappa is the rotating angle.
c 	go is the screw amount along the axis direction
c		Guoguang 900927
c

      dimension a(3,3),t(3)
      dimension vec(3)
c
      call mtovec(a,vec,vkapa)
      if (vkapa.lt.1e-6) then
       screw = vem(3,t)
      end if
c
      if (vem(3,t).lt.(1.e-6)) then
       screw = 0.
       return
      end if
c vec is the direction of the axis vector.
      screw = poimult(3,3,t,vec)
      end
c
c
      subroutine sectime(sec,nhour,nmin,sres)
c input seconds and output the hour and minute and residue second
      nmin = 0
      nhour = 0
      if (sec.gt.60.) then
       smin = sec/60.
       nmin = int(smin)
       sres = sec - nmin*60
      end if
      if (nmin.gt.60) then
       nmin0 = nmin
       nhour = int(float(nmin)/60.)
       nmin = nmin0 - nhour*60 
      end if
      end
c
c
      subroutine seekaxis(a,t,cen1,cen2,POL,go,xyz0)
c	dimension a(3,3),t(3),POL(3),xyz0(3)
C this is a routine to calculate how much the movement is along the
c the rotation axis and where is the rotation axis from a rigid movement
c matrix.
c When there is a non-crystallographic rotation and translation
c x2 = A*x1 + t
c where A(3,3) is the 3*3 matrix
c 	t(3) is translation vector.
c cen(3), center of the two mass molecule
c the routine output POL(3) (psi, phi and kappa), go and xyz0(3)
c where psi (POL(1))  is the angle between the rotation axis and y axis
c	phi is the angle between X axis and the image of the rotation axis
c	kappa is the rotating angle.
c 	go is the screw amount along the axis direction
c		Guoguang 900927
c	xyz0(3) is one point where the axis pass by. This point should be 
c        a project point of CEN on the axis line, where CEN is center of
c	two input molecules (CEN1+CEN2)/2.
c

      dimension a(3,3),t(3),POL(3),xyz0(3),cen(3),cen1(3),cen2(3)
      dimension b1(3),b2(3),b3(3)
      dimension rot(3,3), rot1(3,3)
      dimension b4(3),b5(3),cenp1(3),cenp2(3),xyzp(3)
      dimension vec(3)
      logical*1 zax
      external tand
c
      call arrmc(3,1,t,0.,xyz0)
      call mtopolorz(a,POL,b1)
      if (abs(POL(3)).lt.1e-6) then
       go = vem(3,t)
      end if
c
      if (vem(3,t).lt.(1.e-6)) then
       go = 0.
       return
      end if
c
      call arrad(3,1,cen1,cen2,b4)
      call arrmc(3,1,b4,0.5,cen)
c
c	b1(2) = cosd(POL(1))	
c	b1(1) = sind(POL(1))*cosd(POL(2))	
c	b1(3) = - sind(POL(1))*sind(POL(2))
      call mtovec(a,vec,vkapa)
      call arrgive(3,vec,b3)
c b1 and vec is the direction of the axis vector.
      go = poimult(3,3,t,b3)
c now define a new coordinate system 
c X0 = rot * X'
c where Z' is the rotating axis.
c and X'is in the Z'/cen2-cen1 plane 
c Y' is perpendicular to X' and Z'
c so b1 is Z' vector.
      call arrps(3,1,cen2,cen1,b4)
      call veccrsmlt(b3,b4,b5)
      temp = vem(3,b5)
      if (temp.gt.(1.e-6)) then
       zax = .false.
 	 call arrmc(3,1,b5,1./temp,b2)
c here b2 is X' vector
       call veccrsmlt(b2,b3,b1)
c b3 is Y' vector
c
       call arrgive(3,b2,rot(1,2))
       call arrgive(3,b3,rot(1,3))
       call arrgive(3,b1,rot(1,1))
      else
       call elize(3,rot)
       zax = .true.
      end if
c
      call antiarr(3,3,rot,rot1)
c rot1 = rot**-1
c
c b1 is the translation in new coordinate system
11	call matmult(3,3,3,1,rot1,t,b1)
      if (abs(b1(3)-go).gt.1e-6) then
       if (zax) then
        rot(3,3) = -1.
        rot(2,2) = -1.
        rot1(3,3) = -1.
        rot1(2,2) = -1.
        zax = .false.
        goto 11
       else
        write(6,*) 'go ', go
        write(6,*) 't ',t
        write(6,*) 'b1 ',b1
        write(6,*) 'rot1'
        write(6,'(3f12.5)') rot1
        stop 'guoguang, you are wrong to get go'
       end if
      end if
c
c take cen as origin. take cen1 cen2 into new coordinates as cenp1,cenp2
      call arrps(3,1,cen1,cen,b1)
      call matmult(3,3,3,1,rot1,b1,cenp1)
      call arrps(3,1,cen2,cen,b2)
      call matmult(3,3,3,1,rot1,b2,cenp2)
c
      if (cenp1(2).gt.1.e-4) print *, 'Warning cenp1',cenp1
      if (cenp2(2).gt.1.e-4) print *, 'Warning cenp2',cenp2
c the passing point in new system
      xyzp(1) = 0.
      xyzp(3) = 0.
      if (abs(180.-vkapa).lt.0.001) then
       xyzp(2) = 0.
      else
       xyzp(2) = -cenp1(1)/tand(vkapa/2.)
      end if
c the passing point in old system
      call matmult(3,3,3,1,rot,xyzp,b4)
      call arrad(3,1,b4,cen,xyz0)
c
      end
c
c
      subroutine seekscrew(a,t,POL,go,xyz0)
c	dimension a(3,3),t(3),POL(3),xyz0(3)
C this is a routine to calculate how much the movement is along the
c the rotation axis.
c When there is a non-crystallographic rotation and translation
c x2 = A*x1 + t
c where A(3,3) is the 3*3 matrix
c 	t(3) is translation vector.
c the routine output POL(3) (psi, phi and kappa), go and xyz0(3)
c where psi (POL(1))  is the angle between the rotation axis and y axis
c	phi is the angle between X axis and the image of the rotation axis
c	kappa is the rotating angle.
c 	go is the screw amount along the axis direction
c		Guoguang 900927
c	xyz0(3) is one point where the axis pass by.
c

      dimension a(3,3),t(3),POL(3),xyz0(3)
      dimension b1(3),b2(3),b3(3)
      dimension rot(3,3), rot1(3,3),rot3(3,3),rot2(3,3)
      dimension b4(3)
      dimension vec(3)
      logical*1 zax
      external acosd, cosd
c
       call arrmc(3,1,t,0.,xyz0)
      call mtopolors(a,POL,b1)
      if (abs(POL(3)).lt.1e-6) then
       go = vem(3,t)
      end if
c
      if (vem(3,t).lt.(1.e-6)) then
       go = 0.
       return
      end if
c
c	b1(2) = cosd(POL(1))	
c	b1(1) = sind(POL(1))*cosd(POL(2))	
c	b1(3) = - sind(POL(1))*sind(POL(2))
      call mtovec(a,b1,vkapa)
      call arrmc(3,1,b1,1.,vec)
c b1 and vec is the direction of the axis vector.
      go = poimult(3,3,t,b1)
c
      b2(1) = 0.
      b2(2) = 0.
      b2(3) = 1.
c now decide a new coordinate system 
c X0 = rot * X'
c where Z' is the rotating axis.
c and X'is in the XY plane.
c so b1 is Z' vector.
      call veccrsmlt(b1,b2,b3)
      temp = vem(3,b3)
      if (temp.gt.(1.e-6)) then
       zax = .false.
 	 call arrmc(3,1,b3,1./temp,b2)
c here b2 is X' vector
       call veccrsmlt(b1,b2,b3)
c b3 is Y' vector
c
       call arrmc(3,1,b2,1.,rot(1,1))
       call arrmc(3,1,b3,1.,rot(1,2))
       call arrmc(3,1,b1,1.,rot(1,3))
      else
       call elize(3,rot)
       zax = .true.
      end if
c
      call antiarr(3,3,rot,rot1)
c rot1 = rot**-1
c
c b1 is the translation in new coordinate system
11	call matmult(3,3,3,1,rot1,t,b1)
      if (abs(b1(3)-go).gt.1e-6) then
       if (zax) then
        rot(3,3) = -1.
        rot(2,2) = -1.
        rot1(3,3) = -1.
        rot1(2,2) = -1.
        zax = .false.
       goto 11
       else
        write(6,*) 'go ', go
        write(6,*) 't ',t
        write(6,*) 'b1 ',b1
        write(6,*) 'rot1'
        write(6,'(3f12.5)') rot1
        stop 'guoguang, you are wrong to get go'
       end if
      end if
c
      if (vem(2,b1).lt.1e-6) then
c the axes pass by the origin.
       call arrmc(3,1,t,0.,xyz0)
       return
      end if
c
c set a new coordinate system to make axis x'' is the image of t in new
c x'y' plane. and X' = rot2 * X''
c 
c
      b1(3) = 0.
      call elize(3,rot2)
      call arrmc(3,1,b1, 1./vem(3,b1), rot2(1,1) )
      call veccrsmlt(rot2(1,3),rot2(1,1),rot2(1,2))
      call antiarr(3,3,rot2,rot3)
c x'' = rot3 * x' = rot3 * rot1 * x0
      call matmult(3,3,3,1,rot3,b1,b4)
      if ( abs(b4(1)-vem(2,b1)).gt.1e-3 .or. abs(b4(2)).gt.1e-3 .or
     1 . abs(b4(3)).gt.1e-3) THEN
       WRITE(6,*)  'b1',b1
       WRITE(6,*)  'b4',b4
       write(6,*) 'rot2'
       write(6,'(3f12.5)') rot2
       write(6,*) 'rot3'
       write(6,'(3f12.5)') rot3
       stop 'something wrong in rot2 or rot3'
      end if
      x0 = b4(1)
c
      b2(3) = 0.
      b2(1) = x0/2
      vkapa = POL(3)
      b2(2) = sqrt( (1+cosd(vkapa))/(1-cosd(vkapa)) ) * b2(1)
      if (vkapa.lt.0.) b2(2) = - b2(2)
c b2 is what you want in x'' system
c the mathematics is very simple, isn't it?
c
c check result
      call arrps(3,1,b2,b4,b3)
      ang = acosd( poimult(3,3,b2,b3)/(vem(3,b2)*vem(3,b3)) )
c	if (abs(temp).gt.1) WRITE(6,*)  temp
c	ang = asind(temp)
      if (abs(ang-abs(vkapa)).gt.1e-2) then
       WRITE(6,*)  'something wrong in seekscrew'
       WRITE(6,*) 'angle ',ang
       WRITE(6,*)  'b1 ',b1
       WRITE(6,*)  'b2 ',b2
       WRITE(6,*)  'b3 ',b3
       WRITE(6,*)  'b4 ',b4
      end if	
c now x0 = rot * x' = rot * rot2 * x'' = rot1 * x''
      call matmult(3,3,3,3,rot,rot2,rot1)
      call matmult(3,3,3,1,rot1,b2,xyz0)
c to check the result.
      ds1 = dstpl2(vec,xyz0,t,b1,b4)
      call arrmc(3,1,t,0.,b3)
      ds2 = dstpl2(vec,xyz0,b3,b2,b4)
      df = abs(ds2-ds1)
c
      if (ds1.gt.1e-4) then
        if (df/ds1.gt.1e-4) 
     + stop 'distance between 0-axis and t to axis is not same'
      
      else
        if (ds2.gt.2e-4) 
     + stop 'distance between 0-axis  and t to axis is not same'
      end if

      call arrps(3,1,b1,b2,b3)
      go1 = vem(3,b3)
      if (abs(abs(go)-go1) .gt. 1e-4) then
      WRITE(6,*)  'problem in go'
      WRITE(6,*)  'go ', go
      WRITE(6,*)  'screw', go1
      end if
c go is the real screw value along axis
      end
c
c
      subroutine seekscrewz(a,t,POL,go,xyz0)
c	dimension a(3,3),t(3),POL(3),xyz0(3)
C this is a routine to calculate how much the movement is along the
c the rotation axis.
c When there is a non-crystallographic rotation and translation
c x2 = A*x1 + t
c where A(3,3) is the 3*3 matrix
c 	t(3) is translation vector.
c the routine output POL(3) (psi, phi and kappa), go and xyz0(3)
c where psi (POL(1))  is the angle between the rotation axis and y axis
c	phi is the angle between X axis and the image of the rotation axis
c	kappa is the rotating angle.
c 	go is the screw amount along the axis direction
c		Guoguang 900927
c	xyz0(3) is one point where the axis pass by.
c

      dimension a(3,3),t(3),POL(3),xyz0(3)
      dimension b1(3),b2(3),b3(3)
      dimension rot(3,3), rot1(3,3),rot3(3,3),rot2(3,3)
      dimension b4(3)
      dimension vec(3)
      logical*1 zax
      external acosd, cosd
c
       call arrmc(3,1,t,0.,xyz0)
      call mtopolorz(a,POL,b1)
      if (abs(POL(3)).lt.1e-6) then
       go = vem(3,t)
      end if
c
      if (vem(3,t).lt.(1.e-6)) then
       go = 0.
       return
      end if
c
c	b1(2) = cosd(POL(1))	
c	b1(1) = sind(POL(1))*cosd(POL(2))	
c	b1(3) = - sind(POL(1))*sind(POL(2))
      call mtovec(a,b1,vkapa)
      call arrmc(3,1,b1,1.,vec)
c b1 and vec is the direction of the axis vector.
      go = poimult(3,3,t,b1)
c
      b2(1) = 0.
      b2(2) = 0.
      b2(3) = 1.
c now decide a new coordinate system 
c X0 = rot * X'
c where Z' is the rotating axis.
c and X'is in the XY plane.
c so b1 is Z' vector.
      call veccrsmlt(b1,b2,b3)
      temp = vem(3,b3)
      if (temp.gt.(1.e-6)) then
       zax = .false.
 	 call arrmc(3,1,b3,1./temp,b2)
c here b2 is X' vector
       call veccrsmlt(b1,b2,b3)
c b3 is Y' vector
c
       call arrmc(3,1,b2,1.,rot(1,1))
       call arrmc(3,1,b3,1.,rot(1,2))
       call arrmc(3,1,b1,1.,rot(1,3))
      else
       call elize(3,rot)
       zax = .true.
      end if
c
      call antiarr(3,3,rot,rot1)
c rot1 = rot**-1
c
c b1 is the translation in new coordinate system
11	call matmult(3,3,3,1,rot1,t,b1)
      if (abs(b1(3)-go).gt.1e-6) then
       if (zax) then
        rot(3,3) = -1.
        rot(2,2) = -1.
        rot1(3,3) = -1.
        rot1(2,2) = -1.
        zax = .false.
       goto 11
       else
        write(6,*) 'go ', go
        write(6,*) 't ',t
        write(6,*) 'b1 ',b1
        write(6,*) 'rot1'
        write(6,'(3f12.5)') rot1
        stop 'guoguang, you are wrong to get go'
       end if
      end if
c
      if (vem(2,b1).lt.1e-6) then
c the axes pass by the origin.
       call arrmc(3,1,t,0.,xyz0)
       return
      end if
c
c set a new coordinate system to make axis x'' is the image of t in new
c x'y' plane. and X' = rot2 * X''
c 
c
      b1(3) = 0.
      call elize(3,rot2)
      call arrmc(3,1,b1, 1./vem(3,b1), rot2(1,1) )
      call veccrsmlt(rot2(1,3),rot2(1,1),rot2(1,2))
      call antiarr(3,3,rot2,rot3)
c x'' = rot3 * x' = rot3 * rot1 * x0
      call matmult(3,3,3,1,rot3,b1,b4)
      if ( abs(b4(1)-vem(2,b1)).gt.1e-3 .or. abs(b4(2)).gt.1e-3 .or
     1 . abs(b4(3)).gt.1e-3) THEN
       WRITE(6,*)  'b1',b1
       WRITE(6,*)  'b4',b4
       write(6,*) 'rot2'
       write(6,'(3f12.5)') rot2
       write(6,*) 'rot3'
       write(6,'(3f12.5)') rot3
       stop 'something wrong in rot2 or rot3'
      end if
      x0 = b4(1)
c
      b2(3) = 0.
      b2(1) = x0/2
      vkapa = POL(3)
      b2(2) = sqrt( (1+cosd(vkapa))/(1-cosd(vkapa)) ) * b2(1)
      if (vkapa.lt.0.) b2(2) = - b2(2)
c b2 is what you want in x'' system
c the mathematics is very simple, isn't it?
c
c check result
      call arrps(3,1,b2,b4,b3)
      ang = acosd( poimult(3,3,b2,b3)/(vem(3,b2)*vem(3,b3)) )
c	if (abs(temp).gt.1) WRITE(6,*)  temp
c	ang = asind(temp)
      if (abs(ang-abs(vkapa)).gt.1e-2) then
       WRITE(6,*)  'something wrong in seekscrew'
       WRITE(6,*) 'angle ',ang
       WRITE(6,*)  'b1 ',b1
       WRITE(6,*)  'b2 ',b2
       WRITE(6,*)  'b3 ',b3
       WRITE(6,*)  'b4 ',b4
      end if	
c now x0 = rot * x' = rot * rot2 * x'' = rot1 * x''
      call matmult(3,3,3,3,rot,rot2,rot1)
      call matmult(3,3,3,1,rot1,b2,xyz0)
c to check the result.
      ds1 = dstpl2(vec,xyz0,t,b1,b4)
      call arrmc(3,1,t,0.,b3)
      ds2 = dstpl2(vec,xyz0,b3,b2,b4)
      df = abs(ds2-ds1)
c
      if (ds1.gt.1e-4) then
        if (df/ds1.gt.1e-4) 
     +  stop 'distance between 0-axis and t to axis is not same'
      else
        if (ds2.gt.2e-4) 
     +   stop 'distance between 0-axis  and t to axis is not same'
      end if

      call arrps(3,1,b1,b2,b3)
      go1 = vem(3,b3)
      if (abs(abs(go)-go1) .gt. 1e-4) then
      WRITE(6,*)  'problem in go'
      WRITE(6,*)  'go ', go
      WRITE(6,*)  'screw', go1
      end if
c go is the real screw value along axis
      end
c
c
      SUBROUTINE SQSTLZ(M,P,PS,U,V)
C a subroutine to calculate the orientation matrix and the two axes
c  from a symmetric matrix of an ellipse.         by LGG
c   M(2,2)  is the input symmetric matrix of the ellipse.
C   P(2,2)  is one of the two orientation matrices of the ellipse
C   PS(2,2) is the inverse matrix of the matrix PS(2,2)
C   U, V  are the lengths of the two axes of the ellipse.
C
      DIMENSION M(2,2),P(2,2),PS(2,2)
      REAL M,P,A,B,C,U,V,X1,X2
10	FORMAT(1X,4F10.3)
      A=1
      B=-(M(1,1)+M(2,2))
      C=M(1,1)*M(2,2)-M(2,1)*M(1,2)
      CALL SQUROOT(A,B,C,X1,X2)
      U=SQRT(1./X1)
      V=SQRT(1./X2)
      P(2,1)=(X1-M(1,1))/M(1,2)
      P(2,2)=(X2-M(1,1))/M(1,2)
      S1=SQRT(P(2,1)*P(2,1)+1)
      S2=SQRT(P(2,2)*P(2,2)+1)
      P(2,1)=P(2,1)/S1
      P(2,2)=P(2,2)/S2
      P(1,1)=1./S1
      P(1,2)=1./S2
      PS(1,2)=P(2,1)
      PS(2,1)=P(1,2)
      PS(1,1)=P(1,1)
      PS(2,2)=P(2,2)
      RETURN
      END
c
c
      subroutine spacegp(nunit,file,latnam,nsym,nrot,sym,nsp)
c In this subroutine the user gives a space group name, the subroutine reads the 
c ccp4 symmetry library, then it outputs the symmetry operations
c Input
c       nunit --- unit number of library file
c	file--- symmetry libary file name
c	latnam  ---  *14 character of a spacegroup name
c Output
c 	nsymm --- Total number of symmetry operations in this spacegroup
c	nrot ---- only rotation symmetric operation in this spacegroup
c	symm  ---- a 3*4*nsym symmmetric operation c matrix.
c	nsp --- space group number
c in common symdump,  if dump is true, dump all the information
c maxop is the maximum number of symmetry operations
c library format
c155 6  2    R32
c X,Y,Z * -Y,X-Y,Z * Y-X,-X,Z
c Y,X,-Z * -X,Y-X,-Z * X-Y,-Y,-Z
c X+1/3,Y+2/3,Z+2/3 * -Y+1/3,X-Y+2/3,Z+2/3 * Y-X+1/3,-X+2/3,Z+2/3  
c Y+1/3,X+2/3,-Z+2/3 * -X+1/3,Y-X+2/3,-Z+2/3 * X-Y+1/3,-Y+2/3,-Z+2/3
c X+2/3,Y+1/3,Z+1/3 * -Y+2/3,X-Y+1/3,Z+1/3 * Y-X+2/3,-X+1/3,Z+1/3
c Y+2/3,X+1/3,-Z+1/3 * -X+2/3,Y-X+1/3,-Z+1/3 * X-Y+2/3,-Y+1/3,-Z+1/3
      parameter (maxop=96)
      character file*80,latnam*14
      real sym(3,4,maxop)
      integer*4 nunit,nsp,nsym,nrot
      logical*1 dump
c	COMMON/SYMDUMP/ DUMP
c
      character*80 key,str*40
c...  data statements.  Separate declaration and init required for f2c
      data dump /.false./
c
c	WRITE(6,*)  'nsp',nsp
      nsym=0
      if (nunit.eq.0) nunit=25
      if (file(1:1).eq.' ') call spstrunct(file)
      if (file(1:1).eq.' ') file='SYMOP'
        call ccpdpn(nunit,file(1:lenstr(file)),'READONLY','F',0,0)
10	read(nunit,'(a)',end=220) key
      im = lenstr(latnam)
      in = lenstr(key)
      is = index(key(1:in),latnam(1:im))
      if (is.eq.0) goto 10
c	call redstrin(12,i1-1,key,npar)
      read(key(1:12),*,err=10,end=10) isp,iall,irot
c	read(key(12:80),'(a)') latnam
c	if (isp.ne.nsp) goto 10
      write(6,*) 'Space Group  >>> ',Latnam,isp
      do i = 1, iall
       read(nunit,'(a)') key
       il = lenstr(key)
       key(il+1:il+1)='*'
       iend = 0
       if (dump)  write(6,'(1x,a)') key(1:il)
20	 ist = iend+1
        iend = index(key(ist:il+1),'*')+IST-1
        str = '                                        '
        str(1:iend-ist) = key(ist:iend-1)
        NSYM=NSYM+1
        IF (MATSYM(SYM(1,1,nsym),STR,ICOL).EQ.0) GOTO 502
        WRITE(6,*) 'Error in symop after column ',ICOL
        write(6,*) key
        write(6,*) str
        stop 'Check you file SYMOP'
502	continue
       if (dump) then
        write(6,'(4f8.4)') ((sym(j1,j2,nsym),j2=1,4),j1=1,3)
       end if
       if (iend.lt.il+1) goto 20
       if (i.eq.irot) nrot = nsym
      end do
      write(6,45) nsym,nrot
45	format(1x,'Symmetric operation ----',6x,
     1 'Total: ',i3,6x,'Rotation:',i3)
      close (unit=nunit)
      return
210	WRITE(6,*)  'Error opening the SYMOP file ',FILE(1:LENSTR(FILE))
220	WRITE(6,*)  'Space group',latnam(1:im),
     +              ' was not found in SYMOP file'
      nsym = 0
      nrot = 0
      latnam = '      '
      STOP 'Check your SYMOP file'
      END
c
c
      SUBROUTINE SPSTRUNCT(STRING)
      CHARACTER*(*) STRING
      LENS = LEN(STRING)
      IL = LENSTR(STRING)
C
5	CONTINUE
      ISP = INDEX(STRING(1:IL),' ')
      IF (ISP.EQ.0.OR.ISP.GE.IL) RETURN
      STRING(ISP:IL-1) = STRING(ISP+1:IL)
      STRING(IL:IL) = ' '
      IL = IL - 1
      GOTO 5
      END
c
c
      SUBROUTINE SQUROOT(A,B,C,X1,X2)
c    Finds roots of a quadratic equation
      REAL A,B,C,X1,X2
      X1=(-B+SQRT(B*B-4*A*C))/(2*A)
      X2=(-B-SQRT(B*B-4*A*C))/(2*A)
      RETURN
      END
c
c
C a subroutine to calculate the statistics of a group of numbers
c	subroutine statis(n,value,vmean,rms,dmean)
c	dimension value(n)
c  n is the number of value in the group
c value is the n-dimensional array whose statistics are required.
c vmean is the output mean value of the array value(n)
c rms is the output r.m.s in value(n)
c dmean is the output mean deviation of value(n)
      subroutine statis(n,value,vmean,rms,dmean)
      dimension value(n)
      vmean = 0
      do i =1, n
      vmean = vmean + value(i)
      end do
      vmean = vmean/n
c
      rms = 0.
      dmean = 0.
      do i =1, n
      temp = value(i) - vmean
      dmean = dmean + abs(temp)
      rms = rms + temp*temp
      end do
      rms = sqrt(rms/n)
      dmean = dmean / n
      end 
c
c
      SUBROUTINE LGG_STRING(NUNIT,NCHA,TXT,NPAR,cont)
C A subroutine to write a character string to unit NUNIT using 
c the spaces in the string to split the string into a list of
c parameters.
c NUNIT is the unit number.
c NCHA is the length of the character string.
c TXT is the character string.
C NPAR is the number of parameters in this string.
c cont is a flag which represent if this is a continue string or start
c	.true. = continue
c	.false. = start
c
c
      CHARACTER*(*) TXT
      logical*1 cont 
      
      if (.not.cont) then
         NPAR = 0
         REWIND (NUNIT)
      end if
      
      jcha = 0
      if (ncha.gt.0) then
         if (txt(ncha:ncha).eq.'-') then
            jcha = 1
            txt(ncha:ncha)=' '
         end if
      end if
      
      I = 1
 10   IF (I.LE.NCHA-jcha) then 
         if (TXT(I:I).NE.' ') THEN
            J = I
 20         CONTINUE
            IF ((J+1).GT.NCHA) THEN
               WRITE(NUNIT,'(A)') TXT(I:J)
               NPAR = NPAR + 1
            else if (TXT(J+1:J+1).EQ.' ') then
               WRITE(NUNIT,'(A)') TXT(I:J)
               NPAR = NPAR + 1            
            ELSE  
               J = J + 1
               GOTO 20
            END IF
            I = J + 1
            GOTO 10
         ELSE IF (I.LT.NCHA-jcha) THEN
            I = I + 1
            GOTO 10
         END IF
      endif
      
      if (jcha.eq.1) TXT(NCHA:NCHA)='-'
C
c	if (jcha.eq.0) REWIND(NUNIT)
C
      END
c
c
      SUBROUTINE SUPIM ( NATM, XYZ1, XYZ2, A, T )
C	DIMENSION XYZ1(3,NATM), XYZ2(3,NATM), A(3,3), T(3)
C A subroutine to give the superimpose matrix and vector from MOL1 to 
c MOL2 i.e. XYZ2(3*NATM) = A(3*3) * XYZ1(3*NATM) + T(3)
C Where    NATM represents the number of the atoms in each molecule
c                which will be superimposed.
c          XYZ1(3,NATM) represents the coordinates of MOL1
c          XYZ2(3,NATM) represents the coordinates of MOL2
C          A(3*3)       represents the output matrix.
c          T(3*3)       represents the output vector.
c
C	COMMON/SHIFS/ SCALR,SCALT
c 	DATA SCALR/60./,SCALT/1./
C Note: There should be a scale of the shifts. i.e. Shift= scale * shifts
c Here SCALR is the rotation shiftscale
c Here SCALT is the translation shiftscale
c The initial and suggested SCALR is 60.
c The initial and suggested SCALt is 1.
C
C	COMMON/RMS/ RMS,SMEAN,NREF,NREF1
C RMS is the final R.M.S between two molecules.
C SMEAN is the mean distance.
c NREF is the number of cycles of rotation refinement
c NREF1 is not useful 
c They could be used to judge the SCALR and SCALS
c
C	COMMON/IAT/ IAT1,IAT2,IAT3,IAT
C	DATA SCALR/60./,IAT/0/
C      The routine uses the first three atoms to get the initial Eulerian 
C angle. IAT1, IAT2 and IAT3 are the indexes of the three selected atoms.
c If IAT = 0, these atoms will be selected inside this routine. If not,
c the three atoms will be defined outside the routine through the common
c block. If the program does not work or you want special atoms, change
c IAT1,IAT2,IAT3 in COMMON/IAT/ and set IAT to 0 in order to select 
c the three atoms in the main routine.
c
C NATM cannot be larger than NATM0 (currently 50000) or the parameter NATM0
C should be modified in this routine. 
c
c The program use translation linear to least square refinement. Testing 
c shows that it works quite well. The function of this routine is similar
c to SUPOS but the r.m.s. is less and the orientation might be more dangerous.
c
c
c                                           by Guoguang Lu
C                                               27/01/1989
C
C
      COMMON/RMS/ RMS,SMEAN,NREF,NREF1
      COMMON/SHIFS/ SCALR,SCALS
      COMMON/IAT/ IAT1,IAT2,IAT3,IAT
c	DATA SCALR/60./,SCALS/1./
C	DATA IAT/0/,IAT1/1/,IAT2/2/,IAT3/3/
      PARAMETER (NATM0 = 50000)
c   NATM0 is the largest number of atoms.
      DIMENSION XYZ1(3,NATM), XYZ2(3,NATM), A(3,3), T(3)
      DIMENSION X1(3,NATM0),X2(3,NATM0),VT(3*6*NATM0),DIS(3*NATM0)
      DIMENSION CEN1(3),CEN2(3)
      DIMENSION B1(3),B2(3),B3(3),T0(3)
c
C Number of atoms cannot be more than NATM0 or less than 3.
c
      IF (NATM.GT.NATM0) THEN
      WRITE(6,*) 'ERROR> Atom is more than ',NATM0
      STOP 
      ELSE IF (NATM.LT.3) THEN
      STOP 'ERROR> Atom is less than 3.'
      END IF

c Compute the initial matrix.
      CALL ORIEN(NATM,XYZ1,XYZ2,A)
C compute the  gravity of mol1 and mol2 to CEN1 and CEN2
      CALL AVERG(3,NATM,XYZ1,CEN1)
      CALL AVERG(3,NATM,XYZ2,CEN2)
C T is the initial translation vector
      CALL ARRPS(3,1,CEN2,CEN1,T0)
c Change the origin to CEN1.
      CALL TMOVE(3,NATM,XYZ1,CEN1,-1.,X1)
      CALL TMOVE(3,NATM,XYZ2,CEN1,-1.,X2)
c
C Refine th1, th2, th3, tx, ty and tz
c
      CALL REFRT( NATM, X1, X2, A, T0, VT, DIS)
c
      WRITE(6,*)
      WRITE(6,*) 'R.M.S.'
      WRITE(6,*) '       natm'
      WRITE(6,*) 'SQRT( SIGMA (Distance(i)^2)/natm ) = ',RMS
      WRITE(6,*) '       i=1'
C
      WRITE(6,*)
      WRITE(6,*) 'Mean Distance:'
      WRITE(6,*) ' natm'
      WRITE(6,*) 'SIGMA (Distance(i)) /natm = ',SMEAN
      WRITE(6,*) ' i=1'
C
      WRITE(6,'(A)') '0'
      WRITE(6,'(A)') '0'
      WRITE(6,*) 'Mol1 is superposed to Mol2.'
      WRITE(6,*) 'The matrix and the vector are:'
      WRITE(6,*) 
      WRITE(6,1) (A(1,J),J=1,3),CEN1(1),T0(1)
      WRITE(6,2) (A(2,J),J=1,3),CEN1(2),T0(2)
      WRITE(6,1) (A(3,J),J=1,3),CEN1(3),T0(3)
1	FORMAT(1X,'      (',3F10.6,' )   (     ',F8.3,' )   ('
     1 ,F8.3,' )')
2	FORMAT(1X,' X2 = (',3F10.6,' ) * ( X1 -',F8.3,' ) + ('
     1 ,F8.3,' )')
C
      CALL MATMULT(3,3,3,1,A,CEN1,B3)
      CALL ARRPS(3,1,T0,B3,B3)
      CALL ARRAD(3,1,CEN1,B3,T)
C
      WRITE(6,'(A)') '0'
      WRITE(6,'(A)') '0'
      WRITE(6,*) 
      WRITE(6,4) (A(1,J),J=1,3),T(1)
      WRITE(6,5) (A(2,J),J=1,3),T(2)
      WRITE(6,4) (A(3,J),J=1,3),T(3)
4	FORMAT(1X,'      (',3F10.6,' )   (    )   (',F8.3,' )')
5	FORMAT(1X,' X2 = (',3F10.6,' ) * ( X1 ) + (',F8.3,' )')
C
      END 
c
c
      SUBROUTINE SUPRIMP ( NATM, XYZ1, XYZ2, A, T )
C	DIMENSION XYZ1(3,NATM), XYZ2(3,NATM), A(3,3), T(3)
C A subroutine to give the superimpose matrix and vector from MOL1 to 
c MOL2 i.e. XYZ2(3*NATM) = A(3*3) * XYZ1(3*NATM) + T(3)
C Where    NATM represents the number of the atoms in each molecule
c                which will be superimposed.
c          XYZ1(3,NATM) represents the coordinates of MOL1
c          XYZ2(3,NATM) represents the coordinates of MOL2
C          A(3*3)       represents the output matrix.
c          T(3*3)       represents the output vector.
c
C NATM cannot be larger than NATM0 (currently 50000) or the parameter NATM0
C should be modified in this routine. 
c
C	COMMON/SHIFS/ SCALR,SCALT
c 	DATA SCALR/1./,SCALT/1./
C Note: There should be a scale of the shifts. i.e. Shift= scale * shifts
c Here SCALR is the rotation shiftscale
c Here SCALT is the translation shiftscale
c The initial and suggested SCALR is 1.
c The initial and suggested SCALt is 1.
C
C	COMMON/RMS/ RMS,SMEAN,NREF,NREF1
C RMS is the final R.M.S between two molecules.
C SMEAN is the mean distance.
c NREF is the number of cycles of rotation refinement
c NREF1 is not used by this routine.
c They could be used to judge the SCALR and SCALS
c
C	COMMON/IAT/ IAT1,IAT2,IAT3,IAT
C	DATA SCALR/1./,IAT/0/
C      The routine use the first three atoms to get the initial Eulerian 
C angle. IAT1, IAT2 and IAT3 are the indexes of the three select atoms.
c If IAT = 0, these atoms will be selected inside this routine. If not,
c the three atoms will be defined outside the routine through the common
c block. If the program does not work or you want special atoms, change 
c IAT1,IAT2,IAT3 in COMMON/IAT/ and set IAT to 0 in order to select 
c the three atoms in the main routine. Subroutine ORIEN performs this
c computation.
c 
c     Then the program use the subroutine REFORN to refine the orientation
c by vector method. The refinement equation is same with subroutine SUPOS.
C
c The program use translation linear and Eulerian non-linear least square 
c refinement to refine both th1,th2,th3 and tx,ty,tz. Testing shows
c that it can give very low r.m.s., much less than any other method 
c in most cases, however it is a little expensive in computer time.
c
c                                           by Guoguang Lu
C                                               27/01/1989
C
      COMMON/RMS/ RMS,SMEAN,NREF,NREF1
      COMMON/SHIFS/ SCALR,SCALS
      COMMON/IAT/ IAT1,IAT2,IAT3,IAT
c	DATA SCALR/1./,SCALS/1./,IAT/0/,IAT1/1/,IAT2/2/,IAT3/3/
      PARAMETER (NATM0 = 50000)
c   NATM0 is the largest number of atoms.
      DIMENSION XYZ1(3,NATM), XYZ2(3,NATM), A(3,3), T(3)
      DIMENSION X1(3,NATM0),X2(3,NATM0),VT(3*6*NATM0),DIS(3*NATM0)
      DIMENSION CEN1(3),CEN2(3)
      DIMENSION B1(3),B2(3),B3(3),T0(3)
c
c	DEG=180./3.14159265359
c
C Number of atoms cannot be more than NATM0 or less than 3.
c
      IF (NATM.GT.50000) THEN
      WRITE(6,*) 'ERROR> Atom is more than ',NATM0
      STOP 
      ELSE IF (NATM.LT.3) THEN
      STOP 'ERROR> Atom is less than 3.'
      END IF

c Compute the initial matrix.
      CALL ORIEN(NATM,XYZ1,XYZ2,A)
c	NREF1 = NREF
C
C Refine the orientation by vector method.
C
      CALL REFORN ( NATM, XYZ1, XYZ2, A, VT, DIS)
C
C compute the  gravity of mol1 and mol2 to CEN1 and CEN2
      CALL AVERG(3,NATM,XYZ1,CEN1)
      CALL AVERG(3,NATM,XYZ2,CEN2)
C T is the initial translation vector
      CALL ARRPS(3,1,CEN2,CEN1,T0)
c Change the origin to CEN1.
      CALL TMOVE(3,NATM,XYZ1,CEN1,-1.,X1)
      CALL TMOVE(3,NATM,XYZ2,CEN1,-1.,X2)
c
C Refine th1, th2, th3, tx, ty and tz
c
      CALL REFRT( NATM, X1, X2, A, T0, VT, DIS)
c
      WRITE(6,*)
      WRITE(6,*) 'R.M.S.'
      WRITE(6,*) '       natm'
      WRITE(6,*) 'SQRT( SIGMA (Distance(i)^2)/natm ) = ',RMS
      WRITE(6,*) '       i=1'
C
      WRITE(6,*)
      WRITE(6,*) 'Mean Distance:'
      WRITE(6,*) ' natm'
      WRITE(6,*) 'SIGMA (Distance(i)) /natm = ',SMEAN
      WRITE(6,*) ' i=1'
C
      WRITE(6,*)
      WRITE(6,*) 'Mol1 is superposed to Mol2.'
      WRITE(6,*) 'The matrix and the vector are:'
      WRITE(6,*) 
      WRITE(6,1) (A(1,J),J=1,3),CEN1(1),T0(1)
      WRITE(6,2) (A(2,J),J=1,3),CEN1(2),T0(2)
      WRITE(6,1) (A(3,J),J=1,3),CEN1(3),T0(3)
1	FORMAT(1X,'      (',3F10.6,' )   (     ',f10.5,' )   ('
     1 ,f10.5,' )')
2	FORMAT(1X,' X2 = (',3F10.6,' ) * ( X1 -',f10.5,' ) + ('
     1 ,f10.5,' )')
C
      CALL MATMULT(3,3,3,1,A,CEN1,B3)
      CALL ARRPS(3,1,T0,B3,B3)
      CALL ARRAD(3,1,CEN1,B3,T)
C
      WRITE(6,*) 
      WRITE(6,*) 
      WRITE(6,4) (A(1,J),J=1,3),T(1)
      WRITE(6,5) (A(2,J),J=1,3),T(2)
      WRITE(6,4) (A(3,J),J=1,3),T(3)
4	FORMAT(1X,'      (',3F10.6,' )   (    )   (',f10.5,' )')
5	FORMAT(1X,' X2 = (',3F10.6,' ) * ( X1 ) + (',f10.5,' )')
C
      END 
c
c
      SUBROUTINE SUPRIMPFIN ( NATM, XYZ1, XYZ2, A, T )
C	DIMENSION XYZ1(3,NATM), XYZ2(3,NATM), A(3,3), T(3)
C A subroutine to give the superimpose matrix and vector from MOL1 to 
c MOL2 i.e. XYZ2(3*NATM) = A(3*3) * XYZ1(3*NATM) + T(3)
C Where    NATM represents the number of the atoms in each molecule
c                which will be superimposed.
c          XYZ1(3,NATM) represents the coordinates of MOL1
c          XYZ2(3,NATM) represents the coordinates of MOL2
C          A(3*3)       represents the output matrix.
c          T(3*3)       represents the output vector.
c
C NATM cannot be larger than NATM0 (currently 50000) or the parameter NATM0
C should be modified in this routine. 
c
C	COMMON/SHIFS/ SCALR,SCALT
c 	DATA SCALR/1./,SCALT/1./
C Note: There should be a scale of the shifts. i.e. Shift= scale * shifts
c Here SCALR is the rotation shiftscale
c Here SCALT is the translation shiftscale
c The initial and suggested SCALR is 1.
c The initial and suggested SCALt is 1.
C
C	COMMON/RMS/ RMS,SMEAN,NREF,NREF1
C RMS is the final R.M.S between two molecules.
C SMEAN is the mean distance.
c NREF is the number of the cycles of the rotation refinement
c NREF1 is not used by this routine.
c They could be used to judge the SCALR,and SCALS
c
C	COMMON/IAT/ IAT1,IAT2,IAT3,IAT
C	DATA SCALR/1./,IAT/0/
C      The routine use the first three atoms to get the initial Eulerian 
C angle. IAT1, IAT2 and IAT3 are the indexes of the three select atoms.
c If IAT = 0, these atoms will be selected inside this routine. If not,
c the three atoms will be defined outside the routine through the common
c block. If the program does not work or you want special atoms, change
c IAT1,IAT2,IAT3 in COMMON/IAT/ and give the IAT to 0 in order to select 
c the three atoms in the main routine. Subroutine ORIEN is to proceed this
c computing
c 
c     Then the program uses the subroutine REFORN to refine the orientation
c by vector method. The refinement equation is same with subroutine SUPOS.
C
c The program use translation linear and Eulerian non-linear least square 
c refinement to refine both th1,th2,th3 and tx,ty,tz. Testing shows
c that it can give very low r.m.s., much less than any other method 
c in most cases, however it is a little expensive in computer time.
c
c                                           by Guoguang Lu
C                                               27/01/1989
C
      COMMON/RMS/ RMS,SMEAN,NREF,NREF1
      COMMON/SHIFS/ SCALR,SCALS
      COMMON/IAT/ IAT1,IAT2,IAT3,IAT
c	DATA SCALR/1./,SCALS/1./,IAT/0/,IAT1/1/,IAT2/2/,IAT3/3/
      PARAMETER (NATM0 = 50000)
c   NATM0 is the maximum number of atoms.
      DIMENSION XYZ1(3,NATM), XYZ2(3,NATM), A(3,3), T(3)
      DIMENSION X1(3,NATM0),X2(3,NATM0),VT(3*6*NATM0),DIS(3*NATM0)
      DIMENSION CEN1(3),CEN2(3)
      DIMENSION B1(3),B2(3),B3(3),T0(3)
c
c	DEG=180./3.14159265359
c
C Number of atoms cannot be more than NATM0 or less than 3.
c
      IF (NATM.GT.50000) THEN
      WRITE(6,*) 'ERROR> Atom is more than ',NATM0
      STOP 
      ELSE IF (NATM.LT.3) THEN
      STOP 'ERROR> Atom is less than 3.'
      END IF

c Compute the initial matrix.
      CALL ORIEN(NATM,XYZ1,XYZ2,A)
c	NREF1 = NREF
C
C Refine the orientation by vector method.
cc
      CALL REFORNFIN ( NATM, XYZ1, XYZ2, A, VT, DIS)
      NREFORN = NREF
C
C compute the  gravity of mol1 and mol2 to CEN1 and CEN2
      CALL AVERG(3,NATM,XYZ1,CEN1)
      CALL AVERG(3,NATM,XYZ2,CEN2)
C T is the initial translation vector
      CALL ARRPS(3,1,CEN2,CEN1,T0)
c Change the origin to CEN1.
      CALL TMOVE(3,NATM,XYZ1,CEN1,-1.,X1)
      CALL TMOVE(3,NATM,XYZ2,CEN1,-1.,X2)
c
C Refine th1, th2, th3, tx, ty and tz
c
      CALL REFRTFIN ( NATM, X1, X2, A, T0, VT, DIS )
      NREFRT = NREF1
      CALL REFRTFIN1 ( NATM, X1, X2, A, T0, VT, DIS, VT(1+2*6*NATM) )
      NREFRT1 = NREF1
c
      WRITE(6,*)  'Final fit cycle>>>', NREFORN, NREFRT, NREFRT1
      WRITE(6,*)
      WRITE(6,*) 'R.M.S.'
      WRITE(6,*) '       natm'
      WRITE(6,*) 'SQRT( SIGMA (Distance(i)^2)/natm ) = ',RMS
      WRITE(6,*) '       i=1'
C
      WRITE(6,*)
      WRITE(6,*) 'Mean Distance:'
      WRITE(6,*) ' natm'
      WRITE(6,*) 'SIGMA (Distance(i)) /natm = ',SMEAN
      WRITE(6,*) ' i=1'
C
      WRITE(6,*)
      WRITE(6,*) 'Mol1 is superposed to Mol2.'
      WRITE(6,*) 'The matrix and the vector are:'
      WRITE(6,*) 
      WRITE(6,1) (A(1,J),J=1,3),CEN1(1),T0(1)
      WRITE(6,2) (A(2,J),J=1,3),CEN1(2),T0(2)
      WRITE(6,1) (A(3,J),J=1,3),CEN1(3),T0(3)
1	FORMAT(1X,'      (',3F10.6,' )   (     ',f10.5,' )   ('
     1 ,f10.5,' )')
2	FORMAT(1X,' X2 = (',3F10.6,' ) * ( X1 -',f10.5,' ) + ('
     1 ,f10.5,' )')
C
      CALL MATMULT(3,3,3,1,A,CEN1,B3)
      CALL ARRPS(3,1,T0,B3,B3)
      CALL ARRAD(3,1,CEN1,B3,T)
C
      WRITE(6,*) 
      WRITE(6,*) 
      WRITE(6,4) (A(1,J),J=1,3),T(1)
      WRITE(6,5) (A(2,J),J=1,3),T(2)
      WRITE(6,4) (A(3,J),J=1,3),T(3)
4	FORMAT(1X,'      (',3F10.6,' )   (    )   (',f10.5,' )')
5	FORMAT(1X,' X2 = (',3F10.6,' ) * ( X1 ) + (',f10.5,' )')
C
      END 
c
c
      subroutine lgg_symlib(nunit,file,nsp,nsym,nrot,sym,latnam)
c In this subroutine the user gives a space group number, the subroutine reads the 
c ccp4 symmetry library, then it outputs the symmetry operations
c Input
c	file--- symmetry library file name
c	nsp --- space group number
c Output
c 	nsymm --- Total number of symmetry operations in this spacegroup
c	nrot ---- only rotation symmetric operations in this spacegroup
c	symm  ---- a 3*4*nsym symmetric operation c matrix.
c	latnam  ---  *14 character spacegroup name
c in common symdump,  if dump is true, dump all the information
c maxop is the maximum number of symmetry operations
c libary format
c155 6  2    R32
c X,Y,Z * -Y,X-Y,Z * Y-X,-X,Z
c Y,X,-Z * -X,Y-X,-Z * X-Y,-Y,-Z
c X+1/3,Y+2/3,Z+2/3 * -Y+1/3,X-Y+2/3,Z+2/3 * Y-X+1/3,-X+2/3,Z+2/3  
c Y+1/3,X+2/3,-Z+2/3 * -X+1/3,Y-X+2/3,-Z+2/3 * X-Y+1/3,-Y+2/3,-Z+2/3
c X+2/3,Y+1/3,Z+1/3 * -Y+2/3,X-Y+1/3,Z+1/3 * Y-X+2/3,-X+1/3,Z+1/3
c Y+2/3,X+1/3,-Z+1/3 * -X+2/3,Y-X+1/3,-Z+1/3 * X-Y+2/3,-Y+1/3,-Z+1/3
      parameter (maxop=96)
      character file*80,latnam*14
      real sym(3,4,maxop)
      integer*4 nunit,nsp,nsym,nrot
      logical*1 dump
c	COMMON/SYMDUMP/ DUMP
c
      character*80 key,str*40
c
c...  data statements.  Separate declaration and init required for f2c
      data dump /.false./
c
c	WRITE(6,*)  'nsp',nsp
      nsym=0
      if (nunit.eq.0) nunit=25
      if (file(1:1).eq.' ') call spstrunct(file)
      if (file(1:1).eq.' ') file='SYMOP'
        call ccpdpn(nunit,file(1:lenstr(file)),'READONLY','F',0,0)
10	read(nunit,'(a)',end=220) key
c	il = lenstr(key)
c	i1 = index(key(1:il),'PG')
c	if (i1.eq.0) goto 10
c	call redstrin(12,i1-1,key,npar)
      read(key(1:12),*,err=10,end=10) isp,iall,irot
c	WRITE(6,*) key(1:lenstr(key)),isp,nsp,latnam
      if (isp.ne.nsp) goto 10
c	i1 = index(key(1:il),'PG')
      read(key(12:80),'(a)') latnam
c	call spstrunct(latnam)
      if (latnam(1:1).eq.' ') latnam(1:13) = latnam(2:14)
      if (isp.ne.nsp) goto 10
      write(6,*) 'Space Group  >>> ',Latnam,isp
      do i = 1, iall
       read(nunit,'(a)') key
       il = lenstr(key)
       key(il+1:il+1)='*'
       iend = 0
       if (dump)  write(6,'(1x,a)') key(1:il)
20	 ist = iend+1
        iend = index(key(ist:il+1),'*')+IST-1
        str = '                                        '
        str(1:iend-ist) = key(ist:iend-1)
        NSYM=NSYM+1
        IF (MATSYM(SYM(1,1,nsym),STR,ICOL).EQ.0) GOTO 502
        WRITE(6,*) 'Error in symop after colunm ',ICOL
        write(6,*) key
        write(6,*) str
        stop 'Check you file SYMOP'
502	continue
       if (dump) then
        write(6,'(4f8.4)') ((sym(j1,j2,nsym),j2=1,4),j1=1,3)
       end if
       if (iend.lt.il+1) goto 20
       if (i.eq.irot) nrot = nsym
      end do
      write(6,45) nsym,nrot
45	format(1x,'Symmetric operation ----',6x,
     1 'Total: ',i3,6x,'Rotation:',i3)
      close (unit=nunit)
      return
210	WRITE(6,*)  'Error opening the SYMOP file ',FILE(1:LENSTR(FILE))
220	WRITE(6,*)  'Space group',nsp,' was not found in SYMOP file'
      nsym = 0
      nrot = 0
      latnam = '      '
      STOP 'Check your SYMOP file'
      END
c
c
      SUBROUTINE TMOVE(M,NATM,XIN,T,CONST,XOUT)
C  XOUT = XIN + CONST * T
C where    XIN is  input M*NATM-dimensional array.
C          XOUT N is  output M*NATM-dimensional array.
c          T is a M-dimensional vector.
c          CONST is a constant.
C	DIMENSION XIN(M,NATM),XOUT(M,NATM),T(M),B(100)
c
      DIMENSION XIN(M,NATM),XOUT(M,NATM),T(M),B(100)
      CALL ARRMC(M,1,T,CONST,B)
      DO I = 1, NATM
      CALL ARRAD(M,1,XIN(1,I),B,XOUT(1,I))
      END DO
      END
c
c
c------------------------------------------------------------
      subroutine up(txt,len)
c
c convert character string to upper case
c
      character*(*) txt
      character*80 save
      character*26 ualpha,lalpha
      data ualpha /'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      data lalpha /'abcdefghijklmnopqrstuvwxyz'/

      do 9000 i=1,len
        if((txt(i:i).ge.'a').and.(txt(i:i).le.'z')) then
          match = index(lalpha,txt(i:i))
          save(i:i) = ualpha(match:match)
        else
          save(i:i) = txt(i:i)
        end if
c      end do
9000	continue

      txt = save
      return
      end
c
c
      SUBROUTINE VECCRSMLT(A1,A2,A)
      DIMENSION A1(3),A2(3),A(3)
      A(1)=VLDIM2(A1(2),A1(3),A2(2),A2(3))
      A(2)=VLDIM2(A1(3),A1(1),A2(3),A2(1))
      A(3)=VLDIM2(A1(1),A1(2),A2(1),A2(2))
      END
c
c
      FUNCTION VEM(N,V)
      DIMENSION V(N)
      C=0
      DO 10 I=1,N
10	C=C+V(I)*V(I)
      VEM=SQRT(C)
      RETURN
      END
c
c
      FUNCTION VLDIM3(AT)
C A function to calculate the modulus of a 3*3-dimension matrix.
c VLDIM3 = | AT3*3 |
      dimension at(3,3)
      dimension B1(3)
C
      call veccrsmlt(at(1,1),at(1,2),b1)
      vldim3 = poimult(3,3,b1,at(1,3))
      end
c
c
      FUNCTION VLDIM2(A11,A12,A21,A22)
      VLDIM2=A11*A22-A21*A12
      END
c
c
        REAL FUNCTION COSD(ANGINDEG)
        REAL ANGINDEG
        COSD = COS(ANGINDEG*3.1415926/180.)
        END
c
c
        REAL FUNCTION SIND(ANGINDEG)
        REAL ANGINDEG
        SIND = SIN(ANGINDEG*3.1415926/180.)
        END
c
c
        REAL FUNCTION TAND(ANGINDEG)
        REAL ANGINDEG
        TAND = TAN(ANGINDEG*3.1415926/180.)
        END
c
c
        REAL FUNCTION ACOSD(VAL)
        REAL VAL
        ACOSD = ACOS(VAL)*180./3.1415926
        END
c
c
        REAL FUNCTION ASIND(VAL)
        REAL VAL
        ASIND = ASIN(VAL)*180./3.1415926
        END
c
c
        REAL FUNCTION ATAND(VAL)
        REAL VAL
        ATAND = ATAN(VAL)*180./3.1415926
        END

C
C     plotsubs.f
C
C     This library is free software: you can redistribute it and/or
C     modify it under the terms of the GNU Lesser General Public License
C     version 3, modified in accordance with the provisions of the 
C     license to address the requirements of UK law.
C 
C     You should have received a copy of the modified GNU Lesser General 
C     Public License along with this library.  If not, copies may be 
C     downloaded from http://www.ccp4.ac.uk/ccp4license.php
C 
C     This program is distributed in the hope that it will be useful,
C     but WITHOUT ANY WARRANTY; without even the implied warranty of
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C     GNU Lesser General Public License for more details.
C
      SUBROUTINE PLTAXS(VWPORT,XLOW,XHIGH,NXTICK,NXSTCK,LXTICK,XLABEL,
     .                         YLOW,YHIGH,NYTICK,NYSTCK,LYTICK,YLABEL)
C     ================================================================
C
C
C  Draw box of axes, and set up user coordinate transformation
C
C
C  VWPORT(2,2)  viewport, ie coordinates (in range 0 to 1) of
C               bottom left corner (i,1) and top right corner (i,2)
C               of box
C  XLOW, XHIGH  range of values on x
C  NXTICK       if .gt.0 approximate number of tick marks on x (=0 if none)
C               If .lt.0, use exactly the range (XLOW - XHIGH) & number
C               of ticks specified
C  NXSTCK       number of subsidiary tick marks / division on x
C  LXTICK       |LXTICK| = 1 ticks inside box
C                        = 2 ticks outside box
C               .gt. 0     draw tick & label at end of axis
C               .lt. 0     omit last tick & label at end of axis
C  XLABEL       label for x axis
C
C    similarly,  YLOW,YHIGH,NYTICK,NYSTCK,LYTICK,YLABEL
C
C
      REAL VWPORT(2,2),XLOW,XHIGH,YLOW,YHIGH
      INTEGER NXTICK,NXSTCK,LXTICK,NYTICK,NYSTCK,LYTICK
      CHARACTER*(*) XLABEL,YLABEL
C
      REAL X,Y,TSIZE,WINDOW(2,2),WIN1,WIN2
      INTEGER L,NLAB,IFLAG,JTICK,LENSTR
      EXTERNAL LINSUB,TXTSUB
C
C
      TSIZE=1.2
C
C x axis
      IF(NXTICK.GT.0) THEN
C   Find "best" tick positions
            CALL UGLNDX(XLOW,XHIGH,NXTICK-2,NXTICK+2,
     .          WIN1,WIN2,NLAB)
C           avoid aliasing array elements
            WINDOW (1,1) = WIN1
            WINDOW (1,2) = WIN2
      ELSE
C   Use given values
            NLAB=IABS(NXTICK)
            WINDOW(1,1)=XLOW
            WINDOW(1,2)=XHIGH
      ENDIF
C   Get best format for numbers
      CALL PLTNDG(WINDOW(1,1),WINDOW(1,2),NLAB)
C   bottom axis
      IFLAG=1
      JTICK=LXTICK
      CALL UGLNAX(LINSUB,TXTSUB,IFLAG,
     .   VWPORT(1,1),VWPORT(2,1),VWPORT(1,2),VWPORT(2,1),
     .   WINDOW(1,1),WINDOW(1,2),NLAB,NXSTCK,JTICK)
C   top
      IFLAG=0
      JTICK=(3-IABS(LXTICK))*ISIGN(1,LXTICK)
      CALL UGLNAX(LINSUB,TXTSUB,IFLAG,
     .   VWPORT(1,1),VWPORT(2,2),VWPORT(1,2),VWPORT(2,2),
     .   WINDOW(1,1),WINDOW(1,2),NLAB,NXSTCK,JTICK)
C
C  Plot label
      L=LENSTR(XLABEL)
      X=0.5*(VWPORT(1,1)+VWPORT(1,2))
      Y=VWPORT(2,1)-0.07
      CALL PLTCTX(XLABEL(1:L),X,Y,TSIZE,2,0.0)
C
C y axis
      IF(NYTICK.GT.0) THEN
C   Find "best" tick positions
            CALL UGLNDX(YLOW,YHIGH,NYTICK-2,NYTICK+2,
     .              WIN1,WIN2,NLAB)
C           avoid aliasing array elements
            WINDOW (2,1) = WIN1
            WINDOW (2,2) = WIN2
      ELSE
C   Use given values
            NLAB=IABS(NYTICK)
            WINDOW(2,1)=YLOW
            WINDOW(2,2)=YHIGH
      ENDIF
C   Get best format for numbers
      CALL PLTNDG(WINDOW(2,1),WINDOW(2,2),NLAB)
C   left
      IFLAG=2
      JTICK=(3-IABS(LYTICK))*ISIGN(1,LYTICK)
      CALL UGLNAX(LINSUB,TXTSUB,IFLAG,
     .   VWPORT(1,1),VWPORT(2,1),VWPORT(1,1),VWPORT(2,2),
     .   WINDOW(2,1),WINDOW(2,2),NLAB,NYSTCK,JTICK)
C   right
      IFLAG=0
      JTICK=LYTICK
      CALL UGLNAX(LINSUB,TXTSUB,IFLAG,
     .   VWPORT(1,2),VWPORT(2,1),VWPORT(1,2),VWPORT(2,2),
     .   WINDOW(2,1),WINDOW(2,2),NLAB,NYSTCK,JTICK)
C
C  Plot label
      L=LENSTR(YLABEL)
      X=VWPORT(1,1)-0.11
      Y=0.5*(VWPORT(2,1)+VWPORT(2,2))
      CALL PLTCTX(YLABEL(1:L),X,Y,TSIZE,3,90.0)
C
C Set up user transformation
      CALL PLTWIN(VWPORT,WINDOW)
C
      END
      SUBROUTINE PLTCHS(SCALE)
C     ========================
C
C Set character scale as fraction of space 0-1
C
      REAL SCALE
C
      CALL GSSCLC(SCALE,SCALE)
      END
      SUBROUTINE PLTCTX(STRING,X,Y,SIZE,MODE,ANGLE)
C     =============================================
C
C*** Plot84 version
C  Plot STRING at X,Y, rotated by ANGLE, relative size SIZE
C    MODE = 1, 2, 3 justify left, middle, right
C
      CHARACTER*(*) STRING
      REAL X,Y,ANGLE,DTOR,SIZE
      INTEGER MODE
C
C
      DTOR=ATAN(1.)/45.
      CALL GSANCU(X,Y)
      CALL GSCROT(ANGLE*DTOR,(ANGLE+90.)*DTOR)
      CALL GSCETS(STRING,SIZE,SIZE,MODE)
      END
      SUBROUTINE PLTDBU(X,Y)
C     ======================
C
C Draw by point X,Y (user units)
C
      REAL X,Y,XV,YV
C
C  transform coordinates
      CALL PLTTNS(X,Y,XV,YV)
      CALL PLTDBY(XV,YV)
      END
      SUBROUTINE PLTDBY(X,Y)
C     ======================
C
C*** Plot84 version
C   Draw to X,Y
C
      REAL X,Y
      CALL GSDWBY(X,Y)
      END
      SUBROUTINE PLTDRW(X,Y)
C     ======================
C
C*** Plot84 version
C   Draw to X,Y
C
      REAL X,Y
      CALL GSDWTO(X,Y)
      END
      SUBROUTINE PLTDSH(M,R,D,T)
C     ==========================
C
C  Set dash parameters
C
C   M =0 SOLID LINE
C   M=1 DASHED LINE (DOT DUMMY PARAMETER)
C   M=2  CHAINED LINE
C   R == REPEAT repeat length
C   D == DASH  dash length
C   T == DOT   not used
C  REPEAT DASH DOT  are in basic picture units (ie range 0 to 1 )
C
      INTEGER M
      REAL R,D,T
C
      COMMON /DASH/ LPT,MODE,REPEAT,DASH,DOT,A1,B1
      REAL REPEAT,DASH,DOT,A1,B1
      INTEGER LPT,MODE
      SAVE /DASH/
C
C
      MODE=M
      REPEAT=R
      DASH=D
      DOT=T
      LPT=0
      END
      SUBROUTINE PLTDWU(X,Y)
C     ======================
C
C Draw to point X,Y (user units)
C
      REAL X,Y,XV,YV
C
C  transform coordinates
      CALL PLTTNF(X,Y,XV,YV)
      CALL PLTDRW(XV,YV)
      END
      SUBROUTINE PLTFNM(FNUM,NDIG,NAFTER,X,Y,SIZE,MODE,ANGLE)
C     ========================================================
C
C*** Plot84 version
C  Plot real FNUM at X,Y, rotated by ANGLE
C   NDIG digits, NAFTER digits after decimal point
C    MODE = 1, 2, 3 justify left, middle, right
C
      REAL FNUM,X,Y,ANGLE,DTOR,SIZE
      INTEGER NDIG,NAFTER,MODE
C
C
      DTOR=ATAN(1.)/45.
      CALL GSANCU(X,Y)
      CALL GSCROT(ANGLE*DTOR,(ANGLE+90.)*DTOR)
      CALL GSFNUM(FNUM,NDIG,NAFTER,SIZE,SIZE,MODE)
      END
      SUBROUTINE PLTINI
C     =================
C
C*** Plot84 version
C  Initialize plot on logical name PLOT
C
      REAL XSIZE,YSIZE,CSIZE
      DATA XSIZE,YSIZE,CSIZE/200.,200.,0.015/
C
      CALL GSINIT('PLOT')
      CALL GSBSIZ(XSIZE,YSIZE)
C
10    CALL GSPICT
C  User coordinates in range 0 - 1 on x & y
      CALL GSORGD(0.01*XSIZE,0.01*YSIZE)
      CALL GSSCLU(XSIZE*0.99,YSIZE*0.99)
C  Scale characters to CSIZE (user units)
      CALL GSTLNK(1)
      CALL GSSCLC(CSIZE,CSIZE)
C  Centred characters
      CALL GSCENC(1)
      RETURN
C
      ENTRY PLTPIC
C       =============
C
C Start new picture
C
      CALL GSENDP
      GO TO 10
      END
      SUBROUTINE PLTINM(INUM,NDIG,X,Y,SIZE,MODE,ANGLE)
C     ============================================
C
C*** Plot84 version
C  Plot integer INUM at X,Y, rotated by ANGLE
C   NDIG digits
C    MODE = 1, 2, 3 justify left, middle, right
C
      REAL X,Y,ANGLE,DTOR,SIZE
      INTEGER INUM,NDIG,MODE
C
C
      DTOR=ATAN(1.)/45.
      CALL GSANCU(X,Y)
      CALL GSCROT(ANGLE*DTOR,(ANGLE+90.)*DTOR)
      CALL GSINUM(INUM,NDIG,SIZE,SIZE,MODE)
      END
      SUBROUTINE PLTLIN(X,Y,NPT)
C     =========================
C
C Draw lines to join NPT points X,Y
C Coordinates are in user units
C
      INTEGER NPT
      REAL X(NPT),Y(NPT)
C
      COMMON /DASH/ LPT,MODE,REPEAT,DASH,DOT,A1,B1
      REAL REPEAT,DASH,DOT,A1,B1
      INTEGER LPT,MODE
      SAVE /DASH/
C
      REAL SMALL,GAP,A,B,X1,Y1,X2,Y2,DX,DY,R,XD,YD,XG,YG,D
      INTEGER I,J
      DATA SMALL/0.001/
C
C MODE =0 FOR SOLID LINES
      IF(NPT.LE.1) RETURN
      IF(MODE.GT.0) GO TO 10
C
C SOLID
      CALL PLTMVU(X(1),Y(1))
      DO 1 I=2,NPT
1     CALL PLTDWU(X(I),Y(I))
      RETURN
C
C
C DASHED LINES, REPEAT IS REPEAT LENGTH, DASH IS DASH LENGTH
C DOT IS DUMMY (NO CHAIN LINES)
10    GAP=REPEAT-DASH
      A=DASH
      B=GAP
C LPT=0 IF 1ST CALL SINCE CALL TO S/R DASHED, OTHERWISE KEEP DASHES IN PHASE
      IF(LPT.EQ.0) GO TO 11
      A=A1
      B=B1
C
11    LPT=1
C  Convert user units to picture units before working out dashing
      CALL PLTTNF(X(1),Y(1),X1,Y1)
CC      X1=X(1)
CC      Y1=Y(1)
      I=2
      CALL PLTMOV(X1,Y1)
C
C COME HERE FOR NEW LINE
15    CALL PLTTNF(X(I),Y(I),X2,Y2)
CC15    X2=X(I)
CC      Y2=Y(I)
      DX=X2-X1
      DY=Y2-Y1
      D=SQRT(DX*DX+DY*DY)
      IF(D.LT.SMALL) GO TO 30
      DX=DX/D
      DY=DY/D
      R=D
      A1=0.
      B1=0.
      J=-1
C
C R IS REMAINING LINE LENGTH
C COME HERE FOR EACH DASH REPEAT
20    IF(R.LT.(A+B)) GO TO 25
      IF(J) 26,26,27
C
C LAST BIT, GET REMAINING DASH LENGTH
25    IF(R.LT.A) GO TO 21
C LAST PART IS IN GAP
      A1=0.
      B1=B-R+A
      B=R-A
      GO TO 22
C LAST PART IS IN DASH
21    A1=A-R
      B1=GAP
      A=R
      B=0.
22    J=-2
C
26    J=J+1
      XD=A*DX
      YD=A*DY
      XG=B*DX
      YG=B*DY
C
27    IF(A.GT.SMALL) CALL PLTDBY(XD,YD)
      IF(B.GT.SMALL) CALL PLTMBY(XG,YG)
      R=R-A-B
      IF(J) 30,28,20
C RESET DASH LENGTH AFTER 1ST REPEAT
28    A=DASH
      B=GAP
      J=0
      GO TO 20
C
C END OF LINE, RESTORE UNUSED DASH LENGTH
30    I=I+1
      IF(I.GT.NPT) RETURN
      X1=X2
      Y1=Y2
      A=A1
      B=B1
      GO TO 15
C
      END
      SUBROUTINE PLTMBU(X,Y)
C     ======================
C
C Move by point X,Y (user units)
C
      REAL X,Y,XV,YV
C
C  transform coordinates
      CALL PLTTNS(X,Y,XV,YV)
      CALL PLTMBY(XV,YV)
      END
      SUBROUTINE PLTMBY(X,Y)
C     ======================
C
C*** Plot84 version
C   Move by X,Y
C
      REAL X,Y
      CALL GSMVBY(X,Y)
      END
      SUBROUTINE PLTMOV(X,Y)
C     ======================
C
C*** Plot84 version
C   Move to X,Y
C
      REAL X,Y
      CALL GSMVTO(X,Y)
      END
      SUBROUTINE PLTMVU(X,Y)
C     ======================
C
C Move to point X,Y (user units)
C
      REAL X,Y,XV,YV
C
C  transform coordinates
      CALL PLTTNF(X,Y,XV,YV)
      CALL PLTMOV(XV,YV)
      END
      SUBROUTINE PLTNDG(LOW,HIGH,NLAB)
C     ================================
C
C Try to determine "best" number format for axis labelling
C   Input:
C       low, high       low & high values for tick marks
C       nlab            number of tick marks
C
C   Output in COMMON /PLTDIG/
C       ndec    number of digits in number
C       idec    number of digits after decimal point (0 for integer)
C
      REAL RANGE,LOW,HIGH,DVAL,BIG
      INTEGER NLAB,N
      LOGICAL LINT
C
      COMMON /PLTDIG/ NDEC,IDEC
      INTEGER NDEC,IDEC
      SAVE /PLTDIG/
C
      RANGE=HIGH-LOW
      BIG=MAX(ABS(LOW),ABS(HIGH))
C
      NDEC=5
      IDEC=1
      LINT=.FALSE.
C
      DVAL=1.0
      IF(NLAB.GT.1) DVAL=RANGE/(NLAB-1)
      IDEC=1-ALOG10(ABS(DVAL))
C
      IF(ABS(RANGE).GT.9.99) THEN
            LINT=.TRUE.
            NDEC=2+ALOG10(BIG)
      ENDIF
C
      IF(AMOD(DVAL,1.0).EQ.0.0 .AND.
     .     AMOD(LOW,1.0).EQ.0.0) LINT=.TRUE.
C
      IF(LINT) IDEC=0
      IF((LOW.LT.0.0.OR.HIGH.LT.0.0)) THEN
            N=0
            IF(IDEC.GT.0) N=2+IDEC
            IF(NDEC.LT.N) NDEC=NDEC+1
      ENDIF
C
      END
      SUBROUTINE PLTSTP
C     =================
C
C*** Plot84 version
C  Stop plotting
C
      CALL GSENDP
      CALL GSSTOP
      END
      SUBROUTINE PLTTNF(X,Y,XV,YV)
C     ============================
C
C Transform user X,Y to plotter XV,YV (range 0 to 1)
C
C
      REAL X,Y,XV,YV
C
      COMMON /PLTTRN/ ORIGX,ORIGY,VSCALX,VSCALY
      REAL ORIGX,ORIGY,VSCALX,VSCALY
      SAVE /PLTTRN/
C
      XV=X*VSCALX+ORIGX
      YV=Y*VSCALY+ORIGY
      END
C
      SUBROUTINE PLTTNS(X,Y,XV,YV)
C     ============================
C
C Transform user X,Y to plotter XV,YV (range 0 to 1)
C    without translation (scaling only)
C
C
      REAL X,Y,XV,YV
C
      COMMON /PLTTRN/ ORIGX,ORIGY,VSCALX,VSCALY
      SAVE /PLTTRN/
      REAL ORIGX,ORIGY,VSCALX,VSCALY
C
      XV=X*VSCALX
      YV=Y*VSCALY
      RETURN
      END
C
      SUBROUTINE PLTWIN(VWPORT,WINDOW)
C     ================================
C
C Set up mapping of viewport VWPORT to user window WINDOW
C
      REAL VWPORT(2,2),WINDOW(2,2)
C
      COMMON /PLTTRN/ ORIGX,ORIGY,VSCALX,VSCALY
      REAL ORIGX,ORIGY,VSCALX,VSCALY
      SAVE /PLTTRN/
C
      VSCALX=(VWPORT(1,2)-VWPORT(1,1))/(WINDOW(1,2)-WINDOW(1,1))
      VSCALY=(VWPORT(2,2)-VWPORT(2,1))/(WINDOW(2,2)-WINDOW(2,1))
      ORIGX=VWPORT(1,1)-WINDOW(1,1)*VSCALX
      ORIGY=VWPORT(2,1)-WINDOW(2,1)*VSCALY
      END
      SUBROUTINE UGLNAX(LSUB,TSUB,TFLG,XCLO,YCLO,XCHI,YCHI,
     X                  LOLB,HILB,NLAB,NSUBTK,LLTICK)
C
C *******************  THE UNIFIED GRAPHICS SYSTEM  *******************
C *                    AXIS GENERATION SUBROUTINE                     *
C *                                                                   *
C *  THIS SUBROUTINE MAY BE USED TO GENERATE A DESCRIPTION OF AN      *
C *  AXIS WITH LINEAR LABELING.  A PAIR OF USER SUPPLIED SUBROUTINES  *
C *  ARE CALLED TO PROCESS THE LINE SEGMENT END POINTS AND THE TEXT.  *
C *                                                                   *
C *  THE CALLING SEQUENCE IS:                                         *
C *    CALL UGLNAX(LSUB,TSUB,TFLG,XCLO,YCLO,XCHI,YCHI,                *
C *                LOLB,HILB,NLAB,NSUBTK,LLTICK)                      *
C *                                                                   *
C *  THE PARAMETERS IN THE CALLING SEQUENCE ARE:                      *
C *    LSUB  THE LINE SEGMENT END POINT SUBROUTINE.                   *
C *    TSUB  THE LABEL SUBROUTINE.                                    *
C *    TFLG  A FLAG THAT IS PASSED TO TSUB.                           *
C *    XCLO  X COORDINATE OF THE LOW END OF THE AXIS.                 *
C *    YCLO  Y COORDINATE OF THE LOW END OF THE AXIS.                 *
C *    XCHI  X COORDINATE OF THE HIGH END OF THE AXIS.                *
C *    YCHI  Y COORDINATE OF THE HIGH END OF THE AXIS.                *
C *    LOLB  DATA VALUE AT THE LOW END OF THE AXIS.                   *
C *    HILB  DATA VALUE AT THE HIGH END OF THE AXIS.                  *
C *    NLAB  NUMBER OF LABELS ON THE AXIS. if =0, no tick marks       *
C *    NSUBTK Number of subsidiary tick marks between main ones.      *
C *    LLTICK =1 tick on left, =2 tick on right =3 both               *
C *          if .lt.0,  don't plot tick or label at end of axis       *
C *                                                                   *
C *                          ROBERT C. BEACH                          *
C *                    COMPUTATION RESEARCH GROUP                     *
C *                STANFORD LINEAR ACCELERATOR CENTER                 *
C *                                                                   *
C *********************************************************************
C  PRE 28/7/88 bodged
C
      EXTERNAL      LSUB,TSUB
      INTEGER       TFLG
      REAL          XCLO,YCLO,XCHI,YCHI,LOLB,HILB
      INTEGER       NLAB,NSUBTK,LLTICK
C
C
      INTEGER     EXNT
      REAL        EXLS,EXRS
C
      REAL          DLAX,DLAY
      REAL          DLTX,DLTY
      REAL          DLBX,DLBY,DLBL
      REAL          DLCX,DLCY
      REAL          XCRD,YCRD,VALU
      REAL          XCDS,YCDS
C
      REAL          FLT1
      INTEGER       INT1,INT2,LTICK,J
C
      LTICK=IABS(LLTICK)
C
      EXNT=MAX(0,NSUBTK)
      EXLS=0.0
      EXRS=EXLS
      FLT1=0.01*MAX(ABS(XCHI-XCLO),ABS(YCHI-YCLO))
      IF(MOD(LTICK,2).EQ.1) EXLS=FLT1
      IF(LTICK.GE.2) EXRS=FLT1
C
C  DRAW THE AXIS STARTING AT THE LOW END.
      IF (NLAB.LT.2) THEN
C  Just draw line if .le.2 ticks
            CALL LSUB(XCLO,YCLO,0)
            CALL LSUB(XCHI,YCHI,1)
            GO TO 201
      ENDIF
C
      CALL LSUB(XCLO,YCLO,0)
      CALL LSUB(XCHI,YCHI,1)
C
C  INITIALIZE THE TIC MARK AND LABEL LOOP.
      DLAX=XCHI-XCLO
      DLAY=YCHI-YCLO
      FLT1=SQRT(DLAX*DLAX+DLAY*DLAY)
      DLTX=DLAY/FLT1
      DLTY=-DLAX/FLT1
      FLT1=REAL(NLAB-1)
      DLBX=DLAX/FLT1
      DLBY=DLAY/FLT1
      DLBL=(HILB-LOLB)/FLT1
      IF (EXNT.GE.1) THEN
        FLT1=REAL(EXNT+1)
        DLCX=DLBX/FLT1
        DLCY=DLBY/FLT1
      END IF
C
C  LOOP TO GENERATE THE TIC MARKS AND LABELS.
C  Skip first tick (end of axis) if LLTICK .lt. 0
      J=1
      IF(LLTICK.LT.0) J=2
      DO 102 INT1=J,NLAB
C  GENERATE TIC MARK POSITION.
        FLT1=REAL(INT1-1)
        XCRD=XCHI-FLT1*DLBX
        YCRD=YCHI-FLT1*DLBY
C  GENERATE A LABEL.
        VALU=HILB-FLT1*DLBL
        CALL TSUB(XCRD,YCRD,VALU,TFLG)
C  GENERATE A PRIMARY TIC MARK.
        CALL LSUB(XCRD+EXRS*DLTX,YCRD+EXRS*DLTY,0)
        CALL LSUB(XCRD-EXLS*DLTX,YCRD-EXLS*DLTY,1)
C  GENERATE SECONDARY TIC MARKS.
        IF ((INT1.NE.NLAB).AND.(EXNT.GE.1)) THEN
          DO 101 INT2=1,EXNT
            FLT1=REAL(INT2)
            XCDS=XCRD-FLT1*DLCX
            YCDS=YCRD-FLT1*DLCY
            CALL LSUB(XCDS+0.5*EXRS*DLTX,YCDS+0.5*EXRS*DLTY,2)
            CALL LSUB(XCDS-0.5*EXLS*DLTX,YCDS-0.5*EXLS*DLTY,3)
  101     CONTINUE
        END IF
  102 CONTINUE
C
  201 RETURN
C
C
      END
      SUBROUTINE UGLNDX(LODA,HIDA,MINL,MAXL,LOLB,HILB,NLAB)
C
C *******************  THE UNIFIED GRAPHICS SYSTEM  *******************
C *               AUXILIARY AXIS GENERATION PROGRAM                   *
C *                                                                   *
C *  THIS SUBROUTINE IS AN AID IN USING SUBROUTINE UGLNAX.  IF A      *
C *  PROGRAMMER DETERMINES THE EXTENT OF THE DATA AT EXECUTION TIME,  *
C *  IT CAN BE A PROBLEM TO SUPPLY VALUES OF THE ARGUMENTS LOLB,      *
C *  HILB, AND NLAB WHICH RESULT IN "ROUNDED NUMBERS" FOR THE         *
C *  LABELS.  THIS SUBROUTINE ACCEPTS AS ITS INPUT THE EXTENT OF THE  *
C *  DATA AND THE APPROXIMATE NUMBER OF LABELS TO BE USED.  ITS       *
C *  OUTPUT IS THE THREE ARGUMENTS FOR UGLNAX.                        *
C *                                                                   *
C *  THE CALLING SEQUENCE IS:                                         *
C *    CALL UGLNDX(LODA,HIDA,MINL,MAXL,LOLB,HILB,NLAB)                *
C *                                                                   *
C *  THE PARAMETERS IN THE CALLING SEQUENCE ARE:                      *
C *    LODA  LOW LIMIT OF ACTUAL DATA.                                *
C *    HIDA  HIGH LIMIT OF ACTUAL DATA.                               *
C *    MINL  MINIMUM NUMBER OF LABELS.                                *
C *    MAXL  MAXIMUM NUMBER OF LABELS.                                *
C *    LOLB  COMPUTED LOW LIMIT OF AXIS.                              *
C *    HILB  COMPUTED HIGH LIMIT OF AXIS.                             *
C *    NLAB  COMPUTED NUMBER OF LABELS.                               *
C *                                                                   *
C *                          ROBERT C. BEACH                          *
C *                    COMPUTATION RESEARCH GROUP                     *
C *                STANFORD LINEAR ACCELERATOR CENTER                 *
C *                                                                   *
C *********************************************************************
C
      REAL          LODA,HIDA
      INTEGER       MINL,MAXL
      REAL          LOLB,HILB
      INTEGER       NLAB
C
CCCC      INCLUDE       'UGSYSTEM:UGERRCBK.FOR/LIST'
C
      REAL          PVAL(3)
      INTEGER       NPVL
C
      REAL          DALO,DAHI,SCAL,DLOX,DHIX,SCLX,OVLP
      REAL          TVR1,TVR2
      INTEGER       IMIN,IMAX
C
      INTEGER       INT1,INT2,INT3,INT4
C
      DATA          PVAL/1.0,2.0,5.0/
      DATA          NPVL/3/
C
C  ADJUST THE GIVEN DATA LIMITS.
      IF (LODA.LT.HIDA) THEN
        DALO=LODA
        DAHI=HIDA
      ELSE
        DALO=HIDA-0.5
        DAHI=LODA+0.5
      END IF
      TVR1=0.0005*(DAHI-DALO)
      DALO=DALO+TVR1
      DAHI=DAHI-TVR1
C  INITIALIZE THE LOOP TO FIND THE BEST VALUES.
      OVLP=1E20
      IMIN=MAX(2,MINL)
      IMAX=MAX(IMIN,MAXL)
C  LOOP TO FIND THE BEST VALUES.
      DO 104 INT1=IMIN,IMAX
        SCAL=INT1-1
        TVR2=(DAHI-DALO)/SCAL
        TVR1=LOG10(TVR2)
        INT2=INT(TVR1)
        IF (TVR1.LT.0.0) INT2=INT2-1
        TVR2=TVR2/(10.0**INT2)
        IF (TVR2.GT.PVAL(NPVL)) THEN
          INT2=INT2+1
          TVR2=TVR2/10.0
        END IF
        DO 101 INT4=1,NPVL
          INT3=INT4
          IF (PVAL(INT3).GE.TVR2) GO TO 102
  101   CONTINUE
  102   SCLX=PVAL(INT3)*(10.0**INT2)
        TVR1=(DAHI+DALO-SCLX*SCAL)/(2.0*SCLX)
        DLOX=AINT(TVR1)*SCLX
        IF (TVR1.LT.0.0) DLOX=DLOX-SCLX
  103   DHIX=DLOX+SCLX*SCAL
        IF (DAHI.GT.DHIX) THEN
          DLOX=DLOX+SCLX
          IF ((DLOX-DALO).LE.(0.005*SCLX)) GO TO 103
          IF (NPVL.NE.INT3) THEN
            INT3=INT3+1
          ELSE
            INT3=1
            INT2=INT2+1
          END IF
          GO TO 102
        END IF
        IF ((DHIX-DLOX).LT.OVLP) THEN
          OVLP=DHIX-DLOX
          LOLB=DLOX
          HILB=DHIX
          NLAB=INT1
        END IF
  104 CONTINUE
C
      RETURN
C
      END
      SUBROUTINE LINSUB(X,Y,IFLAG)
C     ============================
C
C  Line drawing subroutine called by UGLNAX
C   Move (IFLAG = 0 or 2) or draw (IFLAG = 1 or 3) to X,Y
C
      REAL X,Y
      INTEGER IFLAG
C
      IF(MOD(IFLAG,2).EQ.0) THEN
            CALL PLTMOV(X,Y)
      ELSE
            CALL PLTDRW(X,Y)
      ENDIF
      END
      SUBROUTINE TXTSUB(X,Y,VALU,IFLAG)
C     =================================
C
C Text drawing subroutine called by UGLNAX
C
C   IFLAG = 1 horizontal axis
C         = 2 vertical axis
C
      REAL X,Y,VALU,XX,YY,ANGLE,SIZE
      INTEGER MODE,IFLAG
C
      COMMON /PLTDIG/ NDEC,IDEC
      INTEGER NDEC,IDEC
      SAVE /PLTDIG/
C
      SIZE=1.0
      XX=X
      YY=Y
      IF(IFLAG.EQ.1) THEN
            YY=YY-0.03
            MODE=2
            ANGLE=0.0
      ELSEIF(IFLAG.EQ.2) THEN
            XX=XX-0.02
            MODE=3
            ANGLE=0.0
      ELSE
            RETURN
      ENDIF
C
      IF(IDEC.EQ.0) THEN
            CALL PLTINM(NINT(VALU),NDEC,XX,YY,SIZE,MODE,ANGLE)
      ELSE
            CALL PLTFNM(VALU,NDEC,IDEC,XX,YY,SIZE,MODE,ANGLE)
      ENDIF
C
      RETURN
      END
C
C
      SUBROUTINE PL84CLEAR
C     =====================
C
C
C---- Start a new picture
C
C
C     .. External Subroutines ..
      EXTERNAL GSPICT
C     ..
      CALL GSPICT
      END
C
C
C
      SUBROUTINE PL84CLOSE
C     =====================
C
C
C     .. External Subroutines ..
      EXTERNAL GSSTOP
C     ..
      CALL GSSTOP
      END
C
C
C
      SUBROUTINE PL84DRAW(IX,IY)
C     ===========================
C
C
C---- Convert from 10 micron units to mm
C
C
C     .. Scalar Arguments ..
      INTEGER IX,IY
C     ..
C     .. Local Scalars ..
      REAL X,Y
C     ..
C     .. External Subroutines ..
      EXTERNAL GSDWTO
C     ..
      X = 0.01*IX
      Y = 0.01*IY
      CALL GSDWTO(X,Y)
      END
C
C
C
      SUBROUTINE PL84END
C     ===================
C
C
C     .. External Subroutines ..
      EXTERNAL GSENDP
C     ..
      CALL GSENDP
      END
C
C
C
C    ****  PLOT84 ROUTINES *****
C          ===============
C
C
      SUBROUTINE PL84INIT
C     ====================
C
C
C---- Initialise PLOT84 file
C
C
C     .. External Subroutines ..
      EXTERNAL GSINIT
C     ..
      CALL GSINIT('PLOT')
      END
C
C
C
      SUBROUTINE PL84INTEG(INUM,NDIG,SIZX,SIZY,NJUST)
C     ===============================================
C
C
C     .. Scalar Arguments ..
      REAL SIZX,SIZY
      INTEGER INUM,NDIG,NJUST
C     ..
C     .. External Subroutines ..
      EXTERNAL GSINUM
C     ..
      CALL GSINUM(INUM,NDIG,SIZX,SIZY,NJUST)
      END
C
C
C
      SUBROUTINE PL84MOVE(IX,IY)
C     ===========================
C
C
C
C---- Convert from 10 micron units to mm
C
C
C     .. Scalar Arguments ..
      INTEGER IX,IY
C     ..
C     .. Local Scalars ..
      REAL X,Y
C     ..
C     .. External Subroutines ..
      EXTERNAL GSMVTO
C     ..
      X = 0.01*IX
      Y = 0.01*IY
      CALL GSMVTO(X,Y)
      END
C
C
C
      SUBROUTINE PL84NEWLINE(X)
C     ==========================
C
C
C     .. Scalar Arguments ..
      REAL X
C     ..
C     .. External Subroutines ..
      EXTERNAL GSLNFD
C     ..
      CALL GSLNFD(X)
      END
C
C
C
      SUBROUTINE PL84ORIGIN(X,Y)
C     ===========================
C
C
C     .. Scalar Arguments ..
      REAL X,Y
C     ..
C     .. External Subroutines ..
      EXTERNAL GSANCD
C     ..
      CALL GSANCD(X,Y)
      END
C
C
C
      SUBROUTINE PL84REAL(X,NDIG,NAFTER,SIZX,SIZY,NJUST)
C     ===================================================
C
C
C     .. Scalar Arguments ..
      REAL SIZX,SIZY,X
      INTEGER NAFTER,NDIG,NJUST
C     ..
C     .. External Subroutines ..
      EXTERNAL GSFNUM
C     ..
      CALL GSFNUM(X,NDIG,NAFTER,SIZX,SIZY,NJUST)
      END
C
C
C
      SUBROUTINE PL84STRING(STR)
C     ===========================
C
C
C
C
C     .. Scalar Arguments ..
      CHARACTER STR* (*)
C     ..
C     .. External Subroutines ..
      EXTERNAL GSSTRC
C     ..
      CALL GSSTRC(STR)
      END
C
C
C
      SUBROUTINE PL84XCUR(X)
C     =======================
C
C
C     .. Scalar Arguments ..
      REAL X
C     ..
C     .. External Subroutines ..
      EXTERNAL GSSCUR
C     ..
      CALL GSSCUR(X)
      END

C
C     modlib.f: grab-bag of mathematical functions
C
C     This library is free software: you can redistribute it and/or
C     modify it under the terms of the GNU Lesser General Public License
C     version 3, modified in accordance with the provisions of the 
C     license to address the requirements of UK law.
C 
C     You should have received a copy of the modified GNU Lesser General 
C     Public License along with this library.  If not, copies may be 
C     downloaded from http://www.ccp4.ac.uk/ccp4license.php
C 
C     This program is distributed in the hope that it will be useful,
C     but WITHOUT ANY WARRANTY; without even the implied warranty of
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C     GNU Lesser General Public License for more details.
C
C  cross.f        dot.f          ea06c.f      ea08c.f     ea09c.f
C  fa01as.f       fa01bs.f       fa01cs.f     fa01ds.f    fm02ad.f
C  icross.f       idot.f         iminv3       match.f     matmul.f
C  matmulnm.f     matmulgen.f
C  matvec.f       mc04b.f        minvn.f      minv3.f     ranmar.f
C  scalev.f       transp.f       unit.f       vdif.f      vset.f
C  vsum.f         zipin.f        zipout.f
C
C Routines added by pjx (June 2000):
C
C     GMPRD multiply two matrices (general)
C     MATMUL4 multiply two 4x4 matrices
C     MATMLN multiply two nxn matrices
C     DETMAT calculate the determinant of 3x3 matrix
C     MATVC4 matrix times vector (matrix is 4x4 array, treated as 3x3,
C            vector is length 3)
C     ML3MAT multiplies three matrices of any size
C     INV44 invert 4x4 matrix
C     MATMLI integer version of 3x3 matrix product MATMUL
C     MATMULTRANS multiply 3x3 matrix by transpose of another 3x3 matrix
C     IMATVEC integer version of MATVEC (post-multiply 3x3 matrix with a
C             vector)
C     TRANSFRM variant of MATVC4, same except that the input vector is
C              overwritten by the output vector
C
C Routines added by mdw (April 2003)
C
C     ZJVX    Compute zero of Bessel function of 1st kind Jv(x)
C     JDVX    Compute Bessel functions of 1st kind Jv(x) and their derivatives
C     JVX     Compute Bessel functions of 1st kind Jv(x)
C     GAMMA   Compute gamma function GA(x)
C     MSTA1   Determine the starting point for backward
C             recurrence such that the magnitude of
C             Jn(x) at that point is about 10^(-MP)
C     MSTA2   Determine the starting point for backward
C             recurrence such that all Jn(x) has MP
C             significant digits
C
C_BEGIN_GMPRD
C
      SUBROUTINE GMPRD(A,B,R,N,M,L)
C     =============================
C
C
C---- Ssp general matrix product
C
C   R(N,L) = A(N,M) * B(M,L)
C
C     .. Scalar Arguments ..
      INTEGER L,M,N
C     ..
C     .. Array Arguments ..
      REAL A(N*M),B(M*L),R(N*L)
C     ..
C     .. Local Scalars ..
      INTEGER I,IB,IK,IR,J,JI,K
C     ..
C
C_END_GMPRD
C
      IR = 0
      IK = -M
      DO 30 K = 1,L
        IK = IK + M
        DO 20 J = 1,N
          IR = IR + 1
          JI = J - N
          IB = IK
          R(IR) = 0.0
          DO 10 I = 1,M
            JI = JI + N
            IB = IB + 1
            R(IR) = A(JI)*B(IB) + R(IR)
   10     CONTINUE
   20   CONTINUE
   30 CONTINUE
      END
C
C_BEGIN_MATMUL4
C
C     =========================
      SUBROUTINE MATMUL4(A,B,C)
C     =========================
C
C     Multiply two 4x4 matrices, A=B*C
C
C
      IMPLICIT NONE
C
C     .. Array Arguments ..
      REAL A(4,4),B(4,4),C(4,4)
C     ..
C     .. Local Scalars ..
      REAL S
      INTEGER I,J,K
C     ..
C_END_MATMUL4
C
      DO 30 I = 1,4
        DO 20 J = 1,4
          S = 0
          DO 10 K = 1,4
            S = B(I,K)*C(K,J) + S
   10     CONTINUE
          A(I,J) = S
   20   CONTINUE
   30 CONTINUE
      RETURN
      END
C
C_BEGIN_MATMLN
C
      subroutine matmln(n,a,b,c)
C     =========================
C
C Multiply two nxn matrices
C  a = b . c
C
      integer n
      real a(n,n),b(n,n),c(n,n)
      integer i,j,k
C
C_END_MATMLN
C
      do 1 i=1,n
         do 2 j=1,n
            a(j,i)=0.
            do 3 k=1,n
               a(j,i)= b(j,k)*c(k,i)+a(j,i)
 3          continue
 2       continue
 1    continue
      return
      end
C
C_BEGIN_DETMAT
C
C     ===========================
      SUBROUTINE DETMAT(RMAT,DET)
C     ============================
C
C---- Calculate determinant DET of 3x3 matrix RMAT
C
C
C     .. Scalar Arguments ..
      REAL DET
C     ..
C     .. Array Arguments ..
      REAL RMAT(3,3)
C     ..
C_END_DETMAT
C
      DET = RMAT(1,1)*RMAT(2,2)*RMAT(3,3) +
     +      RMAT(1,2)*RMAT(2,3)*RMAT(3,1) +
     +      RMAT(1,3)*RMAT(2,1)*RMAT(3,2) -
     +      RMAT(1,3)*RMAT(2,2)*RMAT(3,1) -
     +      RMAT(1,2)*RMAT(2,1)*RMAT(3,3) -
     +      RMAT(1,1)*RMAT(2,3)*RMAT(3,2)
C
      END
C
C
C_BEGIN_MATVC4
C
      SUBROUTINE MATVC4(A,R,B)
C     ========================
C
C Matrix x Vector
C       A(3)  =  R(4x4) . B(3)
C
      REAL A(3), R(4,4), B(3)
C
      REAL AA(4), BB(4)
C
      EXTERNAL GMPRD,VSET
C
C_END_MATVC4
C
      CALL VSET(BB,B)
      BB(4) = 1.0
      CALL GMPRD(R,BB,AA,4,4,1)
      CALL VSET(A,AA)
      RETURN
      END
C
C
C_BEGIN_ML3MAT
C
C 26-Nov-1988       J. W. Pflugrath           Cold Spring Harbor Laboratory
C    Edited to conform to Fortran 77.  Renamed from Multiply_3_matrices to
C    ML3MAT
C
C ==============================================================================
C
C! to multiply three matrices
C
      SUBROUTINE ML3MAT
C          ! input: 1st side of 1st matrix
     1   (P
C          ! input: first matrix
     2   ,A
C          ! input: 2nd side of 1st matrix & 1st side of 2nd matrix
     3   ,Q
C          ! input: second matrix
     4   ,B
C          ! input: 2nd side of 2nd matrix & 1st side of 3rd matrix
     5   ,R
C          ! input: third matrix
     6   ,C
C          ! input: 2nd side of 3rd matrix
     7   ,S
C          ! output: product matrix
     8   ,D)
C
CEE Multiplies three real matrices of any dimensions.  It is not optimised
C   for very large matrices.
C Multiply_3_matrices
C*** this routine is inefficient!
C Multiply_3_matrices
Created: 15-NOV-1985 D.J.Thomas,   MRC Laboratory of Molecular Biology,
C                                  Hills Road, Cambridge, CB2 2QH, England
C
C            ! loop counters
      INTEGER   I,J,K,L
C            ! loop limits
      INTEGER   P,Q,R,S
C           ! first input matrix
      REAL   A  (1:P,1:Q)
C           ! second input matrix
      REAL   B  (1:Q,1:R)
C           ! third input matrix
      REAL   C  (1:R,1:S)
C           ! output matrix
      REAL   D  (1:P,1:S)
C
C_END_ML3MAT
C
      DO 100 L = 1, S
         DO 100 I = 1, P
            D(I,L) = 0.0
            DO 100 K = 1, R
               DO 100 J = 1, Q
C
C                 ! accumulate product matrix D=ABC
C
100               D(I,L) = D(I,L)  +  A(I,J) * B(J,K) * C(K,L)
               CONTINUE
            CONTINUE
         CONTINUE
      CONTINUE
C Multiply_3_matrices
      RETURN
      END
C
C
C_BEGIN_INV44
C
C     ======================
      SUBROUTINE INV44(A,AI)
C     ======================
C
C SUBROUTINE TO INVERT 4*4 MATRICES FOR CONVERSION BETWEEN
C FRACTIONAL AND ORTHOGONAL AXES
C PARAMETERS
C
C           A (I)   4*4 MATRIX TO BE INVERTED
C          AI (O)   INVERSE MATRIX
C
C SPECIFICATION STATEMENTS
C ------------------------
C
C
C GET COFACTORS OF 'A' IN ARRAY 'C'
C ---------------------------------
C
      IMPLICIT NONE
C
C     .. Array Arguments ..
      REAL A(4,4),AI(4,4)
C     ..
C     .. Local Scalars ..
      REAL AM,D
      INTEGER I,I1,II,J,J1,JJ
C     ..
C     .. Local Arrays ..
      REAL C(4,4),X(3,3)
C     ..
C
C_END_INV44
C
      DO 40 II = 1,4
        DO 30 JJ = 1,4
          I = 0
          DO 20 I1 = 1,4
            IF (I1.EQ.II) GO TO 20
            I = I + 1
            J = 0
            DO 10 J1 = 1,4
              IF (J1.EQ.JJ) GO TO 10
              J = J + 1
              X(I,J) = A(I1,J1)
   10       CONTINUE
   20     CONTINUE
          AM = X(1,1)*X(2,2)*X(3,3) - X(1,1)*X(2,3)*X(3,2) +
     +         X(1,2)*X(2,3)*X(3,1) - X(1,2)*X(2,1)*X(3,3) +
     +         X(1,3)*X(2,1)*X(3,2) - X(1,3)*X(2,2)*X(3,1)
          C(II,JJ) = (-1)** (II+JJ)*AM
   30   CONTINUE
   40 CONTINUE
C
C---- calculate determinant
C
      D = 0
      DO 50 I = 1,4
        D = A(I,1)*C(I,1) + D
   50 CONTINUE
C
C---- get inverse matrix
C
      DO 70 I = 1,4
        DO 60 J = 1,4
          AI(I,J) = C(J,I)/D
   60   CONTINUE
   70 CONTINUE
      RETURN
      END
C
C
C_BEGIN_MATMLI
C
      SUBROUTINE MATMLI(A,B,C)
C     ========================
C Integer matrix multiply
      INTEGER A(3,3),B(3,3),C(3,3),I,J,K
C
C_END_MATMULI
C
      DO 1 I=1,3
      DO 2 J=1,3
      A(I,J)=0
      DO 3 K=1,3
      A(I,J)=A(I,J)+B(I,K)*C(K,J)
3     CONTINUE
  2     CONTINUE
 1      CONTINUE
      RETURN
      END
C
C
C_BEGIN_MATMULTRANS
C
      SUBROUTINE MATMULTrans(A,B,C)
C     =============================
C
C  A=B*C(transpose) for 3x3 matrices
C
      IMPLICIT NONE
C
C     ..Array arguments
      REAL A(3,3),B(3,3),C(3,3)
C     ..Local arrays
      REAL CT(3,3)
C
      EXTERNAL MATMUL
C
C_END_MATMULTRANS
C
      CALL TRANSP(CT,C)
      CALL MATMUL(A,B,CT)
      RETURN
      END
C
C
C_BEGIN_IMATVEC
C
      SUBROUTINE IMATVEC(V,A,B)
C     ========================
C
C---- Post-multiply a 3x3 matrix by a vector
C
C       V=AB
C
C     .. Array Arguments ..
      INTEGER A(3,3),B(3),V(3)
C     ..
C     .. Local Scalars ..
      INTEGER I,J,S
C
C_END_IMATVEC
C
      DO 20 I = 1,3
        S = 0
C
C
        DO 10 J = 1,3
          S = A(I,J)*B(J) + S
   10   CONTINUE
C
C
        V(I) = S
   20 CONTINUE
C
C
      END
C
C
C_BEGIN_TRANSFRM
C
      SUBROUTINE TRANSFRM(X,MAT)
C     ==========================
C
C  Transform vector X(3) by quine matrix MAT(4,4)
C  Return transformed vector in X.
C
      IMPLICIT NONE
C
C     ..Array arguments..
      REAL X(3),MAT(4,4)
C     ..Local arrays..
      REAL TMP(3)
C
C_END_TRANSFRM
C
      CALL MATVC4(TMP,MAT,X)
      CALL VSET(X,TMP)
      RETURN
      END
C
C
C
C_BEGIN_CROSS
C
      SUBROUTINE CROSS(A,B,C)
C     =======================
C
C     compute vector product A = B x C
C
C     .. Array Arguments ..
      REAL             A(3),B(3),C(3)
C
C_END_CROSS
C     ..
      A(1) = B(2)*C(3) - C(2)*B(3)
      A(2) = B(3)*C(1) - C(3)*B(1)
      A(3) = B(1)*C(2) - C(1)*B(2)
      END
C
C
C_BEGIN_DOT
C
      REAL FUNCTION DOT(A,B)
C     ======================
C
C     dot product of two vectors
C
C     .. Array Arguments ..
      REAL              A(3),B(3)
C
C_END_DOT
C     ..
      DOT = A(1)*B(1) + A(2)*B(2) + A(3)*B(3)
      END
C

C     ******************************************************************
      SUBROUTINE EIGEN_RS_ASC(A, R, N, MV)
C     ******************************************************************
C
C---- SUBROUTINE TO COMPUTE EIGENVALUES & EIGENVECTORS OF A REAL
C---- SYMMETRIC MATRIX, FROM IBM SSP MANUAL (SEE P165).
C---- DESCRIPTION OF PARAMETERS -
C---- A - ORIGINAL MATRIX STORED COLUMNWISE AS UPPER TRIANGLE ONLY,
C---- I.E. "STORAGE MODE" = 1.  EIGENVALUES ARE WRITTEN INTO DIAGONAL
C---- ELEMENTS OF A  I.E.  A(1)  A(3)  A(6)  FOR A 3*3 MATRIX.
C---- R - RESULTANT MATRIX OF EIGENVECTORS STORED COLUMNWISE IN SAME
C---- ORDER AS EIGENVALUES.
C---- N - ORDER OF MATRICES A & R.
C---- MV = 0 TO COMPUTE EIGENVALUES & EIGENVECTORS.
C
C
c      IMPLICIT    NONE

      INTEGER NMAX
      PARAMETER (NMAX=10)

      REAL        A(*), R(*)
      INTEGER     N, MV
C
      INTEGER     IQ, J, I, IJ, IA, IND, L, M, MQ, LQ, LM, LL, MM
      INTEGER     ILQ, IMQ, IM, IL, ILR, IMR
      REAL        ANORM, ANRMX, RANGE, THR, X, Y, SINX, SINX2,
     &            COSX, COSX2, SINCS

C Lapack variables
      LOGICAL LAPACK
      CHARACTER*1        JOBZ, LAPRANGE, UPLO
      INTEGER            INFO, NVECTORS
      REAL               ABSTOL
      INTEGER            ISUPPZ(2*NMAX), IWORK(10*NMAX)
      REAL               WORK(26*NMAX),EVALUES(NMAX),AM(NMAX,NMAX)
C
C-- FOR REAL
C      DATA RANGE/1D-12/
      DATA RANGE/1E-6/

C  Alternative lapack routine - only marginally tested
      LAPACK = .FALSE.
      IF (LAPACK) THEN
       NVECTORS = 0
       IF (N.GT.NMAX) 
     +    CALL CCPERR(1,'s/r EIGEN_RS_ASC: redimension NMAX!')
       IF (MV.EQ.0) JOBZ = 'V'
       LAPRANGE = 'A'
       UPLO = 'U'
       ABSTOL = 0.0
       IA = 0
       DO I = 1,N
         DO J = 1,I
           IA = IA + 1
           AM(J,I) = A(IA)
         ENDDO
       ENDDO
C       CALL SSYEVR(JOBZ, LAPRANGE, UPLO, N, AM, N, 
C     +   1, N, 1, N, ABSTOL, NVECTORS, EVALUES, R, 
C     +   N, ISUPPZ, WORK, 26*N, IWORK, 10*N, INFO)
       IA = 0
       DO I = 1,NVECTORS
         DO J = 1,I
           IA = IA + 1
           IF (J.EQ.I) A(IA) = EVALUES(I)
         ENDDO
       ENDDO
       RETURN
      ENDIF

      IF (MV.EQ.0) THEN
        IQ=-N
        DO    J=1,N
          IQ=IQ+N
          DO     I=1,N
            IJ=IQ+I
            IF (I.EQ.J) THEN
              R(IJ)=1.
            ELSE
              R(IJ)=0.
            ENDIF
          ENDDO
        ENDDO
      ENDIF
C
C---- INITIAL AND FINAL NORMS (ANORM & ANRMX)
      IA=0
      ANORM=0.
      DO    I=1,N
        DO    J=1,I
          IA=IA+1
          IF (J.NE.I) ANORM=ANORM+A(IA)**2
        ENDDO
      ENDDO
C
      IF (ANORM.LE.0.) GOTO 165
      ANORM=SQRT(2.*ANORM)
      ANRMX=ANORM*RANGE/N
C
C---- INITIALIZE INDICATORS AND COMPUTE THRESHOLD
      IND=0
      THR=ANORM
45    THR=THR/N
50    L=1
55    LQ=L*(L-1)/2
      LL=L+LQ
      M=L+1
      ILQ=N*(L-1)
C
C---- COMPUTE SIN & COS
60    MQ=M*(M-1)/2
      LM=L+MQ
      IF (A(LM)*A(LM)-THR.LT.0.) GOTO 130
      IND=1
      MM=M+MQ
      X=.5*(A(LL)-A(MM))
      Y=-A(LM)/SQRT(A(LM)**2+X*X)
C---- Protect against rounding error. C. Flensburg 20080307.
      IF (ABS(Y).GT.1.0) Y=SIGN(1.0,Y)
      IF (X.LT.0.) Y=-Y
      SINX=Y/SQRT(2.*(1.+(SQRT(1.-Y*Y))))
      SINX2=SINX**2
      COSX=SQRT(1.-SINX2)
      COSX2=COSX**2
      SINCS=SINX*COSX
C
C---- ROTATE L & M COLUMNS
      IMQ=N*(M-1)
      DO 125 I=1,N
        IQ=I*(I-1)/2
        IF (I.NE.L .AND. I.NE.M) THEN
          IF (I.LT.M) THEN
            IM=I+MQ
          ELSE
            IM=M+IQ
          ENDIF
          IF (I.LT.L) THEN
            IL=I+LQ
          ELSE
            IL=L+IQ
          ENDIF
          X=A(IL)*COSX-A(IM)*SINX
          A(IM)=A(IL)*SINX+A(IM)*COSX
          A(IL)=X
        ENDIF
        IF (MV.EQ.0) THEN
          ILR=ILQ+I
          IMR=IMQ+I
          X=R(ILR)*COSX-R(IMR)*SINX
          R(IMR)=R(ILR)*SINX+R(IMR)*COSX
          R(ILR)=X
        ENDIF
125   CONTINUE
C
      X=2.*A(LM)*SINCS
      Y=A(LL)*COSX2+A(MM)*SINX2-X
      X=A(LL)*SINX2+A(MM)*COSX2+X
      A(LM)=(A(LL)-A(MM))*SINCS+A(LM)*(COSX2-SINX2)
      A(LL)=Y
      A(MM)=X
C
C---- TESTS FOR COMPLETION
C---- TEST FOR M = LAST COLUMN
130   IF (M.NE.N) THEN
        M=M+1
        GOTO 60
      ENDIF
C
C---- TEST FOR L =PENULTIMATE COLUMN
      IF (L.NE.N-1) THEN
        L=L+1
        GOTO55
      ENDIF
      IF (IND.EQ.1) THEN
        IND=0
        GOTO50
      ENDIF
C
C---- COMPARE THRESHOLD WITH FINAL NORM
      IF (THR.GT.ANRMX) GOTO 45
165   RETURN
      END
C
C     The routines ea06c, ea08c, ea09c, fa01as, fa01bs, fa01cs, fa01ds,
C     fm02ad, mc04b, (and possibly others) are from the
C     Harwell Subroutine library.  The conditions on their external use,
C     reproduced from the Harwell manual are:
C     * due acknowledgement is made of the use of subroutines in any
C     research publications resulting from their use.
C     * the subroutines may be modified for use in research applications
C     by external users.  The nature of such modifiactions should be
C     indicated in writing for information to the liaison officer.  At
C     no time however, shall the subroutines or modifications thereof
C     become the property of the external user.
C       The liaison officer for the library's external affairs is listed
C     as: Mr. S. Marlow, Building 8.9, Harwell Laboratory, Didcot, 
C     Oxon OX11 0RA, UK.
C
C_BEGIN_EA06C
C
      SUBROUTINE EA06C(A,VALUE,VECTOR,M,IA,IV,W)
C     ==========================================
C
C**  18/03/70 LAST LIBRARY UPDATE
C
C       ( Calls EA08C(W,W(M1),VALUE,VECTOR,M,IV,W(M+M1))
C       and MC04B(A,W,W(M1),M,IA,W(M+M1)) )
C
C       Given a real MxM symmetric matrix A = {aij} this routine
C       finds all its eigenvalues (lambda)i i=1,2,.....,m  and
C       eigenvectors xj i=1,2,...,m.  i.e. finds the non-trivial
C       solutions of Ax=(lambda)x
C
C       The matrix is reduced to tri-diagonal form by applying
C       Householder transformations. The eigenvalue problem for
C       the reduced problem is then solved using the QR algorithm
C       by calling EA08C.
C
C  Argument list
C  -------------
C
C   IA    (I) (integer) should be set to the first dimension
C			of the array A, i.e. if the allocation
C			for the array A was specified by
C			DIMENSION A(100,50)
C			then IA would be set to 100
C
C   M     (I) (integer) should be set to the order m of the matrix
C
C   IV    (I) (integer) should be set to the first dimension
C			of the 2-dimensional array VECTOR
C
C   VECTOR(IV,M) (O) (real) 2-dimensional array, with first dimension IV,
C		            containing the eigenvectors. The components
C		            of the eigenvector vector(i) corresponding
C		            to the eigenvalue (lambda)i (in VALUE(I))
C		            are placed in VECTOR(J,I) J=1,2,...,M.
C		            The eigenvectors are normalized so that
C		            xT(i)x(i)=1 i=1,2,...,m.
C
C   VALUE(M) (O) (real)  array in which the routine puts
C		         the eigenvalues (lambda)i, i=1,2,...,m.
C		         These are not necessarily in any order.
C
C   W    (I) (real(*)) working array used by the routine for
C		       work space. The dimension must be set
C		       to at least 5*M.
C
C_END_EA06C
C
C
C     .. Scalar Arguments ..
      INTEGER          IA,IV,M
C     ..
C     .. Array Arguments ..
      REAL             A(IA,M),VALUE(M),VECTOR(IV,M),W(*)
C     ..
C     .. Local Scalars ..
      REAL             PP
      INTEGER          I,I1,II,K,L,M1
C     ..
C     .. External Subroutines ..
      EXTERNAL         EA08C,MC04B
C     ..
      M1 = M + 1
      W(1) = A(1,1)
      IF (M-2) 30,10,20
   10 W(2) = A(2,2)
      W(4) = A(2,1)
      GO TO 30

   20 CALL MC04B(A,W,W(M1),M,IA,W(M+M1))
   30 CALL EA08C(W,W(M1),VALUE,VECTOR,M,IV,W(M+M1))
      IF (M.GT.2) THEN
          DO 70 L = 1,M
              DO 60 II = 3,M
                  I = M - II + 1
                  IF (W(M1+I).NE.0) THEN
                      PP = 0.0
                      I1 = I + 1
                      DO 40 K = I1,M
                          PP = A(I,K)*VECTOR(K,L) + PP
   40                     CONTINUE
                      PP = PP/ (A(I,I+1)*W(M1+I))
                      DO 50 K = I1,M
                          VECTOR(K,L) = A(I,K)*PP + VECTOR(K,L)
   50                     CONTINUE
                  END IF

   60             CONTINUE
   70         CONTINUE
      END IF

      END
C
C_BEGIN_EA08C
C
      SUBROUTINE EA08C(A,B,VALUE,VEC,M,IV,W)
C     =====================================
C
C       (Calls EA09C(A,B,W(M+1),M,W))
C
C       This uses QR iteration to find the all the eigenvalues and
C       eigenvectors of the real symmetric tri-diagonal matrix
C       whose diagonal elements are A(i), i=1,M and off-diagonal
C       elements are B(i),i=2,M. The eigenvalues will have unit
C       length.	The array W is used for workspace and must have
C       dimension at least 2*M.	We treat VEC as	if it had
C       dimensions (IV,M).
C
C       First EA09, which uses the QR algorithm, is used to find
C       the eigenvalues; using these as shifts the QR algorithm is
C       again applied but now using the	plane rotations	to generate
C       the eigenvectors. Finally the eigenvalues are refined
C       by taking Rayleigh quotients of the vectors.
C
C    Argument list
C    -------------
C
C       A(M)	(I) (real)    Diagonal elements
C
C       B(M)	(I) (real)    Off-diagonal elements
C
C       IV	(I)  (integer)	should be set to the first dimen-
C                               sion of the 2-dimensional array VEC
C
C       M	(I) (integer) should be	set to the order m of the
C                             matrix
C
C       VALUE(M) (O) (real)   Eigenvalues
C
C       VEC	(O) (real)    Eigenvectors. The	dimensions
C			      should be	set to (IV,M).
C
C       W(*)	(I) (real)    Working array.The	dimension must be
C			      set to at	least 2*M.
C
C_END_EA08C
C
C     .. Scalar Arguments ..
      INTEGER          IV,M
C     ..
C     .. Array Arguments ..
      REAL             A(M),B(M),VALUE(M),VEC(1),W(*)
C     ..
C     .. Local Scalars ..
      REAL             A11,A12,A13,A21,A22,A23,A33,A34,CO,EPS,ROOT,S,SI,
     +                 V1,V2,XAX,XX
      INTEGER          I,II,ITER,J,J1,J2,JI,JK,K,L,N1,N2,N2M1
C     ..
C     .. External Subroutines ..
      EXTERNAL         EA09C
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC        ABS,MIN,SIGN,SQRT
C     ..
C     .. Data statements ..
      DATA             EPS/1.0E-5/,A34/0.0/
C     ..
C
C
      CALL EA09C(A,B,W(M+1),M,W)
C
C---- Set vec to the identity matrix.
C
      DO 20 I = 1,M
          VALUE(I) = A(I)
          W(I) = B(I)
          K = (I-1)*IV + 1
          L = K + M - 1
          DO 10 J = K,L
              VEC(J) = 0.0
   10         CONTINUE
          VEC(K+I-1) = 1.0
   20     CONTINUE
      ITER = 0
      IF (M.NE.1) THEN
          N2 = M
   30     CONTINUE
C
C---- Each qr iteration is performed of rows and columns n1 to n2
C
          DO 40 II = 2,N2
              N1 = 2 + N2 - II
              IF (ABS(W(N1)).LE. (ABS(VALUE(N1-1))+ABS(VALUE(N1)))*
     +            EPS) GO TO 50
   40         CONTINUE
          N1 = 1
   50     IF (N2.NE.N1) THEN
              ROOT = W(M+N2)
              ITER = ITER + 1
              N2M1 = N2 - 1
              A22 = VALUE(N1)
              A12 = A22 - ROOT
              A23 = W(N1+1)
              A13 = A23
              DO 70 I = N1,N2M1
                  A33 = VALUE(I+1)
                  IF (I.NE.N2M1) A34 = W(I+2)
                  S = SIGN(SQRT(A12*A12+A13*A13),A12)
                  SI = A13/S
                  CO = A12/S
                  JK = I*IV + 1
                  J1 = JK - IV
                  J2 = MIN(M,I+ITER) + J1 - 1
                  DO 60 JI = J1,J2
                      V1 = VEC(JI)
                      V2 = VEC(JK)
                      VEC(JI) = V1*CO + V2*SI
                      VEC(JK) = V2*CO - V1*SI
                      JK = JK + 1
   60                 CONTINUE
                  IF (I.NE.N1) W(I) = S
                  A11 = CO*A22 + SI*A23
                  A12 = CO*A23 + SI*A33
                  A13 = SI*A34
                  A21 = CO*A23 - SI*A22
                  A22 = CO*A33 - SI*A23
                  A23 = CO*A34
                  VALUE(I) = A11*CO + A12*SI
                  A12 = -A11*SI + A12*CO
                  W(I+1) = A12
                  A22 = A22*CO - A21*SI
   70             CONTINUE
              VALUE(N2) = A22
              GO TO 30

          ELSE
              N2 = N2 - 1
              IF (N2-1.GT.0) GO TO 30
          END IF
C
C---- Rayleigh quotient
C
          DO 90 J = 1,M
              K = (J-1)*IV
              XX = VEC(K+1)**2
              XAX = A(1)*XX
              DO 80 I = 2,M
                  XX = VEC(K+I)**2 + XX
                  XAX = (B(I)*2.0*VEC(K+I-1)+VEC(K+I)*A(I))*VEC(K+I) +
     +                  XAX
   80             CONTINUE
              VALUE(J) = XAX/XX
   90         CONTINUE
      END IF

      END
C
C
      SUBROUTINE EA09C(A,B,VALUE,M,OFF)
C     =================================
C
C    18/03/70 LAST LIBRARY UPDATE
C
C     .. Scalar Arguments ..
      INTEGER          M
C     ..
C     .. Array Arguments ..
      REAL             A(M),B(M),OFF(M),VALUE(M)
C     ..
C     .. Local Scalars ..
      REAL             A11,A12,A13,A21,A22,A23,A33,A34,BB,CC,CO,EPS,
     +                 ROOT,S,SBB,SI
      INTEGER          I,II,N1,N2,N2M1
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC        ABS,SQRT
C     ..
C     .. Data statements ..
      DATA             A34/0.0/,EPS/0.6E-7/
C     ..
C
C
      VALUE(1) = A(1)
      IF (M.NE.1) THEN
          DO 10 I = 2,M
              VALUE(I) = A(I)
              OFF(I) = B(I)
   10         CONTINUE
C
C---- Each qr iteration is performed of rows and columns n1 to n2
C
          N2 = M
   20     CONTINUE
          IF (N2.GT.1) THEN
              DO 30 II = 2,N2
                  N1 = 2 + N2 - II
                  IF (ABS(OFF(N1)).LE. (ABS(VALUE(N1-1))+
     +                ABS(VALUE(N1)))*EPS) GO TO 40
   30             CONTINUE
              N1 = 1
   40         IF (N2.NE.N1) THEN
C
C---- Root  is the eigenvalue of the bottom 2*2 matrix that is nearest
C     to the last matrix element and is used to accelerate the
C     convergence
C
                  BB = (VALUE(N2)-VALUE(N2-1))*0.5
                  CC = OFF(N2)*OFF(N2)
                  SBB = 1.0
                  IF (BB.LT.0.0) SBB = -1.0
                  ROOT = CC/ (SQRT(BB*BB+CC)*SBB+BB) + VALUE(N2)
                  N2M1 = N2 - 1
                  A22 = VALUE(N1)
                  A12 = A22 - ROOT
                  A23 = OFF(N1+1)
                  A13 = A23
                  DO 50 I = N1,N2M1
                      A33 = VALUE(I+1)
                      IF (I.NE.N2M1) A34 = OFF(I+2)
                      S = SQRT(A12*A12+A13*A13)
                      SI = A13/S
                      CO = A12/S
                      IF (I.NE.N1) OFF(I) = S
                      A11 = CO*A22 + SI*A23
                      A12 = CO*A23 + SI*A33
                      A13 = SI*A34
                      A21 = CO*A23 - SI*A22
                      A22 = CO*A33 - SI*A23
                      A23 = CO*A34
                      VALUE(I) = A11*CO + A12*SI
                      A12 = -A11*SI + A12*CO
                      OFF(I+1) = A12
                      A22 = A22*CO - A21*SI
   50                 CONTINUE
                  VALUE(N2) = A22

              ELSE
                  N2 = N2 - 1
              END IF

              GO TO 20

          END IF

      END IF

      END
C
C
C---- Changes put in to make it work on vax (this version has scaling)
C  1. 12 statements for calculation of over/underflow of determinant in ma21
C     replaced by a simple one which will overflow more easily(entry ma21cd)
C  2. changes to mc10ad to replace 370-specific parts....
C     a. u=floati  (6 times)
C     b. new alog16 procedure (twice)
C     c. simpler 16**diag statement (once)
C  3. all double precision replaced by real*8 (not really necessary).
C  4. replace a(n),b(n) by a(1),b(1) in fm02ad to avoid vax array checking.
C
      FUNCTION FA01AS(I)
C     ==================
      DOUBLE PRECISION  G, FA01AS
      INTEGER I
      COMMON/FA01ES/G
      G= 1431655765.D0
C
C
      G=DMOD(G* 9228907.D0,4294967296.D0)
      IF(I.GE.0)FA01AS=G/4294967296.D0
      IF(I.LT.0)FA01AS=2.D0*G/4294967296.D0-1.D0
      RETURN
      END
C
      SUBROUTINE FA01BS(MAX,NRAND)
C     ============================
C
      INTEGER NRAND, MAX
      DOUBLE PRECISION FA01AS
      EXTERNAL FA01AS
      NRAND=INT(FA01AS(1)*FLOAT(MAX))+1
      RETURN
      END
C
      SUBROUTINE FA01CS(IL,IR)
C     ========================
C
      DOUBLE PRECISION  G
      INTEGER IL,IR
      COMMON/FA01ES/G
      G= 1431655765.D0
C
      IL=G/65536.D0
      IR=G-65536.D0*FLOAT(IL)
      RETURN
      END
C
      SUBROUTINE FA01DS(IL,IR)
C     ========================
C
      DOUBLE PRECISION  G
      INTEGER IL,IR
      COMMON/FA01ES/G
      G= 1431655765.D0
C
      G=65536.D0*FLOAT(IL)+FLOAT(IR)
      RETURN
      END
C
C_BEGIN_FM02AD
C
      DOUBLE PRECISION FUNCTION FM02AD(N,A,IA,B,IB)
C     =============================================
C
C     Compute the inner product of two double precision real
C     vectors accumulating the result double precision, when the
C     elements of each vector are stored at some fixed displacement
C     from neighbouring elements. Given vectors A={a(j)},
C     B={b(j)} of length N, evaluates w=a(j)b(j) summed over
C     j=1..N. Can be used to evaluate inner products involving
C     rows of multi-dimensional arrays.
C     It can be used as an alternative to the assembler version,
C     but note that it is likely to be significantly slower in execution.
C
C     Argument list
C     -------------
C
C       N  (I) (integer) The length of the vectors (if N <= 0 FM02AD = 0)
C
C       A  (I) (double precision) The first vector
C
C       IA (I) (integer) Subscript displacement between elements of A
C
C       B  (I) (double precision) The second vector
C
C       IB (I) (integer) Subscript displacement between elements of B
C
C       FM02AD  the result
C
C
C_END_FM02AD
C
      DOUBLE PRECISION  R1,A,B
C
C---- The following statement changed from a(n),b(n) to avoid vax dynamic
C     array check failure.
C
      DIMENSION A(1),B(1)
      INTEGER N,JA,IA,JB,IB,I
C
      R1=0D0
      IF(N.LE.0) GO TO 2
      JA=1
      IF(IA.LT.0) JA=1-(N-1)*IA
      JB=1
      IF(IB.LT.0) JB=1-(N-1)*IB
      I=0
    1 I=I+1
      R1=R1+A(JA)*B(JB)
      JA=JA+IA
      JB=JB+IB
      IF(I.LT.N) GO TO 1
    2 FM02AD=R1
      RETURN
C
      END
C
C
C_BEGIN_ICROSS
C
      SUBROUTINE ICROSS(A,B,C)
C     ========================
C
C    Cross product (integer version)
C
C    A = B x C
C
C     .. Array Arguments ..
      INTEGER           A(3),B(3),C(3)
C
C_END_ICROSS
C     ..
      A(1) = B(2)*C(3) - C(2)*B(3)
      A(2) = B(3)*C(1) - C(3)*B(1)
      A(3) = B(1)*C(2) - C(1)*B(2)
      END
C
C
C_BEGIN_IDOT
C
      INTEGER FUNCTION IDOT(A,B)
C     ==========================
C
C      Dot product (integer version)
C
C      IDOT = A . B
C
C     .. Array Arguments ..
      INTEGER               A(3),B(3)
C
C_END_IDOT
C     ..
      IDOT = A(1)*B(1) + A(2)*B(2) + A(3)*B(3)
      END
C
C
C_BEGIN_IMINV3
C
      SUBROUTINE IMINV3(A,B,D)
C     =======================
C
C     Invert a general 3x3 matrix and return determinant in D
C     (integer version)
C
C     A = (B)-1
C
C     .. Scalar Arguments ..
      INTEGER          D
C     ..
C     .. Array Arguments ..
      INTEGER          A(3,3),B(3,3)
C
C_END_IMINV3
C     ..
C     .. Local Scalars ..
      INTEGER          I,J
C     ..
C     .. Local Arrays ..
      INTEGER          C(3,3)
C     ..
C     .. External Functions ..
      INTEGER          IDOT
      EXTERNAL         IDOT
C     ..
C     .. External Subroutines ..
      EXTERNAL         ICROSS
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC        ABS
C     ..
      CALL ICROSS(C(1,1),B(1,2),B(1,3))
      CALL ICROSS(C(1,2),B(1,3),B(1,1))
      CALL ICROSS(C(1,3),B(1,1),B(1,2))
      D = IDOT(B(1,1),C(1,1))
C
C---- Test determinant
C
      IF (ABS(D).GT.0) THEN
C
C---- Determinant is non-zero
C
          DO 20 I = 1,3
              DO 10 J = 1,3
                  A(I,J) = C(J,I)/D
   10             CONTINUE
   20         CONTINUE

      ELSE
          D = 0
      END IF

      END
C
C
C_BEGIN_MATMUL
C
      SUBROUTINE MATMUL(A,B,C)
C     ========================
C
C      Multiply two 3x3 matrices
C
C      A = BC
C
C     .. Array Arguments ..
      REAL              A(3,3),B(3,3),C(3,3)
C
C_END_MATMUL
C     ..
C     .. Local Scalars ..
      INTEGER           I,J,K
C     ..
      DO 30 I = 1,3
          DO 20 J = 1,3
            A(I,J) = 0.0
              DO 10 K = 1,3
                  A(I,J) = B(I,K)*C(K,J) + A(I,J)
   10             CONTINUE
   20         CONTINUE
   30     CONTINUE
      END
C
C
C_BEGIN_MATMULNM
C
      SUBROUTINE MATMULNM(N,M,A,B,C)
C     ========================
C
C      Multiply  NxM  MXN matrices
C
C      A = BC
C
C     .. Array Arguments ..
      INTEGER N,M
      REAL              A(N,N),B(N,M),C(M,N)
C
C_END_MATMUL
C     ..
C     .. Local Scalars ..
      INTEGER           I,J,K
C     ..
      DO 30 I = 1,N
          DO 20 J = 1,N
            A(I,J) = 0.0
              DO 10 K = 1,M
                  A(I,J) = B(I,K)*C(K,J) + A(I,J)
   10             CONTINUE
   20         CONTINUE
   30     CONTINUE
      END
C
C
C_BEGIN_MATVEC
C
      SUBROUTINE MATVEC(V,A,B)
C     ========================
C
C      Post-multiply a 3x3 matrix by a vector
C
C      V = AB
C
C     .. Array Arguments ..
      REAL              A(3,3),B(3),V(3)
C
C_END_MATVEC
C     ..
C     .. Local Scalars ..
      REAL              S
      INTEGER           I,J
C     ..
      DO 20 I = 1,3
          S = 0
          DO 10 J = 1,3
              S = A(I,J)*B(J) + S
   10         CONTINUE
          V(I) = S
   20     CONTINUE
      END
C
C
C_BEGIN_MATMULGEN
C
      SUBROUTINE MATMULGEN(Nb,Mbc,Nc,A,B,C)
C     =====================================
C
C      Generalised matrix multiplication subroutine
C      Multiplies a NbxMbc matrix (B) by a  MbcXNc
C      (C) matrix, so that
C
C      A = BC
C
      IMPLICIT NONE
C     ..
C     .. Scalar Arguments ..
      INTEGER           Nb,Mbc,Nc
C     ..
C     .. Array Arguments ..
      REAL              A(Nb,Nc),B(Nb,Mbc),C(Mbc,Nc)
C
C_END_MATMULGEN
C     ..
C     .. Local Scalars ..
      INTEGER           I,J,K
C     ..
      DO 30 J = 1,Nc
          DO 20 I = 1,Nb
            A(I,J) = 0.0
              DO 10 K = 1,Mbc
                  A(I,J) = B(I,K)*C(K,J) + A(I,J)
   10         CONTINUE
   20     CONTINUE
   30   CONTINUE
      END
C
C
C_BEGIN_MC04B
C
      SUBROUTINE MC04B(A,ALPHA,BETA,M,IA,Q)
C     =====================================
C
C     Transforms a real symmetric matrix A={a(i,j)}, i, j=1..IA
C     into a tri-diagonal matrix having the same eigenvalues as A
C     using Householder's method.
C
C     .. Scalar Arguments ..
      INTEGER          IA,M
C     ..
C     .. Array Arguments ..
      REAL             A(IA,1),ALPHA(1),BETA(1),Q(1)
C
C_END_MC04B
C     ..
C     .. Local Scalars ..
      REAL             BIGK,H,PP,PP1,QJ
      INTEGER          I,I1,I2,J,J1,KI,KJ,M1,M2
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC        SQRT
C     ..
      ALPHA(1) = A(1,1)
      DO 20 J = 2,M
          J1 = J - 1
          DO 10 I = 1,J1
              A(I,J) = A(J,I)
   10         CONTINUE
          ALPHA(J) = A(J,J)
   20     CONTINUE
      M1 = M - 1
      M2 = M - 2
      DO 110 I = 1,M2
          PP = 0.0
          I1 = I + 1
          DO 30 J = I1,M
              PP = A(I,J)**2 + PP
   30         CONTINUE
          PP1 = SQRT(PP)
          IF (A(I,I+1).LT.0) THEN
              BETA(I+1) = PP1

          ELSE
              BETA(I+1) = -PP1
          END IF

          IF (PP.GT.0) THEN
              H = PP - BETA(I+1)*A(I,I+1)
              A(I,I+1) = A(I,I+1) - BETA(I+1)
              DO 60 KI = I1,M
                  QJ = 0.0
                  DO 40 KJ = I1,KI
                      QJ = A(KJ,KI)*A(I,KJ) + QJ
   40                 CONTINUE
                  IF (KI-M.LT.0) THEN
                      I2 = KI + 1
                      DO 50 KJ = I2,M
                          QJ = A(KI,KJ)*A(I,KJ) + QJ
   50                     CONTINUE
                  END IF

                  Q(KI) = QJ/H
   60             CONTINUE
              BIGK = 0.0
              DO 70 KJ = I1,M
                  BIGK = A(I,KJ)*Q(KJ) + BIGK
   70             CONTINUE
              BIGK = BIGK/ (2.0*H)
              DO 80 KJ = I1,M
                  Q(KJ) = Q(KJ) - A(I,KJ)*BIGK
   80             CONTINUE
              DO 100 KI = I1,M
                  DO 90 KJ = KI,M
                      A(KI,KJ) = A(KI,KJ) - Q(KI)*A(I,KJ) -
     +                           Q(KJ)*A(I,KI)
   90                 CONTINUE
  100             CONTINUE
          END IF

  110     CONTINUE
      DO 120 I = 2,M
          H = ALPHA(I)
          ALPHA(I) = A(I,I)
          A(I,I) = H
  120     CONTINUE
      BETA(M) = A(M-1,M)
      END
C
C
C_BEGIN_MINVN
C
      SUBROUTINE MINVN(A,N,D,L,M)
C     ===========================
C
C
C---- Purpose
C     =======
C
C           invert a matrix
C
C---- Usage
C     ======
C
C           CALL MINVN(A,N,D,L,M)
C
C---- Description of parameters
C     =========================
C
C    A - input matrix, destroyed in computation and replaced by
C        resultant inverse.
C
C    N - order of matrix A
C
C    D - resultant determinant
C
C    L - work vector of length n
C
C    M - work vector of length n
C
C---- Remarks
C     =======
C
C     Matrix a must be a general matrix
C
C---- Subroutines and function subprograms required
C     =============================================
C
C           NONE
C
C---- Method
C     ======
C
C     The standard gauss-jordan method is used. the determinant
C     is also calculated. a determinant of zero indicates that
C     the matrix is singular.
C
C
C---- Note
C     =====
C
C     If a double precision version of this routine is desired, the
C     c in column 1 should be removed from the double precision
C     statement which follows.
C
C     double precision a,d,biga,hold
C
C        the c must also be removed from double precision statements
C        appearing in other routines used in conjunction with this
C        routine.
C
C        The double precision version of this subroutine must also
C        contain double precision fortran functions.  abs in statement
C        10 must be changed to dabs.
C
ccc     REAL*8 D
C
C_END_MINVN
C
C---- Search for largest element
C
C     .. Scalar Arguments ..
      REAL D
      INTEGER N
C     ..
C     .. Array Arguments ..
      REAL A(N*N)
      INTEGER L(N),M(N)
C     ..
C     .. Local Scalars ..
      REAL BIGA,HOLD
      INTEGER I,IJ,IK,IZ,J,JI,JK,JP,JQ,JR,K,KI,KJ,KK,NK
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS
C     ..
C
C
      D = 1.0
      NK = -N
      DO 90 K = 1,N
        NK = NK + N
        L(K) = K
        M(K) = K
        KK = NK + K
        BIGA = A(KK)
        DO 20 J = K,N
          IZ = (J-1)*N
          DO 10 I = K,N
            IJ = IZ + I
            IF ((ABS(BIGA)-ABS(A(IJ))).LT.0.0) THEN
              BIGA = A(IJ)
              L(K) = I
              M(K) = J
            END IF
   10     CONTINUE
   20   CONTINUE
C
C---- Interchange rows
C
        J = L(K)
        IF ((J-K).GT.0) THEN
          KI = K - N
          DO 30 I = 1,N
            KI = KI + N
            HOLD = -A(KI)
            JI = KI - K + J
            A(KI) = A(JI)
            A(JI) = HOLD
   30     CONTINUE
        END IF
C
C---- Interchange columns
C
        I = M(K)
        IF ((I-K).GT.0) THEN
          JP = (I-1)*N
          DO 40 J = 1,N
            JK = NK + J
            JI = JP + J
            HOLD = -A(JK)
            A(JK) = A(JI)
            A(JI) = HOLD
   40     CONTINUE
        END IF
C
C---- Divide column by minus pivot (value of pivot element is
C     contained in biga)
C
        IF (BIGA.NE.0.0) THEN
          DO 50 I = 1,N
            IF ((I-K).NE.0) THEN
              IK = NK + I
              A(IK) = A(IK)/ (-BIGA)
            END IF
   50     CONTINUE
C
C---- Reduce matrix
C
          DO 70 I = 1,N
            IK = NK + I
            HOLD = A(IK)
            IJ = I - N
            DO 60 J = 1,N
              IJ = IJ + N
              IF ((I-K).NE.0) THEN
                IF ((J-K).NE.0) THEN
                  KJ = IJ - I + K
                  A(IJ) = A(KJ)*HOLD + A(IJ)
                END IF
              END IF
   60       CONTINUE
   70     CONTINUE
C
C---- Divide row by pivot
C
          KJ = K - N
          DO 80 J = 1,N
            KJ = KJ + N
            IF ((J-K).NE.0) A(KJ) = A(KJ)/BIGA
   80     CONTINUE
C
C---- Product of pivots
C
          D = D*BIGA
C
C---- Replace pivot by reciprocal
C
          A(KK) = 1.0/BIGA
        ELSE
          GO TO 130
        END IF
   90 CONTINUE
C
C---- Final row and column interchange
C
      K = N
  100 CONTINUE
      K = (K-1)
      IF (K.GT.0) THEN
        I = L(K)
        IF ((I-K).GT.0) THEN
          JQ = (K-1)*N
          JR = (I-1)*N
          DO 110 J = 1,N
            JK = JQ + J
            HOLD = A(JK)
            JI = JR + J
            A(JK) = -A(JI)
            A(JI) = HOLD
  110     CONTINUE
        END IF
        J = M(K)
        IF ((J-K).GT.0) THEN
          KI = K - N
          DO 120 I = 1,N
            KI = KI + N
            HOLD = A(KI)
            JI = KI - K + J
            A(KI) = -A(JI)
            A(JI) = HOLD
  120     CONTINUE
        END IF
        GO TO 100
      ELSE
        RETURN
      END IF
  130 D = 0.0
C
C
      END
C
C
C_BEGIN_MINV3
C
      SUBROUTINE MINV3(A,B,D)
C     ======================
C
C     Invert a general 3x3 matrix and return determinant in D
C
C     A = (B)-1
C
C     .. Scalar Arguments ..
      REAL            D
C     ..
C     .. Array Arguments ..
      REAL            A(3,3),B(3,3)
C
C_END_MINV3
C     ..
C     .. Local Scalars ..
      INTEGER         I,J
C     ..
C     .. Local Arrays ..
      REAL            C(3,3)
C     ..
C     .. External Functions ..
      REAL            DOT
      EXTERNAL        DOT
C     ..
C     .. External Subroutines ..
      EXTERNAL        CROSS
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC       ABS
C     ..
      CALL CROSS(C(1,1),B(1,2),B(1,3))
      CALL CROSS(C(1,2),B(1,3),B(1,1))
      CALL CROSS(C(1,3),B(1,1),B(1,2))
      D = DOT(B(1,1),C(1,1))
C
C---- Test determinant
C
      IF (ABS(D).GT.1.0E-30) THEN
C
C---- Determinant is non-zero
C
          DO 20 I = 1,3
              DO 10 J = 1,3
                  A(I,J) = C(J,I)/D
   10             CONTINUE
   20         CONTINUE

      ELSE
          D = 0.0
      END IF

      END
C
C
C_BEGIN_RANMAR
C
      SUBROUTINE RANMAR(RVEC,LEN)
C     ===========================
C
C     Universal random number generator proposed by Marsaglia and Zaman
C     in report FSU-SCRI-87-50
C     slightly modified by F. James, 1988 to generate a vector
C     of pseudorandom numbers RVEC of length LEN
C     and making the COMMON block include everything needed to
C     specify completely the state of the generator.
C     Transcribed from CERN report DD/88/22.
C     Rather inelegant messing about added by D. Love, Jan. 1989 to
C     make sure initialisation always occurs.
C     *** James says that this is the preferred generator.
C     Gives bit-identical results on all machines with at least
C     24-bit mantissas in the flotaing point representation (i.e.
C     all common 32-bit computers. Fairly fast, satisfies very
C     stringent tests, has very long period and makes it very
C     simple to generate independly disjoint sequences.
C     See also RANECU.
C     The state of the generator may be saved/restored using the
C     whole contents of /RASET1/.
C     Call RANMAR to get a vector, RMARIN to initialise. 
C     
C  Argument list
C  -------------
C
C     VREC (O)                 (REAL)   Random Vector
C
C     LEN  (I)              (INTEGER)   Length of random vector
C
C
C  For ENTRY point RMARIN
C  ----------------------
C
C     Initialisation for RANMAR.  The input values should
C     be in the ranges: 0<=ij<=31328, 0<=kl<=30081
C     This shows the correspondence between the simplified input seeds
C     IJ, KL and the original Marsaglia-Zaman seeds i,j,k,l
C     To get standard values in Marsaglia-Zaman paper,
C     (I=12, J=34, K=56, L=78) put IJ=1802, KL=9373
C
C     IJ   (I)              (INTEGER)   Seed for random number generator
C
C     KL   (I)              (INTEGER)   Seed for randon number generator
C
C_END_RANMAR
C     
C     ..
C     .. Agruments ..
      REAL RVEC(*)
      INTEGER LEN,IJ,KL
C     ..
C     .. Common Variables ..
      REAL C,CD,CM,U
      INTEGER I97,J97
C     ..
C     .. Local Scalars ..
      REAL S,T,UNI
      INTEGER I,II,IVEC,J,JJ,K,L,M
      LOGICAL INITED
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC MOD
C     ..
C     .. Common Blocks ..
      COMMON /RASET1/ U(97),C,CD,CM,I97,J97
C     ..
C     .. Save Statement ..
      SAVE INITED, /RASET1/
C     ..
C     .. Data Statement ..
      DATA INITED /.FALSE./
C
C---- If initialised, fill RVEC and RETURN. If not, do initialisation
C     and return here later.
C
 1    IF (INITED) THEN
        DO 100 IVEC=1,LEN
          UNI=U(I97)-U(J97)
          IF (UNI.LT.0.) UNI=UNI+1.
          U(I97)=UNI
          I97=I97-1
          IF (I97.EQ.0) I97=97
          J97=J97-1
          IF (J97.EQ.0) J97=97
          C=C-CD
          IF (C.LT.0.) C=C+CM
          UNI=UNI-C
          IF (UNI.LT.0.) UNI=UNI+1.
          RVEC(IVEC)=UNI
 100    CONTINUE
        RETURN
      ENDIF
      I=MOD(1802/177,177)+2
      J=MOD(1802,177)+2
      K=MOD(9373/169,178)+1
      L=MOD(9373,169)
C     
      GOTO 10
C
C---- Initialise and return without filling RVEC
C
      ENTRY RMARIN(IJ,KL)
      I=MOD(IJ/177,177)+2
      J=MOD(IJ,177)+2
      K=MOD(KL/169,178)+1
      L=MOD(KL,169)
      INITED=.TRUE.

 10   CONTINUE
      DO 2 II=1,97
        S=0.
        T=.5
        DO 3 JJ=1,24
          M=MOD(MOD(I*J,179)*K,179)
          I=J
          J=K
          K=M
          L=MOD(53*L+1,169)
          IF (MOD(L*M,64).GE.32) S=S+T
          T=0.5*T
 3      CONTINUE
        U(II)=S
 2    CONTINUE
      C=362436./16777216.
      CD=7654321./16777216.
      CM=16777213./16777216.
      I97=97
      J97=33
      IF (.NOT. INITED) THEN
        INITED=.TRUE.
        GOTO 1
      ENDIF

      END
C
C
C_BEGIN_SCALEV
C
      SUBROUTINE SCALEV(A,X,B)
C     ========================
C
C     Scale vector B with scalar X and put result in A
C
C     .. Scalar Arguments ..
      REAL              X
C     ..
C     .. Array Arguments ..
      REAL              A(3),B(3)
C
C_END_SCALEV
C     ..
C     .. Local Scalars ..
      INTEGER           I
C     ..
      DO 10 I = 1,3
          A(I) = B(I)*X
   10     CONTINUE
      END
C
C
C_BEGIN_TRANSP
C
      SUBROUTINE TRANSP(A,B)
C     ======================
C
C---- Transpose a 3x3 matrix
C
C     A = BT
C
C     .. Array Arguments ..
      REAL              A(3,3),B(3,3)
C
C_END_TRANSP
C     ..
C     .. Local Scalars ..
      INTEGER           I,J
C     ..
      DO 20 I = 1,3
          DO 10 J = 1,3
              A(I,J) = B(J,I)
   10         CONTINUE
   20     CONTINUE
      END
C
C
C_BEGIN_UNIT
C
      SUBROUTINE UNIT(V)
C     =================
C
C    Vector V reduced to unit vector
C
C     .. Array Arguments ..
      REAL            V(3)
C
C_END_UNIT
C     ..
C     .. Local Scalars ..
      REAL            VMOD
      INTEGER         I
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC       SQRT
C     ..
      VMOD = V(1)**2 + V(2)**2 + V(3)**2
      VMOD = SQRT(VMOD)
      DO 10 I = 1,3
          V(I) = V(I)/VMOD
   10     CONTINUE
      END
C
C
C_BEGIN_VDIF
C
      SUBROUTINE VDIF(A,B,C)
C     =====================
C
C      Subtract two vectors
C
C      A = B - C
C
C     .. Array Arguments ..
      REAL            A(3),B(3),C(3)
C
C_END_VDIF
C     ..
C     .. Local Scalars ..
      INTEGER         I
C     ..
      DO 10 I = 1,3
          A(I) = B(I) - C(I)
   10     CONTINUE
      END
C
C
C_BEGIN_VSET
C
      SUBROUTINE VSET(A,B)
C     ====================
C
C      Copy a vector from B to A
C
C     .. Array Arguments ..
      REAL            A(3),B(3)
C
C_END_VSET
C     ..
C     .. Local Scalars ..
      INTEGER         I
C     ..
      DO 10 I = 1,3
          A(I) = B(I)
   10     CONTINUE
      END
C
C
C_BEGIN_VSUM
C
      SUBROUTINE VSUM(A,B,C)
C     ======================
C
C     Add two vectors
C
C     A = B + C
C
C     .. Array Arguments ..
      REAL            A(3),B(3),C(3)
C
C_END_VSUM
C     ..
C     .. Local Scalars ..
      INTEGER         I
C     ..
      DO 10 I = 1,3
          A(I) = B(I) + C(I)
   10     CONTINUE
      END
C
C
C_BEGIN_ZIPIN
C
      SUBROUTINE ZIPIN(ID,N,BUF)
C     ==========================
C
C     Fast binary read on unit ID into real array BUF of length N
C
C     .. Scalar Arguments ..
      INTEGER          ID,N
C     ..
C     .. Array Arguments ..
      REAL             BUF(N)
C
C_END_ZIPIN
C     ..
      READ (ID) BUF
      END
C
C
C_BEGIN_ZIPOUT
C
      SUBROUTINE ZIPOUT(ID,N,BUF)
C     ===========================
C
C     Fast binary write to unit ID of real array BUF length N
C
C     .. Scalar Arguments ..
      INTEGER           ID,N
C     ..
C     .. Array Arguments ..
      REAL              BUF(N)
C
C_END_ZIPOUT
C     ..
      WRITE (ID) BUF
      END
C
C The following routines calculate Bessel functions of
C the first kind, their derivatives, and their zeros.
C Subroutine ZJVX is from Ian Tickle.
C Subroutines JDVX, JVX, GAMMA and functions MSTA1, MSTA2
C are from MJYV at http://iris-lee3.ece.uiuc.edu/~jjin/routines/routines.html
C These routines are copyrighted, but permission is given to incorporate these
C routines into programs provided that the copyright is acknowledged. 

      SUBROUTINE ZJVX(V,IZ,BJ,DJ,X)
C
C     =======================================================
C     Purpose: Compute zero of Bessel function Jv(x)
C     Input :  V     --- Order of Jv(x)
C              IZ    --- Index of previous zero of Jv(x)
C              X     --- Value of previous zero of Jv(x)
C     Output:  BJ(N) --- Jv(x) for N = 0...INT(V)
C              DJ(N) --- J'v(x) for N = 0...INT(V)
C              X     --- Value of next zero of Jv(x)
C
      IMPLICIT NONE
      INTEGER IZ,N
      REAL*8 V,VM,X,X0
      REAL*8 BJ(0:*),DJ(0:*)
C
C#### Initial guess at zero: needs previous value if not first.
      N=V
      IF (IZ.EQ.0) THEN
        X=1.99535+.8333883*SQRT(V)+.984584*V
      ELSEIF (N.LE.10) THEN
        X=X+3.11+.0138*V+(.04832+.2804*V)/(IZ+1)**2
      ELSE
        X=X+3.001+.0105*V+(11.52+.48525*V)/(IZ+3)**2
      ENDIF
C
C#### Polish zero by Newton-Cotes iteration.
1     CALL JDVX(V,X,VM,BJ,DJ)
      IF (INT(VM).NE.N) CALL CCPERR(1,'VM != N in ZJVX.')
      X0=X
      X=X-BJ(N)/DJ(N)
      IF (ABS(X-X0).GT.1D-10) GOTO 1
      END
C
C
      SUBROUTINE JDVX(V,X,VM,BJ,DJ)
C
C     =======================================================
C     Purpose: Compute Bessel functions Jv(x) and their derivatives
C     Input :  x --- Argument of Jv(x)
C              v --- Order of Jv(x)
C                    ( v = n+v0, 0 <= v0 < 1, n = 0,1,2,... )
C     Output:  BJ(n) --- Jn+v0(x)
C              DJ(n) --- Jn+v0'(x)
C              VM --- Highest order computed
C     Routines called:
C          (1) GAMMA for computing gamma function
C          (2) MSTA1 and MSTA2 for computing the starting
C              point for backward recurrence
C     =======================================================
C
      IMPLICIT NONE
      INTEGER J,K,K0,L,M,N
      REAL*8 A,A0,BJV0,BJV1,BJVL,CK,CS,F,F0,F1,F2,GA,PI,PX,QX,R,RP,RP2,
     &RQ,SK,V,V0,VG,VL,VM,VV,X,X2,XK
      PARAMETER(PI=3.141592653589793D0, RP2=.63661977236758D0)
      REAL*8 BJ(0:*),DJ(0:*)
      INTEGER MSTA1,MSTA2
C
      X2=X*X
      N=INT(V)
      V0=V-N
      IF (X.LT.1D-100) THEN
        DO K=0,N
          BJ(K)=0D0
          DJ(K)=0D0
        ENDDO
        IF (V0.EQ.0D0) THEN
          BJ(0)=1D0
          DJ(1)=.5D0
        ELSE
          DJ(0)=1D300
        ENDIF
        VM=V
      ELSE
        IF (X.LE.12D0) THEN
          DO L=0,1
            VL=V0+L
            BJVL=1D0
            R=1D0
            DO K=1,40
              R=-.25D0*R*X2/(K*(K+VL))
              BJVL=BJVL+R
              IF (ABS(R).LT.ABS(BJVL)*1D-15) GOTO 20
            ENDDO
20          VG=1D0+VL
            CALL GAMMA(VG,GA)
            A=(.5D0*X)**VL/GA
            IF (L.EQ.0) THEN
              BJV0=BJVL*A
            ELSEIF (L.EQ.1) THEN
              BJV1=BJVL*A
            ENDIF
          ENDDO
        ELSE
          K0=11
          IF (X.GE.35D0) K0=10
          IF (X.GE.50D0) K0=8
          DO J=0,1
            VV=4D0*(J+V0)*(J+V0)
            PX=1D0
            RP=1D0
            DO K=1,K0
              RP=-.78125D-2*RP*(VV-(4*K-3)**2)*(VV-(4*K-1)**2)/
     &        (K*(2*K-1)*X2)
              PX=PX+RP
            ENDDO
            QX=1D0
            RQ=1D0
            DO K=1,K0
              RQ=-.78125D-2*RQ*(VV-(4*K-1)**2)*(VV-(4*K+1)**2)/
     &        (K*(2*K+1)*X2)
              QX=QX+RQ
            ENDDO
            QX=.125D0*(VV-1D0)*QX/X
            XK=X-(.5D0*(J+V0)+.25D0)*PI
            A0=SQRT(RP2/X)
            CK=COS(XK)
            SK=SIN(XK)
            IF (J.EQ.0) THEN
              BJV0=A0*(PX*CK-QX*SK)
            ELSEIF (J.EQ.1) THEN
              BJV1=A0*(PX*CK-QX*SK)
            ENDIF
          ENDDO
        ENDIF
        BJ(0)=BJV0
        BJ(1)=BJV1
        DJ(0)=V0/X*BJ(0)-BJ(1)
        DJ(1)=BJ(0)-(1D0+V0)/X*BJ(1)
        IF (N.GE.2 .AND. N.LE.INT(.9*X)) THEN
          F0=BJV0
          F1=BJV1
          DO K=2,N
            F=2D0*(K+V0-1D0)/X*F1-F0
            BJ(K)=F
            F0=F1
            F1=F
          ENDDO
        ELSEIF (N.GE.2) THEN
          M=MSTA1(X,200)
          IF (M.LT.N) THEN
            N=M
          ELSE
            M=MSTA2(X,N,15)
          ENDIF
          F2=0D0
          F1=1D-100
          DO K=M,0,-1
            F=2D0*(V0+K+1D0)/X*F1-F2
            IF (K.LE.N) BJ(K)=F
            F2=F1
            F1=F
          ENDDO
          IF (ABS(BJV0).GT.ABS(BJV1)) THEN
            CS=BJV0/F
          ELSE
            CS=BJV1/F2
          ENDIF
          DO K=0,N
            BJ(K)=CS*BJ(K)
          ENDDO
        ENDIF
        DO K=2,N
          DJ(K)=BJ(K-1)-(K+V0)/X*BJ(K)
        ENDDO
        VM=N+V0
      ENDIF
      END
C
C
      SUBROUTINE JVX(V,X,VM,BJ)
C
C     =======================================================
C     Purpose: Compute Bessel functions Jv(x)
C     Input :  x --- Argument of Jv(x)
C              v --- Order of Jv(x)
C                    ( v = n+v0, 0 <= v0 < 1, n = 0,1,2,... )
C     Output:  BJ(n) --- Jn+v0(x)
C              VM --- Highest order computed
C     Routines called:
C          (1) GAMMA for computing gamma function
C          (2) MSTA1 and MSTA2 for computing the starting
C              point for backward recurrence
C     =======================================================
C
      IMPLICIT NONE
      INTEGER J,K,K0,L,M,N
      REAL*8 A,A0,BJV0,BJV1,BJVL,CK,CS,F,F0,F1,F2,GA,PI,PX,QX,R,RP,RP2,
     &RQ,SK,V,V0,VG,VL,VM,VV,X,X2,XK
      PARAMETER(PI=3.141592653589793D0, RP2=.63661977236758D0)
      REAL*8 BJ(0:*)
      INTEGER MSTA1,MSTA2
C
      X2=X*X
      N=INT(V)
      V0=V-N
      IF (X.LT.1D-100) THEN
        DO K=0,N
          BJ(K)=0D0
        ENDDO
        IF (V0.EQ.0D0) BJ(0)=1D0
        VM=V
      ELSE
        IF (X.LE.12D0) THEN
          DO L=0,1
            VL=V0+L
            BJVL=1D0
            R=1D0
            DO K=1,40
              R=-.25D0*R*X2/(K*(K+VL))
              BJVL=BJVL+R
              IF (ABS(R).LT.ABS(BJVL)*1D-15) GOTO 20
            ENDDO
20          VG=1D0+VL
            CALL GAMMA(VG,GA)
            A=(.5D0*X)**VL/GA
            IF (L.EQ.0) THEN
              BJV0=BJVL*A
            ELSEIF (L.EQ.1) THEN
              BJV1=BJVL*A
            ENDIF
          ENDDO
        ELSE
          K0=11
          IF (X.GE.35D0) K0=10
          IF (X.GE.50D0) K0=8
          DO J=0,1
            VV=4D0*(J+V0)*(J+V0)
            PX=1D0
            RP=1D0
            DO K=1,K0
              RP=-.78125D-2*RP*(VV-(4*K-3)**2)*(VV-(4*K-1)**2)/
     &        (K*(2*K-1)*X2)
              PX=PX+RP
            ENDDO
            QX=1D0
            RQ=1D0
            DO K=1,K0
              RQ=-.78125D-2*RQ*(VV-(4*K-1)**2)*(VV-(4*K+1)**2)/
     &        (K*(2*K+1)*X2)
              QX=QX+RQ
            ENDDO
            QX=.125D0*(VV-1D0)*QX/X
            XK=X-(.5D0*(J+V0)+.25D0)*PI
            A0=SQRT(RP2/X)
            CK=COS(XK)
            SK=SIN(XK)
            IF (J.EQ.0) THEN
              BJV0=A0*(PX*CK-QX*SK)
            ELSEIF (J.EQ.1) THEN
              BJV1=A0*(PX*CK-QX*SK)
            ENDIF
          ENDDO
        ENDIF
        BJ(0)=BJV0
        BJ(1)=BJV1
        IF (N.GE.2 .AND. N.LE.INT(.9*X)) THEN
          F0=BJV0
          F1=BJV1
          DO K=2,N
            F=2D0*(K+V0-1D0)/X*F1-F0
            BJ(K)=F
            F0=F1
            F1=F
          ENDDO
        ELSEIF (N.GE.2) THEN
          M=MSTA1(X,200)
          IF (M.LT.N) THEN
            N=M
          ELSE
            M=MSTA2(X,N,15)
          ENDIF
          F2=0D0
          F1=1D-100
          DO K=M,0,-1
            F=2D0*(V0+K+1D0)/X*F1-F2
            IF (K.LE.N) BJ(K)=F
            F2=F1
            F1=F
          ENDDO
          IF (ABS(BJV0).GT.ABS(BJV1)) THEN
            CS=BJV0/F
          ELSE
            CS=BJV1/F2
          ENDIF
          DO K=0,N
            BJ(K)=CS*BJ(K)
          ENDDO
        ENDIF
        VM=N+V0
      ENDIF
      END
C
      SUBROUTINE GAMMA(X,GA)
C
C     ==================================================
C     Purpose: Compute gamma function GA(x)
C     Input :  x  --- Argument of GA(x)
C                     ( x is not equal to 0,-1,-2,... )
C     Output:  GA --- GA(x)
C     ==================================================
C
      IMPLICIT NONE
      INTEGER K,M,M1
      REAL*8 GA,GR,PI,R,X,Z
      PARAMETER(PI=3.141592653589793D0)
      REAL*8 G(26)
      DATA G/1D0, .5772156649015329D0,
     &-.6558780715202538D0, -.420026350340952D-1,
     &.1665386113822915D0, -.421977345555443D-1,
     &-.96219715278770D-2, .72189432466630D-2,
     &-.11651675918591D-2, -.2152416741149D-3,
     &.1280502823882D-3, -.201348547807D-4,
     &-.12504934821D-5, .11330272320D-5,
     &-.2056338417D-6, .61160950D-8,
     &.50020075D-8, -.11812746D-8,
     &.1043427D-9, .77823D-11,
     &-.36968D-11, .51D-12,
     &-.206D-13, -.54D-14, .14D-14, .1D-15/
C
      IF (X.EQ.INT(X)) THEN
        IF (X.GT.0D0) THEN
          GA=1D0
          M1=X-1
          DO K=2,M1
            GA=GA*K
          ENDDO
        ELSE
          GA=1D300
        ENDIF
      ELSE
        IF (ABS(X).GT.1D0) THEN
          Z=ABS(X)
          M=INT(Z)
          R=1D0
          DO K=1,M
            R=R*(Z-K)
          ENDDO
          Z=Z-M
        ELSE
          Z=X
        ENDIF
        GR=G(26)
        DO K=25,1,-1
          GR=GR*Z+G(K)
        ENDDO
        GA=1D0/(GR*Z)
        IF (ABS(X).GT.1D0) THEN
          GA=GA*R
          IF (X.LT.0D0) GA=-PI/(X*GA*DSIN(PI*X))
        ENDIF
      ENDIF
      END
C
      INTEGER FUNCTION MSTA1(X,MP)
C
C     ===================================================
C     Purpose: Determine the starting point for backward
C              recurrence such that the magnitude of
C              Jn(x) at that point is about 10^(-MP)
C     Input :  x     --- Argument of Jn(x)
C              MP    --- Value of magnitude
C     Output:  MSTA1 --- Starting point
C     ===================================================
C
      IMPLICIT NONE
      INTEGER IT,MP,N,N0,N1,NN
      REAL*8 A0,F,F0,F1,X
      REAL*8 ENVJ
      ENVJ(N,X)=.5D0*LOG10(6.28D0*N)-N*LOG10(1.36D0*X/N)
C
      A0=ABS(X)
      N0=INT(1.1D0*A0)+1
      F0=ENVJ(N0,A0)-MP
      N1=N0+5
      F1=ENVJ(N1,A0)-MP
      DO IT=1,20
        NN=N1-(N1-N0)/(1D0-F0/F1)
        F=ENVJ(NN,A0)-MP
        IF(ABS(NN-N1).LT.1) GOTO 20
        N0=N1
        F0=F1
        N1=NN
        F1=F
      ENDDO
20    MSTA1=NN
      END
C
      INTEGER FUNCTION MSTA2(X,N,MP)
C
C     ===================================================
C     Purpose: Determine the starting point for backward
C              recurrence such that all Jn(x) has MP
C              significant digits
C     Input :  x  --- Argument of Jn(x)
C              n  --- Order of Jn(x)
C              MP --- Significant digit
C     Output:  MSTA2 --- Starting point
C     ===================================================
C
      IMPLICIT NONE
      INTEGER IT,MP,N,N0,N1,NN
      REAL*8 A0,F,F0,F1,EJN,HMP,OBJ,X
      REAL*8 ENVJ
      ENVJ(N,X)=.5D0*LOG10(6.28D0*N)-N*LOG10(1.36D0*X/N)
C
      A0=ABS(X)
      HMP=.5D0*MP
      EJN=ENVJ(N,A0)
      IF (EJN.LE.HMP) THEN
        OBJ=MP
        N0=INT(1.1D0*A0)
      ELSE
        OBJ=HMP+EJN
        N0=N
      ENDIF
      F0=ENVJ(N0,A0)-OBJ
      N1=N0+5
      F1=ENVJ(N1,A0)-OBJ
      DO IT=1,20
        NN=N1-(N1-N0)/(1D0-F0/F1)
        F=ENVJ(NN,A0)-OBJ
        IF (ABS(NN-N1).LT.1) GOTO 20
        N0=N1
        F0=F1
        N1=NN
        F1=F
      ENDDO
20    MSTA2=NN+10
      END
C

C
C     pxxml.f: write XML tags into program outout
C     Copyright (C) 2001  Alun Ashton
C
C     This library is free software: you can redistribute it and/or
C     modify it under the terms of the GNU Lesser General Public License
C     version 3, modified in accordance with the provisions of the 
C     license to address the requirements of UK law.
C 
C     You should have received a copy of the modified GNU Lesser General 
C     Public License along with this library.  If not, copies may be 
C     downloaded from http://www.ccp4.ac.uk/ccp4license.php
C 
C     This program is distributed in the hope that it will be useful,
C     but WITHOUT ANY WARRANTY; without even the implied warranty of
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C     GNU Lesser General Public License for more details.
C
C
C
C    =========
C    pxxml.f
C    =========
C
C     Author  : a.w.ashton@ccp4.ac.uk
C     Version : 1.0  
C     future  : translate to C or C++
C  
C    Assumption 1 : Exsisting/New file
C     XML files are only to be writen from new. The design must take into consideration 
C     the possability of future extension so that XML file might be reopned. 
C
C    Assumption 2 : Sizes
C     The maximum size for an Element value or name is 80 characters.
C     The maximum size for an Attribute value or name is 80 characters. 
C     The maximum size for program name is 20 characters.
C     The maximum size for XML filename – including path is 70 characters.
C     The maximum number of elements is 80.
C
C    Assumption 3: Language
C     In the first instance the libs will be writen in fortran to test the other 
C     assumptions!

C     SUBROUTINE XMLOpen (XMLFileUnit, rootvalue, ifail)
C
C     First subroutine to be called.
C     Arguments: 	XMLFIleUnit : Input - No value
C                           Output returns the file Unit number
C               root value = eg html
C		Ifail : same as usual!
C
C     Purpose: open an XML file.
C
C     See if XMLFILE has been assigned e.g. on command line.
C     If XMLFILE not assigned use program name.xml.
C     If file exists overwrite it.
C     Write out the header.
C     No provision for existing XML files to be reopened

      subroutine XMLOpen (XMLFileUnit, rootvalue, ifail)

      logical ccpexs
      
      character*(*) rootvalue

      integer XMLFileUnit, ifail, elementstatus(80), elementnumber 
      character*80 openelements(80), XMLFileName
      character*1024 XMLOutputLine

      character version*10, date*8, progname*32
      
      common /ccp4xmld/ elementnumber, elementstatus, openelements, 
     $     XMLFileName,XMLOutputLine

      integer lenstr
      external ccpexs,lenstr

      XMLFileName=' '
      elementnumber=0
      elementstatus(1)=0

      call ccp4_version(version)
      call ccpdat(date)
      call ccppnm(progname)

      call ugtenv('XMLFILE',XMLFileName)

      if (XMLFileUnit.ne.6) then
        if (XMLFileName.eq.' ') 
     +       XMLFileName=progname(1:lenstr(progname))//'.xml'
        
        if (ccpexs(XMLFileName)) call ccperr(2,'XMLFILE OVERWRITTEN')
        
        call ccpdpn(XMLFileUnit,XMLFileName,'UNKNOWN','F',0,ifail)
      endif

C     check to see if the rootvalue has a value or default to html
      if (lenstr(rootvalue).le.1) rootvalue='html'

      if (rootvalue(1:lenstr(rootvalue)).ne.'html') 
     $     write (XMLFileUnit,'(A)') '<?xml version="1.0"?>'

      call XMLOpenElement(XMLFileUnit, rootvalue(1:lenstr(rootvalue)), 
     $     ifail) 

      if (rootvalue(1:lenstr(rootvalue)).ne.'html') then
C     First element should be information about the program
        call XMLOpenElement(XMLFileUnit, 
     $       progname(1:lenstr(progname)), ifail)
        call XMLWriteAttribute(XMLFileUnit, 
     $       progname(1:lenstr(progname)),
     $       'ccp4_version', version(1:lenstr(version)), ifail)
        call XMLWriteAttribute(XMLFileUnit, 
     $       progname(1:lenstr(progname)),
     $   'date', date(1:lenstr(date)), ifail)
        call XMLCloseElement(XMLFileUnit, progname(1:lenstr(progname)), 
     $       ifail)
      endif

      return
      end

C      subroutine XMLWriteJournalCitation(XMLFileUnit, AuthorsString, 
C     +  JournalString, VolumeString, PageStart, PageEnd, YearString, 
C     +  ifail)
C      For example:
C        call XMLWriteJournalCitation(XMLFILEUNIT,'B.W.Matthews',
C     +   'J.Mol.Biol.','33','491','497','1968',ifail)
C      If using the Bioxhit schema, this should only be called once 
C      for each processing_stage.

      subroutine XMLWriteJournalCitation(XMLFileUnit, AuthorsString, 
     +  JournalString, VolumeString, IssueString, PageStart, PageEnd, 
     +  YearString, ifail)

      integer XMLFileUnit, ifail
      character*(*) AuthorsString, JournalString, VolumeString, 
     +  IssueString, PageStart, PageEnd, YearString

      call XMLOpenElement(XMLFileUnit,'citation',ifail)

      call XMLWriteElement(XMLFileUnit, 
     +    'citation_type', 'journal', ifail)
      if (AuthorsString.ne.' ') call XMLWriteElement(XMLFileUnit, 
     +    'citation_id', AuthorsString, ifail)
      if (JournalString.ne.' ') call XMLWriteElement(XMLFileUnit, 
     +    'journal_abbreviation', JournalString, ifail)
      if (VolumeString.ne.' ') call XMLWriteElement(XMLFileUnit, 
     +     'journal_volume', VolumeString, ifail)
      if (IssueString.ne.' ') call XMLWriteElement(XMLFileUnit, 
     +     'journal_issue', IssueString, ifail)
      if (PageStart.ne.' ') call XMLWriteElement(XMLFileUnit, 
     +     'page_from', PageStart, ifail)
      if (PageEnd.ne.' ') call XMLWriteElement(XMLFileUnit, 
     +     'page_to', PageEnd, ifail)
      if (YearString.ne.' ') call XMLWriteElement(XMLFileUnit, 
     +     'publication_year', YearString, ifail)

      call XMLCloseElement(XMLFileUnit,'citation',ifail)

      return
      end

C      subroutine XMLWriteMessages(XMLFileUnit, ccperr_level, 
C     +  MessageString, ifail)
C      For example: 
C        call XMLWriteMessage(XMLFileUnit,0,'Normal Termination',ifail)
C      If using the Bioxhit schema, this should only be called once 
C      for each processing_stage.

      subroutine XMLWriteMessages(XMLFileUnit, ccperr_level, 
     +  MessageString, ifail)

      integer XMLFileUnit, ifail, ccperr_level
      character*(*) MessageString
      character MessageCode*4,MessageSeverity*12

      write(MessageCode,'(I4)') ccperr_level
      if (ccperr_level.eq.0) MessageSeverity='information'
      if (ccperr_level.eq.1) MessageSeverity='fatal error'
      if (ccperr_level.eq.2) MessageSeverity='warning'
      if (ccperr_level.eq.3) MessageSeverity='information'
      if (ccperr_level.eq.4) MessageSeverity='information'

      call XMLOpenElement(XMLFileUnit,'messages',ifail)
      call XMLWriteElement(XMLFileUnit, 
     +    'message_code', MessageCode, ifail)
      if (MessageString.ne.' ') call XMLWriteElement(XMLFileUnit, 
     +    'message_text', MessageString, ifail)
      call XMLWriteElement(XMLFileUnit, 
     +    'message_severity', MessageSeverity, ifail)        
      call XMLCloseElement(XMLFileUnit,'messages',ifail)

      return
      end

C subroutine XMLOpenElement(XMLFileUnit, ElementName, ifail)
C     XMLFileUnit - integer - if file not already opened it will be
C     element name = value is char string.
C        completes a tag and reates a sub element but leaves tag open
C        e.g. <oldtag
C             >
C              <leftopen

      subroutine XMLOpenElement(XMLFileUnit, ElementName, ifail)

      logical ccpexs

      character*(*) ElementName
      character*32 progname

      character*80 indentline
      integer indent

      integer XMLFileUnit, ifail, elementstatus(80), elementnumber 
      character*80 openelements(80), XMLFileName
      character*1024 XMLOutputLine
      
      common /ccp4xmld/ elementnumber, elementstatus, openelements,
     $     XMLFileName,XMLOutputLine
c      save /ccp4xml/

      integer lenstr
      external ccpexs,lenstr

      indentline=' ' 

      if (.not.ccpexs(XMLFileName) .and. .not.(XMLFileUnit.eq.6)) then
        call ccppnm(progname)
        call ccplwc(progname)
        call XMLOpen (XMLFileUnit,progname(1:lenstr(progname)), ifail)
      endif

      elementnumber=elementnumber+1

      openelements(elementnumber)=ElementName(1:lenstr(ElementName))

      if (elementnumber.eq.1) then
        if (elementstatus(1).ne.2) then       
          write (XMLFileUnit, 95) ElementName(1:lenstr(ElementName))
          elementstatus(elementnumber) = 2
        endif
        return
      endif

c     close previous element if needed
      if (elementnumber.gt.1) then
        if (elementstatus(elementnumber-1).eq.1) then
c     add the closing bracket and print
          write (XMLOutputLine(lenstr(XMLOutputLine)+1:),100)
          write (XMLFileUnit,'(a)') 
     $              XMLOutputLine(1:lenstr(XMLOutputLine))
          XMLOutputLine = ' '
c     change status to complete and open
          elementstatus(elementnumber-1)=2
        endif
      endif
c
c     open current element
c     firstly indent line
      do 10 indent = 1, elementnumber
        write (indentline(indent:indent), 110)
 10   continue
c     write indent and tag
      write (XMLOutputLine,130) indentline(1:elementnumber),
     $     ElementName(1:lenstr(ElementName))

      elementstatus(elementnumber)=1

c unindented tag
 95   format(' <',a,'>')
c tag end and start...
 100  format('>')
 105  format('<')
c this is the indent
 110  format(' ')
c simply a string...
 120  format(a)
c indented open tag
 130  format(a,'<',a)
      return
      end

C     subroutine XMLWriteAttribute 
C     ElementName - if element not already opened then it will be
C     these are strings: AttributeName, AttributeValue,
C
      subroutine XMLWriteAttribute(XMLFileUnit, ElementName,
     $     AttributeName, AttributeValue, ifail)

      integer lenstr

      character*(*) ElementName, AttributeName, AttributeValue

      integer indent

      integer XMLFileUnit, ifail, elementstatus(80), elementnumber 
      character*80 openelements(80), XMLFileName
      character*1024 XMLOutputLine
      
      common /ccp4xmld/ elementnumber, elementstatus, openelements,
     $     XMLFileName,XMLOutputLine
c      save /ccp4xml/

      external lenstr

c     firstly check element is open otherwise open!
      if (elementstatus(elementnumber).ne.1) then
        call XMLOpenElement(XMLFileUnit, ElementName, ifail)
      endif 

c     secondly write the attribute 
      write (XMLOutputLine(lenstr(XMLOutputLine)+1:), 120) 
     $     AttributeName(1:lenstr(AttributeName)),
     $     AttributeValue(1:lenstr(AttributeValue))


c this is the indent
 110  format(' ')
c simply a string...
 120  format('  ',a,'="',a,'" ')

      return
      end

C     subroutine XMLWriteElement
C     for inputing the value of the element. if its not already opened
C     it will be. Closes the element as well
C
      subroutine XMLWriteElement(XMLFileUnit, ElementName,
     $     ElementValue, ifail)
      
      character*(*) ElementName, ElementValue

      integer XMLFileUnit, ifail, elementstatus(80), elementnumber 
      character*80 openelements(80), XMLFileName
      character*1024 XMLOutputLine
      
      common /ccp4xmld/ elementnumber, elementstatus, openelements,
     $     XMLFileName,XMLOutputLine
c      save /ccp4xml/

      integer lenstr
      external lenstr

      if (ElementName(1:lenstr(ElementName)).ne.
     $     openelements(elementnumber)) then
        call XMLOpenElement(XMLFileUnit, ElementName, ifail)
      endif

      if (elementnumber.ne.1) then
c     complete element and give the value
        write (XMLOutputLine(lenstr(XMLOutputLine)+1:), 125) 
     $               ElementValue(1:lenstr(ElementValue))
        elementstatus(elementnumber)=2
      endif

      call XMLCloseElement(XMLFileUnit, ElementName, ifail)
      

c an indented string
 125  format('>',a)

      return
      end

c subroutine XMLCloseElement
C the subroutine will close the element if it is the current element
C or go up the tree closing all elements till it reaches teh one specified.
C if its the root element being specified then it will close the file as well.
C
      subroutine XMLCloseElement(XMLFileUnit, ElementName, ifail)

      character*(*) ElementName

      character*80 indentline
      integer indent, elementlength

      integer XMLFileUnit, ifail, elementstatus(80), elementnumber 
      character*80 openelements(80), XMLFileName
      
      integer lenstr
      external lenstr
      character*1024 XMLOutputLine

      common /ccp4xmld/ elementnumber, elementstatus, openelements,
     $     XMLFileName,XMLOutputLine
c      save /ccp4xml/

c  sanity check to see if element is open
      do i = elementnumber,1,-1
        if (ElementName(1:lenstr(ElementName)).eq.
     $     openelements(i)) goto 1
      enddo
      call ccperr(2,'XMLCloseElement: trying to close wrong element')
      return

 1    continue

      elementlength=lenstr(openelements(elementnumber))

      indentline=' '
      indent=0

      do 10 indent = 1, elementnumber
        write (indentline(indent:indent), 110)
 10   continue

      if (ElementName(1:lenstr(ElementName)).ne.
     $     openelements(elementnumber)) then
C     if the element to close is not the open one then close 
C     the open one - can assume its just e.g. <wibble and not
C     <wibble> so only need a />
        write (XMLOutputLine(lenstr(XMLOutputLine)+1:), 155)
        write (XMLFileUnit,'(a)') 
     $              XMLOutputLine(1:lenstr(XMLOutputLine))
        XMLOutputLine = ' '
        openelements(elementnumber)=' '
        elementstatus(elementnumber)=0
        elementnumber=elementnumber-1
        goto 1
      else
        if (elementstatus(elementnumber).eq.1) then
          write (XMLOutputLine(lenstr(XMLOutputLine)+1:), 155)
          elementstatus(elementnumber)=2
          write (XMLFileUnit,'(a)') 
     $              XMLOutputLine(1:lenstr(XMLOutputLine))
          XMLOutputLine = ' '
        else
          if (lenstr(XMLOutputLine).eq.0) then
            write (XMLOutputLine,145) indentline(1:elementnumber),
     $            openelements(elementnumber)(1:elementlength)
          else
            write (XMLOutputLine(lenstr(XMLOutputLine)+1:), 150)
     $         openelements(elementnumber)(1:elementlength)
          endif
          write (XMLFileUnit,'(a)') 
     $              XMLOutputLine(1:lenstr(XMLOutputLine))
          XMLOutputLine = ' '
        endif
        openelements(elementnumber)=' '
        elementstatus(elementnumber)=0
        elementnumber=elementnumber-1
      endif

      if (elementnumber.eq.0) then
        close (XMLFileUnit)
      endif

c this is the indent
 110  format(' ')
c indented complete end tag
 145  format(a,'</',a,'>')
c indented complete end tag
 150  format('</',a,'>')
c indented complete end tag
 155  format(' />')

      return
      end 

C
C     w32mvs.f: platform-dependent low-level functions for MVS
C     Copyright (C) 1999  Alun Ashton
C
C     This library is free software: you can redistribute it and/or
C     modify it under the terms of the GNU Lesser General Public License
C     version 3, modified in accordance with the provisions of the 
C     license to address the requirements of UK law.
C 
C     You should have received a copy of the modified GNU Lesser General 
C     Public License along with this library.  If not, copies may be 
C     downloaded from http://www.ccp4.ac.uk/ccp4license.php
C 
C     This program is distributed in the hope that it will be useful,
C     but WITHOUT ANY WARRANTY; without even the implied warranty of
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C     GNU Lesser General Public License for more details.
C
C  *** this file is an equivelant to unix.f or vms.for but 
C  *** for the microsoft visual studio packages.
C
C ========
C w32mvs.f
C ========
C
C CCPOPN - open a file
C UBYTES - Returns number of bytes per word and 'words'/'bytes'
C          to indicate if byte handling is available
C UCPUTM - Get CPU time
C UGERR  - Get error explanation
C UGTENV - Get value of env. variable
C UGTUID - Get user id - it's name
C UIDATE - Get date in 3 integer 
C UISATT - Is file a terminal?
C USTIME - Get absolute time in seconds (-1 for VMS)
C UTIME  - Get current time
C VAXVMS - Logical function returns TRUE if VAX/VMS
C WINMVS - Logical function returns TRUE if W32/Microsoft dev studio
C TTSEND - Write string to terminal with various carriage control
C     options
C GETELAPSED - Print timing info for CCPERR - removed for now
C UGTARG - Get command-line argument
C GETREF - Abstracted from abscale since it has BYTE declaration.
C CCPSPW - Spawns a new process to run shell command
C RTNBKS - Returns a Backslash as unix compilers are fussy!
C
C
      SUBROUTINE CCPOPN(IIUN,LOGNAM,KSTAT,ITYPE,LREC,IFAIL)
C     ====================================================
C
C---- This subroutine is used to open a file
C
C     The requirement to specify that leading carriage control
C     characters in the output records should be obeyed (or not) can't
C     be implemented portably; likewise specifying readonly opening.
C     Some compilers accept VAXtran `carriagecontrol=' and `readonly'
C     specifiers; if so we use them.  Others have IOINIT, which can be
C     used to specify the carriage control.  The HPUX compiler is said
C     not to have any means of doing this and AIX seems to be likewise,
C     sigh; they both seem to obey the normal unix convention of
C     printing the  as-is rather than obeying the first character
C     as carriage control.  Concentrix does obey the first column a la
C     VMS and `traditional' Fortran; the MIPS compilers have a compile
C     (link?) option to do so.  Unfortunately, carriagecontrol
C     specification isn't even defined in Fortan90, although
C     `ACTION="READ"' can be used.
C
C PARAMETERS
C ==========
C
C        IIUN (I)   UNIT NUMBER
C      LOGNAM (I)   LOGICAL FILE NAME (UP TO 8 CHARACTERS)
C       KSTAT (I)   FILE STATUS FLAG =1, 'UNKNOWN'
C                                    =2, 'SCRATCH'
C                                    =3, 'OLD'
C                                    =4, 'NEW'
C                                    =5, 'READONLY'
C                                    =6, 'PRINTER'
C       ITYPE (I)   FILE TYPE FLAG =1, 'SEQUENTIAL' 'FORMATTED'
C                                  =2, 'SEQUENTIAL' 'UNFORMATTED'
C                                  =3, 'DIRECT'     'FORMATTED'
C                                  =4, 'DIRECT'     'UNFORMATTED'
C        LREC (I)   RECORD LENGTH FOR DIRECT ACCESS FILE (NO. OF
C                   CHARACTERS FOR A FORMATTED FILE OR WORDS FOR
C                   AN UNFORMATTED FILE). NOT RELEVANT FOR A SEQUENTIAL
C                   FILE
C       IFAIL (I/O) ON INPUT:     =0, STOP ON OPEN FAILURE
C                                 =1, CONTINUE AFTER OPEN FAILURE
C                                 =2, CONTINUE SILENTLY AFTER OPEN FAILURE
C                   ON OUTPUT:    UNCHANGED IF FILE OPEN OK
C                                 =-1, ERROR IN OPENING FILE
C
C     .. Scalar Arguments ..
      INTEGER IFAIL,KSTAT,ITYPE,IIUN,LREC
      CHARACTER LOGNAM* (*)
C     ..
C     .. Local Scalars ..
      INTEGER LLREC,IUN,IBYTES,ISTAT,L,IOS
      CHARACTER CCNTRL*7,ST*7,FRM*12,ERRSTR*500,
     +     NAMFIL*255,HANDLE*5,OPNVAR*20, access*10
      INTEGER UNKNWN, SCRTCH, OLD, NEW, RDONLY, PRINTR
      PARAMETER (UNKNWN=1, SCRTCH=2, OLD=3, NEW=4, RDONLY=5, PRINTR=6)
      LOGICAL CCPEXS, LNONAM
C     ..
C     .. Local Arrays ..
      CHARACTER STAT(6)*7, DISP*6
C     ..
C     .. External Functions ..
      INTEGER LENSTR, LUNSTO
      EXTERNAL LENSTR, LUNSTO
C     ..
C     .. External Subroutines ..
      EXTERNAL UGERR,UGTENV, CCPEXS
C     ..
C     .. Data statements ..
C     NB mustn't have SCRATCH in here, because result is system
C     -dependent

c     but as this is a system dependant file its ok!
      DATA STAT/'UNKNOWN','SCRATCH','OLD','NEW','OLD','UNKNOWN'/
C     ..
C     
      ISTAT = KSTAT
C     Negative unit number means don't give messages for successful open
      IUN = IIUN
      IF (IIUN.LT.0) IUN = -IIUN
C     Check args:
      IF (ISTAT.LT.1 .OR. ISTAT.GT.6 .OR. ITYPE.LT.1 .OR. ITYPE.GT.4)
     +     THEN 
        IF (IFAIL.EQ.0) THEN
          CALL CCPERR(1,
     +         '**CCPOPN ERROR** Invalid parameters in call')
        ELSE
          WRITE (LUNSTO(1),
     +         '('' **CCPOPN ERROR** Invalid parameters in call'',/)')
          IFAIL = -1
        END IF
        RETURN
      ENDIF 
C
C     Do nothing for pre-connected units (what's the significance of
C     `TERM...'?) 
      IF (LOGNAM.EQ.'DATA' .OR. LOGNAM.EQ.'PRINTER' .OR.
     +     LOGNAM(:4).EQ.'TERM') RETURN
C
C     if environment variable CCP4_OPEN has value `UNKNOWN', open files
C     with status UNKNOWN rather than new if they exist
      IF (ISTAT.EQ.NEW) THEN
        OPNVAR = ' '
        CALL UGTENV('CCP4_OPEN',OPNVAR)
        IF (OPNVAR.EQ.'UNKNOWN' .OR. OPNVAR.EQ.'unknown') ISTAT = 1
      END IF
C
C     check for `logical name' referencing real file
      CALL UGTENV(LOGNAM,NAMFIL)
      LNONAM = .FALSE.
      IF (NAMFIL.EQ.' ') THEN
        IF (.NOT. CCPEXS(LOGNAM)) LNONAM = .TRUE.
        NAMFIL = LOGNAM
      END IF
C     VMS null device (VMS code canonicalises /dev/null)
      IF (NAMFIL.EQ.'NL:' .OR. NAMFIL.EQ.'nl:') NAMFIL='/dev/null'
C     Special case:  /dev/null should be opened UNKNOWN
      IF ( NAMFIL.EQ.'/dev/null') ISTAT = 1
C
C     type of open
      ST = STAT(ISTAT)
      IF (ITYPE.EQ.2 .OR. ITYPE.EQ.4) THEN
        FRM = 'UNFORMATTED'
      ELSE
        FRM = 'FORMATTED'
      ENDIF 
      IF (ITYPE .EQ. 1 .OR. ITYPE.EQ.2) THEN
        ACCESS='SEQUENTIAL'
      ELSE
        ACCESS='DIRECT'
      ENDIF
C
      IF (ISTAT.EQ.SCRTCH) THEN
        DISP = 'DELETE'
      ELSE
        DISP = 'KEEP'
      ENDIF
C     
      IF (access.eq.'DIRECT') THEN
C       Need to check is record length in words or bytes and set LLREC
C       accordingly. 
        CALL UBYTES (IBYTES,HANDLE)
        LLREC = LREC*IBYTES
        IF (HANDLE.EQ.'WORDS'.AND.ITYPE.EQ.4) LLREC=LLREC/IBYTES
        IF (ISTAT.EQ.RDONLY) THEN
C          may be defined as null or as `READONLY,'
          OPEN(UNIT=IUN,STATUS='UNKNOWN',ACCESS='DIRECT',FORM=FRM,
     +         READONLY,
     +         FILE=NAMFIL,RECL=LLREC,IOSTAT=IOS,ERR=5)
        ELSE
          OPEN(UNIT=IUN,STATUS='UNKNOWN',ACCESS='DIRECT',FORM=FRM,
     +         DISPOSE=DISP,
     +         FILE=NAMFIL,RECL=LLREC,IOSTAT=IOS,ERR=5)
        ENDIF 
      ELSE
C       if available, carriagecontrol='fortran' for print file, else = 
C       'list'.  we can use ioinit instead where it's available (see e.g.
C       Sun manual). 
        IF (ISTAT.EQ.PRINTR) THEN
C         want to obey  characters in column 1
          CCNTRL = 'FORTRAN'
          FRM = 'FORMATTED'
        ELSE
C         no special significance to column 1
          CCNTRL = 'LIST'
        END IF
        IF (FRM .EQ. 'UNFORMATTED') THEN
C         (carriage control not relevant)
          IF (ISTAT.EQ.RDONLY) THEN
            OPEN(UNIT=IUN, FILE=NAMFIL, STATUS=ST, ACCESS='SEQUENTIAL',
     +           READONLY,
     +           FORM=FRM, ERR=5, IOSTAT=IOS)
          ELSE
            OPEN(UNIT=IUN, FILE=NAMFIL, STATUS=ST, ACCESS='SEQUENTIAL',
     +           DISPOSE=DISP,
     +           FORM=FRM, ERR=5, IOSTAT=IOS)
          ENDIF
        ELSE
          IF (ISTAT.EQ.RDONLY) THEN
            OPEN(UNIT=IUN, FILE=NAMFIL, STATUS=ST, ACCESS='SEQUENTIAL',
     +           READONLY,
     +           CARRIAGECONTROL=CCNTRL,
     +           FORM=FRM, ERR=5, IOSTAT=IOS)
          ELSE
            OPEN(UNIT=IUN, FILE=NAMFIL, STATUS=ST, ACCESS='SEQUENTIAL',
     +           CARRIAGECONTROL=CCNTRL,
     +           DISPOSE=DISP,
     +           FORM=FRM, ERR=5, IOSTAT=IOS)
          ENDIF
        ENDIF
      ENDIF
C
C     Scratch files are immediately unlinked from the directory; they
C     become inaccessible only when closed, but don't appear in the
C     directory and the name can be re-used.
C     NB this may break with REWIND if that is implemented as close +
C     reopen, sigh.  See also  above
c  *** this now removed for windows. we will try actually opeing scratch files instead
c	IF (ISTAT.EQ.SCRTCH) CALL CUNLINK(NAMFIL)
C
C     Error check
 5    CONTINUE
C     don't report UNKNOWN if actually SCRATCH
      IF (ISTAT.EQ.SCRTCH) ST = 'SCRATCH'
      IF (IOS.NE.0) THEN
        CALL UGERR(IOS,ERRSTR)
        IF (IFAIL.EQ.0) THEN
C         warning if there was no file associated with logical name
          IF (LNONAM) THEN
             ERRSTR = 'CCPOPN Logical name '//LOGNAM
             ERRSTR(LENSTR(ERRSTR)+2:) = 'has no associated file name'
             CALL CCPERR(2,ERRSTR)
          END IF
C         hard failure
          WRITE (LUNSTO (1),FMT=6002) IUN, NAMFIL(1:LENSTR(NAMFIL)),
     +         LOGNAM(1:LENSTR(LOGNAM))
 6002     FORMAT (' Open failed: Unit:',I4,', File: ',A, ' (logical: ',
     +         A, ')')
          ERRSTR = ' Open failed: File: ' // NAMFIL
          CALL CCPERR(-1, ERRSTR)
        else
C         soft failure
          IF (IFAIL.EQ.1) WRITE (lunsto (1),FMT=6004) FRM, ST, IUN, 
     +         LOGNAM(1:LENSTR(LOGNAM)), NAMFIL(1:LENSTR(NAMFIL)),
     +         ERRSTR(1:LENSTR(ERRSTR))
 6004     FORMAT (' **CCPOPN ERROR**  ',A,3X,A,
     +         ' file open failure on unit ',I3,/' Logical name: ',
     +         A,', ','File name: ',A/1X,A/)
          IFAIL = -1
          RETURN            
        ENDIF
      ELSE
        IF (IIUN.LE.0) RETURN 
        WRITE (ERRSTR,FMT=6000) FRM,ST,IUN
        CALL QPRINT (1, ' ')
        CALL QPRINT (1, ERRSTR)
        call ccp4h_summary_beg()
        ERRSTR = 'Logical name: '
        ERRSTR (15:) = LOGNAM
        L = MIN(LENSTR (ERRSTR) + 1, LEN (ERRSTR))
        ERRSTR (L:) = ', Filename: ' // NAMFIL
        CALL QPRINT (1, ERRSTR)
        call ccp4h_summary_end()
        CALL QPRINT (1, ' ')
 6000 FORMAT (A,3X,A,' file opened on unit ',I3)
      ENDIF 
      END
C
C
C     ==============================
      SUBROUTINE UBYTES(INUM,STRING)
C     ==============================
C
C UBYTES - Return statistics about byte handling
C
C Input:  none
C
C Output:    INUM - number of bytes per word
C            HANDLE - 'WORDS' or 'BYTES'
C            HANDLE - For unformatted files records are usually
C                     counted in 'BYTES', however both VAX and 
C                     SGI swap to 'WORDS' for this file type.
C
C Arguments: INTEGER     INUM
C            CHARACTER*5 HANDLE
C
C Usage:     CALL UBYTES (INUM,HANDLE)
C
C     .. Scalar Arguments ..
      INTEGER INUM
      CHARACTER STRING*5
C     ..
C
C
      INUM = 4
      STRING = 'BYTES'
C
      END
C
C
C     ======================
      SUBROUTINE UCPUTM(SEC)
C     ======================
C
C     Get CPU time in seconds
C
C     Parameter:
C     REAL SEC (i/o): If sec<=0.0, initialize timer and return current
C                     elapsed cpu time since start of execution, otherwise
C                     return elapsed cpu since timer was initialized.
C                     Time is in seconds.
C
C     .. Scalar Arguments ..
      REAL SEC
C     ..
C     .. Local Scalars ..
      REAL TLAST
C     ..
C     .. Local Arrays ..
      REAL TARRAY(2)
C     ..
C     .. Save statement ..
      SAVE TLAST
C     ..
      IF (SEC.LE.0.0) THEN
        TLAST = ETIME (TARRAY)
        SEC = TLAST
      ELSE
        SEC = ETIME (TARRAY) - TLAST
      ENDIF
      
      END
C
C
C     ===============================
      SUBROUTINE UGERR(STATUS,ERRSTR)
C     ===============================
cDEC$ IF DEFINED (__INTEL_COMPILER) 
      USE IFCORE 
cDEC$ ENDIF
C UGERR - Get error message string for error number in STATUS
C     (supposedly).  Actually it ignores STATUS and always uses the
C     *last* error that occurred.
C
C Input:     STATUS - Error number (if negative print error message)
C
C Output:    ERRSTR - Error message string
C
C Arguments: INTEGER       STATUS
C            CHARACTER*(*) ERRSTR
C
C Usage:     CALL UGERR(STATUS, ERRSTR)
C
C     .. Scalar Arguments ..
      INTEGER STATUS
      CHARACTER ERRSTR* (*)
C     ..
C     .. Local Scalars ..
      LOGICAL IPRINT
C     ..
C     .. External Subroutines ..
      INTEGER IERRNO, LUNSTO
      EXTERNAL IERRNO, LUNSTO
C     ..
      IPRINT = .FALSE.
      IF (STATUS.LT.0) THEN
        IPRINT = .TRUE.
        STATUS = -STATUS
      END IF
C
C---- Get error message from system
C
      IF (IERRNO().NE.0) THEN
        CALL GERROR(ERRSTR)
      ELSE
        ERRSTR = ' '
      ENDIF
      IF (IPRINT) WRITE (LUNSTO(1),FMT=6000) 'UGERR',ERRSTR
C
 6000 FORMAT (' ',A,': ',A)
      END
C
C     ================================
      SUBROUTINE UGTENV(NAMENV,VALENV)
C     ================================
C
C UGTENV - Get value of env. variable
C
C Input:     NAMENV - Logical Name (trailing blanks are stripped)
C
C Output:    VALENV - Its value
C
C Arguments: CHARACTER*(*) NAMENV, VALENV
C
C Usage:     CALL UGTENV(NAMENV, VALENV)
C
C     .. Scalar Arguments ..
      CHARACTER NAMENV* (*),VALENV* (*)
C     ..
C     .. External Subroutines ..
C     don't declare getenv
      INTEGER LENSTR
      EXTERNAL LENSTR
C     ..
      CALL GETENV(NAMENV(:LENSTR(NAMENV)),VALENV)
C
      END
C
C
C     =========================
      SUBROUTINE UGTUID(USRNAM)
C     =========================
C
C UGTUID - Get user ID
C
C Customised for win nt
C
C Input:     none
C
C Output:    UID - user ID string
C
C Arguments: CHARACTER*(*) UID
C
C Usage:     CALL UGTUID(UID)
C
C     .. Scalar Arguments ..
      CHARACTER USRNAM* (*)
C     ..
C     .. External Subroutines ..
C     don't declare getenv
C     ..
C      CALL GETENV('USER',USRNAM)
      CALL GETLOG(USRNAM)
      IF (USRNAM.EQ.' ') CALL GETENV('LOGNAME',USRNAM)
C
      END
C
C
C     ====================================
      SUBROUTINE UIDATE(IMONTH,IDAY,IYEAR)
C     ====================================
C
C UIDATE - Get date in 3 integer . Alliant uses INTEGER*4
C          and order is IDAY,IMONTH,IYEAR
C
C Input:     none
C
C Output:    MONTH,DAY,YEAR
C
C Arguments: INTEGER MONTH, DAY, YEAR
C
C Usage:     CALL UIDATE(MONTH, DAY, YEAR)
C
C     .. Scalar Arguments ..
      INTEGER IDAY,IMONTH,IYEAR
C     .. Local Arrays ..
      INTEGER IARRAY(3)
C     ..
C     don't declare IDATE -- it's often an intrinsic to avoid confusion
C     between the two possible calling sequences.  On SGI, it's only
C     documented in one style but seems to work with the canonical
C     Unix one too; however, the order of the arguments of the
C     documented version (used here) *isn't* the same as for VMS...
C
      CALL IDATE (IARRAY(1), IARRAY(2), IARRAY(3))
      IDAY = IARRAY(1)
      IMONTH = IARRAY(2)
      IYEAR = IARRAY(3)
C
      END
C
C
C     ==============================
      SUBROUTINE UISATT(FLUN,ANSWER)
C     ==============================
C
C UISATT - This function determines whether a program is being
C          run on-line if this information is available.
C
C Input:     FLUN - Fortran Unit Number
C
C Output:    ANS - 1 for on-line, 0 otherwise
C
C Arguments: INTEGER FLUN, ANS
C
C Usage:     CALL UISATT (FLUN,ANS)
C
C     .. Scalar Arguments ..
      INTEGER ANSWER,FLUN
C     ..
      LOGICAL ISATTY
      EXTERNAL ISATTY
      ANSWER = 0
      IF (ISATTY(FLUN)) ANSWER = 1
C
      END
C
C
C     =======================
      SUBROUTINE USTIME(ISEC)
C     =======================
C
C USTIME - Get absolute time in seconds.
C          Convex uses STIME (), others seem to use TIME ().
C
C Input:     none
C
C Output:    SEC
C
C Arguments: INTEGER SEC
C
C Usage:     CALL USTIME(SEC)
C
      INTEGER ISEC
C
      INTEGER TIME
C
      ISEC = TIME()
C
      END
C
C
C     =======================
      SUBROUTINE UTIME(CTIME)
C     =======================
C
C UTIME - Get current time hh:mm:ss
C
C Input:     none
C
C Output:    TIME - as ASCII string
C
C Arguments: CHARACTER*(*) CTIME
C
C Usage:     CALL UTIME(CTIME)
C
C     .. Scalar Arguments ..
      CHARACTER CTIME* (*)
C     ..
C     .. Local Arrays ..
      INTEGER IARRAY(3)
C     ..
      CALL ITIME(IARRAY)
      WRITE (CTIME,FMT=6000) IARRAY(1),IARRAY(2),IARRAY(3)
 6000 FORMAT (I2,2 (':',I2.2))
      END
C
C
C     =========================
      LOGICAL FUNCTION VAXVMS()
C     =========================
C
C VAXVMS - Operating Sytem in use returns .TRUE. if VAXVMS
C
C Input:     none
C
C Returns:   .TRUE. for VAXVMS, .FALSE. otherwise
C
C Arguments: none
C
C Usage:     VAXVMS ()
C
      VAXVMS = .FALSE.
C
      END
C
C
C     =========================
      LOGICAL FUNCTION WINMVS()
C     =========================
C
C WINMVS - Windows mircrosoft Visual Studio
C
C Input:     none
C
C Returns:   .TRUE. for WINMVS, .FALSE. otherwise
C
C Arguments: none
C
C Usage:     WINMVS ()
C
      WINMVS = .TRUE.
C
      END
C
C
C SUBROUTINE 'TTSEND'
C ===================
C
C Write a string to a terminal with various carriage control options
C for LAUE
C
      SUBROUTINE TTSEND (IUN, STR, ICC)
C
C Parameters:
C
C         IUN (I)   Unit number for the output
C         STR (I)   The string to be output
C         ICC (I)   = 0, no carriage control at the end of the string
C                        (for prompts)
C                        e.g. for routine TPROMP
C                   = 1, normal carriage control
C                        e.g. for routine TWRITE
C                   = 2, no carriage control (for sending escape/control
C                        character sequences to ANSI/T4014 terminals)
C                        e.g. for QSCREEN graphics routines
C                   = 3, Output line at current point on screen (no leading
C                        line feed or carriage return - trailing does not
C                        matter)
C
C Machine dependence examples: Convex   1000  FORMAT (A,$)
C                                       1001  FORMAT (A)
C                                       1002  FORMAT (A,$)
C                                       1003  FORMAT (A)
C                              
C                              Vax      1000  FORMAT (' ',A,$)
C                                       1001  FORMAT (' ',A)
C                                       1002  FORMAT ('+',A,$)
C                                       1003  FORMAT ('+',A)
C
C
C====== Specification statements
C
      CHARACTER*(*) STR
      CHARACTER*10 CCNTRL
C
C====== Write string
C
C     'LIST' is the equivalent of the normal unix state
      CCNTRL = 'LIST'
C     in the case of systems obeying the carriagecontrol specifier, 
C     we assume the stream has actually been opened, so that the
C     specifier is suitably defined -- on the Alliant, for instance,
C     it will be 'UNKNOWN' for an unopened stream (6 is pre-opened)
C
      IF (CCNTRL .EQ. 'FORTRAN') THEN
C       VMS-type
        IF (ICC.EQ.0) THEN
          WRITE (IUN,1004) STR
        ELSE IF (ICC.EQ.2) THEN
          WRITE (IUN,1006) STR
        ELSE IF (ICC.EQ.3) THEN
          WRITE (IUN,1007) STR
        ELSE
          WRITE (IUN,1005) STR
        ENDIF
      ELSE
        IF (ICC.EQ.0) THEN
          WRITE (IUN,1000) STR
        ELSE IF (ICC.EQ.2) THEN
          WRITE (IUN,1002) STR
        ELSE IF (ICC.EQ.3) THEN
          WRITE (IUN,1003) STR
        ELSE
          WRITE (IUN,1001) STR
        ENDIF
      ENDIF
C     these formats are mostly non-standard, of course...
1000  FORMAT (A,$)
1001  FORMAT (A)
1002  FORMAT (A,$)
1003  FORMAT (A)
 1004 FORMAT (' ',A,$)
 1005 FORMAT (' ',A)
 1006 FORMAT ('+',A,$)
 1007 FORMAT ('+',A)
      END
C
C
C     =====================
c      SUBROUTINE GETELAPSED
cC     =====================
cC
c      EXTERNAL LUNSTO, USTIME
c      INTEGER LUNSTO
c      REAL TARRAY(2), JUNK
c      INTEGER ELAPS, START
c      LOGICAL INITED
c      SAVE START, INITED
c      DATA INITED /.FALSE./
cC     
c      JUNK = ETIME(TARRAY)
c      CALL USTIME(ELAPS)
c      ELAPS = ELAPS - START
cC     don't print anything if it hasn't been initialised (by CCPFYP)
c      IF (INITED) WRITE(LUNSTO(1),6000) TARRAY(1), TARRAY(2), 
c     +     ELAPS/60, MOD(ELAPS, 60)
c 6000 FORMAT(' Times: User: ', F9.1, 's System: ', F6.1, 's Elapsed:',
c     +     I5 , ':',I2.2)
cC     
c      ENTRY INITFYP
c      CALL USTIME(START)
c      INITED = .TRUE.
cC     Machine-dependent startup, e.g. set FPE on SunOS

c      END
C
      SUBROUTINE UGTARG(I, ARG)
      INTEGER I
      CHARACTER *(*) ARG
      CALL GETARG(I, ARG)
      END
C     
C     =====================================================
      SUBROUTINE GETREF(KERFLG,NREAD,NSPOTS,DYNAM,MAXOMITL)
C     =====================================================
C
C     This has been abtracted from ABSCALE because of the BYTE
C     declaration.
C
C        implicit none
C     
C     
C     
C     
C     
C     Read one reflection into common /IND/, skipping unmeasured reflections
C     Return 1 if end of file or all N spots found
C     Both integrated and profile fitted I's and SD's are stored, one in
C     INTT,SD and the other in INTT2,SD2. The values in INTT,SD are used
C     in scaling, and this is chosen on input card 1 to be either the 
C     integrated or profile fitted value.
C     
C
C This routine is probably VAX specific in its unpacking of indices
C
C
C
C---- IC  generate file variables
C
C
C
C     .. Scalar Arguments ..
      INTEGER           NREAD,NSPOTS,KERFLG,MAXOMITL
      LOGICAL DYNAM
C     ..
C     .. Scalars in Common ..
      INTEGER           IREC,IX,IY,JGUNIT,JH,JK,JL,MND
      LOGICAL           PROFILE
C     ..
C     .. Arrays in Common ..
      REAL              SPACER(12)
      INTEGER           INTT(3),INTT2(3),ISD(3),ISD2(3),JUNK(2)
C     ..
C     .. Local Scalars ..
      INTEGER           I,ICOL,ICOL2,IER,I4INTS,I4INTP
      BYTE              IR,IM
C     ..
C     .. Local Arrays ..
cejd      INTEGER*2         IBUF(18)
      INTEGER*2         IBUF(19)
      BYTE              B(2)
C     ..
C     .. External Subroutines ..
      EXTERNAL          QREAD
C     ..
C     .. Common blocks ..
       LOGICAL BRIEF
       INTEGER IBRIEF
       COMMON /BRF/ BRIEF,IBRIEF
      COMMON      /IND/JH,JK,JL,MND,JUNK,IX,IY,SPACER,INTT,ISD,
     +            INTT2,ISD2
      COMMON      /INREC/JGUNIT,IREC
      COMMON      /INTTYP/PROFILE
C     ..
C     .. Equivalences ..
      EQUIVALENCE       (B(1),IBUF(4)), (B(1),IR), (B(2),IM)
      EQUIVALENCE       (I4INTS,IBUF(7)),(I4INTP,IBUF(13))
C     ..
      SAVE
C
C
          KERFLG = 0
C
C
   10 CONTINUE
      NREAD = NREAD + 1
C
C
      IF (NREAD.GT.NSPOTS) THEN
          GO TO 40
      ELSE
C
C              *************************
          CALL QREAD(JGUNIT,IBUF,36,IER)
C              *************************
C
          IREC = IREC + 1
          IF (IER.NE.0) THEN
              GO TO 30
C
C---- If rejected, skip to next refl
C
CAL ALLOW IR TO HAVE VALUES 5,6
          ELSE IF ((IR.NE.0).AND.(IR.LE.4)) THEN
              GO TO 10
          END IF
      END IF
C
C
      JH = IBUF(1)
      JK = IBUF(2)
      JL = IBUF(3)
      MND = IM
      IF (MND.LT.0) MND = 8
      IX = IBUF(5)
      IY = IBUF(6)
C
C---- A film intensity in ibuf(7) for integrated intensities or
C     ibuf(13) for profile fitted intensities
C
      IF (PROFILE) THEN
          ICOL = 13
          ICOL2 = 7
      ELSE
          ICOL = 7
          ICOL2 = 13
      END IF
C
C
      DO 20 I = 1,3
          IF (DYNAM) THEN
           ISD(I) = IBUF(ICOL+2)
           ISD2(I) = IBUF(ICOL2+2)
           IF (PROFILE) THEN
             INTT(I) = I4INTP
             INTT2(I) = I4INTS
           ELSE
             INTT(I) = I4INTS
             INTT2(I) = I4INTP
           END IF
          ELSE
           INTT(I) = IBUF(ICOL)
           ISD(I) = IBUF(ICOL+1)
           INTT2(I) = IBUF(ICOL2)
           ISD2(I) = IBUF(ICOL2+1)
          END IF
C
C---- Test for badspots (isd=-9999) change to unmeasured
C     this will also reject overloaded reflections
C-AL   Change this so overloads are rejected (and counted) in RDREF
C
       IF ( (ISD(I)   .EQ. -9999) .AND.
     +      (INTT(I)  .NE. MAXOMITL) )       INTT(I) = -9999
       IF ( (ISD2(I)  .EQ. -9999) .AND.
     +      (INTT2(I) .NE. MAXOMITL) ) 
     +                                     INTT2(I) = -9999
C
C
          ICOL = ICOL + 2
          ICOL2 = ICOL2 + 2
   20     CONTINUE
      RETURN
   30 KERFLG = -1
      RETURN 
   40 KERFLG = -1
      RETURN
C
C
      END
C_BEGIN_CCPSPW
      SUBROUTINE CCPSPW(STRING)
C     =========================
C
C     Spawns a new process to run shell command
C
C Arguments:
C ==========
C
C  STRING (I)   CHARACTER*(*): string containing command
C_END_CCPSPW
C
       CHARACTER STRING*(*)
       EXTERNAL SYSTEM
       CALL SYSTEM(STRING)
       END
C
      SUBROUTINE CCPAL1 (ROUTNE, N, TYPE, LENGTH)
C
C     Arrange to call ROUTNE with N TYPEd array arguments of given
C     LENGTH (see CCPALC)
C
      EXTERNAL ROUTNE
      INTEGER N, TYPE (*), LENGTH (*)
      INTEGER I, SIZES (5), POINTER (12), ISTAT
C     bytes per word (assuming 32 bit words...)
      DATA SIZES /4,4,8,8,1/

C     The calling routine, CCPALC, will have checked that the arguments
C     are in range
      DO I=1,N
        POINTER(I) = malloc(SIZES(TYPE (I))*LENGTH(I))
        IF (POINTER(I) .eq. 0)
     +       CALL CCPERR (-1, 'CCPALC: can''t allocate memory')
        CALL CCPZBI (%VAL(POINTER(I)), SIZES(TYPE (I))*LENGTH(I))
      ENDDO
      IF (N.EQ.1) THEN
        CALL ROUTNE (LENGTH (1), %VAL(POINTER(1)))
      ELSE IF (N.EQ.2) THEN
        CALL ROUTNE (
     +       LENGTH (1), %VAL(POINTER(1)), LENGTH (2), %VAL(POINTER(2)))
      ELSE IF (N.EQ.3) THEN
        CALL ROUTNE (
     +       LENGTH (1), %VAL(POINTER(1)), LENGTH (2), %VAL(POINTER(2)),
     +       LENGTH (3), %VAL(POINTER(3)))
      ELSE IF (N.EQ.4) THEN
        CALL ROUTNE (
     +       LENGTH (1), %VAL(POINTER(1)), LENGTH (2), %VAL(POINTER(2)),
     +       LENGTH (3), %VAL(POINTER(3)), LENGTH (4), %VAL(POINTER(4)))
      ELSE IF (N.EQ.5) THEN
        CALL ROUTNE (
     +       LENGTH (1), %VAL(POINTER(1)), LENGTH (2), %VAL(POINTER(2)),
     +       LENGTH (3), %VAL(POINTER(3)), LENGTH (4), %VAL(POINTER(4)),
     +       LENGTH (5), %VAL(POINTER(5)))
      ELSE IF (N.EQ.6) THEN
        CALL ROUTNE (
     +       LENGTH (1), %VAL(POINTER(1)), LENGTH (2), %VAL(POINTER(2)),
     +       LENGTH (3), %VAL(POINTER(3)), LENGTH (4), %VAL(POINTER(4)),
     +       LENGTH (5), %VAL(POINTER(5)), LENGTH (6), %VAL(POINTER(6)))
      ELSE IF (N.EQ.7) THEN
        CALL ROUTNE (
     +       LENGTH (1), %VAL(POINTER(1)), LENGTH (2), %VAL(POINTER(2)),
     +       LENGTH (3), %VAL(POINTER(3)), LENGTH (4), %VAL(POINTER(4)),
     +       LENGTH (5), %VAL(POINTER(5)), LENGTH (6), %VAL(POINTER(6)),
     +       LENGTH (7), %VAL(POINTER(7)))
      ELSE IF (N.EQ.8) THEN
        CALL ROUTNE (
     +       LENGTH (1), %VAL(POINTER(1)), LENGTH (2), %VAL(POINTER(2)),
     +       LENGTH (3), %VAL(POINTER(3)), LENGTH (4), %VAL(POINTER(4)),
     +       LENGTH (5), %VAL(POINTER(5)), LENGTH (6), %VAL(POINTER(6)),
     +       LENGTH (7), %VAL(POINTER(7)), LENGTH (8), %VAL(POINTER(8)))
      ELSE IF (N.EQ.9) THEN
        CALL ROUTNE (
     +       LENGTH (1), %VAL(POINTER(1)), LENGTH (2), %VAL(POINTER(2)),
     +       LENGTH (3), %VAL(POINTER(3)), LENGTH (4), %VAL(POINTER(4)),
     +       LENGTH (5), %VAL(POINTER(5)), LENGTH (6), %VAL(POINTER(6)),
     +       LENGTH (7), %VAL(POINTER(7)), LENGTH (8), %VAL(POINTER(8)),
     +       LENGTH (9), %VAL(POINTER(9)))
      ELSE IF (N.EQ.10) THEN
        CALL ROUTNE (
     +       LENGTH (1), %VAL(POINTER(1)), LENGTH (2), %VAL(POINTER(2)),
     +       LENGTH (3), %VAL(POINTER(3)), LENGTH (4), %VAL(POINTER(4)),
     +       LENGTH (5), %VAL(POINTER(5)), LENGTH (6), %VAL(POINTER(6)),
     +       LENGTH (7), %VAL(POINTER(7)), LENGTH (8), %VAL(POINTER(8)),
     +       LENGTH (9), %VAL(POINTER(9)),
     +       LENGTH (10), %VAL(POINTER(10)))
      ELSE IF (N.EQ.11) THEN
        CALL ROUTNE (
     +       LENGTH (1), %VAL(POINTER(1)), LENGTH (2), %VAL(POINTER(2)),
     +       LENGTH (3), %VAL(POINTER(3)), LENGTH (4), %VAL(POINTER(4)),
     +       LENGTH (5), %VAL(POINTER(5)), LENGTH (6), %VAL(POINTER(6)),
     +       LENGTH (7), %VAL(POINTER(7)), LENGTH (8), %VAL(POINTER(8)),
     +       LENGTH (9), %VAL(POINTER(9)),
     +       LENGTH (10), %VAL(POINTER(10)),
     +       LENGTH (11), %VAL(POINTER(11)))
      ELSE IF (N.EQ.12) THEN
        CALL ROUTNE (
     +       LENGTH (1), %VAL(POINTER(1)), LENGTH (2), %VAL(POINTER(2)),
     +       LENGTH (3), %VAL(POINTER(3)), LENGTH (4), %VAL(POINTER(4)),
     +       LENGTH (5), %VAL(POINTER(5)), LENGTH (6), %VAL(POINTER(6)),
     +       LENGTH (7), %VAL(POINTER(7)), LENGTH (8), %VAL(POINTER(8)),
     +       LENGTH (9), %VAL(POINTER(9)),
     +       LENGTH (10), %VAL(POINTER(10)),
     +       LENGTH (11), %VAL(POINTER(11)),
     +       LENGTH (12), %VAL(POINTER(12)))
      ENDIF
      DO I=1,N
        CALL free(POINTER(I))
      ENDDO
      END
C
      SUBROUTINE CEXIT (ICODE)
C     trivial interface to system-dependent EXIT routine
      INTEGER ICODE
      CALL EXIT (ICODE)
      END
 
      subroutine clear
      end




        subroutine gdummy
        character *(*) char_dummy
        entry  qreset
          return
        entry  reshap
          return
        entry  qdevic(keybd)
          return
        entry  winope(char_dummy,i0)
          return
        entry  keepas(i1,i2)
          return
        entry  draw2i(i3,i4)
          return
        entry  move2i(i5,i6)
          return
        entry  loadma(i7)
          return
        entry  gconfi
          return
        entry  mmode(i8)
          return
        entry  foregr
          return
        entry  getval(i9)
          return
        entry  color(i10)
          return
        entry  getsiz(r1,r2)
          return
cc        entry  clear this is in somewhere else in -ltermcap
cc          return
        entry  ortho2(r3,r4,r5,r6)
          return
        entry  getori(r7,r8)
          return
        end
C
C
C     =========================
       CHARACTER FUNCTION RTNBKS()
C     =========================
C
C RTNBKS - Returns a Backslash for nt as unix compilers are fussy!
C
C Input:     none
C
C Returns:   \ if WIN32 or space if unix or vms
C
C Arguments: none
C
C Usage:     RTNBKS ()
C
      RTNBKS='\'
C
      END

c     ============================
      subroutine hciftime(ciftime)
c     ============================

c     Uses f90 intrinsic Date_and_Time. Using f77:
c       works on VMS Fortran V7 but not earlier versions
c       works on Digital UNIX V4.0F 
c       doesn't work on IRIX 6.5
c
      implicit none
c
      character ciftime*(*)
c
      character cdate*8,ctime*10,czone*5
      integer ivalues(8)
c
c ... check if the argument can hold 25 characters
c     (better to return an error flag, of course ;-)
c
      if (len(ciftime) .lt. 25) then
        print *,'error --- hciftime: string too short'
        ciftime = ' '
        return
      end if
c
      CALL Date_and_Time(CDATE,CTIME,CZONE,IVALUES)
c
      write (ciftime,fmt=6000) IVALUES(1),IVALUES(2),IVALUES(3),
     +   IVALUES(5),IVALUES(6),IVALUES(7),CZONE(1:3),CZONE(4:5)
c
c ... NOTE: "i4" in the following format makes that this routine
c           is not Year-10,000-compliant !!!
c
 6000 format (i4,'-',i2.2,'-',i2.2,'T',i2.2,':',i2.2,':',i2.2,
     +   a3,':',a2)
c
      return
      end

C
C     testlib.f: test program for Machine dependent routines
C
C     This library is free software: you can redistribute it and/or
C     modify it under the terms of the GNU Lesser General Public License
C     version 3, modified in accordance with the provisions of the 
C     license to address the requirements of UK law.
C 
C     You should have received a copy of the modified GNU Lesser General 
C     Public License along with this library.  If not, copies may be 
C     downloaded from http://www.ccp4.ac.uk/ccp4license.php
C 
C     This program is distributed in the hope that it will be useful,
C     but WITHOUT ANY WARRANTY; without even the implied warranty of
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C     GNU Lesser General Public License for more details.
C
      PROGRAM MCTEST
C
C---- Test file for Machine dependent routines
C
C     .. Parameters ..
      INTEGER LBUF,LSTR
      PARAMETER (LBUF=500,LSTR=12)
C     ..
C     .. Local Scalars ..
      REAL ERSTR,SEC,NAN
      INTEGER I,IBYTE,IDAY,IER,ILENGTH,ILOOP,IMON,ISEC,ISEED,ISTAT,
     +        IYEAR,IYES,J,LDUM,LUN,LUNIN,LUNOUT,NREC
      CHARACTER ERRSTR*40,HANDLE* (LSTR),NAME1* (LSTR),NAME2* (LSTR),
     +          ENVNAM* (120),USRNAM* (LSTR),UDATE* (LSTR),
     +          USRTIM* (LSTR),REPLY* (LSTR),TSTNAM*(LSTR),FOO*3
C     ..
C     .. Local Arrays ..
      REAL BUFFER(LBUF)
C     ..
C     .. External Functions ..
      LOGICAL LITEND,VAXVMS, WINMVS, QISNAN
      REAL RANU
      INTEGER CCPNUN
      EXTERNAL LITEND,VAXVMS, WINMVS, QISNAN, RANU, CCPNUN
C     ..
C     .. External Subroutines ..
      EXTERNAL CCPERR,CCPFYP,NOCRLF,QCLOSE,QMODE,QOPEN,QQINQ,QREAD,
     +         QSEEK,QWRITE,UBYTES,UCPUTM,UGERR,UGTENV,UGTUID,
     +         UIDATE,UISATT,USTIME,UTIME,CCPRCS,CCPDPN, QNAN
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC NINT
C     ..
C     .. Data statements ..
      DATA LUNIN/5/,LUNOUT/6/,NAME1/'AAA.TST'/,NAME2/'ZZZ.TST'/,
     +     ISEED/0/,ILOOP/100/,TSTNAM/'TESTNAME'/
C     ..
C
C---- Initialise CPU timer
C
      SEC = -1.0
      CALL UCPUTM(SEC)
C
C---- Parse command line arguments, open printer stream and print
C     version 
C
      CALL CCPFYP
      I = 0
      CALL CCPDPN(LUNOUT,'PRINTER','PRINTER','F',0,I)
      IF (I.NE.0) CALL CCPERR(1,'Can''t open printer stream')
      CALL CCPRCS(6,'TESLIB','$Date$')
C
C---- Other initialisations
C
      I = 0
      CALL CCPDPN(10,NAME1,'NEW','F',0,I)
      IF (I.NE.0) CALL CCPERR(1,' Failed to open file '//NAME1)
      WRITE (10,FMT='(A)') ' I am the test file, delete me.'
      CLOSE (10,STATUS='DELETE')
C
C---- Start of Tests
C
      WRITE (LUNOUT,FMT=6000) ' Routine  Result      Comments'
C
C---- UGTENV
C
      CALL UGTENV('TESTENV',ENVNAM)
      WRITE (LUNOUT,FMT=6002) ' UGTENV',ENVNAM(1:12),
     .                                    'Get value of TESTENV'
C
C---- UGTUID
C
      CALL UGTUID(USRNAM)
      WRITE (LUNOUT,FMT=6002) ' UGTUID',USRNAM,'Get Users name'
C
C---- UIDATE
C
      CALL UIDATE(IMON,IDAY,IYEAR)
      WRITE (UDATE,FMT=6006) IDAY,IMON,IYEAR
      WRITE (LUNOUT,FMT=6002) ' UIDATE',UDATE,'Todays date'
C
C---- UTIME
C
      CALL UTIME(USRTIM)
      WRITE (LUNOUT,FMT=6002) ' UTIME ',USRTIM,'Current time'
C
C---- USTIME
C
      CALL USTIME(ISEC)
      WRITE (UDATE,FMT=6020) ISEC
      WRITE (LUNOUT,FMT=6002) ' USTIME',UDATE,'Absolute time (VMS=-1)'
C
C---- UISATT
C
      CALL UISATT(LUNOUT,IYES)
      IF (IYES.EQ.0) THEN
        REPLY = 'No'
      ELSE
        WRITE (REPLY,FMT=6004) 'Yes, ',LUNOUT
      END IF
      WRITE (LUNOUT,FMT=6002) ' UISATT',REPLY,
     +  'are we attached to at tty? Unit number?'
C
C---- VAXVMS
C
      REPLY = 'No'
      IF (VAXVMS()) REPLY = 'Yes'
      WRITE (LUNOUT,FMT=6002) ' VAXVMS',REPLY,'Is this VMS?'
C
C---- WINMVS
C
      REPLY = 'No'
      IF (WINMVS()) REPLY = 'Yes'
      WRITE (LUNOUT,FMT=6002) ' WINMVS',REPLY,'Is this Win NT et al?'
C
C---- UBYTES
C
      CALL UBYTES(IBYTE,HANDLE)
      WRITE (REPLY,FMT=6008) HANDLE,IBYTE
      WRITE (LUNOUT,FMT=6002) ' UBYTES',REPLY,
     +  'Get BYTE/WORD Handling and number of bytes per word'
C
C---- LITEND
C
      REPLY = 'Big'
      IF (LITEND(IDUM)) REPLY = 'Little'
      WRITE (LUNOUT,FMT=6002) ' LITEND',REPLY,'Big/Little end machine'
CCCC
CCCC---- URENAM
CCCC
CCC      CALL URENAM(NAME1,NAME2,ISTAT)
CCC      ERRSTR = 'OK'
CCC      IF (ISTAT.NE.0) CALL UGERR(ISTAT,ERSTR)
CCC      WRITE (LUNOUT,FMT=6002) ' URENAM',ERRSTR,'Check rename status'
CCC      CALL CUNLINK (NAME2)
C
C---- UGERR
C
      OPEN (21,FILE='TESTFILE',STATUS='OLD',IOSTAT=I)
      CALL UGERR(I,ERRSTR)
      WRITE (REPLY,FMT=6020) I
      WRITE (LUNOUT,FMT=6002) ' UGERR ',REPLY,ERRSTR
C
C---- UCPUTM
C
      SEC = 99.99
      CALL UCPUTM(SEC)
      WRITE (REPLY,FMT=6016) SEC
      WRITE (LUNOUT,FMT=6002) ' UCPUTM',REPLY,'Show elapsed CPU time'
C
C---- NOCRLF
C     
      CALL NOCRLF('NOCRLF')
      WRITE(LUNOUT,'(''+'',14X,A)') 'Should be on same line'
C
C --- CCPNUN
C
      I = CCPNUN ()
      WRITE (REPLY,FMT=6020) I
      WRITE (LUNOUT,FMT=6002) ' CCPNUN',REPLY,'Next free unit'
C
C --- QNAN/QISNAN (`magic numbers')
C
      CALL QNAN (NAN)
      IF ((.NOT.QISNAN (NAN)) .OR. QISNAN (1.0)) THEN
        WRITE (LUNOUT,'(/'' *** QNAN/QISNAN test failed''/)')
      ELSE
        WRITE (LUNOUT,'('' QNAN/QISNAN test OK'')') 
      ENDIF
C
C---- End of tests
C
      WRITE (LUNOUT,FMT=6000) ' Now test diskio routines'
C
C---- Now test the diskio stuff
C
      CALL QOPEN(LUN,'DISKIO','UNKNOWN')
      CALL QMODE(LUN,2,LDUM)
C
C---- Write a file of size LBUF x LBUF x WORDSIZE
C
      DO 20 I = 1,LBUF
        DO 10 J = 1,LBUF
10        BUFFER(J) = 0.
        BUFFER(I) = I
        CALL QWRITE(LUN,BUFFER,LBUF)
   20 CONTINUE
C
C---- Close the file
C
      CALL QCLOSE(LUN)
C
C---- reset the array buffer(*)
C
      DO 30 I = 1,LBUF
        BUFFER(I) = 0.0
   30 CONTINUE
C
C---- Now do some reads on the file just created
C
      CALL QOPEN(LUN,'DISKIO','OLD')
      CALL QMODE(LUN,2,LDUM)
C
C---- test file size
C
      CALL QQINQ(LUN,'DISKIO',REPLY,ILENGTH)
      ISTAT = LDUM*LBUF*LBUF
      WRITE (6,'(A,2(I8,A)//)')
     &' DISKIO should be',ISTAT,' bytes; is',ILENGTH,' bytes.'
      IF (ILENGTH.NE.ISTAT) CALL CCPERR(1, '*** FILE SIZE ERROR ***')
C
C---- Seed random Number Generator
C
      REPLY = ' '
      CALL UGTENV('SEED',REPLY)
      IF (REPLY.NE.' ') READ (REPLY,*) ISEED
C
C---- Get number of reads to perform
C
      CALL UGTENV('READS',REPLY)
      IF (REPLY.NE.' ') READ (REPLY,*) ILOOP
C
C---- Do random reads & writes on the file
C
      CALL UGTENV('NUMRECORD',ENVNAM)
      IF (ENVNAM.EQ.' ') THEN
        DO 40 I = 1,ILOOP
          NREC = NINT(100.*RANU(ISEED) + 1.)
          IF (NREC.LE.0 .OR. NREC.GT.LBUF)
     &    CALL CCPERR(1,'*** RECORD ERROR ***')
          CALL QSEEK(LUN,NREC,1,LBUF)
          IF (RANU(ISEED).LT..5) THEN
            CALL QREAD(LUN,BUFFER,LBUF,IER)
            WRITE (LUNOUT,FMT=6014) NREC,BUFFER(NREC),IER
            IF (BUFFER(NREC).NE.NREC)
     &      CALL CCPERR(1,'*** VERIFY ERROR ***')
          ELSE
            DO 70 J = 1,LBUF
70            BUFFER(J) = 0.
            BUFFER(NREC) = NREC
            CALL QWRITE(LUN,BUFFER,LBUF)
            WRITE (LUNOUT,FMT=6015) NREC,BUFFER(NREC)
          ENDIF
   40   CONTINUE
      ELSE
   50   CONTINUE
          CALL NOCRLF('Record to seek (-ve to write, Ctrl/Z to stop)> ')
          READ (LUNIN,6020,END=60) NREC
          I=IABS(NREC)
          IF (I.EQ.0 .OR. I.GT.LBUF) THEN
            WRITE (LUNOUT,*) '*** RECORD ERROR ***'
            GOTO 50
          ENDIF
          CALL QSEEK(LUN,I,1,LBUF)
          IF (NREC.GT.0) THEN
            CALL QREAD(LUN,BUFFER,LBUF,IER)
            WRITE (LUNOUT,FMT=6014) NREC,BUFFER(NREC),IER
            IF (BUFFER(NREC).NE.NREC)
     &      WRITE (LUNOUT,*) '*** VERIFY ERROR ***'
          ELSE
            DO 80 J = 1,LBUF
80            BUFFER(J) = 0.
            BUFFER(I) = I
            CALL QWRITE(LUN,BUFFER,LBUF)
            WRITE (LUNOUT,FMT=6015) I,BUFFER(I)
          ENDIF
        GOTO 50
      ENDIF
   60 CALL QCLOSE (LUN)
      CALL CUNLINK ('DISKIO')
C     Now check we can open and close a scratch file
      CALL QOPEN (LUN, 'foo.bar', 'SCRATCH')
      CALL QCLOSE (LUN)
C     and can we rewind a scratch file?  (make sure something's been
C     written to it first)
      I = 0
      CALL CCPDPN (LUN,'FOOEY','SCRATCH','F',0,I)
      WRITE (LUN,'(A)') 'foo'
      REWIND (LUN,ERR=170)
      READ (LUN,'(A)') FOO
      WRITE (LUNOUT, *) 'contents of temp file: ', FOO
      CALL CCPERR(0,'Normal Termination')
 170  CALL CCPERR (1,'Can''t rewind scratch file')
90    CALL CCPERR(1,'*** EOF ERROR ***')
C
C---- Format Statements
C
 6000 FORMAT (//A,/)
 6002 FORMAT (A7,3X,A12,A)
 6004 FORMAT (A,I3)
 6006 FORMAT (I2.2,'/',I2.2,'/',I4)
 6008 FORMAT (A5,I3)
 6014 FORMAT (' Seek Record:',I5,'  Read:  ',F8.2,'  Status: ',I4)
 6015 FORMAT (' Seek Record:',I5,'  Write: ',F8.2)
 6016 FORMAT (F8.2)
 6020 FORMAT (I10)
      END
C
C
      REAL FUNCTION RANU(K)
C==== UNIFORM PSEUDO-RANDOM NUMBER IN THE RANGE >= 0 AND < 1.
C
C     Set the seed K zero or negative to start or restart the sequence.
C     K must be a variable since a new value is returned each time.
C
      IMPLICIT           NONE
      INTEGER            M, IA, IC
      REAL               RM
      PARAMETER         (M=714025, IA=1366, IC=150889, RM=1./M)
      INTEGER            J, K, IY, IR(97)
      LOGICAL            FF
      SAVE               IY, IR, FF
      DATA               FF /.TRUE./
C
      IF (K.LE.0 .OR. FF) THEN
        FF = .FALSE.
        K = MOD(IC-K,M)
        DO 11 J = 1, 97
          K = MOD(IA*K + IC, M)
11        IR(J) = K
        K = MOD(IA*K + IC, M)
        IY = K
      ENDIF
C
      J = 1 + 97*IY/M
      IY = IR(J)
      RANU = IY*RM
      K = MOD(IA*K + IC, M)
      IR(J) = K
      END

C
C     ccplib.f: Pseudo-machine-independent low-level routines
C
C     This library is free software: you can redistribute it and/or
C     modify it under the terms of the GNU Lesser General Public License
C     version 3, modified in accordance with the provisions of the 
C     license to address the requirements of UK law.
C 
C     You should have received a copy of the modified GNU Lesser General 
C     Public License along with this library.  If not, copies may be 
C     downloaded from http://www.ccp4.ac.uk/ccp4license.php
C 
C     This program is distributed in the hope that it will be useful,
C     but WITHOUT ANY WARRANTY; without even the implied warranty of
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C     GNU Lesser General Public License for more details.
C
C_BEGIN_CCPLIB
C     These are supposedly-machine-independent low-level routines.
C     They're actually machine-dependent at least insofar as some
C     contain non-standard code, but they do compile with the compilers
C     tried on unix as well as VMS.
C
C     fixme: the bit-twiddling should be in library.c, not here.
C     amalgamate ccppsf and fdir/fext/froot.  also add tests of these
C     routines to testlib.
C
C     $Id$
C
C      CCFILL    Set specified number of elements of byte array
C      CCPALC    Call subroutine with allocated memory
C      CCPALE    Call subroutine with allocated memory set from environment
C      CCPBYI    Copy array of unsigned (or signed) bytes into integer array
C      CCPBYT    Indicate whether byte handling is available
C      CCPCPI    Copy array of BYTE or INTEGER*2 elements into integer array
C      CCPDEX    Periodicity reduction of 1024 (for PROLSQ)
C      CCPDPN    more friendly CCPOPN
C      CCPE2I    read integer from logical name value
C      CCPGI2    Get unsigned integer*2 value from 0 to 65535 from N'th
C                unsigned integer*2 element of array.
C      CCPGTB    Get unsigned byte value from 0 to 255 from N'th byte of
C                array.
C      CCPI2I    Copy an array of INTEGER*2 elements into an integer array
C      CCPIBY    Copy array of integers into array of bytes.
C      CCPII2    Copy array of integers into array of INTEGER*2 elements.
C      CCPMDE    If byte handling available return nos. of bytes for map
C                modes
C      CCPMVB    Move bytes from one non-character array to another if
C                byte handling is available
C      CCPMVI    Move words from one integer array to another
C      CCPMVR    Move words from one real array to another
C      CCPNUN    Return an unconnected i/o unit number
C      CCPONL    See if program is being run interactively
C      CCPPSF    Parse file name into components
C      CSETNV    Associate logical name with file name
C      CCPPAG    Set paging parameters if available
C      CCPSI2    Set integer value from 0 to 65535 into the N'th
C                unsigned integer*2 element of an array.
C      CCPSTB    Set integer value from 0 to 255 into N'th byte of array.
C      CCPSUM    Sum the elements of an array
C      CCPTOI    Convert n'th byte or I*2 in a non-character array to an
C                integer
C      CCPUFL    Supress underflow messages
C      CCPZBI    Sets an array of bytes to zero
C      CCPZI     Set 'n' words of an integer array to zero using a simple loop
C      CCPZR     Set 'n' words of a real array to zero using a simple loop
C      FDIR      Returns the directory part of a file name
C      FEXTN     Returns the extension of a file name
C      FROOT     Returns the root of a file name
C      LITEND    determine endianness
C      LENSTR    length of string to last non-space ( C equiv 
C                ccp4_utils_flength
C      LUNSTI    Get logical unit number for input
C      LUNSTO    Get logical unit number for output
C      NBITST    Return the (unsigned) integer value held within a bit
C                field in a word
C      NOCRLF    write line supressing cr/lf to standard output
C      STBITS    Set a bit field within a word to a given (unsigned)
C                integer value
C      HKLEQ     Are the reflection indices the equal
C      Subroutines for generating and accessing a hash table
C      CCP4_HASH_SETUP
C      CCP4_HASH_LOOKUP
C      CCP4_HASH_ZEROIT
C
C_END_CCPLIB
C
C
C
C_BEGIN_CCFILL
      SUBROUTINE CCFILL(ARR1,SCAL,NTIMES)
C     ===================================
C
C      CCFILL    Set NTIMES bytes array ARR1 to value SCAL
C
C Arguments:
C ==========
C
C        ARR1 (O)   BYTE ARRAY (*): WHERE BYTES ARE TO BE COPIED
C        SCAL (I)   BYTE: value to be copied into ARR1
C      NTIMES (I)   INTEGER: NUMBER OF BYTES TO BE COPIED
C_END_CCFILL
C
C     .. Scalar Arguments ..
      INTEGER NTIMES
      INTEGER*1 SCAL
C     ..
C     .. Array Arguments ..
      INTEGER*1 ARR1(*)
C     ..
C     .. Local Scalars ..
      INTEGER N
C     ..
      DO 10 N = 1,NTIMES
        ARR1(N) = SCAL
   10 CONTINUE
C
      END
C
C
C_BEGIN_CCPALC
      SUBROUTINE CCPALC(ROUTNE, N, TYPE, LENGTH)
C     ==========================================
C
C     Arrange to call subroutine ROUTNE with N array arguments each of
C     length LENGTH (i) and type indicated by TYPE (i): 'i' == integer,
C     'r' == real, 'd' == double precision, 'c' == complex, 'b' ==
C     "byte" (logical*1 or integer*1, unportable and deprecated) .  TYPE
C     elements may have either case.
C     Consider `call ccpalc (fred, 3, types, lens)' with types = (/'i',
C     'r', 'c'/)  and lens = (/1000, 2000, 3000/).  This effectively does
C        call fred (1000, arr1, 2000, arr2, 3000, arr3)
C     with
C        subroutine fred (n1, foo, n2, bar, n3, baz)
C        integer n1, n2, n3, foo (n1)
C        real bar (n2)
C        complex baz (n3)
C        ...
C     Obviously all communication with ROUTNE must be by COMMON (or,
C     possibly, extra ENTRYs).  The allocated memory is freed on return
C     from ROUTNE.  As a concession, it's initially filled with zeroed
C     bytes.

C
C Arguments:
C ==========
C
C      ROUTNE (I)   EXTERNAL: routine to call
C           N (I)   INTEGER: number of arguments to ROUTNE (<=12)
C        TYPE (I)   CHARACTER*1 (*): type of arguments to ROUTNE:
C                      'I': INTEGER; 'R': REAL; 'D': DOUBLE PRECISION;
C                      'C': COMPLEX; 'B': LOGICAL*1 or INTEGER*1
C      LENGTH (I)   INTEGER*(*): number of elements in each (array)
C                       argument of ROUTNE
C_END_CCPALC
C
C     .. Scalar Arguments ..
      INTEGER N
C     ..
C     .. Array Arguments ..
      CHARACTER TYPE (*)
      INTEGER LENGTH (*)
C     ..
      EXTERNAL ROUTNE, CCPAL1, CCPUPC
      INTEGER I, ITYPE (12)
      CHARACTER TTYPE (12)
C     ..
      IF (N.LT.1 .OR. N.GT.12)
     +     CALL CCPERR (1, 'CCPALC: bad number of arguments')
      DO 10 I=1,N
        TTYPE (I) = TYPE (I)
        CALL CCPUPC (TTYPE (I))
        ITYPE (I) = INDEX ('IRDCB', TTYPE (I))
        IF (ITYPE (I) .EQ. 0) CALL CCPERR (1, 'CCPALC: bad TYPE: '//
     +       TYPE (I))
        IF (LENGTH (I).LE.0) CALL CCPERR (1, 'CCPALC: length <=0')
 10   CONTINUE
      CALL CCPAL1 (ROUTNE, N, ITYPE, LENGTH)
      END
C
C
C_BEGIN_CCPALE
      SUBROUTINE CCPALE(ROUTNE, N, TYPE, LENGTH, LENDEF, PRINT)
C     =================================================
C
C     Arrange to call subroutine ROUTNE with N array arguments each of
C     length LENGTH (i) and type indicated by TYPE (i): 'i' == integer,
C     'r' == real, 'd' == double precision, 'c' == complex, 'b' == byte.
C     TYPE elements may have either case.  LENGTH points to an array of
C     environment variable (logical) names from which integer values are
C     read.  The lengths default to values from LENDEF.
C     This is a convenient interface to CCPALC to allow configuring of
C     the memory requirements on the command line where appropriate.
C     This may be useful if the memory requirements can't be determined
C     initially and it's necessary to guess.
C
C Arguments:
C ==========
C
C      ROUTNE (I)   EXTERNAL: routine to call
C           N (I)   INTEGER: number of arguments to ROUTNE (<=12)
C        TYPE (I)   CHARACTER*1 (*): type of arguments to ROUTNE:
C                      'I': INTEGER; 'R': REAL; 'D': DOUBLE PRECISION;
C                      'C': COMPLEX; 'B': LOGICAL*1 or INTEGER*1
C     LENGTH (I)   CHARACTER *(*): logical names representing the number
C                       of elements in each (array) argument of ROUTNE
C     LENDEF (I)   INTEGER (*): default lengths for the argument arrays
C     used if the appropriate LENGTH argument doesn't represent a
C     defined logical
C     PRINT  (I)   LOGICAL: whether or not to print the values of the
C     array lengths
C_END_CCPALE
C
C     .. Scalar Arguments ..
      INTEGER N
      LOGICAL PRINT
C     ..
C     .. Array Arguments ..
      CHARACTER TYPE (*),  LENGTH (*)*(*)
      INTEGER LENDEF (*)
C     ..
      EXTERNAL ROUTNE, CCPE2I, CCPALC, LUNSTO
      INTEGER I, LENG (12), CCPE2I, LUNSTO
C     ..
      DO 10 I=1,N
        LENG (I) = CCPE2I (LENGTH (I), LENDEF (I))
 10   CONTINUE
      IF (PRINT) THEN
        WRITE (LUNSTO(1), 
     +     '(/'' Memory allocation (logical name, type, elements):'')')
        WRITE (LUNSTO(1), '(3X, A, 1X, A, 3X, I10)')
     +       (LENGTH (I), TYPE (I), LENG (I), I=1,N)
      ENDIF
      CALL CCPALC (ROUTNE, N, TYPE, LENG)
      END
C
C
C
C SUBROUTINE 'CCPBYI'
C ===================
C
C_BEGIN_CCPBYI
      SUBROUTINE CCPBYI(IA,IBYT,NB)
C     =============================
C
C COPY AN ARRAY OF UNSIGNED (OR SIGNED) BYTES INTO AN INTEGER ARRAY
C
C (MUST BE IMPLEMENTED IF CCPBYT FUNCTION RETURNS .TRUE.)
C [added for LAUE]
C
C Arguments:
C ==========
C
C      IA (O)   INTEGER ARRAY(*): TO RETURN INTEGER VALUES
C    IBYT (I)   BYTE ARRAY(*): DATA (MAY BE AN INTEGER ARRAY FOR EXAMPLE
C               WITH DATA PACKED INTO ADJACENT BYTES
C      NB (I)   INTEGER: IF >0, THE NUMBER OF UNSIGNED BYTES TO BE COPIED
C                        IF <0, -THE NUMBER OF SIGNED BYTES TO BE COPIED
C_END_CCPBYI
C
C SPECIFICATION STATEMENTS
C ------------------------
C
      INTEGER IA(*)
      INTEGER*1 IBYT(*)
      INTEGER*1 JBYT(4)
      EQUIVALENCE (JA,JBYT(1))
      LOGICAL CALLED, LITEND
      INTEGER IND
      EXTERNAL LITEND
      SAVE CALLED, IND
      DATA CALLED/.FALSE./
C
      IF (.NOT.CALLED) THEN
        CALLED=.TRUE.
        IF (LITEND(1)) THEN
          IND = 1
        ELSE
          IND = 4
        ENDIF
      ENDIF
C
C COPY DATA
C ---------
C
      NE = NB
      IF (NE.GT.0) THEN
         JA=0
         DO 10 I=1,NE
           JBYT(IND)=IBYT(I)
           IA(I)=JA
 10      CONTINUE
      ELSE
         NE = -NE
         DO 20 I=1,NE
         IA(I) = IBYT(I)
20       CONTINUE
      END IF
      END
C
C
C
C_BEGIN_CCPBYT
      LOGICAL FUNCTION CCPBYT(NBW)
C     ============================
C
C---- This function indicates whether byte handling is available or not.
C      if a value of .true. is returned then the subroutines ccpmde and
C      ccpmvb must be fully implemented.
C
C Arguments:
C ==========
C
C         NBW (O)   INTEGER: RETURNS THE NUMBER OF BYTES PER WORD OR A VALUE
C                   OF 1 IF NO BYTE HANDLING IS AVAILABLE.
C
C  RETURNS   CCPBYT  = .TRUE.  BYTE HANDLING AND ASSOCIATED CCPLIB
C                              ROUTINES AVAILABLE.
C                    = .FALSE. NO BYTE HANDLING AVAILABLE.
C_END_CCPBYT
C
C     .. Scalar Arguments ..
      INTEGER NBW
C     ..
      CCPBYT = .TRUE.
      NBW = 4
      END
C
C
C SUBROUTINE 'CCPCPI'
C ===================
C_BEGIN_CCPCPI
      SUBROUTINE CCPCPI(IA,IB,MINEL,MAXEL,ITYP)
C     =========================================
C
C Copy an array of BYTE or INTEGER*2 elements into an integer array
C
C (Must be implemented if ccpbyt function returns .TRUE.)
C [for LAUE]
C
C Arguments:
C ==========
C
C      IA (O)   INTEGER Array(*): to return values
C      IB (I)   INTEGER Array(*): holding data with data packed into adjacant 
C                                 BYTE or INTEGER*2 elements
C   MINEL (I)   INTEGER: Minimum element to copy
C   MAXEL (I)   INTEGER: Maximum element to copy
C    ITYP (I)   INTEGER: Type =1 unsigned byte
C                             =2 signed byte
C                             =3 unsigned two byte integer
C                             =4 signed two byte integer
C
C               Note: if MINEL>MAXEL elements will be copied in reverse order
C_END_CCPCPI
C
C====== Specification statements
C
      INTEGER IA(*)
      INTEGER*1 IB(*)
      INTEGER*2 J2(2)
      INTEGER*1 JBYT(4)
      EQUIVALENCE (JA,J2(1),JBYT(1))
      LOGICAL CALLED, LITEND
      EXTERNAL LITEND
      INTEGER IND1, IND2, INDB
      SAVE CALLED, IND1, IND2, INDB
      DATA CALLED/.FALSE./
C
      IF (.NOT.CALLED) THEN
        IF (LITEND(1)) THEN
          IND1 = 1
          IND2 = 2
          INDB = 1
        ELSE
          IND1 = 3
          IND2 = 4
          INDB = 4
        ENDIF
        CALLED=.TRUE.
      ENDIF
C
C====== Copy data
C
      ISTEP = 1
      IF (MINEL.GT.MAXEL) ISTEP=-1
      IF (ITYP.EQ.1) THEN
         JA=0
         J=0
         DO 10 I=MINEL,MAXEL,ISTEP
            J=J+1
            JBYT(INDB)=IB(I)
            IA(J)=JA
10       CONTINUE
      ELSE IF (ITYP.EQ.2) THEN
         J=0
         DO 20 I=MINEL,MAXEL,ISTEP
            J=J+1
            IA(J)=IB(I)
20       CONTINUE
      ELSE IF (ITYP.EQ.3) THEN
         JA=0
         J=0
         DO 30 I=MINEL,MAXEL,ISTEP
            J=J+1
            JBYT(IND1)=IB(2*I-1)
            JBYT(IND2)=IB(2*I)
            IA(J)=JA
30       CONTINUE
      ELSE IF (ITYP.EQ.4) THEN
         J=0
         DO 40 I=MINEL,MAXEL,ISTEP
            J=J+1
            JBYT(1)=IB(2*I-1)
            JBYT(2)=IB(2*I)
            IA(J)=J2(1)
40       CONTINUE
      END IF
      RETURN
      END
C
C
C
C_BEGIN_CCPDEX
      SUBROUTINE CCPDEX(INDX,N)
C     =========================
C
C---- This subroutine performs a periodicity reduction for a period
C     of 1024 for the elements of an array. written particularly for
C     'prolsq' to allow for use of the 'and' function on the cray or
C     'moveb' on the m28oh(iap).
C      These are much faster than the mod function used in
C      the standard fortran77 version.
C
C Arguments:
C ==========
C
C        INDX (I/O) INTEGER ARRAY(*): NUMBERS FOR PERIODICITY REDUCTION
C           N (I)   INTEGER: NO. OF ELEMENTS IN INDX
C
C EXAMPLE OF FUNCTIONS:
C
C FORTRAN77     INDX(I)=MOD(INDX(I),1024)+1
C CRAY-1S       INDX(I)=AND(INDX(I),1023)+1
C M280H(IAP)    CALL MOVEB(INDX(I),1,0,1,22)
C               INDX(I)=INDX(I)+1
C_END_CCPDEX
C
C SPECIFICATION STATEMENTS AND CODE
C
C     .. Scalar Arguments ..
      INTEGER N
C     ..
C     .. Array Arguments ..
      INTEGER INDX(N)
C     ..
C     .. Local Scalars ..
      INTEGER I
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC MOD
C     ..
      DO 10 I = 1,N
        INDX(I) = MOD(INDX(I),1024) + 1
   10 CONTINUE
      END
C
C_BEGIN_CCPDPN
      SUBROUTINE CCPDPN(IUN,LOGNAM,STATUS,TYPE,LREC,IFAIL)
C     ====================================================
C
C---- Calls CCPOPN to open a file, but with mnemonic arguments
C
C Arguments:
C ==========
C
C         IUN (I)   INTEGER: UNIT NUMBER
C
C      LOGNAM (I)   CHARACTER*(*): LOGICAL FILE NAME
C
C      STATUS (I)   CHARACTER*(*): FILE STATUS FLAG:
C                                     'UNKNOWN'
C                                     'SCRATCH'
C                                     'OLD'
C                                     'NEW'
C                                     'READONLY'
C                                     'PRINTER'
C
C        TYPE (I)   CHARACTER*(*): FILE TYPE FLAG:
C                                  ='F', 'SEQUENTIAL' 'FORMATTED'
C                                  ='U', 'SEQUENTIAL' 'UNFORMATTED'
C                                  ='DF', 'DIRECT'     'FORMATTED'
C                                  ='DU', 'DIRECT'     'UNFORMATTED'
C     [STATUS and TYPE are case-insensitive]
C
C        LREC (I)   INTEGER: RECORD LENGTH FOR DIRECT ACCESS FILE (NO. OF
C                   CHARACTERS FOR A FORMATTED FILE OR WORDS FOR
C                   AN UNFORMATTED FILE). NOT RELEVANT FOR A SEQUENTIAL
C                   FILE
C
C       IFAIL (I/O) INTEGER: ON INPUT     =0, STOP ON OPEN FAILURE
C                                         =1, CONTINUE AFTER OPEN FAILURE
C                                             (only on file not found)
C                                         =2, CONTINUE SILENTLY AFTER OPEN FAILURE
C                                         =-1, As 0, but silent on success
C                                             (equivalent to negative IUN)
C                            ON OUTPUT    UNCHANGED IF FILE OPEN OK
C                                         =-1, ERROR IN OPENING FILE
C_END_CCPDPN
C
C     .. Scalar Arguments ..
      INTEGER IFAIL,IUN,IUN1,LREC
      CHARACTER LOGNAM* (*),STATUS* (*),TYPE* (*)
C     ..
C     .. Local Scalars ..
      INTEGER ISTAT,ITYPE
      CHARACTER ERRSTR*80
C     ..
C     .. Local Arrays ..
      CHARACTER TYPES(4)*2,STATS(6)*8, STAT*8, TYP*2
C     ..
C     .. External Functions ..
      INTEGER CCPNUN,LENSTR
      EXTERNAL CCPNUN,LENSTR
C     ..
C     .. External Subroutines ..
      EXTERNAL CCPOPN
C     ..
C     .. Data statements ..
      DATA STATS/'UNKNOWN','SCRATCH','OLD','NEW','READONLY','PRINTER'/
      DATA TYPES/'F','U','DF','DU'/
C     ..
C
      IF (IUN .EQ. 0) IUN = CCPNUN()
      STAT = STATUS
      TYP = TYPE
      CALL CCPUPC(STAT)
      CALL CCPUPC(TYP)
      DO 10 ISTAT = 1,6
        IF (STAT.EQ.STATS(ISTAT)) GO TO 20
   10 CONTINUE
      ERRSTR = ' CCPDPN: illegal status : '
      ERRSTR(LENSTR(ERRSTR)+2:) = STATUS
      CALL CCPERR(1,ERRSTR)
C
   20 DO 30 ITYPE = 1,4
        IF (TYP.EQ.TYPES(ITYPE)) GO TO 40
   30 CONTINUE
      ERRSTR = ' CCPDPN: illegal type: '
      ERRSTR(LENSTR(ERRSTR)+2:) = TYPE
      CALL CCPERR(1,ERRSTR)
C
 40   CONTINUE
      IUN1 = IUN
C  If IFAIL lt 0 No open message from CCPOPN
      IF(IFAIL.LT.0 .AND. IUN.GT.0) THEN
        IUN1 = -IUN
        IFAIL = 0
      ENDIF
      CALL CCPOPN(IUN1,LOGNAM,ISTAT,ITYPE,LREC,IFAIL)
C
      END
C
C
C_BEGIN_CCPE2I
      INTEGER FUNCTION CCPE2I (NAME, DEFVAL)
C     ======================================
C
C     Return an integer extracted from enviroment variable NAME.  If
C     NAME isn't defined, use DEFVAL as the default.  If the value of
C     NAME isn't a representation of an integer, abort.
C
C     Arguments
C     =========
C
C     NAME (I)    CHARACTER *(*)
C     DEFVAL (I)  INTEGER
C_END_CCPE2I
      CHARACTER *(*) NAME
      CHARACTER BUFFER*80, EMESS*100
      INTEGER DEFVAL, LENSTR
      EXTERNAL UGTENV, LENSTR
      BUFFER = ' '
      CALL UGTENV (NAME, BUFFER)
      IF (BUFFER.EQ.' ') THEN
        CCPE2I = DEFVAL
        RETURN
      ENDIF
      READ (BUFFER, '(BN,I80)', ERR=99) CCPE2I
      RETURN 
 99   EMESS = ' Logical name '
      EMESS(LENSTR(EMESS)+2:) = NAME(1:LENSTR(NAME))
      IF(LENSTR(EMESS) .LE. 99) THEN
        EMESS(LENSTR(EMESS)+1:) =' should represent an integer and is: '
        IF(LENSTR(EMESS) .LE. 98) 
     .           EMESS(LENSTR(EMESS)+2:) = BUFFER(1:LENSTR(BUFFER))
      ENDIF
      CALL CCPERR (1, EMESS)
      END
C
C
C SUBROUTINE 'CCPGI2'
C ===================
C
C_BEGIN_CCPGI2
      SUBROUTINE CCPGI2(IVAL,IA,N)
C     ============================
C
C GET AN UNSIGNED INTEGER*2 VALUE FROM 0 TO 65535 FROM THE N'TH unsigned
C INTEGER*2 ELEMENT OF AN INTEGER (OR OTHER) ARRAY.
C
C (MUST BE IMPLEMENTED IF CCPBYT FUNCTION RETURNS .TRUE.)
C [added for LAUE]
C
C Arguments:
C ==========
C
C    IVAL (O)   INTEGER: THE RETURNED VALUE FROM 0 TO 65535
C      IA (I/O) INTEGER*2 ARRAY(*): FROM WHICH THE UNSIGNED INTEGER*2 VALUE
C               IS TO BE RETRIEVED
C       N (I)   INTEGER: POSITION IN 'IA' WHERE THE UNSIGNED INTEGER*2 VALUE
C               IS TO BE RETRIEVED
C_END_CCPGI2
C
C SPECIFICATION STATEMENTS
C ------------------------
C
      INTEGER*2 IA(*)
      INTEGER*2 JBYT(2)
      EQUIVALENCE (JA,JBYT(1))
      LOGICAL CALLED, LITEND
      EXTERNAL LITEND
      INTEGER IND
      SAVE CALLED, IND
      DATA CALLED/.FALSE./
C
      IF (.NOT.CALLED) THEN
        IF (LITEND(1)) THEN
          IND = 1
        ELSE
          IND = 2
        ENDIF
        CALLED=.TRUE.
      ENDIF
C
C GET UNSIGNED INTEGER*2
C ----------------------
C
      JA=0
      JBYT(IND)=IA(N)
      IVAL=JA
      END
C
C
C SUBROUTINE 'CCPGTB'
C ===================
C
C_BEGIN_CCPGTB
      SUBROUTINE CCPGTB(IVAL,IA,N)
C     ============================
C
C GET AN UNSIGNED BYTE VALUE FROM 0 TO 255 FROM THE N'TH BYTE OF AN INTEGER
C (OR OTHER) ARRAY.
C
C (MUST BE IMPLEMENTED IF CCPBYT FUNCTION RETURNS .TRUE.)
C [for LAUE]
C
C Arguments:
C ==========
C
C    IVAL (O)   INTEGER: THE RETURNED VALUE FROM 0 TO 255
C      IA (I/O) BYTE ARRAY(*): FROM WHICH THE BYTE VALUE IS TO BE RETRIEVED
C       N (I)   INTEGER: THE POSITION IN 'IA' WHERE THE BYTE VALUE IS
C               TO BE RETRIEVED
C_END_CCPGTB
C
C SPECIFICATION STATEMENTS
C ------------------------
C
      INTEGER*1 IA(*)
      INTEGER*1 JBYT(4)
      EQUIVALENCE (JA,JBYT(1))
      LOGICAL CALLED, LITEND
      EXTERNAL LITEND
      INTEGER IND
      SAVE CALLED, IND
      DATA CALLED/.FALSE./
C
      IF (.NOT.CALLED) THEN
        IF (LITEND(1)) THEN
          IND = 1
        ELSE
          IND = 4
        ENDIF
        CALLED=.TRUE.
      ENDIF
C
C GET BYTE
C --------
C
      JA=0
      JBYT(IND)=IA(N)
      IVAL=JA
      END
C
C
C SUBROUTINE 'CCPI2I'
C ===================
C_BEGIN_CCPI2I
      SUBROUTINE CCPI2I(IA,I2,NE,SIGNED,SWAPB)
C     ========================================
C
C Copy an array of INTEGER*2 elements into an integer array
C
C (Must be implemented if ccpbyt function returns .TRUE.)
C [for LAUE]
C
C Arguments:
C ==========
C
C      IA (O)   INTEGER Array(*): to return values
C      I2 (I)   INTEGER*2 Array(*): holding data (may be an INTEGER array for
C               example with data packed into adjacant INTEGER*2 elements
C      NE (I)   INTEGER: The number of elements to be copied
C  SIGNED (I)   LOGICAL: =.TRUE.  Copy as signed integer*2 values
C                        =.FALSE. Copy as unsigned integer*2 values
C   SWAPB (I)   LOGICAL: =.TRUE.  Swap bytes in the integer*2 elements
C                        =.FALSE. Do not swap bytes
C_END_CCPI2I
C
C====== Specification statements
C
      LOGICAL SIGNED, SWAPB
      INTEGER IA(*),JA
      INTEGER*2 I2(*)
      INTEGER*2 J2(2)
      INTEGER*2 IEIGHT, I255
      PARAMETER (I255=255)
      EQUIVALENCE (JA,J2(1))
      LOGICAL CALLED, LITEND
      EXTERNAL LITEND
      INTEGER IND,I,NE
      SAVE CALLED, IND
      DATA CALLED/.FALSE./
C
      IF (.NOT.CALLED) THEN
        IF (LITEND(1)) THEN
          IND = 1
        ELSE
          IND = 2
        ENDIF
        CALLED=.TRUE.
      ENDIF
C
C====== Swap bytes if required
C
      IEIGHT = 8
      IF (SWAPB) THEN
         DO 10 I = 1,NE
            I2(I) = IOR(IAND(ISHFT(I2(I),-IEIGHT),I255),
     +              ISHFT(I2(I),IEIGHT))
10       CONTINUE
      END IF
C
C====== Copy data
C
      IF (SIGNED) THEN
         DO 20 I=1,NE
            IA(I) = I2(I)
20       CONTINUE
      ELSE
         JA=0
         DO 30 I=1,NE
         J2(IND)=I2(I)
         IA(I)=JA
30       CONTINUE
      END IF
      END
C
C
C
C SUBROUTINE 'CCPIBY'
C ===================
C
C_BEGIN_CCPIBY
      SUBROUTINE CCPIBY(IBYT,IA,NB)
C     =============================
C
C COPY AN ARRAY OF INTEGERS INTO AN ARRAY OF UNSIGNED (OR UNSIGNED) BYTES.
C NOTE: NO OVERFLOW CHECKING IS DONE.
C
C (MUST BE IMPLEMENTED IF CCPBYT FUNCTION RETURNS .TRUE.)
C [for LAUE]
C
C Arguments:
C ==========
C
C    IBYT (O)   BYTE ARRAY(*) RETURNING DATA (MAY BE AN INTEGER ARRAY
C               FOR EXAMPLE WITH DATA PACKED INTO ADJACENT BYTES)
C      IA (I)   INTEGER ARRAY(*): Input values
C      NB (I)   INTEGER: IF >0, THE NUMBER OF ELEMENTS TO BE COPIED TO
C                        UNSIGNED BYTES
C                        IF <0, -THE NUMBER OF ELEMENTS TO BE COPIED TO
C                        SIGNED BYTES
C_END_CCPIBY
C
C SPECIFICATION STATEMENTS
C ------------------------
C
      INTEGER IA(*)
      INTEGER*1 IBYT(*)
      INTEGER*1 JBYT(4)
      EQUIVALENCE (JA,JBYT(1))
      LOGICAL CALLED, LITEND
      EXTERNAL LITEND
      INTEGER IND
      SAVE CALLED, IND
      DATA CALLED/.FALSE./
C
      IF (.NOT.CALLED) THEN
        IF (LITEND(1)) THEN
          IND = 1
        ELSE
          IND = 4
        ENDIF
        CALLED=.TRUE.
      ENDIF
C
C COPY DATA
C ---------
C
      NE = NB
      IF (NE.GT.0) THEN
         DO 10 I=1,NE
         JA=IA(I)
         IBYT(I)=JBYT(IND)
10       CONTINUE
      ELSE
         NE = -NE
         DO 20 I=1,NE
         IBYT(I) = IA(I)
20       CONTINUE
      END IF
      END
C
C
C
C SUBROUTINE 'CCPII2'
C ===================
C
C_BEGIN_CCPII2
      SUBROUTINE CCPII2(I2,IA,NE,SIGNED,SWAPB)
C     ========================================
C
C Copy an array of integers into an array of INTEGER*2 elements.
C NOTE: No overflow checking is done.
C
C (Must be implemented if ccpbyt function returns .TRUE.)
C [for LAUE]
C
C Arguments:
C ==========
C
C      I2 (O)   INTEGER*2 ARRAY(*): returning data (may be an INTEGER array for
C               example with data packed into adjacent INTEGER*2 elements)
C      IA (I)   INTEGER ARRAY(*): holding input values
C      NE (I)   INTEGER: The number of elements to be copied
C  SIGNED (I)   LOGICAL: =.TRUE.  Copy as signed integer*2 values
C                        =.FALSE. Copy as unsigned integer*2 values
C   SWAPB (I)   LOGICAL: =.TRUE.  Swap bytes in the integer*2 elements
C                        =.FALSE. Do not swap bytes
C_END_CCPII2
C
C====== Specification statements
C
      LOGICAL SIGNED, SWAPB
      INTEGER IA(*)
      INTEGER*2 I2(*)
      INTEGER*2 J2(2)
      INTEGER*2 IEIGHT, I255
      PARAMETER (I255=255)
      EQUIVALENCE (JA,J2(1))
      LOGICAL CALLED, LITEND
      EXTERNAL LITEND
      INTEGER IND
      SAVE CALLED, IND
      DATA CALLED/.FALSE./
C
      IF (.NOT.CALLED) THEN
        IF (LITEND(1)) THEN
          IND = 1
        ELSE
          IND = 2
        ENDIF
        CALLED=.TRUE.
      ENDIF
C
C====== Copy data
C
      IEIGHT = 8
      IF (SIGNED) THEN
         DO 10 I=1,NE
            I2(I) = IA(I)
10       CONTINUE
      ELSE
         DO 20 I=1,NE
            JA=IA(I)
            I2(I)=J2(IND)
20       CONTINUE
      ENDIF
C
C====== Swap bytes if required
C
      IF (SWAPB) THEN
         DO 30 I = 1,NE
            I2(I) = IOR(IAND(ISHFT(I2(I),-IEIGHT),I255),
     +              ISHFT(I2(I),IEIGHT))
30       CONTINUE
      END IF
      END
C
C
C
C_BEGIN_CCPMDE
      SUBROUTINE CCPMDE(MODE,NBYT)
C     ============================
C
C---- If byte handling is available (see ccpbyt) then this subroutine
C     returns the number of bytes per data item for the different modes
C     used, in particular, in the map handling subroutines.
C
C---- If byte handling is not available, then the number of words per
C     item is returned with zeros for the undefined items
C
C Arguments:
C ==========
C
C        MODE (I)   INTEGER:
C                   MODE = 0,   BYTES
C                        = 1,   SHORT (2 BYTE) INTEGERS
C                        = 2,   REAL/INTEGER (SINGLE WORD)
C                        = 3,   SHORT COMPLEX (2 * 2 BYTE INTEGERS)
C                        = 4,   COMPLEX (TWO WORDS)
C
C        NBYT (O)   INTEGER:
C                        > 0,   THE NUMBER OF BYTES FOR THE ITEM  IF
C                               CCPBYT RETURNS .TRUE. OR THE  NUMBER
C                               OF WORDS IF CCPBYT RETURNS .FALSE.
C                        = 0,   NO VALUE AVAILABLE FOR THIS MODE
C                        = -1,  INVALID MODE
C
C  TYPICAL VALUES:  1  2  4  4  8    IF BYTE HANDLING AVAILABLE WITH 4
C                                    BYTES/WORD
C                   0  0  1  0  2    IF BYTE HANDLING UNAVAILABLE
C_END_CCPMDE
C
C SPECIFICATION STATEMENTS
C ------------------------
C
C     .. Scalar Arguments ..
      INTEGER MODE,NBYT
C     ..
C     .. Local Arrays ..
      INTEGER MODES(0:4)
C     ..
C     .. Data statements ..
      DATA MODES/1,2,4,4,8/
C     ..
C
C---- Get number of bytes or words
C
      NBYT = -1
      IF (MODE.GE.0 .AND. MODE.LE.4) NBYT = MODES(MODE)
      END
C
C
C
C_BEGIN_CCPMVB
      SUBROUTINE CCPMVB(ARR1,I1,ARR2,I2,NTOMOV)
C     =========================================
C
C---- This subroutine moves bytes from one non-character array
C     to another. I must be implemented if ccpbyt returns .true.
C     but will otherwise be a dummy routine.
C
C Arguments:
C ==========
C
C        ARR1 (I/O) BYTE ARRAY(*): TO WHICH BYTES ARE TO BE COPIED
C          I1 (I)   INTEGER: THE START BYTE NUMBER IN ARR1 WHERE THE BYTES ARE
C                   TO BE COPIED
C        ARR2 (I)   BYTE ARRAY(*): FROM WHICH BYTES ARE TO BE COPIED
C          I2 (I)   THE START BYTE NUMBER IN ARR2 FROM WHICH THE BYTES
C                   ARE TO BE COPIED
C      NTOMOV (I)   INTEGER: THE NUMBER OF BYTES TO BE COPIED
C_END_CCPMVB
C
C     .. Scalar Arguments ..
      INTEGER I1,I2,NTOMOV
C     ..
C     .. Array Arguments ..
      INTEGER*1 ARR1(*),ARR2(*)
C     ..
C     .. Local Scalars ..
      INTEGER I,J,N
C     ..
      I = I1 - 1
      J = I2 - 1
      DO 10 N = 1,NTOMOV
        I = I + 1
        J = J + 1
        ARR1(I) = ARR2(J)
   10 CONTINUE
C
      END
C
C
C_BEGIN_CCPMVI
      SUBROUTINE CCPMVI (IARR1,IARR2,NUM)
C     =================================
C
C  This routine assigns the first NUM words of IARR2 to IARR1
C
C Arguments:
C ==========
C
C    IARR1 (O)   INTEGER ARRAY(*)
C    IARR2 (O)   INTEGER ARRAY(*)
C     NUM (I)   Number of words to copy
C_END_CCPMVI
C
C  Arguments
      INTEGER NUM
      REAL IARR1(*),IARR2(*)
C
      INTEGER J
C
      DO 10 J=1,NUM
   10 IARR1(J)=IARR2(J)
      END
C
C
C_BEGIN_CCPMVR
      SUBROUTINE CCPMVR (ARR1,ARR2,NUM)
C     =================================
C
C  This routine assigns the first NUM elements of ARR2 to ARR1
C
C Arguments:
C ==========
C
C    ARR1 (O)   REAL ARRAY(*)
C    ARR2 (O)   REAL ARRAY(*)
C     NUM (I)   Number of words to copy
C_END_CCPMVR
C
C  Arguments
      INTEGER NUM
      REAL ARR1(*),ARR2(*)
C
      INTEGER J
C
      DO 10 J=1,NUM
   10 ARR1(J)=ARR2(J)
      END
C
C_BEGIN_CCPNUN
      INTEGER FUNCTION CCPNUN ()
C     ==========================
C
C     Return (the next) unused (not connected) i/o unit number.
C     Use this to select an arbitrary unit for i/o to avoid clashes with
C     other code.  (The value returned will be the same until the unit in
C     question is opened or a lower-numbered one is closed.)
C
C_END_CCPNUN
      LOGICAL OD, EX
      EXTERNAL CCPERR
      INTEGER IOS
C     The `standard' unit 5 and 6 may or may not be reported as open,
C     normally depending on whether an appropriate read or write has
C     happened, so we'll start at 7.  Lower-numbered ones might be used
C     for other things such as standard error.  99 seems a reasonable
C     place to stop.
      DO 10 CCPNUN=7,99
        INQUIRE (UNIT=CCPNUN, OPENED=OD, IOSTAT=IOS, EXIST=EX)
        IF (EX .AND. (.NOT.OD) .AND. IOS.EQ.0) RETURN
 10   CONTINUE
      CALL CCPERR (1, 'CCPNUN: Can''t find an unused unit')
      END
C
C
C
C_BEGIN_CCPONL
      LOGICAL FUNCTION CCPONL(IDUM)
C     =============================
C
C---- This function determines whether a program is being run on-line
C     if this information is available
C
C Arguments:
C ==========
C
C        IDUM (D)   DUMMY
C
C RETURNS .TRUE.  IF PROGRAM IS BEING RUN ON-LINE
C RETURNS .FALSE. IF BATCH MODE OR STATUS UNKNOWN
C_END_CCPONL
C
C     .. Scalar Arguments ..
      INTEGER IDUM
C     ..
C     .. Local Scalars ..
      INTEGER IYES,ITERM
C     ..
C     .. External Functions ..
      EXTERNAL UISATT
C     ..
C
C      test for fortran unit=6 o/p
C
      IYES = 0
      ITERM = 6
      CALL UISATT(ITERM,IYES)
      CCPONL = IYES.EQ.1
      END
C
C
C
C SUBROUTINE 'CCPPSF'
C ===================
C
C_BEGIN_CCPPSF
      SUBROUTINE CCPPSF(FILNAM,PATH,NAME,TYPE,VERS)
C     =============================================
C
C PARSE FILE NAME INTO COMPONENTS
C
C NOTE: THE ROUTINE  CONTAINS MACHINE DEPENDENT CODE
C
C
C Arguments:
C ==========
C
C      FILNAM (I)   CHARACTER*(*): FILE NAME STRING (NO EMBEDDED BLANKS ASSUMED)
C
C        PATH (O)   CHARACTER*(*): STRING RETURNING PATH OR, FOR VAX VMS,
C                   THE PART OF THE FILE SPECIFICATION UP TO THE
C                   END OF THE DIRECTORY SPECIFICATION (BLANK IF NONE)
C                   (INCLUDES TERMINATING ] or : or /)
C
C        NAME (O)   CHARACTER*(*): STRING RETURNING NAME.  (BLANK IF NONE)
C
C        TYPE (O)   CHARACTER*(*): STRING RETURNING FILE TYPE/EXTENSION
C                   (BLANK IF NONE)
C
C        VERS (O)   CHARACTER*(*): STRING RETURNING THE VERSION.
C                   (BLANK IF NONE)
C
C AFTER REMOVAL OF THE PATH PART OF THE STRING, IF PRESENT, THE VERSION ON
C A VAX IS TAKEN AS ANY TEXT FOLLOWING A SEMICOLON IN THE STRING OR, IF NO
C SEMICOLON IS PRESENT, ANY TEXT FOLLOWING THE LAST DOT IN THE STRING
C PROVIDED THAT AT LEAST TWO DOTS ARE PRESENT. ON A UNIX SYSTEM THE VERSION
C WILL ALWAYS BE RETURNED AS A BLANK.
C
C AFTER THE REMOVAL OF THE PATH AND VERSION PARTS OF THE STRING THEN, IF
C THERE IS AT LEAST ONE DOT, THE NAME IS THE STRING UP TO THE LAST DOT
C REMAINING AND THE TYPE IS THE PART OF THE STRING AFTER THE DOT. IF
C NO DOT IS PRESENT THEN THE REMAINING STRING IS THE NAME AND THE TYPE
C IS BLANK.
C_END_CCPPSF
C
C SPECIFICATION STATEMENTS
C ------------------------
C
      CHARACTER*(*) FILNAM,PATH,NAME,TYPE,VERS
      INTEGER LMAX,LMIN,L,LSC,LDOT,NDOT,LENSTR
      EXTERNAL VAXVMS, WINMVS, RTNBKS, LENSTR
      LOGICAL VAXVMS, WINMVS, VMS, MVS
      CHARACTER RTNBKS*1, BKS*1
C
C INITIALISATIONS
C ---------------
C
      PATH=' '
      NAME=' '
      TYPE=' '
      VERS=' '
      LMAX=LENSTR(FILNAM)
      IF (LMAX.EQ.0) RETURN
      LMIN=0
      VMS = VAXVMS()
      MVS = WINMVS()
      BKS = RTNBKS()      
10    LMIN=LMIN+1
      IF (FILNAM(LMIN:LMIN).EQ.' ') GO TO 10
C
C GET PATH
C --------
C
      IF (VMS) THEN
        DO 20 L=LMAX,LMIN,-1
          IF (FILNAM(L:L).EQ.':'.OR.FILNAM(L:L).EQ.']') GO TO 30
 20     CONTINUE
      ELSEIF (MVS) THEN
        DO 21 L=LMAX,LMIN,-1
          IF (FILNAM(L:L).EQ.BKS .OR. FILNAM(L:L).EQ.'/')GO TO 30
 21     CONTINUE
      ELSE
        DO 22 L=LMAX,LMIN,-1
          IF (FILNAM(L:L).EQ.'/')GO TO 30
 22     CONTINUE
      ENDIF
      GO TO 40
30    PATH=FILNAM(LMIN:L)
      LMIN=L+1
      IF (LMIN.GT.LMAX) RETURN
C
C GET VERSION IF PRESENT
C ----------------------
C
 40   CONTINUE
      IF (VMS) THEN
        LSC=INDEX(FILNAM(LMIN:LMAX),';')
        IF (LSC.GT.0) THEN
          LSC=LSC+LMIN-1
          IF (LSC.LT.LMAX) VERS=FILNAM(LSC+1:LMAX)
          LMAX=LSC-1
        ELSE
          LDOT=0
          NDOT=0
          DO 50 L=LMAX,LMIN,-1
            IF (FILNAM(L:L).EQ.'.') THEN
              NDOT=NDOT+1
              IF (LDOT.EQ.0) LDOT=L
            ENDIF
 50       CONTINUE
          IF (NDOT.GT.1) THEN
            IF (LDOT.LT.LMAX) VERS=FILNAM(LDOT+1:LMAX)
            LMAX=LDOT-1
          ENDIF
        ENDIF
      ENDIF
C
C GET NAME AND TYPE
C -----------------
C
      IF (LMAX.LT.LMIN) RETURN
      LDOT=0
      DO 60 L=LMAX,LMIN,-1
      IF (FILNAM(L:L).EQ.'.') THEN
         LDOT=L
         GO TO 70
      ENDIF
60    CONTINUE
70    IF (LDOT.EQ.0) THEN
         NAME=FILNAM(LMIN:LMAX)
         RETURN
      ELSE
         IF (LDOT.GT.LMIN) NAME=FILNAM(LMIN:LDOT-1)
         IF (LDOT.LT.LMAX) TYPE=FILNAM(LDOT+1:LMAX)
      ENDIF
      END
C
C
C_BEGIN_CSETNV
      SUBROUTINE CSETNV(LNAME,FILNAM,ENAME,ETYPE,EXTN,ICOUNT,LSKIP)
C     =============================================================
C
C     Associate `logical name' LNAME with value FILNAM.  It is passed
C     arrays of (name, type, extension) for ICOUNT number of name lines
C     read from environ.def.  Doesn't re-define existing name if LSKIP is true.
C
C Arguments:
C ==========
C
C   LNAME (I)   CHARACTER*(*): Logical name (environment variable).
C
C  FILNAM (I/O) CHARACTER*(*): File name, if extension is omitted it is appended
C
C   ENAME (I/O) CHARACTER(150)*20 ARRAY: containing list of environment
C               variables; if LNAME is not in list it is appended
C               (also to ETYPE & EXTN arrays).
C
C   ETYPE (I,O) CHARACTER(150)*5 ARRAY: containing list of in/out types.
C
C    EXTN (I/O) CHARACTER(150)*4 ARRAY: containing list of extensions.
C
C  ICOUNT (I/O) INTEGER: Length of arrays ENAME, ETYPE & EXTN.
C
C   LSKIP (I)   LOGICAL: If .TRUE. existing name not re-defined.
C
C_END_CSETNV
C
C     .. Parameters ..
      INTEGER ILIMIT,ISTRLN,IENV
      PARAMETER (ILIMIT=150,ISTRLN=200,IENV=20)
C     ..
C     .. Scalar Arguments ..
      INTEGER ICOUNT
      CHARACTER LNAME* (*),FILNAM* (*)
      LOGICAL LSKIP
C     ..
C     .. Array Arguments ..
      CHARACTER ENAME(ILIMIT)* (IENV),ETYPE(ILIMIT)* (5),
     +          EXTN(ILIMIT)* (4)
C     ..
C     .. Local Scalars ..
      INTEGER I,II,ISTAT,JJ,PROCID
      LOGICAL VAX,MVS,EXIST
      CHARACTER ERRSTR* (ISTRLN),LIBFIL* (ISTRLN),PROGNM* (ISTRLN),
     +          TMPNAM* (ISTRLN),LINE* (ISTRLN),SCRFIL* (ISTRLN),
     +          BKS*(1)
C     ..
C     .. External Functions ..
      INTEGER GETPID,LENSTR
      LOGICAL VAXVMS, WINMVS
      CHARACTER FDIR* (ISTRLN),FEXTN* (ISTRLN),FROOT* (ISTRLN), RTNBKS
      EXTERNAL LENSTR,VAXVMS,FDIR,FEXTN,FROOT
C     ..
C     .. External Subroutines ..
      EXTERNAL CCPERR,UGTARG,QPRINT,UGTENV,USTENV
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC INDEX
C     ..
      SAVE
      DATA PROGNM/' '/
C
C---- Check Logical Name does not already exist (unless processing
C     command line, in which case LSKIP will be true to override
C     environment)
C
      CALL UGTENV(LNAME,TMPNAM)
      IF (TMPNAM.NE.' ' .AND. LSKIP ) RETURN
      VAX = VAXVMS()
      MVS = WINMVS()
      BKS = RTNBKS()
C
C---- Get program name (argv[0]), but check if we have it already
C
      IF (PROGNM.EQ.' ') THEN
        CALL UGTARG(0,TMPNAM)
        PROGNM = FROOT(TMPNAM)
      ENDIF
C
C---- look through list for a match (possibly abbreviated) [is this
C     abbreviation possibility documented?]
C
      DO 10 JJ = 1,ICOUNT
        IF (ENAME(JJ).EQ.LNAME(1:LENSTR(ENAME(JJ)))) GO TO 20
   10 CONTINUE
C
C---- Unknown logical name add it to the list.
C
      TMPNAM = 'Non standard logical name '
      TMPNAM(27:) = LNAME
      CALL QPRINT(2,TMPNAM)
      ICOUNT = ICOUNT + 1
      IF (ICOUNT.GT.ILIMIT)
     +     CALL CCPERR(1,'Too many logical names')
      ENAME(ICOUNT) = LNAME
      ETYPE(ICOUNT) = 'undef'
      IF (LENSTR(FEXTN(FILNAM)).GT.4)
     +  CALL CCPERR(2,
     +  'Extension too long in s/r CSETNV: '//FEXTN(FILNAM))
      EXTN(ICOUNT) = FEXTN(FILNAM)
      JJ = ICOUNT
C
C---- Known logical name processing
C
   20 IF (FEXTN(FILNAM).EQ.' ') THEN
C
C---- Add extension
C
        IF (FILNAM.EQ.'/dev/null' .OR. FILNAM.EQ.'NL:') THEN
C          but not if FILNAM is /dev/null or NL:
          GOTO 333
        ELSE
          II = LENSTR(FILNAM) + 1
          FILNAM(II:) = EXTN(JJ)
        ENDIF
      ENDIF
      IF (FDIR(FILNAM).EQ.' ') THEN
CCC       this didn't agree with documentation:
CCC        IF (EXTN(JJ).EQ.'.lib' .OR. EXTN(JJ).EQ.'.prt' .OR.
CCC     +      EXTN(JJ).EQ.'.bes' .OR. EXTN(JJ).EQ.'.dic') THEN
        TMPNAM = FEXTN(FILNAM)
        IF (VAX) CALL CCPLWC(TMPNAM)
        IF (TMPNAM.EQ.'lib' .OR. TMPNAM.EQ.'prt' .OR.
     +      TMPNAM.EQ.'bes' .OR. TMPNAM.EQ.'dic') THEN
C         look for files without path but with standard extension in the
C         standard place
          CALL UGTENV('CLIBD',LIBFIL)
C         add the standard directory qualifier
          IF (VAX) THEN
C           fixme: should we insist that VMS defines CLIBD as well as un*x?
            IF (LIBFIL.NE.' ') THEN
              TMPNAM = 'CLIBD:'
              TMPNAM(7:) = FILNAM
            ELSE
              TMPNAM = FILNAM
            ENDIF
          ELSEIF (MVS) THEN
            IF (LIBFIL.EQ.' ') CALL CCPERR(1,'CLIBD not defined')
            II = LENSTR(LIBFIL)
            TMPNAM = LIBFIL(:II)//BKS
            II = II + 2
            TMPNAM(II:) = FILNAM
          ELSE
            IF (LIBFIL.EQ.' ') CALL CCPERR(1,'CLIBD not defined')
            II = LENSTR(LIBFIL)
            TMPNAM = LIBFIL(:II)//'/'
            II = II + 2
            TMPNAM(II:) = FILNAM
          END IF
          FILNAM = TMPNAM
        ELSE IF (EXTN(JJ).EQ.'.scr' .OR. FEXTN(FILNAM).EQ.'scr') THEN
C         scratch files in a special place
C         actually create <ccp4_scr>/<prognm>_.<pid>
          CALL UGTENV('CCP4_SCR',TMPNAM)
          IF (VAX) THEN
            IF (TMPNAM.EQ.' ') THEN
              TMPNAM = PROGNM
            ELSE
              TMPNAM = 'CCP4_SCR:' // PROGNM
            ENDIF
          ELSEIF (MVS) THEN
            IF (TMPNAM.EQ.' ') CALL CCPERR(1,'CCP4_SCR not defined')
            II = LENSTR(TMPNAM) + 1
            TMPNAM(II:) = BKS//PROGNM
          ELSE
            IF (TMPNAM.EQ.' ') CALL CCPERR(1,'CCP4_SCR not defined')
            II = LENSTR(TMPNAM) + 1
            TMPNAM(II:) = '/'//PROGNM
          END IF
          II = LENSTR(TMPNAM) + 1
          TMPNAM(II:II) = '_'
          II = II + 1
          I = INDEX(FILNAM,'.')
          TMPNAM(II:) = FILNAM(:I)
          IF (VAX) THEN
            WRITE (SCRFIL,'(Z8.8)') GETPID()
          ELSE
            PROCID = MOD(GETPID(),100000)
C     Windows98 does not return a pid so make a number up
            IF (PROCID.GT.99999 .OR. PROCID.LE.0) THEN
              CALL USTIME(PROCID)
              PROCID = MOD(PROCID,100000)
            ENDIF
            WRITE (SCRFIL,'(I5.5)') PROCID
          ENDIF
          FILNAM = TMPNAM(1:LENSTR(TMPNAM))//SCRFIL
        END IF
      END IF
333   CONTINUE
C
C---- Now test input files do exist (but not for defaults, to avoid
C     checking 40 or 50 files listed in default.def which the setup
C     should guarantee)
C
      IF (ETYPE(JJ).EQ.'in' .AND. .NOT.LSKIP) THEN
        INQUIRE(FILE=FILNAM,EXIST=EXIST)
        IF (.NOT.EXIST) THEN
          ERRSTR = 'Cannot find file '
          ERRSTR(18:) = FILNAM
          CALL CCPERR (-1,ERRSTR)
        END IF
      END IF
      II = LENSTR(LNAME) + 1
      LINE = LNAME
      LINE(II:II) = '='
      II = II + 1
      LINE(II:) = FILNAM
C     =======================================
      CALL USTENV(LINE(1:LENSTR(LINE)),ISTAT)
C     =======================================
      IF (ISTAT.NE.0) THEN
        IF (VAX) THEN
          ERRSTR = 'Cannot create environment variable '
        ELSE
          ERRSTR = 'Cannot create logical name '
        ENDIF
        ERRSTR(36:) = LNAME
        CALL CCPERR (-1,ERRSTR)
      END IF
      CALL QPRINT(3,LINE)
      END
C
C
C
C_BEGIN_CCPPAG
      SUBROUTINE CCPPAG(IUN,NCOL,NLIN)
C     ================================
C
C---- This subroutine returns the number of columns and lines
C     for a printer output page on a given fortran unit number
C     if the information is available
C
C Arguments:
C ==========
C
C         IUN (I)   INTEGER: FORTRAN UNIT NUMBER
C        NCOL (O)   INTEGER: NUMBER OF COLUMNS IN THE PAGE
C        NLIN (O)   INTEGER: NUMBER OF LINES IN THE PAGE
C
C Return 80,132 unless a terminal whence 0,80
C_END_CCPPAG
C
C     .. Scalar Arguments ..
      INTEGER IUN,NCOL,NLIN
C     ..
C     .. Local Scalars ..
      INTEGER IYES
C     ..
C     .. External Subroutines ..
      EXTERNAL UISATT
C     ..
      CALL UISATT(IUN,IYES)
      IF (IYES.EQ.1) THEN
        NLIN = 0
        NCOL = 80
      ELSE
        NLIN = 80
        NCOL = 132
      END IF
      END
C
C
C
C SUBROUTINE 'CCPSI2'
C ===================
C
C_BEGIN_CCPSI2
      SUBROUTINE CCPSI2(IVAL,IA,N)
C     ============================
C
C SET AN INTEGER VALUE FROM 0 TO 65535 INTO THE N'TH UNSIGNED INTEGER*2 ELEMENT
C OF AN INTEGER (OR OTHER) ARRAY.
C NOTE: NO OVERFLOW CHECKING IS DONE.
C
C (MUST BE IMPLEMENTED IF CCPBYT FUNCTION RETURNS .TRUE.)
C [for LAUE]
C
C Arguments:
C ==========
C
C    IVAL (I)   INTEGER: VALUE FROM 0 TO 65535
C
C      IA (I/O) INTEGER*2 ARRAY: WHERE THE UNSIGNED INTEGER*2 VALUE IS TO BE
C               INSERTED
C
C       N (I)   INTEGER: THE POSITION IN 'IA' WHERE THE UNSIGNED INTEGER*2
C               VALUE IS TO BE INSERTED
C_END_CCPSI2
C
C SPECIFICATION STATEMENTS
C ------------------------
C
      INTEGER*2 IA(*)
      INTEGER*2 JBYT(2)
      INTEGER   JA,IVAL,N
      EQUIVALENCE (JA,JBYT(1))
      LOGICAL CALLED, LITEND
      EXTERNAL LITEND
      INTEGER IND
      SAVE CALLED, IND
      DATA CALLED/.FALSE./
C
      IF (.NOT.CALLED) THEN
        IF (LITEND(1)) THEN
          IND = 1
        ELSE
          IND = 2
        ENDIF
        CALLED=.TRUE.
      ENDIF
C
C SET UNSIGNED INTEGER*2
C ----------------------
C
      JA=IVAL
      IA(N)=JBYT(IND)
      END
C
C
C
C SUBROUTINE 'CCPSTB'
C ===================
C
C_BEGIN_CCPSTB
      SUBROUTINE CCPSTB(IVAL,IA,N)
C     ============================
C
C SET AN INTEGER VALUE FROM 0 TO 255 INTO THE N'TH BYTE OF AN INTEGER
C (OR OTHER) ARRAY.
C NOTE: NO OVERFLOW CHECKING IS DONE.
C
C (MUST BE IMPLEMENTED IF CCPBYT FUNCTION RETURNS .TRUE.)
C [for LAUE]
C
C Arguments:
C ==========
C
C    IVAL (I)   INTEGER: VALUE FROM 0 TO 255
C      IA (I/O) BYTE ARRAY(*): WHERE THE BYTE VALUE IS TO BE INSERTED
C       N (I)   INTEGER: THE POSITION IN 'IA' WHERE THE BYTE VALUE IS TO
C               BE INSERTED
C_END_CCPSTB
C
C SPECIFICATION STATEMENTS
C ------------------------
C
      INTEGER*1 IA(*)
      INTEGER*1 JBYT(4)
      EQUIVALENCE (JA,JBYT(1))
      EQUIVALENCE (JA,JBYT(1))
      LOGICAL CALLED, LITEND
      EXTERNAL LITEND
      INTEGER IND
      SAVE CALLED, IND
      DATA CALLED/.FALSE./
C
      IF (.NOT.CALLED) THEN
        IF (LITEND(1)) THEN
          IND = 1
        ELSE
          IND = 4
        ENDIF
        CALLED=.TRUE.
      ENDIF
C
C SET BYTE
C --------
C
      JA=IVAL
      IA(N)=JBYT(IND)
      END
C
C
C
C_BEGIN_CCPSUM
      REAL FUNCTION CCPSUM(A,N,L)
C     ===========================
C
C---- This function sums the elements of an array. (for the cray this
C     function will call the cray 'ssum' function)
C
C Arguments:
C ==========
C
C           A (I)   REAL ARRAY(N): ARRAY TO BE SUMMED
C           N (I)   INTEGER: NO. OF ELEMENTS IN THE ARRAY
C           L (I)   INTEGER: SUM EVERY L'TH ELEMENT
C
C  CCPSUM RETURNS THE SUM
C_END_CCPSUM
C
C SPECIFICATION STATEMENTS AND CODE
C
C     .. Scalar Arguments ..
      INTEGER L,N
C     ..
C     .. Array Arguments ..
      REAL A(N)
C     ..
C     .. Local Scalars ..
      INTEGER I
C     ..
      CCPSUM = 0.0
      DO 10 I = 1,N,L
        CCPSUM = A(I) + CCPSUM
   10 CONTINUE
      END
C
C
C
C_BEGIN_CCPTOI
      SUBROUTINE CCPTOI(ARRAY,N,II,ITYP,IFAIL)
C     ========================================
C
C---- This subroutine converts the n'th byte or integer*2 element in a
C     non-character array to an integer value. it is used by the
C     map file handling routines and must be implemented if map modes
C     0,1,3 or 5 are to be used.
C
C Arguments:
C ==========
C
C       ARRAY (I)   REAL ARRAY(*): CONTAINING THE ELEMENTS TO BE CONVERTED
C
C           N (I)   INTEGER: THE NUMBER OF THE ELEMENT TO BE CONVERTED
C
C          II (O)   INTEGER: THE CALCULATED INTEGER VALUE (FOR BYTES THIS WILL
C                   BE IN THE RANGE 0-255)
C
C        ITYP (I)   INTEGER: THE CONVERSION TYPE =1, BYTE TO INTEGER
C                                                =2, INTEGER*2 TO INTEGER
C
C       IFAIL (I/O) INTEGER: ON INPUT   =0, STOP IF CONVERSION NOT AVAILABLE
C                                       =1, RETURN FROM SUBROUTINE ALWAYS
C                            ON OUTPUT  UNCHANGED IF CONVERSION CARRIED OUT
C                                       =-1 IF CONVERSION NOT AVAILABLE
C_END_CCPTOI
C
C     .. Scalar Arguments ..
      INTEGER IFAIL,II,ITYP,N
C     ..
C     .. Array Arguments ..
      REAL ARRAY(*)
C     ..
C     .. Local Scalars ..
      REAL RR
      INTEGER IA,NB,NIH,NW
C     ..
C     .. Local Arrays ..
      INTEGER*1 IBYT(4),JBYT(4)
      INTEGER*2 JHALF(2)
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC MOD
C     ..
C     .. Equivalences ..
      EQUIVALENCE (IA,IBYT(1))
      EQUIVALENCE (RR,JHALF(1),JBYT(1))
C     ..
      LOGICAL CALLED, LITEND
      INTEGER IND
      EXTERNAL LITEND, CCPERR
      SAVE CALLED, IND
      DATA CALLED/.FALSE./
C
      IF (.NOT.CALLED) THEN
        CALLED=.TRUE.
        IF (LITEND(1)) THEN
          IND = 1
        ELSE
          IND = 4
        ENDIF
      ENDIF
C
      GO TO (10,20) ITYP
C
C---- Byte to integer value
C
   10 NW = (N-1)/4 + 1
      NB = MOD(N-1,4) + 1
      IA = 0
      RR = ARRAY(NW)
      IBYT(IND) = JBYT(NB)
      II = IA
      IF (II.LT.0 .OR. II.GT.255) THEN
        IF (IFAIL .EQ. 0) THEN
          CALL CCPERR(1,' *** Error in CCPTOI, bad convertion ***') 
        ELSE
          IFAIL = -1
        ENDIF
      ENDIF
      RETURN
C
C---- Integer*2 to integer value
C
   20 NW = (N-1)/2 + 1
      NIH = MOD(N-1,2) + 1
      RR = ARRAY(NW)
      II = JHALF(NIH)
      IF (II.LT.0 .OR. II.GT.65535) THEN
        IF (IFAIL .EQ. 0) THEN
          CALL CCPERR(1,' *** Error in CCPTOI, bad convertion ***')
        ELSE
          IFAIL = -1
        ENDIF
      ENDIF
      END
C
C
C
C_BEGIN_CCPUFL
      SUBROUTINE CCPUFL
C     =================
C
C---- This subroutine is called to suppress underflow error messages
C     if required and if the facility is available.
C
C Arguments:  NONE
C ==========
C
C----  Not implemented.
C_END_CCPUFL
      END
C
C
C
C_BEGIN_CCP4_PATCH_LEVEL
      SUBROUTINE CCP4_PATCH_LEVEL(PATCH_LEVEL)
C     =================================
C
C---- Return current CCP4 patch level as string
C
C Arguments:
C ==========
C
C      PATCH_LEVEL  (O)   CHARACTER*(*): current patch level of CCP4 suite
C_END_CCP4_PATCH_LEVEL
C
C     .. Scalar Arguments ..
      CHARACTER*(*) PATCH_LEVEL

      PATCH_LEVEL = '5.0f'

      END
C
C
C
C_BEGIN_CCPZBI
      SUBROUTINE CCPZBI (ARR1,NUM)
C     ============================
C
C  This routine zeros NUM bytes of the array ARR1
C
C Arguments:
C
C    ARR1 (O)   BYTE ARRAY(*): array to be zeroed
C     NUM (I)   INTEGER: Number of bytes
C_END_CCPZBI
C
C  Arguments ......
      INTEGER NUM
      INTEGER*1 ARR1(*)
C
      INTEGER J
C
      DO 10 J=1,NUM
   10 ARR1(J)=0
      END
C
C
C_BEGIN_CCPZI
      SUBROUTINE CCPZI (IARR1,NUM)
C     ===========================
C
C  This routine assigns zero to IARR1 using NUM words
C
C Arguments:
C
C    IARR1 (O)   INTEGER ARRAY(*): array to be zeroed
C     NUM (I)   INTEGER: Number of words
C_END_CCPZI
C
C  Arguments ..........
      INTEGER NUM, IARR1(*)
C
      INTEGER J
C
      DO 10 J=1,NUM
   10 IARR1(J)=0
      END
C
C
C_BEGIN_CCPZR
      SUBROUTINE CCPZR (ARR1,NUM)
C     ===========================
C
C  This routine assigns zero to ARR1 using NUM words
C
C Arguments:
C
C    ARR1 (O)   REAL ARRAY(*): array to be zeroed
C     NUM (I)   INTEGER: Number of words
C_END_CCPZR
C
C  Arguments ..........
      INTEGER NUM
      REAL ARR1(*)
C
      INTEGER J
C
      DO 10 J=1,NUM
   10 ARR1(J)=0.0
      END
C
C
C     ===================================
C_BEGIN_FDIR
      FUNCTION FDIR(FILNAM)
      CHARACTER*(*) FDIR
C     ===================================
C
C---- Returns the path (directory) of a file name or ' '
C
C Arguments:
C
C  FILNAM (I)   CHARACTER*(*): File name
C_END_FDIR
      CHARACTER FILNAM* (*)
      CHARACTER*1 NAME, TYPE, VERS
      EXTERNAL CCPPSF
C
      CALL CCPPSF(FILNAM, FDIR, NAME, TYPE, VERS)
      END
C
C
C     ====================================
C_BEGIN_FEXTN
      FUNCTION FEXTN(FILNAM)
      CHARACTER*(*) FEXTN
C     ====================================
C
C---- Returns the extension of a file name or ' '
C
C Arguments:
C
C  FILNAM (I)   CHARACTER*(*): File name
C_END_FEXTN
      CHARACTER FILNAM* (*)
      CHARACTER*1 PATH, NAME, VERS
      EXTERNAL CCPPSF
C
      CALL CCPPSF(FILNAM, PATH, NAME, FEXTN, VERS)
      END
C
C
C     ====================================
C_BEGIN_FROOT
      FUNCTION FROOT(FILNAM)
      CHARACTER*(*) FROOT
C     ====================================
C
C---- Returns a file name minus an extension.
C
C Arguments:
C
C  FILNAM (I)   CHARACTER*(*): File name
C_END_FROOT
C
      CHARACTER FILNAM* (*)
      CHARACTER*1 PATH, TYPE, VERS
      EXTERNAL CCPPSF
C
      CALL CCPPSF(FILNAM, PATH, FROOT, TYPE, VERS)
      END
C
C
C
C_BEGIN_LITEND
         LOGICAL FUNCTION LITEND(IDUM)
C        =============================
C
C---- Check endedness, Returns TRUE if little endian (VAX, FX2800,
C                                                   Ultrix)
C                              FALSE if big endian (IBM,IRIS,ESV)
C
C Arguments:
C ==========
C
C    IDUM (D)   DUMMY
C_END_LITEND
C
         INTEGER I, IDUM
         INTEGER*1 B(4)
         EQUIVALENCE (I,B(1))
C
C---- Initialise B
C
          DO 10 JDO=1,4
            B(JDO) = 0
 10       CONTINUE
C
          I = 1
C
          IF (B(1) .NE. 0) THEN
              LITEND = .TRUE.
          ELSE
              LITEND = .FALSE.
          END IF
C
        END
C      
C^L
C====================================================================== 
C                      
C_BEGIN_LENSTR
      INTEGER FUNCTION LENSTR(STRING)
C     ===============================
C      
C---- Returns significant string length excluding trailing spaces       
C                     
C     NB: LENSTR removes trailing spaces, plus trailing "null"
C     characters (ascii code 0) and carriage-returns (ascii code 13).
C     Carriage-returns may be inserted by editing on non-unix
C     systems? (PJX)
C      
C Arguments:
C ==========
C      
C  STRING (I)   CHARACTER*(*): Input string
C_END_LENSTR
C      
C     .. Scalar Arguments ..
      CHARACTER STRING* (*)
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC LEN
C     ..
      LENSTR = LEN(STRING)
 10   CONTINUE
      IF (LENSTR.NE.0) THEN
        IF(  ICHAR(STRING(LENSTR:LENSTR)).EQ.0   .OR.
     .       ICHAR(STRING(LENSTR:LENSTR)).EQ.13  .OR.
     .             STRING(LENSTR:LENSTR) .EQ.' '      ) THEN
          LENSTR = LENSTR - 1
          GO TO 10
        END IF
      END IF
C      
      END
C
C
C FUNCTION 'LUNSTI'
C =================
C
C_BEGIN_LUNSTI
      FUNCTION LUNSTI(IDUM)
C     =====================
C
C Returns the fortran standard input unit number
C
C Arguments:
C ==========
C
C       IDUM (D)   Dummy
C_END_LUNSTI
C
      INTEGER LUNSTI,IDUM
C
      LUNSTI = 5
      END
C
C
C FUNCTION 'LUNSTO'
C =================
C
C_BEGIN_LUNSTO
      FUNCTION LUNSTO(IDUM)
C     =====================
C
C Returns the fortran standard output unit number
C
C Arguments:
C ==========
C
C       IDUM (I)   Dummy argument
C_END_LUNSTO
C
      INTEGER LUNSTO,IDUM
C
      LUNSTO = 6
      END
C
C
C FUNCTION 'NBITST'
C =================
C
C_BEGIN_NBITST
      FUNCTION NBITST(IWORD,LSB,NBITS)
C     ================================
C
C Return the (unsigned) integer value held within a bit field in a word
C [for LAUE]
C
C Arguments:
C ==========
C
C      IWORD (I)    INTEGER: The word containing the bits to be examined
C
C        LSB (I)    INTEGER: The least significant bit offset for the bit field
C
C      NBITS (I)    INTEGER: The number of bits in the bit field (Must be less
C                   than the word length)
C_END_NBITST
C
C====== Get the bit value
C
      INTEGER IWORD,LSB,NBITS,IVAL,KMSK,KVAL
C
      KMSK = 2**NBITS - 1
      NBITST = IAND(ISHFT(IWORD,-LSB),KMSK)
      END
C
C
C     =======================
C_BEGIN_NOCRLF
      SUBROUTINE NOCRLF(LINE)
C     =======================
C
C---- Output a line supressing cr/lf.
C
C Arguments:
C ==========
C
C    LINE (I)   CHARACTER*(*): Line to output.
C_END_NOCRLF
C
      EXTERNAL LUNSTO,TTSEND
      INTEGER LUNSTO
      CHARACTER*(*) LINE
      CALL TTSEND(LUNSTO(1),LINE,0)
      END
C
C
C SUBROUTINE 'STBITS'
C ===================
C
C_BEGIN_STBITS
      SUBROUTINE STBITS (IWORD,LSB,NBITS,IVAL)
C     ========================================
C Set a bit field within a word to a given (unsigned) integer value
C [for LAUE]
C
C Arguments:
C ==========
C
C      IWORD (I/O)  INTEGER: The word in which the bits are to be set
C
C        LSB (I)    INTEGER: The least significant bit offset for the bit field
C
C      NBITS (I)    INTEGER: The number of bits in the bit field (must be less
C                   than the word length)
C
C       IVAL (I)    INTEGER: The unsigned integer value to be set in the bit
C                   field (The user should ensure that this value will
C                   fit within the requested bit field)
C_END_STBITS
C
C====== Set the bits
C
      KMSK = 2**NBITS - 1
      KVAL = IVAL
      KMSK = ISHFT(KMSK,LSB)
      KMSK = NOT(KMSK)
      KVAL = ISHFT(KVAL,LSB)
      IWORD = IOR(IAND(IWORD,KMSK),KVAL)
      END
C      
C^L
C     ============================
      LOGICAL FUNCTION HKLEQ(IH,KH)
C     =============================    
C    
C---- Returns true if indices ih = kh
C        
C     .. Array Arguments ..   
      INTEGER IH(3),KH(3)
C     ..
C
      HKLEQ = .FALSE.
C 
      IF (IH(1).EQ.KH(1) .AND. IH(2).EQ.KH(2) .AND. 
     +    IH(3).EQ.KH(3)) HKLEQ = .TRUE.
C 
      END
C  
C Group 7: Subroutines for generating and accessing a hash table:
C======================================================================
C 
C---- CCP4_HASH_SETUP CCP4_HASH_LOOKUP CCP4_HASH_ZEROIT
C   
C         Routines and functions used to initialise, set up and access
C         an internal look-up table. Not clear why these routines are
C         here in particular.
C    
C---- SUBROUTINE CCP4_HASH_SETUP(NSER,NFIND)
C 
C---- This subroutine sets up a value for the function ccp4_hash_lookup
C     when ccp4_hash_lookup(nser) is later evaluated it will return nfind
C     this function will allow the efficient retrieval of an identifier
C     for a large range variable (such as a crystal number).  the values
C     of the function ccp4_hash_lookup(nser) are stored in the array
C     it(2, kpri) where kpri is the prime number used to generate the
C     function.
C     The array it  lives in the common look which is shared by
C     ccp4_hash_setup and the function ccp4_hash_lookup
C    
C     NOTES: A hash table is a way of storing information so that it
C     easily be retrieved without the need for indexing or long searches.
C     NSER is referred to as the "key", which is "hashed" (computer-
C     science speak for "messed up") by the hashing function (in this
C     case MOD(NSER4,KPRI) + 1) to determine where the value pair will
C     be stored. The function LOOKUP can then search on the same basis
C     when supplied with the key, to retreive the pair in (at most) 3
C     calculations. Note that KPRI (the table size) MUST BE A PRIME in
C     order for this method to work.   
C                  
C     IT(1, NDX) = NSER,  IT(2, NDX) = NFIND
C    
C---- INTEGER FUNCTION CCP4_HASH_LOOKUP(NSER)
C
C---- The function ccp4_hash_lookup returns the value nfind (which was
C     input when setting up the function in the subroutine ccp4_hash_setup)
C     for the large range variable nser.  Uses hashing. (see comments for
C     CCP4_HASH_SETUP for description of hashing method).      
C                       
C---- SUBROUTINE CCP4_HASH_ZEROIT()      
C
C     Initialises elements of array it used in ccp4_hash_setup and
C     ccp4_hash_lookup to zero.

C^L
C     =======================================
      INTEGER FUNCTION CCP4_HASH_LOOKUP(NSER)
C     =======================================
C
C---- The function ccp4_hash_lookup returns the value nfind (which was
C     input when setting up the function in the subroutine ccp4_hash_setup)
C     for the large range variable nser.  Uses hashing. (see comments for
C     CCP4_HASH_SETUP for description of hashing method).
C 
      IMPLICIT NONE
C     .. Parameter (table size: MUST BE A PRIME NUMBER)
      INTEGER KPRI
      PARAMETER (KPRI=12007)
C
C     .. Scalar Arguments ..
      INTEGER NSER
C     ..
C     .. Arrays in Common ..
      INTEGER IT
C     ..
C     .. Local Scalars ..
      INTEGER NDX,NSER4
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC MOD
C     ..
C     .. Common blocks ..  
      COMMON /LOOK/IT(2,KPRI)
      SAVE /LOOK/
C     .. 
C
      NSER4 = NSER
C     
   10 CONTINUE
C
      NDX = MOD(NSER4,KPRI) + 1
      IF (NSER.NE.IT(1,NDX)) THEN
        IF (IT(1,NDX).NE.0) THEN
          NSER4 = NSER4 + 3
          GO TO 10
        END IF
      END IF
C 
      CCP4_HASH_LOOKUP = IT(2,NDX)
C
      END
C
C^L
C     ======================================
      SUBROUTINE CCP4_HASH_SETUP(NSER,NFIND)
C     ======================================
C     
C---- This subroutine sets up a value for the function ccp4_hash_lookup
C     when ccp4_hash_lookup(nser) is later evaluated it will return nfind
C     this function will allow the efficient retrieval of an identifier
C     for a large range variable (such as a crystal number).  the values
C     of the function ccp4_hash_lookup(nser) are stored in the array
C     it(2, kpri) where kpri is the prime number used to generate the
C     function
C     The array it  lives in the common look which is shared by
C     ccp4_hash_setup and the function ccp4_hash_lookup
C
C     NOTES: A hash table is a way of storing information so that it
C     easily be retrieved without the need for indexing or long searches.
C     NSER is referred to as the "key", which is "hashed" (computer-
C     science speak for "messed up") by the hashing function (in this
C     case MOD(NSER4,KPRI) + 1) to determine where the value pair will
C     be stored. The function LOOKUP can then search on the same basis
C     when supplied with the key, to retreive the pair in (at most) 3      
C     calculations. Note that KPRI (the table size) MUST BE A PRIME in   
C     order for this method to work.
C
C     IT(1, NDX) = NSER,  IT(2, NDX) = NFIND
C 
      IMPLICIT NONE
C     .. Parameter (table size: MUST BE A PRIME NUMBER)
      INTEGER KPRI
      PARAMETER (KPRI=12007)
C
C     .. Scalar Arguments ..
      INTEGER NFIND,NSER
C     ..
C     .. Arrays in Common ..
      INTEGER IT
C     ..
C     .. Local Scalars ..
      INTEGER NDX,NSER4
      CHARACTER STROUT*140
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC MOD
C     ..
C     .. Common blocks ..  
      COMMON /LOOK/IT(2,KPRI)
      SAVE /LOOK/
C     .. 
C
      NSER4 = NSER
   10 CONTINUE
      NDX = MOD(NSER4,KPRI) + 1  
      IF ((NSER4-NSER) .GE. 3*KPRI) THEN
         WRITE (STROUT, '(A,I8)')
     $     ' **** Error in SETUP: overflowed hash table, size ', KPRI
         CALL PUTLIN(STROUT,'CURWIN')
         CALL CCPERR(1,'*** Filled hash table in SETUP ***')
      ENDIF
      IF (IT(1,NDX).NE.0) THEN
        NSER4 = NSER4 + 3
        GO TO 10
      END IF
C 
      IT(1,NDX) = NSER
      IT(2,NDX) = NFIND
      RETURN
      END
C
C^L
C         
C     =============================
      SUBROUTINE CCP4_HASH_ZEROIT()
C     =============================
C 
      IMPLICIT NONE
C     .. Parameter (table size: MUST BE A PRIME NUMBER)
      INTEGER KPRI
      PARAMETER (KPRI=12007)
C     
C     .. Arrays in Common ..
      INTEGER IT
C     ..
C     .. Local Scalars ..
      INTEGER I
C     ..
C     ..
C     .. Common blocks ..
      COMMON /LOOK/IT(2,KPRI)
      SAVE /LOOK/
C     
      DO 20 I = 1,KPRI
        IT(1,I) = 0
        IT(2,I) = 0
   20 CONTINUE
      RETURN
C     
      END
C
C^L
C
C     ==================================
      REAL FUNCTION LSTLSQ(MINDX, IH, IK, IL)
C     ==================================
C
      IMPLICIT NONE
C     
      EXTERNAL LSTLSQ1
C
C     PARAMETERS
      INTEGER MINDX, IH, IK, IL
C
C     reso RETURN value
      REAL RESO
C
      CALL LSTLSQ1(RESO, MINDX, IH, IK, IL)
      LSTLSQ=RESO
      RETURN
      END
C     
C^L   
C     
C     ==================================
      REAL FUNCTION STHLSQ(IH, IK, IL)
C     ==================================
C     
      IMPLICIT NONE
C     
      EXTERNAL STHLSQ1
C
C     PARAMETERS
      INTEGER IH, IK, IL
C
C     reso RETURN value
      REAL RESO
C
      CALL STHLSQ1(RESO, IH, IK, IL)
      STHLSQ=RESO
      RETURN
      END
C     
C^L   
C     
C     ==================================
      REAL FUNCTION STS3R4(IH, IK, IL)
C     ==================================
C     
      IMPLICIT NONE
C
      EXTERNAL STS3R41
C     
C     PARAMETERS
      INTEGER IH, IK, IL
C
C     reso RETURN value
      REAL RESO
C
      CALL STS3R41(RESO, IH, IK, IL)
      STS3R4=RESO
      RETURN
      END

C
C     libhtml.f: write HTML tags into program output
C     Copyright (C) 1998  Kevin Cowtan et al
C
C     This library is free software: you can redistribute it and/or
C     modify it under the terms of the GNU Lesser General Public License
C     version 3, modified in accordance with the provisions of the 
C     license to address the requirements of UK law.
C 
C     You should have received a copy of the modified GNU Lesser General 
C     Public License along with this library.  If not, copies may be 
C     downloaded from http://www.ccp4.ac.uk/ccp4license.php
C 
C     This program is distributed in the hope that it will be useful,
C     but WITHOUT ANY WARRANTY; without even the implied warranty of
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C     GNU Lesser General Public License for more details.
C
C     November 1998 KDC
C     WROTE IT!
C     Autumn 1999 SPE, AWA, MDW
C     New routines ccp4h_init_lib, ccp4h_html_close, ccp4h_summary_beg,
C                  ccp4h_summary_end
C
C    =========
C    libhtml.f
C    =========
C
C Link destinations can be of the for "#name" for a link in the same
C document. Any other link will be prepended with $CHTML to link to
C the documentation area
C
C The contents of the environment variable $CCP_PROGRAM_ID is concatenated
c to the end of each link name. This allows multiple runs of a single 
C program from a script to be combined in one file without the links
C conflicting.
C
C The environment variable $CCP_SUPPRESS_HTML if set suppresses the output
C of most HTML tags. This is useful for devotees of plain text, and
C especially for the command input section.
C
C   ccp4h_init_lib(int ihtml, int isumm) - initialise the routines for
C     writing tags (html and summary)
C
C   ccp4h_init() - write initial comment to identify file
C
C   ccp4h_html_close() - write html close tag
C
C   ccp4h_toc_beg() - write starting Contents section tags
C
C   ccp4h_toc_ent(char*(*) text, char*(*) dest) - write Contents entry
C     text= the link text
C     dest= the link destination
C
C   ccp4h_toc_end() - write ending Contents section tags
C
C   ccp4h_graph_beg(x,y) - write starting JLogGraph applet tag
C     x = width of graph in pixels
C     y = height of graph in pixels
C      both can be zero, then they default to 400,300.
C
C   ccp4h_graph_end() - write ending JLogGraph applet tag
C
C   ccp4h_summary_beg() - begin summary section
C
C   ccp4h_summary_end() - end summary section 
C
C   ccp4h_pre_beg() - begin preformatted (html <pre> tag)
C
C   ccp4h_pre_end() - end preformatted (html <pre> tag)
C
C   ccp4h_rule() - rule (html <hr> tag)
C
C   ccp4h_link(char*(*) text, char*(*) dest) - link (html <a> tag)
C     text= the link text
C     dest= the link destination
C       if dest is not an anchor name (i.e. begins with '#'), then
C       the $CHTML path is prefixed automatically.
C
C   ccp4h_link_key(char*(*) text, char*(*) dest) - link to CCP4 documentation
C     text= the keyparser keyword
C     dest= the link destination filename and anchor,
C       the $CHTML path is prefixed automatically.
C     Between call memparse(.false.) and the main keyparser processing,
C     call this routine with any keywords and links which should be
C     linked to the program doc. Then call parsefail() to restart
C     syntax checking.... e.g.
C      call memoparse(.false)
C      call ccp4h_link_key('LABIN   ','fft.html#labin')
C      call ccp4h_link_key('GRID    ','fft.html#grid')
C      call ccp4h_link_key('FFTSPGRP','fft.html#fftspgrp')
C      call parsefail()
C
C   ccp4h_header(char*(*) text, char*(*) name, int level) - header
C     text= the link text
C     name= header name to link to
C     level=0-6. Header size. 0= plain text
C
      subroutine ccp4h_init()
C   ccp4h_init() - write initial comment to identify file
      integer lpt, htmlinit, summlevel
      logical html,logsumm,htmlopen,summopen
      character cbin*160,chtml*160,cpid*160
      common /ccp4hdat/lpt,html,logsumm,cbin,chtml,cpid,htmlinit,
     .                 htmlopen,summopen, summlevel
      save   /ccp4hdat/
      call ccp4h_init_lib(0,0)
      if (html .and. .not.htmlopen) then
        call ccp4h_summary_beg()
        write (lpt,10)
 10     format('<html> <!-- CCP4 HTML LOGFILE -->')
        htmlopen=.true.
        call ccp4h_rule()
        call ccp4h_summary_end()
      endif
      return
      end
C
      subroutine ccp4h_init_lib(ihtml,isumm)
C   ccp4h_init_lib(ihtml,isum) - initialise variables in common block
C
C   Arguments: ihtml = 0 (use default settings for html tags)
C                     -1 (switch off html tags)
C              isumm = 0 (use default settings for summary tags)
C                     -1 (switch off summary tags)
C
      integer ihtml,isumm,ihtml_level,isumm_level
      integer lpt, idum, htmlinit, summlevel
      logical html,logsumm,htmlopen,summopen
      character cbin*160,chtml*160,cpid*160,dummy*160
      external lunsto
      common /ccp4hdat/lpt,html,logsumm,cbin,chtml,cpid,htmlinit,
     .                 htmlopen,summopen, summlevel
      save   /ccp4hdat/
      data htmlinit/-1/, htmlopen/.false./
      if (htmlinit.lt.0) then
        lpt=lunsto(idum)
        cbin = ' '
        chtml = ' '
        cpid = ' '
        dummy = ' '
        call ugtenv('CBIN',cbin)
        call ugtenv('CHTML',chtml)
        call ugtenv('CCP_PROGRAM_ID',cpid)
        call ugtenv('CCP_SUPPRESS_HTML',dummy)
        if (ihtml.lt.0) then
          html=.false.
        else
          html=(dummy.eq.' ')
        end if
        call ugtenv('CCP_SUPPRESS_SUMMARY',dummy)
        if (isumm.lt.0) then
          logsumm=.false.
        else
          logsumm=(dummy.eq.' ')
        end if
        ihtml_level=0
        if (html) ihtml_level=1
        isumm_level=0
        if (logsumm) isumm_level=1
        call ccp4h_init_clib(ihtml_level,isumm_level)
        htmlinit=0
        summopen=.false.
        summlevel=0
      endif
      return
      end
C
      subroutine ccp4h_html_close()
C   ccp4h_html_close() - write html close tag
      integer lpt,htmlinit, summlevel
      logical html,logsumm,htmlopen,summopen
      character cbin*160,chtml*160,cpid*160
      common /ccp4hdat/lpt,html,logsumm,cbin,chtml,cpid,htmlinit,
     .                 htmlopen,summopen, summlevel
      save   /ccp4hdat/
      if (html) then
        call ccp4h_summary_beg()
        write (lpt,10)
 10     format('</html>')
        htmlopen=.false.
        call ccp4h_summary_end()
      endif
      return
      end
C
      subroutine ccp4h_toc_beg()
C   ccp4h_toc_beg() - write starting Contents section tags
      integer lpt,htmlinit, summlevel
      logical html,logsumm,htmlopen,summopen
      character cbin*160,chtml*160,cpid*160
      common /ccp4hdat/lpt,html,logsumm,cbin,chtml,cpid,htmlinit,
     .                 htmlopen,summopen, summlevel
      save   /ccp4hdat/
      call ccp4h_header('Contents','toc',2)
      if (html) write (lpt,10)
 10   format('<ul>')
      return
      end
C
      subroutine ccp4h_toc_ent(text,dest)
C   ccp4h_toc_ent(char*(*) text, char*(*) dest) - write Contents entry
C     text= the link text
C     dest= the link destination
      character*(*) text,dest
      integer lpt,htmlinit, summlevel
      logical html,logsumm,htmlopen,summopen
      character cbin*160,chtml*160,cpid*160,pn*160
      common /ccp4hdat/lpt,html,logsumm,cbin,chtml,cpid,htmlinit,
     .                 htmlopen,summopen, summlevel
      save   /ccp4hdat/
      integer lenstr
      external lenstr,ccppnm
      call ccppnm (pn)
      if (html) then
       write (lpt,10)dest,pn(1:lenstr(pn)),
     +    cpid(1:lenstr(cpid)),text
      else
       write (lpt,11)text
      endif
 10   format('<li><a href="',a,a,a,'">',a,'</a>')
 11   format(a)
      return
      end
C
      subroutine ccp4h_toc_end()
C   ccp4h_toc_end() - write ending Contents section tags
      integer lpt, htmlinit, summlevel
      logical html,logsumm,htmlopen,summopen
      character cbin*160,chtml*160,cpid*160
      common /ccp4hdat/lpt,html,logsumm,cbin,chtml,cpid,htmlinit,
     .                 htmlopen,summopen, summlevel
      save   /ccp4hdat/
      if (html) write (lpt,10)
 10   format('</ul>')
      return
      end
C
      subroutine ccp4h_graph_beg(x,y)
C   ccp4h_graph_beg() - write starting JLogGraph applet tag
C     x = width of graph in pixels
C     y = height of graph in pixels
C      both can be zero, then they default to 400,300.
      integer x,y,x1,y1,lenstr
      integer lpt, htmlinit, summlevel
      logical html,logsumm,htmlopen,summopen
      character cbin*160,chtml*160,cpid*160
      common /ccp4hdat/lpt,html,logsumm,cbin,chtml,cpid,htmlinit,
     .                 htmlopen,summopen, summlevel
      save   /ccp4hdat/
      external lenstr
      x1=x
      y1=y
      if (x1.le.0) x1=400
      if (y1.le.0) y1=300
      if (html) write (lpt,20)x1,y1,cbin(1:lenstr(cbin))
 20   format(
     +  '<applet width="',i4,'" height="',i4,'" code="JLogGraph.class" '
     +  ,/,'codebase="',a,'"><param name="table" value="')
      return
      end
C
      subroutine ccp4h_graph_end()
C   ccp4h_graph_end() - write ending JLogGraph applet tag
      integer lpt, htmlinit, summlevel
      logical html,logsumm,htmlopen,summopen
      character cbin*160,chtml*160,cpid*160
      common /ccp4hdat/lpt,html,logsumm,cbin,chtml,cpid,htmlinit,
     .                 htmlopen,summopen, summlevel
      save   /ccp4hdat/
      if (html) write (lpt,10)
 10   format('"><b>For inline graphs use a Java browser</b></applet>')
      return
      end
C
      subroutine ccp4h_summary_beg()
C   ccp4h_summary_beg() - begin summary section
      integer lpt, htmlinit, summlevel
      logical html,logsumm,htmlopen,summopen
      character cbin*160,chtml*160,cpid*160
      common /ccp4hdat/lpt,html,logsumm,cbin,chtml,cpid,htmlinit,
     .                 htmlopen,summopen, summlevel
      save   /ccp4hdat/
      call ccp4h_init_lib(0,0)
C   logsumm should be true unless CCP_SUPPRESS_SUMMARY set
      if (.not.logsumm) return
C
C   if summopen is true then there is already an "unclosed" BEGIN tag
C   in this case don't write another
C   keep track of nested level of calls to ccp4h_summary_beg and
C   ccp4h_summary_end
      if (summopen) then
        summlevel = summlevel + 1
        return
      else
        summlevel = 1
      endif
      if (html) then
        write (lpt,10)
 10     format('<B><FONT COLOR="#FF0000"><!--SUMMARY_BEGIN-->')
      else
        write (lpt,20)
 20     format('<!--SUMMARY_BEGIN-->')
      endif
C   set summopen to indicate there is an "unclosed" BEGIN
      summopen=.true.
      return
      end
C
      subroutine ccp4h_summary_end()
C   ccp4h_summary_end() - end summary section 
      integer lpt, htmlinit, summlevel
      logical html,logsumm,htmlopen,summopen
      character cbin*160,chtml*160,cpid*160
      common /ccp4hdat/lpt,html,logsumm,cbin,chtml,cpid,htmlinit,
     .                 htmlopen,summopen, summlevel
      save   /ccp4hdat/
      if (.not.logsumm) return
C   if summopen is not true then there is no matching BEGIN tag
C   in this case don't write an END
C   keep track of nested level of calls to ccp4h_summary_beg and
C   ccp4h_summary_end
      if (.not.summopen) THEN
        summlevel = 0
        return
      endif
      if (summlevel .GT. 1) THEN
        summlevel = summlevel - 1
        return
      endif
      if (html) then
        write (lpt,10)
 10     format('<!--SUMMARY_END--></FONT></B>')
      else
        write (lpt,20)
 20     format('<!--SUMMARY_END-->')
      endif
C   set summopen and summlevel to indicate there is no unmatched 
C   BEGIN tag
      summopen=.false.
      summlevel = 0
      return
      end
C
C
      subroutine ccp4h_pre_beg()
C   ccp4h_pre_beg() - begin preformatted (html <pre> tag)
      integer lpt, htmlinit, summlevel
      logical html,logsumm,htmlopen,summopen
      character cbin*160,chtml*160,cpid*160
      common /ccp4hdat/lpt,html,logsumm,cbin,chtml,cpid,htmlinit,
     .                 htmlopen,summopen, summlevel
      save   /ccp4hdat/
      if (html) write (lpt,10)
 10   format('<pre>')
      return
      end
C
      subroutine ccp4h_pre_end()
C   ccp4h_pre_end() - end preformatted (html <pre> tag)
      integer lpt, htmlinit, summlevel
      logical html,logsumm,htmlopen,summopen
      character cbin*160,chtml*160,cpid*160
      common /ccp4hdat/lpt,html,logsumm,cbin,chtml,cpid,htmlinit,
     .                 htmlopen,summopen, summlevel
      save   /ccp4hdat/
      if (html) write (lpt,10)
 10   format('</pre>')
      return
      end
C
      subroutine ccp4h_rule()
C   ccp4h_rule() - rule (html <hr> tag)
      integer lpt, htmlinit, summlevel
      logical html,logsumm,htmlopen,summopen
      character cbin*160,chtml*160,cpid*160
      common /ccp4hdat/lpt,html,logsumm,cbin,chtml,cpid,htmlinit,
     .                 htmlopen,summopen, summlevel
      save   /ccp4hdat/
      if (html) then
       write (lpt,10)
 10    format('<hr>')
      else
       write (lpt,11)
 11    format('-------------------------------------------------------')
      endif
      return
      end
C
      subroutine ccp4h_link(text,dest)
C   ccp4h_link(char*(*) text, char*(*) dest) - link (html <a> tag)
C     text= the link text
C     dest= the link destination
      character*(*) text,dest
      integer lpt, htmlinit, summlevel
      logical html,logsumm,htmlopen,summopen
      character cbin*160,chtml*160,cpid*160,pn*160
      common /ccp4hdat/lpt,html,logsumm,cbin,chtml,cpid,htmlinit,
     .                 htmlopen,summopen, summlevel
      save   /ccp4hdat/
      integer lenstr
      external lenstr,ccppnm
      call ccppnm(pn)
      if (html) then
       if (dest(1:1).eq.'#') then
        write (lpt,10)dest,pn(1:lenstr(pn)),cpid(1:lenstr(cpid)),text
 10     format('<a href="',a,a,a,'">',a,'</a>')
       else
        write (lpt,20)chtml(1:lenstr(chtml)),dest,text
 20     format('<a href="',a,'/',a,'">',a,'</a>')
       endif
      else
       write (lpt,30)text
 30    format(a)
      endif
      return
      end
C
      subroutine ccp4h_link_key(key,dest)
C   ccp4h_link(char*(*) text, char*(*) dest) - link keyword
C     text= the link text
C     dest= the link destination
      character*(*) key,dest
      integer lpt, htmlinit, summlevel
      logical html,logsumm,htmlopen,summopen
      character cbin*160,chtml*160,cpid*160
      common /ccp4hdat/lpt,html,logsumm,cbin,chtml,cpid,htmlinit,
     .                 htmlopen,summopen, summlevel
      save   /ccp4hdat/
      character kw*4,rest*120
      logical flag
      integer lenstr
      external lenstr
      flag=.false.
      kw=key
      call parsesubkey(kw,'    ',flag)
      if (flag) then
       call parsekeyarg(kw,rest)
       if (html) then
        write(lpt,20)
     +    chtml(1:lenstr(chtml)),dest(1:lenstr(dest)),key,
     +    rest(1:lenstr(rest))
 20     format(' Data line--- <a href="',a,'/',a,'">',a,'</a> ',a)
       else
        write(lpt,30)key,rest(1:lenstr(rest))
 30     format(' Data line--- ',a,a)
       endif
      endif
      return
      end
C
      subroutine ccp4h_header(text,name,level)
C   ccp4h_header(char*(*) text, char*(*) name, int level) - header
C     text= the link text
C     name= header name to link to
C     level=0-6. Header size. 0= plain text
      character*(*) text,name
      integer level,lenstr
      integer lpt, htmlinit, summlevel
      logical html,logsumm,htmlopen,summopen
      character cbin*160,chtml*160,cpid*160,pn*160
      common /ccp4hdat/lpt,html,logsumm,cbin,chtml,cpid,htmlinit,
     .                 htmlopen,summopen, summlevel
      save   /ccp4hdat/
      character*60 underline
      external lenstr,ccppnm
      call ccppnm(pn)
      if (html) then
       if (level.gt.0) then
        write (lpt,10)name,pn(1:lenstr(pn)),cpid(1:lenstr(cpid)),
     +      level,text,level
 10     format(/,'<a name="',a,a,a,'"><h',i1,'>',a,'</h',i1,'></a>')
       else
        write (lpt,20)name,pn(1:lenstr(pn)),cpid(1:lenstr(cpid)),text
 20     format(/,'<a name="',a,a,a,'">',a,'</a>')
       endif
      else
       if (level.le.0) then
        write(lpt,30)text(1:lenstr(text))
 30     format(a)
       else if (level.eq.1.or.level.eq.2.or.level.eq.3) then
        underline=
     +    '------------------------------------------------------------'
        write(lpt,31)text(1:lenstr(text)),
     +               underline(1:min(lenstr(text),60))
 31     format(/,/,a,/,a,/)
       else
        write(lpt,32)text(1:lenstr(text))
 32     format(/,a,/)
       endif
      endif
      return
      end
C
